/**
 * LiuNianMingPan.js
 * 流年命盘
 *
 * @date 2014-01-09
 * @version 0.1
 */
 
 function LiuNianMingPan(){
	this._year = false;                 // 年份
	this._yearOfGanZhi = false;         // 年份的干支表示法
	this._liuNianDouJun = false;        // 流年斗君
	this._xuSui = false;                // 虚岁
	this._liuNianLuCun = false;         // 流禄位置
	this._xiaoXianIndex = false;        // 小限
	
 }
 
 LiuNianMingPan.prototype = new MingPan();
 
 LiuNianMingPan.prototype.init = function(personalInfo, year){
	var birthday = personalInfo.getBirthday();
 
	this.createItems();
	this.setTianGan(birthday.getYearOfGanZhi().split("$")[0]);
	
	var sysCfg = SystemConfig.getConfig();

	var runYueConfig = sysCfg.getRunYueConfig();
	
	var lunarMonth = birthday.getLunarMonth().index;
	var isRunYue = birthday.isLunarRunYue();
	
	if(isRunYue){
		if("ASNEXTMONTH" == runYueConfig){
			lunarMonth ++;
		}else{
			if(personalInfo.getBirthday().getLunarDay().index >= 16){
				lunarMonth ++;
			}
		}
	}
	
	this.set12Gong(lunarMonth, personalInfo.getBirthday().getLunarHour());
	
	var mingGongGanZhi = this._items[this._mingGongIndex].getTianGan() + "$" + this._items[this._mingGongIndex].getDiZhi();
	personalInfo.setMingJu(mingGongGanZhi);
	
	this.setStars(personalInfo);
	
	for(var i = 0; i < this._items.length; i ++)
	{
		if(!this._items[i]._stars)
		{
			this._items[i]._stars = [];
		}
	}
	
	var yearOfGanZhi = PerpetualCalendar.getLunarYearGanZhiStr(year);
	
	this._year = year;
	this._yearOfGanZhi = yearOfGanZhi;
	
	this._setXuSui(year, personalInfo.getBirthday().getLunarYear());
	
	this.setDaYunStars(personalInfo);
	this.setLiuNianStars(personalInfo);
	this.setXiaoXian(personalInfo.getGender(), birthday.getYearOfGanZhi());
 };
 
 LiuNianMingPan.prototype.getLiuNianGongWei = function(gongWei)
{
	for (var i = 0; i < this._items.length; i++)
	{
		var section = this._items[i];

		if (section.getLiuNianGongWei() == gongWei)
		{
			return section;
		}
	}

	return false;
}
 
 LiuNianMingPan.prototype.getDaYun = function(personalInfo, index){
	this.createItems();
	this.setTianGan(personalInfo.getBirthday().getYearOfGanZhi().split("$")[0]);
	this.set12Gong(personalInfo.getBirthday().getLunarMonth().index, personalInfo.getBirthday().getLunarHour(), personalInfo.getBirthday().isLunarRunYue(), 15);
	
	var mingGongGanZhi = this._items[this._mingGongIndex].getTianGan() + "$" + this._items[this._mingGongIndex].getDiZhi();
	personalInfo.setMingJu(mingGongGanZhi);
	
	this.setStars(personalInfo);
 
	var mingJu = personalInfo.getMingJu();
 
	this._xuSui = mingJu.index + (index - 1)* 10;
	
	this._year = personalInfo.getBirthday().getLunarYear() + this._xuSui -1; 
	
	this._yearOfGanZhi = PerpetualCalendar.getLunarYearGanZhiStr(this._year);
	
	var daYunItem = this.getDaYunInfoByAge(this._xuSui, personalInfo);
	
	this.setDaYunStars(personalInfo);
	
	this.setLiuNianDouJun();
	
	this.step = index;
	
	return this;
 };
 
 LiuNianMingPan.prototype.getDaYunGongWei = function(gongWei)
{
	for (var i = 0; i < this._items.length; i++)
	{
		var section = this._items[i];

		if (section.getDaYunGongWei() == gongWei)
		{
			return section;
		}
	}

	return null;
}
 
 /**
  * 获取流月命盘
  */
 LiuNianMingPan.prototype.getLiuYueMingPan = function(personalInfo, year, month, isRunYue){
	this.init(personalInfo, year);
	
	for(var i = 0 ; i < this._items.length; i ++){
		this._items[i] = LiuYueMingPanSection.extend(this._items[i]);
	}
	
	var siZhu = SiZhu.createSiZhu(year, month, 15, 0, isRunYue);
	
	var yueZhu = siZhu.getYueZhu();
	
	this.setSiHuaStar(yueZhu, "LiuYueMingPan");
	
	this.setLiuYueGongWei(isRunYue ? month + 1 : month);
	
	this.month = month;
	this.monthOfGanZhi = yueZhu;
	this.monthIsRunYue = isRunYue ? true : false;
	
	return this;
 };
 
LiuNianMingPan.prototype.getLiuYueGongWei = function(gongWei)
{
	for (var i = 0; i < this._items.length; i++)
	{
		var section = this._items[i];

		if (section.getMonthGongWei() == gongWei)
		{
			return section;
		}
	}

	return false;
}
 
 /**
  * 获取流日命盘
  */
 LiuNianMingPan.prototype.getLiuRiMingPan = function(personalInfo, year, month, day, isRunYue){
	this.getLiuYueMingPan(personalInfo, year, month, isRunYue);
	
	for(var i = 0 ; i < this._items.length; i ++){
		this._items[i] = LiuRiMingPanSection.extend(this._items[i]);
	}
	
	var siZhu = SiZhu.createSiZhu(year, month, day, 0, isRunYue);
	
	var riZhu = siZhu.getRiZhu();
	
	riZhu = Util.convertJiaZi2GanZhi(riZhu);
	
	this.setSiHuaStar(riZhu, "LiuRiMingPan");
	
	this.setLiuRiGongWei(day);
	
	var birthday = personalInfo.getBirthday();
	
	this._yearOfGanZhi = siZhu.getNianZhu();
	this.monthOfGanZhi = siZhu.getYueZhu();
	this.day = day;
	this.dayOfGanZhi = riZhu;
	
	return this;
 };
 
LiuNianMingPan.prototype.getLiuRiGongWei = function(gongWei)
{
	for (var i = 0; i < this._items.length; i++)
	{
		var section = this._items[i];

		if (section.getDayGongWei() == gongWei)
		{
			return section;
		}
	}

	return null;
}
 
 /**
  * 获取流时命盘
  */
 LiuNianMingPan.prototype.getLiuShiMingPan = function(personalInfo, year, month, day, hour, isRunYue){
	this.getLiuRiMingPan(personalInfo, year, month, day, isRunYue);
	
	for(var i = 0 ; i < this._items.length; i ++){
		this._items[i] = LiuShiMingPanSection.extend(this._items[i]);
	}
	
	var siZhu = SiZhu.createSiZhu(year, month, day, hour, isRunYue);
	
	var shiZhu = siZhu.getShiZhu();
	
	this.setSiHuaStar(shiZhu, "LiuShiMingPan");
	
	var lunarHour = Util.getLunarHour(hour);
	
	var lunarHourIndex = Util.getIndexByDiZhi(lunarHour);

	var riDiZhi = this.getLiuRiGongWeiDiZhi(day);
	
	this.setLiuShiHour(riDiZhi);
	
	this.setLiuShiGongWei(riDiZhi, lunarHourIndex);
	
	this.hour = hour;
	this.hourOfGanZhi = shiZhu;
	
	return this;
 };
 
 /**
  * 获取流分命盘
  */
 LiuNianMingPan.prototype.getLiuFenMingPan = function(personalInfo, year, month, day, hour, min, isRunYue){
	this.getLiuShiMingPan(personalInfo, year, month, day, hour, isRunYue);
	
	for(var i = 0 ; i < this._items.length; i ++){
		this._items[i] = LiuFenMingPanSection.extend(this._items[i]);
	}
	
	var lunarMinIndex = this.getLunarMinIndex(hour, min);
	
	var shiDiZhi = this.getLiuShiGongWeiDiZhi(hour);
	
	this.setLiuFen(shiDiZhi);
	
	var mingGanZhi = this.setLiuFenGongWei(shiDiZhi, lunarMinIndex);
	
	this.setSiHuaStar(mingGanZhi, "LiuFenMingPan");
	
	this.minute = min;
	
	return this;
 };
 
 LiuNianMingPan.prototype.getLunarMinIndex = function(hour, min){
	var index = Math.floor(min / 10);
	
	// index ++;
	
	if(hour % 2 == 0){
		index += 6;
	}
	
	return index;
 }
 
/**
 * 创建12宫位
 */
LiuNianMingPan.prototype.createItems = function(){
	var itemArr = new Array();
	
	for(var i = 0 ; i < 12; i ++){
		var item = new LiuNianMingPanSection();
		
		item.setIndex(i + 1);
		item.setDiZhi(Util.getDiZhiByIndex(i));
		
		itemArr.push(item);
	}
	
	this._items = itemArr;
};

 /**
  * 设置大运星曜
  */
 LiuNianMingPan.prototype.setDaYunStars = function(personalInfo){
	// 
	var daYunItem = this.getDaYunInfoByAge(this._xuSui, personalInfo);
	
	this.setDaYunGongWei(Util.getIndexByDiZhi(daYunItem.getDiZhi()));
	this.setSiHuaGongWei(Util.getIndexByDiZhi(daYunItem.getDiZhi()));
	this.setSiHuaYunGong(Util.getIndexByDiZhi(daYunItem.getDiZhi()));
	
	var daYunGanZhi = daYunItem.getTianGan() +"$"+ daYunItem.getDiZhi();
	
	this._setDaYunTianKuiTianYue(daYunGanZhi);
	this._setDaYunWenChangWenQu(daYunGanZhi);
	var luCunIndex = this._setDaYunLuCun(daYunGanZhi);
	this._setDaYunQingYangTuoLuo(luCunIndex);
	this.setSiHuaStar(daYunGanZhi, "DaYunMingPan");
	
	this.setDaYunAgePeriod(personalInfo);
	this.setSiHuaStar(personalInfo.getBirthday().getYearOfGanZhi(), "XianTianMingPan");
 };
 
 LiuNianMingPan.prototype.setDaYunAgePeriod = function(personalInfo){
	var that = this;
	var mingJu = personalInfo.getMingJu();
	var gender = personalInfo.getGender();
	var genderDescriptor = personalInfo.getGenderDescriptor();
	
	var mingGongIndex = that._mingGongIndex;
	
	var agePeriodArr = new Array();
	var beginAge = mingJu.index;
	
	for(var i = 0 ; i < 12 ; i ++){
		var item = {
			"begin" : beginAge + i * 10,
			"end" : beginAge + (i + 1) * 10 -1
		};
		
		agePeriodArr.push(item);
	}

	var index = 0;

	// 阳男阴女顺行， 阴男阳女逆行
	if((gender === "GENDER_NAN" && genderDescriptor === "YY_YANG") || (gender === "GENDER_NV" && genderDescriptor === "YY_YIN")){
		for(var i = 0 ; i < agePeriodArr.length; i ++){
			that._items[mingGongIndex].setDaYunAgePeriod(agePeriodArr[i]);
			
			mingGongIndex ++;
			
			mingGongIndex = mingGongIndex % 12;
		}
	}else{
		for(var i = 0 ; i < agePeriodArr.length; i ++){
			that._items[mingGongIndex].setDaYunAgePeriod(agePeriodArr[i]);
			
			mingGongIndex --;
			
			mingGongIndex = (mingGongIndex + 12) % 12;
		}
	}
 };

 /**
  * 设置大运擎羊陀罗
  */
 LiuNianMingPan.prototype._setDaYunQingYangTuoLuo = function(luCunIndex){
	var qingYangIndex = (luCunIndex + 12 + 1) % 12;
	var tuoLuoIndex = (luCunIndex + 12 - 1) % 12;
	
	this._items[qingYangIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.FIENDSTAR_QINGYANGXING.starName,
		"shortName" : BizEnum.YUNYAO.FIENDSTAR_QINGYANGXING.shortName
	});
	
	this._items[tuoLuoIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.FIENDSTAR_TUOLUOXING.starName,
		"shortName" : BizEnum.YUNYAO.FIENDSTAR_TUOLUOXING.shortName
	});
 };
 
 /**
  * 设置大运禄存
  */
 LiuNianMingPan.prototype._setDaYunLuCun = function(daYunGanZhi){
	var luCunIndex = -1;
	
	switch(daYunGanZhi.split("$")[0]){
		case "TG_JIA" : luCunIndex = Util.getIndexByDiZhi("DZ_YIN"); break;
		case "TG_YI" : luCunIndex = Util.getIndexByDiZhi("DZ_MAO"); break;
		case "TG_BING" : 
		case "TG_WU" : luCunIndex = Util.getIndexByDiZhi("DZ_SI"); break;
		case "TG_DING" : 
		case "TG_JI" : luCunIndex = Util.getIndexByDiZhi("DZ_WU"); break;
		case "TG_GENG" : luCunIndex = Util.getIndexByDiZhi("DZ_SHEN"); break;
		case "TG_XIN" : luCunIndex = Util.getIndexByDiZhi("DZ_YOU"); break;
		case "TG_REN" : luCunIndex = Util.getIndexByDiZhi("DZ_HAI"); break;
		case "TG_GUI" : luCunIndex = Util.getIndexByDiZhi("DZ_ZI"); break;
		default: break;
	}
	
	this._items[luCunIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.GEMSTAR_LUCUNXING.starName,
		"shortName" : BizEnum.YUNYAO.GEMSTAR_LUCUNXING.shortName
	});
	
	return luCunIndex;
 };
 
 /**
  * 设置大运文昌文曲
  */
 LiuNianMingPan.prototype._setDaYunWenChangWenQu = function(daYunGanZhi){
	var wenChangIndex = -1;
	var wenQuIndex = -1;
 
	switch(daYunGanZhi.split("$")[0]){
		case "TG_JIA" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_YOU");
			
			break;
		}
		case "TG_YI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_WU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SHEN");
			
			break;
		}
		case "TG_BING" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SHEN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_WU");
			
			break;
		}
		case "TG_DING" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YOU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SI");
			
			break;
		}
		case "TG_WU" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SHEN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_WU");
			
			break;
		}
		case "TG_JI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YOU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SI");
			
			break;
		}
		case "TG_GENG" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_HAI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_MAO");
			
			break;
		}
		case "TG_XIN" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_ZI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_YIN");
			
			break;
		}
		case "TG_REN" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YIN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_ZI");
			
			break;
		}
		case "TG_GUI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_MAO");
			wenQuIndex = Util.getIndexByDiZhi("DZ_HAI");
			
			break;
		}
		default : break;
	}


	this._items[wenChangIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.GEMSTAR_WENCHANGXING.starName,
		"shortName" : BizEnum.YUNYAO.GEMSTAR_WENCHANGXING.shortName
	});
	
	this._items[wenQuIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.GEMSTAR_WENQUXING.starName,
		"shortName" : BizEnum.YUNYAO.GEMSTAR_WENQUXING.shortName
	});
 };
 
 /**
  * 设置大运天魁天钺
  */
 LiuNianMingPan.prototype._setDaYunTianKuiTianYue = function(daYunLunarYear){
	var tianKuiIndex = -1;
	var tianYueIndex = -1;
	
	var tiangan = daYunLunarYear.split("$")[0];
	// 甲戊庚年，天魁在丑，天钺在未
	if(tiangan === "TG_JIA" || tiangan === "TG_WU" || tiangan === "TG_GENG"){
		tianKuiIndex = 1;
		tianYueIndex = 7;
	}
	
	// 乙己年，天魁在子，天钺在申
	if(tiangan === "TG_YI" || tiangan === "TG_JI"){
		tianKuiIndex = 0;
		tianYueIndex = 8;
	}
	
	// 辛年，天魁在午，天钺在寅
	if(tiangan === "TG_XIN"){
		tianKuiIndex = 6;
		tianYueIndex = 2;
	}
	
	// 壬癸年，天魁在卯，天钺在巳
	if(tiangan === "TG_REN" || tiangan === "TG_GUI"){
		tianKuiIndex = 3;
		tianYueIndex = 5;
	}
	
	// 丙丁年，天魁在亥，天钺在酉
	if(tiangan === "TG_BING" || tiangan === "TG_DING"){
		tianKuiIndex = 11;
		tianYueIndex = 9;
	}

	this._items[tianKuiIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.GEMSTAR_TIANKUIXING.starName,
		"shortName" : BizEnum.YUNYAO.GEMSTAR_TIANKUIXING.shortName
	});

	this._items[tianYueIndex].addDaYunStar({
		"starName" : BizEnum.YUNYAO.GEMSTAR_TIANYUEXING.starName,
		"shortName" : BizEnum.YUNYAO.GEMSTAR_TIANYUEXING.shortName
	});
 };
 
 /**
  * 设置流年星曜
  */
 LiuNianMingPan.prototype.setLiuNianStars = function(personalInfo){
	// 流魁 流钺 流昌 流曲 流禄 流马 流羊 流陀 流年解 流四化
	var liuNianGanZhi = this._yearOfGanZhi;
	
	this._setLiuNianTianKuiTianYue(liuNianGanZhi);
	this._setLiuNianWenChangWenQu(liuNianGanZhi);
	this._liuNianLuCun = luCunIndex = this._setLiuNianLuCun(liuNianGanZhi);
	this._setLiuNianQingYangTuoLuo(luCunIndex);
	this._setLiuNianHongLuanTianXi(liuNianGanZhi);
	this.setSiHuaStar(liuNianGanZhi, "LiuNianMingPan");
	this.setSiHuaStar(personalInfo.getBirthday().getYearOfGanZhi(), "XianTianMingPan");
	this.setLiuNianGongWei(Util.getIndexByDiZhi(liuNianGanZhi.split("$")[1]));
	
	this.setShaSuiShaLuSuiQiangJiangQiang(luCunIndex, personalInfo.getGender(), personalInfo.getGenderDescriptor(), liuNianGanZhi);
	
	this.setLiuNianDouJun();
	
	this.setMonth();
 };
 
  /**
  * 设置流年天魁天钺
  */
 LiuNianMingPan.prototype._setLiuNianTianKuiTianYue = function(liuNianLunarYear){
	var tianKuiIndex = -1;
	var tianYueIndex = -1;
	
	var tiangan = liuNianLunarYear.split("$")[0];
	
	// 甲戊庚年，天魁在丑，天钺在未
	if(tiangan === "TG_JIA" || tiangan === "TG_WU" || tiangan === "TG_GENG"){
		tianKuiIndex = 1;
		tianYueIndex = 7;
	}
	
	// 乙己年，天魁在子，天钺在申
	if(tiangan === "TG_YI" || tiangan === "TG_JI"){
		tianKuiIndex = 0;
		tianYueIndex = 8;
	}
	
	// 辛年，天魁在午，天钺在寅
	if(tiangan === "TG_XIN"){
		tianKuiIndex = 6;
		tianYueIndex = 2;
	}
	
	// 壬癸年，天魁在卯，天钺在巳
	if(tiangan === "TG_REN" || tiangan === "TG_GUI"){
		tianKuiIndex = 3;
		tianYueIndex = 5;
	}
	
	// 丙丁年，天魁在亥，天钺在酉
	if(tiangan === "TG_BING" || tiangan === "TG_DING"){
		tianKuiIndex = 11;
		tianYueIndex = 9;
	}

	this._items[tianKuiIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.GEMSTAR_TIANKUIXING.starName,
		"shortName" : BizEnum.LIUYAO.GEMSTAR_TIANKUIXING.shortName
	});
	
	this._items[tianYueIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.GEMSTAR_TIANYUEXING.starName,
		"shortName" : BizEnum.LIUYAO.GEMSTAR_TIANYUEXING.shortName
	});
 };
 
 /**
  * 设置流年文昌文曲
  */
 LiuNianMingPan.prototype._setLiuNianWenChangWenQu = function(liuNianGanZhi){
	var wenChangIndex = -1;
	var wenQuIndex = -1;
 
	switch(liuNianGanZhi.split("$")[0]){
		case "TG_JIA" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_YOU");
			
			break;
		}
		case "TG_YI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_WU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SHEN");
			
			break;
		}
		case "TG_BING" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SHEN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_WU");
			
			break;
		}
		case "TG_DING" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YOU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SI");
			
			break;
		}
		case "TG_WU" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_SHEN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_WU");
			
			break;
		}
		case "TG_JI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YOU");
			wenQuIndex = Util.getIndexByDiZhi("DZ_SI");
			
			break;
		}
		case "TG_GENG" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_HAI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_MAO");
			
			break;
		}
		case "TG_XIN" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_ZI");
			wenQuIndex = Util.getIndexByDiZhi("DZ_YIN");
			
			break;
		}
		case "TG_REN" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_YIN");
			wenQuIndex = Util.getIndexByDiZhi("DZ_ZI");
			
			break;
		}
		case "TG_GUI" : {
			wenChangIndex = Util.getIndexByDiZhi("DZ_MAO");
			wenQuIndex = Util.getIndexByDiZhi("DZ_HAI");
			
			break;
		}
		default : break;
	}

	this._items[wenChangIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.GEMSTAR_WENCHANGXING.starName,
		"shortName" : BizEnum.LIUYAO.GEMSTAR_WENCHANGXING.shortName
	});
	
	this._items[wenQuIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.GEMSTAR_WENQUXING.starName,
		"shortName" : BizEnum.LIUYAO.GEMSTAR_WENQUXING.shortName
	});
 };
 
  /**
  * 设置流年禄存
  */
 LiuNianMingPan.prototype._setLiuNianLuCun = function(liuNianGanZhi){
	var luCunIndex = -1;
	
	switch(liuNianGanZhi.split("$")[0]){
		case "TG_JIA" : luCunIndex = Util.getIndexByDiZhi("DZ_YIN"); break;
		case "TG_YI" : luCunIndex = Util.getIndexByDiZhi("DZ_MAO"); break;
		case "TG_BING" : 
		case "TG_WU" : luCunIndex = Util.getIndexByDiZhi("DZ_SI"); break;
		case "TG_DING" : 
		case "TG_JI" : luCunIndex = Util.getIndexByDiZhi("DZ_WU"); break;
		case "TG_GENG" : luCunIndex = Util.getIndexByDiZhi("DZ_SHEN"); break;
		case "TG_XIN" : luCunIndex = Util.getIndexByDiZhi("DZ_YOU"); break;
		case "TG_REN" : luCunIndex = Util.getIndexByDiZhi("DZ_HAI"); break;
		case "TG_GUI" : luCunIndex = Util.getIndexByDiZhi("DZ_ZI"); break;
		default: break;
	}
	
	this._items[luCunIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.GEMSTAR_LUCUNXING.starName,
		"shortName" : BizEnum.LIUYAO.GEMSTAR_LUCUNXING.shortName
	});
	
	return luCunIndex;
 };
 
 /**
  * 设置流年擎羊陀罗
  */
 LiuNianMingPan.prototype._setLiuNianQingYangTuoLuo = function(luCunIndex){
	var qingYangIndex = (luCunIndex + 12 + 1) % 12;
	var tuoLuoIndex = (luCunIndex + 12 - 1) % 12;
	
	this._items[qingYangIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.FIENDSTAR_QINGYANGXING.starName,
		"shortName" : BizEnum.LIUYAO.FIENDSTAR_QINGYANGXING.shortName
	});

	this._items[tuoLuoIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.FIENDSTAR_TUOLUOXING.starName,
		"shortName" : BizEnum.LIUYAO.FIENDSTAR_TUOLUOXING.shortName
	});
 };
 
 /**
  * 设置流年红鸾天喜
  */
 LiuNianMingPan.prototype._setLiuNianHongLuanTianXi = function(liuNianGanZhi){
	var startIndex = Util.getIndexByDiZhi("DZ_MAO");
	
	var step = Util.getIndexByDiZhi(liuNianGanZhi.split("$")[1]);
	
	var hongLuanIndex = (startIndex - step + 12) % 12;
	
	var tianXiIndex = (hongLuanIndex - 6 + 12) % 12;
	
	this._items[hongLuanIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.NORMALSTAR_HONGLUANXING.starName,
		"shortName" : BizEnum.LIUYAO.NORMALSTAR_HONGLUANXING.shortName
	});
   
	this._items[tianXiIndex].addLiuNianStar({
		"starName" : BizEnum.LIUYAO.NORMALSTAR_TIANXIXING.starName,
		"shortName" : BizEnum.LIUYAO.NORMALSTAR_TIANXIXING.shortName
	});
 };
 
  /**
  * 设置大运宫位
  */
 LiuNianMingPan.prototype.setDaYunGongWei = function(startIndexOf12Gong){
	// 知道命宫后逆排12宫
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndexOf12Gong].setDaYunGongWei(Util.getGongWeiByIndex(i));
		
		startIndexOf12Gong --;
		
		startIndexOf12Gong = (startIndexOf12Gong + 12) % 12;
	}
 };
 
  /**
  * 设置四化盘宫位
  */
 LiuNianMingPan.prototype.setSiHuaGongWei = function(startIndexOf12Gong){
	// 知道命宫后逆排12宫
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndexOf12Gong].setSiHuaGongWei(Util.getSiHuaGongWeiByIndex(i));
		
		startIndexOf12Gong --;
		
		startIndexOf12Gong = (startIndexOf12Gong + 12) % 12;
	}
 };
 
  /**
  * 设置四化盘宫位的运势
  */
 LiuNianMingPan.prototype.setSiHuaYunGong = function(startIndexOf12Gong){
	// 知道命宫后逆排12宫
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndexOf12Gong].setSiHuaYunGong(Util.getYunGongByIndex(i));
		
		startIndexOf12Gong --;
		
		startIndexOf12Gong = (startIndexOf12Gong + 12) % 12;
	}
 };
 
 
 
 /**
  * 设置流年宫位
  */
 LiuNianMingPan.prototype.setLiuNianGongWei = function(startIndexOf12Gong){
	// 知道命宫后逆排12宫
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndexOf12Gong].setLiuNianGongWei(Util.getGongWeiByIndex(i));
		
		startIndexOf12Gong --;
		
		startIndexOf12Gong = (startIndexOf12Gong + 12) % 12;
	}
 };
 
  /**
  * 设置流月宫位
  */
 LiuNianMingPan.prototype.setLiuYueGongWei = function(month){
	var startIndexOf12Gong = -1;
	
	for(var i = 0; i < this._items.length;  i++){
		if(this._items[i].getMonth().index == month){
			startIndexOf12Gong = i;
		}
	}
	
	// 知道命宫后逆排12宫
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndexOf12Gong].setMonthGongWei(Util.getGongWeiByIndex(i));
		
		startIndexOf12Gong --;
		
		startIndexOf12Gong = (startIndexOf12Gong + 12) % 12;
	}
 };
 
 /**
  * 设置流日宫位
  */
 LiuNianMingPan.prototype.setLiuRiGongWei = function(day){
	var dizhi = this.getLiuRiGongWeiDiZhi(day);
	
	var startIndex = Util.getIndexByDiZhi(dizhi);
	
	for(var i = 0 ; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndex].setDayGongWei((BizEnum.GONGWEI[(12 - i + 12)% 12]));
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
 };
 
 /**
  * 获取流日宫位地支 
  */
 LiuNianMingPan.prototype.getLiuRiGongWeiDiZhi = function(day){
	var monthMingGongIndex = -1;
	
	for(var i = 0 ; i < this._items.length; i ++){
		if(this._items[i].getMonthGongWei().indexOf("GONGWEI_MINGGONG") >= 0){
			monthMingGongIndex = i;
			break;
		}
	}
	
	if(monthMingGongIndex < 0){
		return false;
	}
	
	day = (day - 1) % 12;
	
	var index = (monthMingGongIndex + day) % 12;
	
	return this._items[index].getDiZhi();
 };
 
 LiuNianMingPan.prototype.setLiuShiGongWei = function(ridizhi, lunarHourIndex){
	var startIndex = (Util.getIndexByDiZhi(ridizhi) + lunarHourIndex) % 12;
	
	for(var i = 0; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndex].setHourGongWei(BizEnum.GONGWEI[(12 - i + 12) % 12]);
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
 };
 
 /**
  * 设置流时的时辰
  */
 LiuNianMingPan.prototype.setLiuShiHour = function(ridizhi){
	var startIndex = Util.getIndexByDiZhi(ridizhi);
 
	for(var i = 0 ; i < BizEnum.DIZHI.length; i ++){
		this._items[startIndex].setLunarHour(BizEnum.DIZHI[i]);
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
 };
 
 /**
  * 获取流时宫位地支
  */
 LiuNianMingPan.prototype.getLiuShiGongWeiDiZhi = function(hour){
	var dayMingGongIndex = -1;
	
	for(var i = 0 ; i < this._items.length; i ++){
		if(this._items[i].getDayGongWei().indexOf("GONGWEI_MINGGONG") >= 0){
			dayMingGongIndex = i;
			break;
		}
	}
	
	if(dayMingGongIndex < 0){
		return false;
	}
	
	var lunarHour = Util.getLunarHour(hour);
	
	var lunarHourIndex = Util.getIndexByDiZhi(lunarHour);
	
	var index = (dayMingGongIndex + lunarHourIndex) % 12;
	
	return this._items[index].getDiZhi();
 };
 
 /**
  * 设置流分宫位
  */
 LiuNianMingPan.prototype.setLiuFenGongWei = function(shidizhi, lunarMinIndex){
	var mingGanZhi = -1;
 
	 var startIndex = (Util.getIndexByDiZhi(shidizhi) + lunarMinIndex) % 12;
	
	for(var i = 0; i < BizEnum.GONGWEI.length; i ++){
		this._items[startIndex].setMinGongWei(BizEnum.GONGWEI[(12 - i + 12) % 12]);
		
		if((12 - i + 12) % 12 == 0){
			mingGanZhi = this._items[startIndex].getTianGan() + "$" + this._items[startIndex].getDiZhi();
		}
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
	
	return mingGanZhi;
 };
 
  /**
  * 设置流分
  */
 LiuNianMingPan.prototype.setLiuFen = function(shidizhi){
	var startIndex = Util.getIndexByDiZhi(shidizhi);
 
	for(var i = 0 ; i < BizEnum.DIZHI.length; i ++){
		this._items[startIndex].setLunarMin(BizEnum.DIZHI[i]);
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
 };
 
 
 /** .
  * 设置太岁杀戮、流年将前和流年岁前
  */
 LiuNianMingPan.prototype.setShaSuiShaLuSuiQiangJiangQiang = function(liuNianLuCunIndex, gender, genderDescriptor, liuNianLunarYear){
	this.setTaiSuiShaLuStar(liuNianLuCunIndex, gender, genderDescriptor);
	this.setLiuNianSuiQianStar(liuNianLunarYear);
	this.setLiuNianJiangQianStar(liuNianLunarYear);
 };
 
 /**
  * 根据虚岁年龄获取大运信息
  */
 LiuNianMingPan.prototype.getDaYunInfoByAge = function(xuSui, personalInfo){
	var mingJu = personalInfo.getMingJu();
	var gender = personalInfo.getGender();
	var genderDescriptor = personalInfo.getGenderDescriptor();
	
	if(xuSui < mingJu.index){
		xuSui = mingJu.index;
	}
	
	for(var i = 0 ; i < 12; i ++){
		var start = mingJu.index + 10 * i;
		
		var end = mingJu.index + 10 * (i + 1) - 1;
		
		if(xuSui<= end && xuSui >= start){
			var index = -1;
			
			if((gender == "GENDER_NAN" && genderDescriptor == "YY_YANG") || (gender == "GENDER_NV" && genderDescriptor == "YY_YIN")){
				index = this._mingGongIndex + i; 
			}else{
				index = this._mingGongIndex - i; 
			}
		
			return this._items[(index + 12) % 12];
		}
	}		
	
	return false;
 };
 
 
 /**
  * 设置流年斗君
  */
 LiuNianMingPan.prototype.setLiuNianDouJun = function(){
	var gongWei = this._items[Util.getIndexByDiZhi("DZ_YIN")].getGongWei();
	
	gongWei = gongWei.replace("(GONGWEI_SHENGONG)", "");
	
	for(var i = 0; i < this._items.length; i ++){
		var month = this._items[i];
		
		var liuNianGongWei = month.getLiuNianGongWei();
		
		if(gongWei == liuNianGongWei){
			this._liuNianDouJun = month.getDiZhi();
		}
	}
 };
 
 LiuNianMingPan.prototype.setMonth = function(){
	var startIndex = Util.getIndexByDiZhi(this._liuNianDouJun);
	
	for(var j = 0; j < BizEnum.LUNARMONTH.length; j ++){
		this._items[startIndex].setMonth(Util.getLunarMonthByIndex(j));
		
		startIndex ++;
		
		startIndex = startIndex % 12;
	}
 };
 
 /**
  * 获取虚岁
  */
 LiuNianMingPan.prototype.getXuSui = function(){
	return this._xuSui;
 };
 
 LiuNianMingPan.prototype._setXuSui = function(year, birthYear){
	this._xuSui = year - birthYear + 1;
 };
 
 LiuNianMingPan.prototype.getMonth = function(){
	return this._items;
 };
 
LiuNianMingPan.prototype.getYear = function(){
	return this._year;
};
 
LiuNianMingPan.prototype.getYearOfGanZhi = function(){
	return this._yearOfGanZhi;
};

LiuNianMingPan.prototype.getLiuNianDouJun = function(){
	return this._liuNianDouJun;
};

LiuNianMingPan.prototype.getXiaoXianIndex = function(){
	return this._xiaoXianIndex;
};

LiuNianMingPan.prototype.setXiaoXian = function(gender, birthYearOfGanZhi){
	var startIndex = -1;

	switch(birthYearOfGanZhi.split("$")[1]){
		case "DZ_YIN" : 
		case "DZ_WU" : 
		case "DZ_XU" : {
			startIndex = Util.getIndexByDiZhi("DZ_CHEN");
			break;
		}
		case "DZ_SHEN" : 
		case "DZ_ZI" : 
		case "DZ_CHEN" : {
			startIndex = Util.getIndexByDiZhi("DZ_XU");
			break;
		}
		case "DZ_HAI" : 
		case "DZ_MAO" : 
		case "DZ_WEI" : {
			startIndex = Util.getIndexByDiZhi("DZ_CHOU");
			break;
		}
		case "DZ_SI" : 
		case "DZ_YOU" : 
		case "DZ_CHOU" : {
			startIndex = Util.getIndexByDiZhi("DZ_WEI");
			break;
		}
		default : break;
	}
	
	var step = this._xuSui % 12;
	
	if(gender == "GENDER_NAN"){
		this._xiaoXianIndex = (startIndex + step - 1 + 12) % 12;
	}else{
		this._xiaoXianIndex = (startIndex - step + 1 + 12) % 12;
	}
};