/**
 * PerpetualCalendarDay.js
 * 万年历天， 指代万年历中的某一天
 *
 * @date 2013-12-31
 * @version 0.1
 *
 * @date 2014-01-04
 * @version 0.2
 * @description  修改原先万年历项所指代的概念(以前指代一个农历年),将其改为指代
 *                一个公历天,因变动大,所以必须进行全面代码重构,并将文件名改为
 *                perpetualcalendarday.js,将类名改为PerpetualCalendarDay
 *
 * @date 2014-01-08
 * @version 0.3
 * @description 增加命名空间,增加小时
 */
 
 namespace("com.taxen.framework.ziwei.calendar");
 
 /**
  * 万年历天
  */
 function PerpetualCalendarDay(){
	this._year = false;                          // 公历年(eg. 2014)
	this._month = false;                         // 公历月(eg. 1)
	this._day = false;                           // 公历日(eg. 4) 
	this._hour = false;                          // 公历时(eg. 14)
	this._lunarYear = false;                     // 农历年(eg. 2013)
	this._lunarMonth = false;                    // 农历月(eg. 腊月)
	this._isLunarRunYue = false;                 // 是否是农历闰月(eg. false)
	this._lunarDay = false;                      // 农历日(eg. 初四)
	this._lunarHour = false;                     // 农历时(eg. 申时)
	this._yearOfGanZhi = false;                  // 农历干支年(eg. 癸巳年)
	this._yearOfGanZhiWithFeast = false;         // 带节气信息的农历干支年表示法
	this._monthOfGanZhi = false;                 // 农历干支月(eg. 甲子月)
	this._dayOfGanZhi = false;                   // 农历干支日(eg. 乙亥日)
	this._hourOfGanZhi = false;                  // 农历干支时(eg. 癸未时)
	this._zodiac = false;                        // 农历年生肖(eg. 蛇年) 
	this._weekday = false;                       // 星期数(eg. 星期六)
	this._festival = false;                      // 今天的节日(eg. 无)           // 暂未实现
	this._suitableThings = false;                // 宜(eg. 入宅...)              // 暂未实现
	this._inappropriateThings = false;           // 忌(eg. 嫁娶...)              // 暂未实现
	this._feast = false;                         // 今日的节气
 }
 
 PerpetualCalendarDay.prototype.getYear = function(){
	return this._year;
 };
 
 PerpetualCalendarDay.prototype.setYear = function(year){
	this._year = year;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getMonth = function(){
	return this._month;
 };
 
 PerpetualCalendarDay.prototype.setMonth = function(month){
	this._month = month;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getDay = function(){
	return this._day;
 };
 
 PerpetualCalendarDay.prototype.setDay = function(day){
	this._day = day;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getHour = function(){
	return this._hour;
 };
 
 PerpetualCalendarDay.prototype.setHour = function(hour){
	this._hour = hour;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getLunarYear = function(){
	return this._lunarYear;
 };
 
 PerpetualCalendarDay.prototype.setLunarYear = function(lunarYear){
	this._lunarYear = lunarYear;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getLunarMonth = function(){
	return this._lunarMonth;
 };
 
 PerpetualCalendarDay.prototype.setLunarMonth = function(lunarMonth){
	this._lunarMonth = lunarMonth;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.isLunarRunYue = function(){
	return this._isLunarRunYue;
 };
 
 PerpetualCalendarDay.prototype.setLunarRunYue = function(lunarRunYue){
	this._isLunarRunYue = lunarRunYue;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getLunarDay = function(){
	return this._lunarDay;
 };
 
 PerpetualCalendarDay.prototype.setLunarDay = function(lunarDay){
	this._lunarDay = lunarDay;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getLunarHour = function(){
	return this._lunarHour;
 };
 
 PerpetualCalendarDay.prototype.setLunarHour = function(lunarHour){
	this._lunarHour = lunarHour;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getYearOfGanZhi = function(){
	return this._yearOfGanZhi;
 };
 
 PerpetualCalendarDay.prototype.setYearOfGanZhi = function(yearOfGanZhi){
	this._yearOfGanZhi = yearOfGanZhi;
	
	return this;
 };
 
  PerpetualCalendarDay.prototype.getYearOfGanZhiWithFeast = function(){
	return this._yearOfGanZhiWithFeast;
 };
 
 PerpetualCalendarDay.prototype.setYearOfGanZhiWithFeast = function(yearOfGanZhi){
	this._yearOfGanZhiWithFeast = yearOfGanZhi;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getMonthOfGanZhi = function(){
	return this._monthOfGanZhi;
 };
 
 PerpetualCalendarDay.prototype.setMonthOfGanZhi = function(monthOfGanZhi){
	this._monthOfGanZhi = monthOfGanZhi;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getDayOfGanZhi = function(){
	return this._dayOfGanZhi;
 };
 
 PerpetualCalendarDay.prototype.setDayOfGanZhi = function(dayOfGanZhi){
	this._dayOfGanZhi = dayOfGanZhi;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getHourOfGanZhi = function(){
	return this._hourOfGanZhi;
 };
 
 PerpetualCalendarDay.prototype.setHourOfGanZhi = function(hourOfGanZhi){
	this._hourOfGanZhi = hourOfGanZhi;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getZodiac = function(){
	return this._zodiac;
 };
 
 PerpetualCalendarDay.prototype.setZodiac = function(zodiac){
	this._zodiac = zodiac;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getWeekday = function(){
	return this._weekday;
 };
 
 PerpetualCalendarDay.prototype.setWeekday = function(weekday){
	this._weekday = weekday;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getFestival = function(){
	return this._festival;
 };
 
 PerpetualCalendarDay.prototype.setFestival = function(festival){
	this._festival = festival;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getSuitableThings = function(){
	return this._suitableThings;
 };
 
 PerpetualCalendarDay.prototype.setSuitableThings = function(suitableThings){
	this._suitableThings = suitableThings;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getInappropriateThings = function(){
	return this._inappropriateThings;
 };
 
 PerpetualCalendarDay.prototype.setInappropriateThings = function(inappropriateThings){
	this._inappropriateThings = inappropriateThings;
	
	return this;
 };
 
 PerpetualCalendarDay.prototype.getFeast = function(){
	return this._feast;
 };
 
 PerpetualCalendarDay.prototype.setFeast = function(feast){
	this._feast = feast;
	
	return this;
 };