/**
 * Section.js
 * 命盘中12块之一，基础类
 *
 * @date 2013-01-08
 * @version 0.1
 */
 
 namespace("com.taxen.framework.ziwei.core");
 
 /**
  * Section主要包括以下信息：
  * 天干、地支、宫位、长生十二神、星星
  */
 function Section(){
	this._index = false;              // 位置(从1开始)
	this._tianGan = false;            // 天干
	this._diZhi = false;              // 地支
	this._gongWei = false;            // 宫位
	this._changSheng12Shen = false;   // 长生十二神
	this._stars = false;              // 星星
	this._taiSuiShaLu = false;        // 12太岁杀禄
	this._liuNianSuiQian = false;     // 流年岁前
	this._liuNianJiangQian = false;   // 流年将前
	this._isLaiYin = false;			//是莱茵宫
	this._isTaiSui = false;        //是太岁宫
	
 }
 
 Section.prototype.setLiuNianJiangQian = function(liuNianJiangQian){
	this._liuNianJiangQian = liuNianJiangQian;
 };
 
 Section.prototype.getLiuNianJiangQian = function(){
	return this._liuNianJiangQian;
 };
 
 Section.prototype.setLiuNianSuiQian = function(liuNianSuiQian){
	this._liuNianSuiQian = liuNianSuiQian;
 };
 
  Section.prototype.getLiuNianSuiQian = function(){
	return this._liuNianSuiQian;
 };
 
 Section.prototype.setTaiSuiShaLu = function(taiSuiShaLu){
	this._taiSuiShaLu = taiSuiShaLu;
 };
 
  Section.prototype.getTaiSuiShaLu = function(){
	return this._taiSuiShaLu;
 };
 
 Section.prototype.setIndex = function(index){
	this._index = index;
 };
 
 Section.prototype.getIndex = function(){
	return this._index;
 };
 
 Section.prototype.getStars = function(){
	return this._stars;
 };
 
 Section.prototype.addStar = function(star){
	if(!this._stars){
		this._stars = new Array();
	}
	
	this._stars.push(star);
	
	return this;
 };
 
 Section.prototype.setStars = function(stars){
	this._stars = stars;
	
	return this;
 };
 
 Section.prototype.getChangSheng12Shen = function(){
	return this._changSheng12Shen;
 };
 
 Section.prototype.setChangSheng12Shen = function(changSheng12Shen){
	this._changSheng12Shen = changSheng12Shen;
	
	return this;
 };
 
 Section.prototype.getGongWei = function(){
	return this._gongWei;
 };
 
 Section.prototype.setGongWei = function(gongWei){
	this._gongWei = gongWei
	
	return this;
 };
 
 Section.prototype.getDiZhi = function(){
	return this._diZhi;
 };
 
 Section.prototype.setDiZhi = function(diZhi){
	this._diZhi = diZhi;
	
	return this;
 };
 
 Section.prototype.getTianGan = function(){
	return this._tianGan;
 };
 
 Section.prototype.setTianGan = function(tianGan){
	this._tianGan = tianGan;
	
	return this;
 };
 
 Section.prototype.setLaiYin = function(laiYin){
 	this._isLaiYin = laiYin;
 }
 
 Section.prototype.getLaiYin = function(){
 	return this._isLaiYin;
 }
 
 Section.prototype.setTaisui = function(taiSui){
 	this._isTaiSui = taiSui
 }

 Section.prototype.getTaisui = function(){
 	return this._isTaiSui;
 }