/**
 * XianTianMingPan.js
 *
 * 先天命盘类，提供计算先天命盘的功能
 *
 * @date 2014-01-08
 * @version 0.2
 * @description 增加命名空间
 */
 
 function XianTianMingPan(){
	this._mingZhu = false;                   // 命主
	this._shenZhu = false;                   // 身主
 }
 
 XianTianMingPan.prototype = new MingPan();
 
 XianTianMingPan.newInstance = function(personalInfo){
	
 };
 
 XianTianMingPan.prototype.init = function(personalInfo,xusui){
	this.createItems();
	this.setTianGan(personalInfo.getBirthday().getYearOfGanZhi().split("$")[0]);
	var sysCfg = SystemConfig.getConfig();

	var runYueConfig = sysCfg.getRunYueConfig();
	var lunarMonth = personalInfo.getBirthday().getLunarMonth().index;
	var isRunYue = personalInfo.getBirthday().isLunarRunYue();
	
	if(isRunYue){
		if("ASNEXTMONTH" == runYueConfig){
			lunarMonth ++;
		}else{
			if(personalInfo.getBirthday().getLunarDay().index >= 16){
				lunarMonth ++;
			}
		}
	}
	
	this.set12Gong(lunarMonth, personalInfo.getBirthday().getLunarHour());
	
	var mingGongGanZhi = this._items[this._mingGongIndex].getTianGan() + "$" + this._items[this._mingGongIndex].getDiZhi();
	personalInfo.setMingJu(mingGongGanZhi);
	
	this.setStars(personalInfo);
	
	for(var i = 0; i < this._items.length; i ++)
	{
		if(!this._items[i]._stars)
		{
			this._items[i]._stars = [];
		}
	}
	
	this.setDaYun(personalInfo.getGender(), personalInfo.getGenderDescriptor(), personalInfo.getMingJu(),xusui);
	
	this.setMingZhu(this._items[this._mingGongIndex].getDiZhi());
	
	this.setShenZhu(personalInfo.getBirthday().getYearOfGanZhi());
	
	// 十二宫太岁杀禄
	//this.setTaiSuiShaLuStar(this._luCunIndex, personalInfo.getGender(), personalInfo.getGenderDescriptor());

	// 流年岁前诸星
	this.setLiuNianSuiQianStar(personalInfo.getBirthday().getYearOfGanZhi());
	
	// 安流年将前诸星
	this.setLiuNianJiangQianStar(personalInfo.getBirthday().getYearOfGanZhi());
	
	this.setSiHuaStar(personalInfo.getBirthday().getYearOfGanZhi(), "XianTianMingPan");
	
	//命宫干支
	this.setSiHuaStar(mingGongGanZhi, "MingGongSiHua");
	
	//四化盘的所有
	this.setSiHuaPanStar("SiHuaMingPan");
	
 };
 
 /**
 * 创建12宫位
 */
XianTianMingPan.prototype.createItems = function(){
	var itemArr = new Array();
	
	for(var i = 0 ; i < 12; i ++){
		var item = new XianTianMingPanSection();
		
		item.setIndex(i + 1);
		item.setDiZhi(Util.getDiZhiByIndex(i));
		
		itemArr.push(item);
	}
	
	this._items = itemArr;
};
 
 /**
 * 设置大运
 */
XianTianMingPan.prototype.setDaYun = function(gender, genderDescriptor, mingJu,xusui){
	var that = this;
	var mingGongIndex = that._mingGongIndex;   // 命宫的位置
//	var shenGongIndex = that._shenGongIndex;
	var agePeriodArr = that.getDaYunAgeArray(mingJu,xusui);
	var index = 0;

	// 阳男阴女顺行， 阴男阳女逆行
	if((gender === "GENDER_NAN" && genderDescriptor === "YY_YANG") || (gender === "GENDER_NV" && genderDescriptor === "YY_YIN")){
		for(var i = 0 ; i < agePeriodArr.length; i ++){
			that._items[mingGongIndex].setAgePeriod(agePeriodArr[i]);
			
			mingGongIndex ++;
			
			mingGongIndex = mingGongIndex % 12;
		}
	}else{
		for(var i = 0 ; i < agePeriodArr.length; i ++){
			that._items[mingGongIndex].setAgePeriod(agePeriodArr[i]);
			
			mingGongIndex --;
			
			mingGongIndex = (mingGongIndex + 12) % 12;
		}
	}
};
 
 /**
 * 获取大运的年龄数组
 */
XianTianMingPan.prototype.getDaYunAgeArray = function(mingJu,xusui){
	var agePeriodArr = new Array();
	var beginAge = mingJu.index;
	var currentDaYun = false;
	var daYunIndex = false;
	
	if(xusui < 0){
		xusui = beginAge;
	}
	
	for(var i = 0 ; i < 12 ; i ++){
		var begin = beginAge + i * 10;
		var end = beginAge + (i + 1) * 10 -1;
		
		if(xusui >= begin && xusui <= end){
			currentDaYun = true;
			daYunIndex = i + 1;
		}
		
		var item = {
			"begin" : beginAge + i * 10,
			"end" : beginAge + (i + 1) * 10 -1,
			"isCurrent" : currentDaYun,
			"daYunIndex" : daYunIndex
		};
		
		currentDaYun = false;
		daYunIndex = false;
		
		agePeriodArr.push(item);
	}

	return agePeriodArr;
};

 XianTianMingPan.prototype.getMingZhu = function(){
	return this._mingZhu;
 };
 
 XianTianMingPan.prototype.setMingZhu = function(mingGongDiZhi){
	switch(mingGongDiZhi){
		case "DZ_ZI" : {
			this._mingZhu = "MAINSTAR_TANLANGXING";
			break;
		}
		case "DZ_CHOU" :
		case "DZ_HAI" : {
			this._mingZhu = "MAINSTAR_JUMENXING";
			break;
		}
		case "DZ_YIN" :
		case "DZ_XU" : {
			this._mingZhu = "GEMSTAR_LUCUNXING";
			break;
		}
		case "DZ_MAO" :
		case "DZ_YOU" : {
			this._mingZhu = "GEMSTAR_WENQUXING";
			break;
		}
		case "DZ_SHEN" :
		case "DZ_CHEN" : {
			this._mingZhu = "MAINSTAR_LIANZHENXING";
			break;
		}
		case "DZ_SI" :
		case "DZ_WEI" : {
			this._mingZhu = "MAINSTAR_WUQUXING";
			break;
		}
		case "DZ_WU" : {
			this._mingZhu = "MAINSTAR_POJUNXING";
			break;
		}
		default : break;
	}
	
	return this;
 };
 
 XianTianMingPan.prototype.getShenZhu = function(){
	return this._shenZhu;
 };
 
 XianTianMingPan.prototype.setShenZhu = function(lunarYear){
	// 子午人火铃星，丑未人天相星，寅申人天梁星，卯酉人天同星，辰戌人文昌星，巳亥人天机星
	var that = this;

	var dizhi = lunarYear.split("$")[1];
	switch(dizhi){
		case "DZ_ZI" : {
			that._shenZhu = "FIENDSTAR_HUOXING";
			break;
		}
		case "DZ_WU" : {
			that._shenZhu = "FIENDSTAR_HUOXING";
			break;
		}
		case "DZ_CHOU" :
		case "DZ_WEI" : {
			that._shenZhu = "MAINSTAR_TIANXIANGXING";
			break;
		}
		case "DZ_YIN" :
		case "DZ_SHEN" : {
			that._shenZhu = "MAINSTAR_TIANLIANGXING";
			break;
		}
		case "DZ_MAO" :
		case "DZ_YOU" : {
			that._shenZhu = "MAINSTAR_TIANTONGXING";
			break;
		}
		case "DZ_CHEN" :
		case "DZ_XU" : {
			that._shenZhu = "GEMSTAR_WENCHANGXING";
			break;
		}
		case "DZ_SI" :
		case "DZ_HAI" : {
			that._shenZhu = "MAINSTAR_TIANJIXING";
			break;
		}
		default : break;
	}
	
	return this;
 };
 
