/**
 * sizhu.js
 * 四柱
 *
 * @date 2013-12-31
 * @version 0.1
 * @remark 
 *          1. 年与年之交换点是立春，并非以农历一月一日为一年之开始，是以立春之日为新的一年开始，每年立春日都不相同，应依万年历之记载为标准。
 */
 
 /**
  * 四柱
  */
 function SiZhu(){
	this._nianZhu = false;                // 年柱
	this._yueZhu = false;                 // 月柱
	this._riZhu = false;                  // 日柱
	this._shiZhu = false;                 // 时柱
 }
 
 SiZhu.createSiZhu = function(year, month, day, hour, isRunYue){  // 全部是农历时间
	var lunarYear = year; 
 
	var springBeginDate = SimpleFeastCalculator.getSpringBeginDateByYear(year);
	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(springBeginDate.getFullYear(), springBeginDate.getMonth() + 1, springBeginDate.getDate(), 0);
	
	lunarYear --;
	
	if(year > lunarDate.year || (year == lunarDate.year && month  > lunarDate.month) || (year == lunarDate.year && month == lunarDate.month && day >= lunarDate.day)){
		springBeginDate = SimpleFeastCalculator.getSpringBeginDateByYear(year + 1);
		lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(springBeginDate.getFullYear(), springBeginDate.getMonth() + 1, springBeginDate.getDate(), 0);
		
		lunarYear = year;
	}
	
	if(lunarYear > lunarDate.year || (lunarYear == lunarDate.year && month > lunarDate.month) || (lunarYear == lunarDate.year && month == lunarDate.month && day >= lunarDate.day)){
		lunarYear ++;
	}
	
	var siZhu = new SiZhu();
	siZhu.setNianZhu(lunarYear);
	
	var gregorianDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, day, hour, isRunYue);
	gYear = gregorianDate.getFullYear();
	gMonth = gregorianDate.getMonth() + 1;
	gDay = gregorianDate.getDate();
	
	var feastName = SimpleFeastCalculator.getFeastByDate(gYear, gMonth, gDay);
	var monthIndex = Util.getMonthIndexByFeastName(feastName);
	
	siZhu.setYueZhu(monthIndex);
	
	siZhu.setRiZhu(year, month, day, hour, isRunYue);
	
	siZhu.setShiZhu(hour);
	
	return siZhu;
 };
 
  SiZhu.createSiZhu2 = function(year, month, day, hour, isRunYue){  // 全部是农历时间
	var lunarYear = year; 
 
	var springBeginDate = SimpleFeastCalculator.getSpringBeginDateByYear(year);
	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(springBeginDate.getFullYear(), springBeginDate.getMonth() + 1, springBeginDate.getDate(), 0);
	
	lunarYear --;
	
	if(year > lunarDate.year || (year == lunarDate.year && month  > lunarDate.month) || (year == lunarDate.year && month == lunarDate.month && day >= lunarDate.day)){
		springBeginDate = SimpleFeastCalculator.getSpringBeginDateByYear(year + 1);
		lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(springBeginDate.getFullYear(), springBeginDate.getMonth() + 1, springBeginDate.getDate(), 0);
		
		lunarYear = year;
	}
	
	/**
	if(lunarYear > lunarDate.year || (lunarYear == lunarDate.year && month > lunarDate.month) || (lunarYear == lunarDate.year && month == lunarDate.month && day >= lunarDate.day)){
		lunarYear ++;
	}
	*/
	
	var siZhu = new SiZhu();
	siZhu.setNianZhu(lunarYear);
	
	var gregorianDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, day, hour, isRunYue);
	gYear = gregorianDate.getFullYear();
	gMonth = gregorianDate.getMonth() + 1;
	gDay = gregorianDate.getDate();
	
	var feastName = SimpleFeastCalculator.getFeastByDate(gYear, gMonth, gDay);
	var monthIndex = Util.getMonthIndexByFeastName(feastName);
	
	siZhu.setYueZhu(monthIndex);
	
	siZhu.setRiZhu(year, month, day, hour, isRunYue);
	
	siZhu.setShiZhu(hour);
	
	return siZhu;
 };
 
 SiZhu.prototype.toSpecifyString = function(){
	return this._nianZhu + "-" + this._yueZhu + "-" + this._riZhu + "-" + this._shiZhu;
 };
 
 SiZhu.prototype.getNianZhu = function(){
	return this._nianZhu;
 };
 
 SiZhu.prototype.setNianZhu = function(year){
	this._nianZhu = PerpetualCalendar.getLunarYearGanZhiStr(year);
 }
 
 SiZhu.prototype.getYueZhu = function(){
	return this._yueZhu;
 };
 
 SiZhu.prototype.setYueZhu = function(monthIndex){
	var tianGanStartIndex = -1;
	
	var tiangan = this._nianZhu.split("$")[0];
 
	switch(tiangan){
		case "TG_JIA" :
		case "TG_JI" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_BING");
			break;
		}
		case "TG_YI" :
		case "TG_GENG" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_WU");
			break;
		}
		case "TG_BING" :
		case "TG_XIN" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_GENG");
			break;
		}
		case "TG_DING" :
		case "TG_REN" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_REN");
			break;
		}
		case "TG_WU" :
		case "TG_GUI" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_JIA");
			break;
		}
	}

	var diZhiStartIndex = Util.getIndexByDiZhi("DZ_YIN");
	
	var tianGanIndex = (tianGanStartIndex + monthIndex - 1) % 10;
	var diZhiIndex = (diZhiStartIndex + monthIndex - 1) % 12;
	
	this._yueZhu = Util.getTianGanByIndex(tianGanIndex) + "$" +Util.getDiZhiByIndex(diZhiIndex);
 }
 
 SiZhu.prototype.getRiZhu = function(){
	return this._riZhu;
 };
 
 SiZhu.prototype.setRiZhu = function(year, month, day, hour, isRunYue){
	var gregorianDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, day, hour, isRunYue);
	year = gregorianDate.getFullYear();
	month = gregorianDate.getMonth() + 1;
	day = gregorianDate.getDate();
	
	var baseTable = ["JIAZI_JIMAO","JIAZI_RENSHEN","JIAZI_JIAZI","JIAZI_DINGSI","JIAZI_JIYOU","JIAZI_RENYIN","JIAZI_JIAWU","JIAZI_DINGHAI"];
	
	var baseYear = -1;
	
	var mod_year = year % 10;
	
	if(mod_year < 4){
		baseYear = (Math.floor(year / 10)) * 10 + 4 - 10;
	}else{
		baseYear = (Math.floor(year / 10)) * 10 + 4;
	}
	
	var index = ((baseYear - 1924) / 10) % 8;
	
	var points = (year - baseYear) * 5;
	
	for(var i = baseYear; i < year; i ++){
		if(PerpetualCalendar.isLeapYear(i)){
			points ++;
		}
	}
	
	points += (PerpetualCalendar.getIntervalDays(new Date(year, 0, 1), new Date(year, month -1, day)) % 60);
	
	points = points % 60;
	
	var startIndex = Util.getIndexByJiaZi(baseTable[index]);
	
	var index = startIndex + points
	
	index = (index - 1 + 60) % 60;
	
	this._riZhu = Util.getJiaZiByIndex(index);
 }
 
  SiZhu.prototype.getShiZhu = function(){
	return this._shiZhu;
 };
 
 SiZhu.prototype.setShiZhu = function(hour){
	var tianGanStartIndex = -1;
	var diZhiStartIndex = Util.getIndexByDiZhi("DZ_ZI");
	var hourIndex = Util.getIndexByDiZhi(Util.getLunarHour(hour));
 
	var ganzhi = this._riZhu.split("_")[1];
	
	ganzhi = "TG_" + ganzhi;
	
	var defaultConfig = [{
		"tiangan" : "TG_JIA",
		"startIndex" : "TG_JIA"
	},{
		"tiangan" : "TG_JI",
		"startIndex" : "TG_JIA"
	},{
		"tiangan" : "TG_YI",
		"startIndex" : "TG_BING"
	},{
		"tiangan" : "TG_GENG",
		"startIndex" : "TG_BING"
	},{
		"tiangan" : "TG_BING",
		"startIndex" : "TG_WU"
	},{
		"tiangan" : "TG_XIN",
		"startIndex" : "TG_WU"
	},{
		"tiangan" : "TG_DING",
		"startIndex" : "TG_GENG"
	},{
		"tiangan" : "TG_REN",
		"startIndex" : "TG_GENG"
	},{
		"tiangan" : "TG_WU",
		"startIndex" : "TG_REN"
	},{
		"tiangan" : "TG_GUI",
		"startIndex" : "TG_REN"
	}	
	];
	
	for(var i = 0 ; i < defaultConfig.length; i ++){
		var config = defaultConfig[i];
		
		if(ganzhi.indexOf(config.tiangan) == 0){
			tianGanStartIndex = Util.getIndexByTianGan(config.startIndex);
			break;
		}
	}
	
	var tianGanIndex = (tianGanStartIndex + hourIndex) % 10;
	var diZhiIndex = hourIndex;
	
	this._shiZhu = Util.getTianGanByIndex(tianGanIndex) + "$" + Util.getDiZhiByIndex(diZhiIndex);
	
	return this;
 }