/**
 * Star.js
 * 
 * @date 2013-12-27
 * @version 0.1
 *
 * @date 2014-01-08
 * @version 0.2
 * @description 增加星星的自动创建方法
 */

/**
 * 星星 
 */
function Star(){
	this._name = false;               // 星星的名称
	this._index = false;              // 星星的位置
	this._descriptor = false;         // 星星的描述符(eg. 旺，庙，闲，陷，平等)
	this._color = false;              // 星星名称的字体颜色
	this._bgColor = false;            // 星星名称的背景色
//		this._containSiXiang = false;     // 是否包含“科权禄忌”四星
	this._siXiang = false;            // 如果包括，该项指代所包含的具体的星星
	this._siHuaOfLiuNian = false;     // 流年四化
	this._siHuaOfDaYun = false;       // 大运四化
	this._siHuaOfLiuYue = false;      // 流月四化
	this._siHuaOfLiuRi = false;       // 流日四化
	this._siHuaOfLiuShi = false;      // 流时四化
	this._siHuaOfLiuFen = false;      // 流分四化
}

Star.newInstance = function(starName, index){
	if(!starName){
		return false;
	}

	var star = new Star();
	
	var cor = ColorConfig.getStarColor(starName);
	
	star.setName(starName);
	star.setColor(cor.color);
	star.setBgColor(cor.bgcolor);
	star.setDescriptor(Util.getMiaoWangByStarAndIndex(starName, index));
	
	return star;
};

Star.prototype.containsSiHuaOfLiuFen = function(){
 	return !!this._siHuaOfLiuFen;
};

Star.prototype.getSiHuaOfLiuFen = function(){
	return this._siHuaOfLiuFen;
};

Star.prototype.setSiHuaOfLiuFen = function(siHuaOfLiuFen){
	this._siHuaOfLiuFen = siHuaOfLiuFen;
};

Star.prototype.containsSiHuaOfLiuShi = function(){
 	return !!this._siHuaOfLiuShi;
};

Star.prototype.getSiHuaOfLiuShi = function(){
	return this._siHuaOfLiuShi;
};

Star.prototype.setSiHuaOfLiuShi = function(siHuaOfLiuShi){
	this._siHuaOfLiuShi = siHuaOfLiuShi;
};

Star.prototype.containsSiHuaOfLiuRi = function(){
 	return !!this._siHuaOfLiuRi;
};

Star.prototype.getSiHuaOfLiuRi = function(){
	return this._siHuaOfLiuRi;
};

Star.prototype.setSiHuaOfLiuRi = function(siHuaOfLiuRi){
	this._siHuaOfLiuRi = siHuaOfLiuRi;
};

Star.prototype.containsSiHuaOfLiuYue = function(){
 	return !!this._siHuaOfLiuYue;
};

Star.prototype.getSiHuaOfLiuYue = function(){
	return this._siHuaOfLiuYue;
};

Star.prototype.setSiHuaOfLiuYue = function(siHuaOfLiuYue){
	this._siHuaOfLiuYue = siHuaOfLiuYue;
};

Star.prototype.containsSiHuaOfDaYun = function(){
 	return !!this._siHuaOfDaYun;
};

Star.prototype.getSiHuaOfDaYun = function(){
	return this._siHuaOfDaYun;
};

Star.prototype.setSiHuaOfDaYun = function(siHuaOfDaYun){
	this._siHuaOfDaYun = siHuaOfDaYun;
};

Star.prototype.containsSiHuaOfLiuNian = function(){
 	return !!this._siHuaOfLiuNian;
};

Star.prototype.getSiHuaOfLiuNian = function(){
	return this._siHuaOfLiuNian;
};

Star.prototype.setSiHuaOfLiuNian = function(siHuaOfLiuNian){
	this._siHuaOfLiuNian = siHuaOfLiuNian;
};

Star.prototype.containsSiXiang = function(){
 	return !!this._siXiang;
};

Star.prototype.getSiXiang = function(){
	return this._siXiang;
};

Star.prototype.setSiXiang = function(siXiang){
	this._siXiang = siXiang;
};

Star.prototype.getColor = function(){
	return this._color;
};

Star.prototype.setColor = function(color){
	this._color = color;
};

Star.prototype.getBgColor = function(){
	return this._bgColor;
};

Star.prototype.setBgColor = function(bgColor){
	this._bgColor = bgColor;
};

Star.prototype.getName = function(){
	return this._name;
};
	
Star.prototype.setName = function(name){
	this._name = name;
};

Star.prototype.getIndex = function(){
	return this._index;
};

Star.prototype.setIndex = function(index){
	this._index = index;
};

Star.prototype.hasDescriptor = function(){
	return !!this._descriptor ;
};

Star.prototype.getDescriptor = function(){
	return this._descriptor;
};

Star.prototype.setDescriptor = function(descriptor){
	this._descriptor = descriptor;
};