/**
 * User.js
 * 用户
 *
 * @date 2014-01-12
 * @version 0.1
 */
 
 function User(){
	this._userInfo = false;                   // 用户信息
	this._token = false;                      // 用户凭证
	this._xianTianMingPan = false;            // 先天命盘
	this._liuNianMingPan = false;             // 流年命盘
	this._daYunMingPan = false;               // 大运命盘
	this._liuYueMingPan = false;              // 流月命盘
	this._liuRiMingPan = false;               // 流日命盘
	this._liuShiMingPan = false;              // 流时命盘
	this._liuFenMingPan = false;              // 流分命盘
 }
 
 User.newInstance = function(username, gender, year, month, day, hour, isLunarDate, isRunYue){
	var user = new User();

	var lunarDate = {
		"year" : year,
		"month" : month,
		"day" : day,
		"isRunYue" : isRunYue
	};
	
	if(!isLunarDate){
		lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(year, month, day);
	}
	
	var personalInfo = PersonalInfo.newInstance(username, gender, lunarDate.year, lunarDate.month, lunarDate.day, hour, lunarDate.isRunYue);
	user.setUserInfo(personalInfo);
	
	var uuid = new UUID().toString();
	user.setToken(uuid);
	
	return user;
 };
 
  User.prototype.getLiuFenMingPan = function(year, month, day, hour, min, isRunYue){
	if(arguments.length == 0){
		return this._liuFenMingPan;
	}else{
		var liuNianMingPan = new LiuNianMingPan();

        liuNianMingPan.getLiuShiMingPan(this._userInfo, year, month, day, hour, isRunYue);
		
		liuNianMingPan.getLiuFenMingPan(this._userInfo, year, month, day, hour, min, isRunYue);
		
		this._liuFenMingPan = liuNianMingPan;
	}
	
	return this._liuFenMingPan;
 };
 
 User.prototype.getLiuShiMingPan = function(year, month, day, hour, isRunYue){
	if(arguments.length == 0){
		return this._liuShiMingPan;
	}else{
		var liuNianMingPan = new LiuNianMingPan();
		
		liuNianMingPan.getLiuShiMingPan(this._userInfo, year, month, day, hour, isRunYue);
		
		this._liuShiMingPan = liuNianMingPan;
	}
	
	return this._liuShiMingPan;
 };
 
 User.prototype.getLiuRiMingPan = function(year, month, day, isRunYue){
	if(arguments.length == 0){
		return this._liuRiMingPan;
	}else{
		if(!this._liuRiMingPan || (this._liuRiMingPan._year != year || this._liuRiMingPan.month != month || this._liuRiMingPan.day != day)){
			var liuNianMingPan = new LiuNianMingPan();
			liuNianMingPan.getLiuRiMingPan(this._userInfo, year, month, day, isRunYue);
		
			this._liuRiMingPan = liuNianMingPan;
		}
	}
 	
	return this._liuRiMingPan;
 };
 
 User.prototype.setLiuRiMingPan = function(liuRiMingPan){
	this._liuRiMingPan = liuRiMingPan;
 };
 
 User.prototype.getLiuYueMingPan = function(year, month, isRunYue){
	if(arguments.length == 0){
		return this._liuYueMingPan;
	}else{
			if(!this._liuYueMingPan || (this._liuYueMingPan._year != year || this._liuYueMingPan.month != month || this._liuYueMingPan.monthIsRunYue != isRunYue)){
			var liuNianMingPan = new LiuNianMingPan();
			liuNianMingPan.getLiuYueMingPan(this._userInfo, year, month, isRunYue);
		
			this._liuYueMingPan = liuNianMingPan;
		}
	}

	return this._liuYueMingPan;
 };
 
 User.prototype.setLiuYueMingPan = function(liuYueMingPan){
	this._liuYueMingPan = liuYueMingPan;
 };
 
 User.prototype.getDaYunMingPan = function(index){
	if(!this._daYunMingPan || (index && this._daYunMingPan.step != index)){
		var liuNianMingPan = new LiuNianMingPan();
		
		liuNianMingPan.getDaYun(this._userInfo, index);
		
		this._daYunMingPan = liuNianMingPan;
		
		return this._daYunMingPan;
	}
	
	return this._daYunMingPan;
 };
 
 User.prototype.setDaYunMingPan = function(daYunMingPan){
	this._daYunMingPan = daYunMingPan;
 };
 
 User.prototype.getLiuNianMingPan = function(year){
	if(!this._liuNianMingPan || (year && this._liuNianMingPan.getYear() != year)){
		var liuNianMingPan = new LiuNianMingPan();
		
		liuNianMingPan.init(this._userInfo, year);
		
		this._liuNianMingPan = liuNianMingPan;
	}
	
	return this._liuNianMingPan;
 };
 
 User.prototype.setLiuNianMingPan = function(liuNianMingPan){
	this._liuNianMingPan = liuNianMingPan;
 };
 
 User.prototype.getXianTianMingPan = function(){
	if(!this._xianTianMingPan){
		var xianTianMingPan = new XianTianMingPan();
		
		xianTianMingPan.init(this._userInfo);
		
		this._xianTianMingPan = xianTianMingPan;
	}
 
	return this._xianTianMingPan;
 };
 
 User.prototype.setXianTianMingPan = function(xianTianMingPan){
	this._xianTianMingPan = xianTianMingPan;
 };
 
 User.prototype.getUserInfo = function(){
	return this._userInfo;
 };
 
 User.prototype.setUserInfo = function(userInfo){
	this._userInfo = userInfo;
 };
 
 User.prototype.getToken = function(){
	return this._token;
 };
 
 User.prototype.setToken = function(token){
	this._token = token;
 };