function VipPrivilegeQuestionAlgorithm()
{
	
}

VipPrivilegeQuestionAlgorithm.addDate = function(date,days)
{ 
   var d=new Date(date); 
   
   d.setDate(d.getDate()+days); 
   
   return d;
 };

/**
 * 获取昨天
 */
VipPrivilegeQuestionAlgorithm.getYesterday = function()
{
	var session = Session.getSession();
	
	var gDate = session.getGregorianDate();
	
	gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, -1);
	
	var lDate = PerpetualCalendar.convertGregorianDate2LunarDate(gDate.getFullYear(), gDate.getMonth() +1, gDate.getDate(), 0);
	
	return lDate;
};

/**
 * 获取明天
 */
VipPrivilegeQuestionAlgorithm.getTomorrow = function()
{
	var session = Session.getSession();
	
	var gDate = session.getGregorianDate();
	
	gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, 1);
	
	var lDate = PerpetualCalendar.convertGregorianDate2LunarDate(gDate.getFullYear(), gDate.getMonth() +1, gDate.getDate(), 0);
	
	return lDate;
};

/**
 * 获取上个月
 */
VipPrivilegeQuestionAlgorithm.getLastMonth = function()
{
	var session = Session.getSession();
	
	var gDate = session.getGregorianDate();
	
	var savedLunarDate = session.getLunarDate();
	
	if(savedLunarDate.day >= 15)
	{
		gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, -29);
	}
	else
	{
		gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, -15);
	}
	
	var lDate = PerpetualCalendar.convertGregorianDate2LunarDate(gDate.getFullYear(), gDate.getMonth() +1, gDate.getDate(), 0);
	
	return lDate;
};

/**
 * 获取下个月
 */
VipPrivilegeQuestionAlgorithm.getNextMonth = function()
{
	var session = Session.getSession();
	
	var gDate = session.getGregorianDate();
	
	var savedLunarDate = session.getLunarDate();
	
	if(savedLunarDate.day >= 15)
	{
		gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, 15);
	}
	else
	{
		gDate = VipPrivilegeQuestionAlgorithm.addDate(gDate, 29);
	}

	var lDate = PerpetualCalendar.convertGregorianDate2LunarDate(gDate.getFullYear(), gDate.getMonth() +1, gDate.getDate(), 0);
	
	return lDate;
};

/**
 * 获取流日命盘
 */
VipPrivilegeQuestionAlgorithm.getLiuRiMingPan = function(type)
{
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	// YEST, TOMO
	if(!type)
	{
		type = 'YEST';
	}
	
	var curLunarDate = null;
	
	switch(type)
	{
		case 'YEST' : {
			curLunarDate = VipPrivilegeQuestionAlgorithm.getYesterday();
			break;
		}
		case 'TOMO' : {
			curLunarDate = VipPrivilegeQuestionAlgorithm.getTomorrow();
			break;
		}
		default : break;
	}
	
	if(!curLunarDate){
		return false;
	}
	
	return curUser.getLiuRiMingPan(curLunarDate.year, curLunarDate.month, curLunarDate.day, curLunarDate.isRunYue);
};

/**
 * 获取流月命盘
 */
VipPrivilegeQuestionAlgorithm.getLiuYueMingPan = function(type){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	// LAST_MONTH, NEXT_MONTH
	if(!type)
	{
		type = 'LAST_MONTH';
	}
	
	var curLunarDate = null;
	
	switch(type)
	{
		case 'LAST_MONTH' : {
			curLunarDate = VipPrivilegeQuestionAlgorithm.getLastMonth();
			break;
		}
		case 'NEXT_MONTH' : {
			curLunarDate = VipPrivilegeQuestionAlgorithm.getNextMonth();
			break;
		}
		default : break;
	}
	
	if(!curLunarDate){
		return false;
	}
	
	return curUser.getLiuYueMingPan(curLunarDate.year, curLunarDate.month, curLunarDate.isRunYue);
};

// 昨天-WA3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA3 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA3_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA3_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
		
	var zuoStars = false;
	var huiStars = false;
	
	for(var j = 0; j < sections.length; j ++){
		if(sections[j].getDayGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			zuoStars = sections[j].getStars();
			
			huiStars = sections[(j + 4) % 12].getStars();
			
			huiStars.concat(sections[(j + 8) % 12].getStars());
		}
	}
	
	var sanFangStars = zuoStars.concat(huiStars);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	if(sanFangHasKongJie){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrongMainStar && shaNum < 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	var hasLiuNianHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU"){
			hasLiuNianHuaLu = true;
			
			break;
		}
	}
	
	if(!isStrongMainStar && shaNum <= 1 && hasLiuNianHuaLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WA10
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA10 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA10_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WA10_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
	
	//var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < fuqiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = fuqiSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}

	var hasLiuRiHuaLuOrHuaKe = false,
		hasLiuRiJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU" || star.getSiHuaOfLiuRi() == "SIHUA_KE"){
			hasLiuRiHuaLuOrHuaKe = true;
		}
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_JI"){
			hasLiuRiJi = true;
		}
	}
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

// 昨天-WS10
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS10 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS10_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS10_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var hasKongJie = false;
	var isStrong = false;
	
	for(var i = 0; i < sections.length; i ++){
		if(sections[i].getDayGongWei().indexOf("GONGWEI_SHIYEGONG") >= 0){
			var zuoStars = sections[i].getStars();
			
			for(var j = 0; j < zuoStars.length; j ++){
				var starName = zuoStars[j].getName();
				
				if(starName.indexOf("MAINSTAR_") >= 0){
					isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
					
					break;
				}
			}
			
			var hui1Stars = sections[(i + 4) % 12].getStars();
			
			var hui2Stars = sections[(i + 8) % 12].getStars();
			
			var totalSanFangStars = zuoStars.concat(hui1Stars, hui2Stars);
			
			for(var j = 0; j < totalSanFangStars.length; j ++){
				var starName = totalSanFangStars[j].getName();
				
				if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
					hasKongJie = true;
					
					break;
				}
			}
		}
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasHuaQuanLu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var sihua = totalStars[i].getSiHuaOfLiuRi();
		
		if(sihua == "SIHUA_LU" || sihua == "SIHUA_QUAN"){
			hasHuaQuanLu = true;
			
			break;
		}
	}
	
	if(!hasKongJie && isStrong && hasHuaQuanLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WS11
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS11 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS11_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS11_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui'], mingSanFangSiZhengStars['dui']);
	
	var hasKuiYue = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_TIANKUIXING" || starName == "GEMSTAR_TIANYUEXING"){
			hasKuiYue = true;
			
			break;
		}
	}
	
	if(hasKuiYue){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WS12
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS12 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS12_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS12_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING"){
			hasChangQu = true;
			
			break;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WS13
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS13 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS13_stub();
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WS13_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var qianyiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_QIANYIGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = qianyiSanFangSiZhengStars['zuo'].concat(qianyiSanFangSiZhengStars['hui']);
	
	var qianyiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuRiMingPan");

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var shiyeShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(shiyeSanFangSiZhengStars['zuo'], "LiuRiMingPan");

	if(qianyiShaNum >= 3){
		if(shiyeShaNum >= 1){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}else{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
};

// 昨天-WJ2
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ2 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ2_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ2_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var hasTianFu = false;
	for(var t = 0; t < sanFangStars.length; t ++){
		var starName = sanFangStars[t].getName();
		
		if(starName == "MAINSTAR_TIANFUXING"){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WJ4
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ4 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ4_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ4_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var fudeSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUDEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var fudeSanFangStars = fudeSanFangSiZhengStars['zuo'].concat(fudeSanFangSiZhengStars['hui']);
	
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(fudeSanFangStars, "LiuRiMingPan"); 
	
	if(shaNum >= 3){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 昨天-WJ7
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ7 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ7_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ7_stub = function()
{
var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan("YEST");
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var jieHasLiuRiHuaJi = false;
	var jieHasLiuRiHuaLu = false;
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuRiSiHua = jieTotalStars[i].getSiHuaOfLiuRi();
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuRiSiHua){
			jieHasLiuRiHuaJi = true;
		}
		
		if("SIHUA_LU" == liuRiSiHua){
			jieHasLiuRiHuaLu = true;
		}
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
	}
	
	var jieShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuRiMingPan"); 
	
	if(jieShaNum >= 1 && jieHasLiuRiHuaJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var mingShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuRiMingPan"); 
	
	if(mingShaNum >= 4 && (jieHasLiuRiHuaJi || jieHasLiuRiHuaLu || jieHasLiuYueHuaJi || jieHasLiuYueHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var mingHuaLuQuanJi = false;
	
	for(var i = 0; i < jieSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = jieSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuRi();
		
		if(siHua == "SIHUA_LU" || siHua == "SIHUA_QUAN" || siHua == "SIHUA_JI"){
			mingHuaLuQuanJi = true;
			
			break;
		}
	}
	
	/*
	if(mingShaNum >= 4 && mingHuaLuQuanJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	*/
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 昨天-WJ6
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ6 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ6_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WJ6_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
		
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan"); 
	
	if(shaNum >= 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WC3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC3 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC3_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC3_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		
		var liuRiGongWei = section.getDayGongWei();
		
		if(liuRiGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
			var liuYueGongWei = section.getMonthGongWei();
			
			if(liuYueGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_FUDEGONG") >= 0){
				
				var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
				var totalStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui'], caiboSanFangSiZhengStars['dui']);
				
				for(var j = 0; j < totalStars.length; j ++){
					if(totalStars[j].getSiHuaOfLiuYue() == "SIHUA_LU" || totalStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
				
				var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuRiMingPan, "LiuRiMingPan");
				
				var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
				
				for(var j = 0; j < xiongdiSanFangStars.length; j ++){
					if(xiongdiSanFangStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WC8
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC8 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC8_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WC8_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasKongJie = false;
	var hasLiuRiHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
		
		if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_LU"){
			hasLiuRiHuaLu = true;
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3 && !hasKongJie){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3 && !hasKongJie){
			if(hasLiuRiHuaLu){
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}else{
				return JSON.stringify({
					'request' : 'B',
					'useful' : true
				});
			}
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}
};

// 昨天-WD1
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD1 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD1_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD1_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++){
		var starName = mingSanFangSiZhengStars['zuo'][i].getName();
		
		if("MAINSTAR_TANLANGXING" == starName){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_ZINVGONG', liuRiMingPan, "LiuRiMingPan");
	
	for(var i = 0; i < zinvSanFangSiZhengStars['zuo'].length; i ++){
		var starName = zinvSanFangSiZhengStars['zuo'][i].getName();
		
		if(("MAINSTAR_ZIWEIXING" == starName) || ("MAINSTAR_TIANXIANGXING" == starName) ||
		   ("MAINSTAR_POJUNXING" == starName) || ("MAINSTAR_TANLANGXING" == starName) ||
		   ("MAINSTAR_LIANZHENXING" == starName) || ("MAINSTAR_TIANTONGXING" == starName) ||
		   ("MAINSTAR_TAIYINXING" == starName) ){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 昨天-WD2
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD2 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD2_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WD2_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('YEST');
	
	if(!liuRiMingPan){
		return false;
	}

	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '品牌酒店',
		'MAINSTAR_TIANFUXING' : '高档大酒店',
		'MAINSTAR_TIANXIANGXING' : '豪华酒店',
		'MAINSTAR_LIANZHENXING' : '情侣酒店',
		'MAINSTAR_WUQUXING' : '经济酒店',
		'MAINSTAR_QISHAXING' : '酒店',
		'MAINSTAR_POJUNXING' : '旅游景区',
		'MAINSTAR_TANLANGXING' : '夜店 会所 情调酒店',
		'MAINSTAR_TAIYANGXING' : '郊外',
		'MAINSTAR_TAIYINXING' : '海景房 湖景别墅',
		'MAINSTAR_TIANLIANGXING' : '古镇',
		'MAINSTAR_TIANTONGXING' : '露营',
		'MAINSTAR_JUMENXING' : '便捷酒店 厨房',
		'MAINSTAR_TIANJIXING' : '客厅 车里'
	};
	
	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_ZINVGONG', liuRiMingPan, "LiuRiMingPan");
	
	var resultArray = new Array();
	
	for(var i = 0; i < zinvSanFangSiZhengStars['zuo'].length; i ++){
		var starName = zinvSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : resultArray.join(" ")
	});
};

// 昨天-WX6
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WX6 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WX6_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Yest_WX6_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WA3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA3 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA3_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA3_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
		
	var zuoStars = false;
	var huiStars = false;
	
	for(var j = 0; j < sections.length; j ++){
		if(sections[j].getDayGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			zuoStars = sections[j].getStars();
			
			huiStars = sections[(j + 4) % 12].getStars();
			
			huiStars.concat(sections[(j + 8) % 12].getStars());
		}
	}
	
	var sanFangStars = zuoStars.concat(huiStars);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	if(sanFangHasKongJie){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrongMainStar && shaNum < 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	var hasLiuNianHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU"){
			hasLiuNianHuaLu = true;
			
			break;
		}
	}
	
	if(!isStrongMainStar && shaNum <= 1 && hasLiuNianHuaLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WA10
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA10 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA10_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WA10_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
	
	//var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < fuqiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = fuqiSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}

	var hasLiuRiHuaLuOrHuaKe = false,
		hasLiuRiJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU" || star.getSiHuaOfLiuRi() == "SIHUA_KE"){
			hasLiuRiHuaLuOrHuaKe = true;
		}
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_JI"){
			hasLiuRiJi = true;
		}
	}
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

// 明天-WS10
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS10 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS10_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS10_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var hasKongJie = false;
	var isStrong = false;
	
	for(var i = 0; i < sections.length; i ++){
		if(sections[i].getDayGongWei().indexOf("GONGWEI_SHIYEGONG") >= 0){
			var zuoStars = sections[i].getStars();
			
			for(var j = 0; j < zuoStars.length; j ++){
				var starName = zuoStars[j].getName();
				
				if(starName.indexOf("MAINSTAR_") >= 0){
					isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
					
					break;
				}
			}
			
			var hui1Stars = sections[(i + 4) % 12].getStars();
			
			var hui2Stars = sections[(i + 8) % 12].getStars();
			
			var totalSanFangStars = zuoStars.concat(hui1Stars, hui2Stars);
			
			for(var j = 0; j < totalSanFangStars.length; j ++){
				var starName = totalSanFangStars[j].getName();
				
				if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
					hasKongJie = true;
					
					break;
				}
			}
		}
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasHuaQuanLu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var sihua = totalStars[i].getSiHuaOfLiuRi();
		
		if(sihua == "SIHUA_LU" || sihua == "SIHUA_QUAN"){
			hasHuaQuanLu = true;
			
			break;
		}
	}
	
	if(!hasKongJie && isStrong && hasHuaQuanLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WS11
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS11 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS11_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS11_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui'], mingSanFangSiZhengStars['dui']);
	
	var hasKuiYue = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_TIANKUIXING" || starName == "GEMSTAR_TIANYUEXING"){
			hasKuiYue = true;
			
			break;
		}
	}
	
	if(hasKuiYue){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
}

// 明天-WS12
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS12 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS12_stub();

	return result;	
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS12_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING"){
			hasChangQu = true;
			
			break;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WS13
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS13 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS13_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WS13_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var qianyiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_QIANYIGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = qianyiSanFangSiZhengStars['zuo'].concat(qianyiSanFangSiZhengStars['hui']);
	
	var qianyiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuRiMingPan");

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var shiyeShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(shiyeSanFangSiZhengStars['zuo'], "LiuRiMingPan");

	if(qianyiShaNum >= 3){
		if(shiyeShaNum >= 1){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}else{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
};

// 明天-WJ4
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ4 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ4_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ4_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var fudeSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUDEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var fudeSanFangStars = fudeSanFangSiZhengStars['zuo'].concat(fudeSanFangSiZhengStars['hui']);
	
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(fudeSanFangStars, "LiuRiMingPan"); 
	
	if(shaNum >= 3){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 明天-WJ7
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ7 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ7_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ7_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var jieHasLiuRiHuaJi = false;
	var jieHasLiuRiHuaLu = false;
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuRiSiHua = jieTotalStars[i].getSiHuaOfLiuRi();
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuRiSiHua){
			jieHasLiuRiHuaJi = true;
		}
		
		if("SIHUA_LU" == liuRiSiHua){
			jieHasLiuRiHuaLu = true;
		}
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
	}
	
	var jieShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuRiMingPan"); 
	
	if(jieShaNum >= 1 && jieHasLiuRiHuaJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var mingShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuRiMingPan"); 
	
	if(mingShaNum >= 4 && (jieHasLiuRiHuaJi || jieHasLiuRiHuaLu || jieHasLiuYueHuaJi || jieHasLiuYueHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var mingHuaLuQuanJi = false;
	
	for(var i = 0; i < jieSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = jieSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuRi();
		
		if(siHua == "SIHUA_LU" || siHua == "SIHUA_QUAN" || siHua == "SIHUA_JI"){
			mingHuaLuQuanJi = true;
			
			break;
		}
	}
	
	/*
	if(mingShaNum >= 4 && mingHuaLuQuanJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	*/
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 明天-WJ2
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ2 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ2_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ2_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var hasTianFu = false;
	for(var t = 0; t < sanFangStars.length; t ++){
		var starName = sanFangStars[t].getName();
		
		if(starName == "MAINSTAR_TIANFUXING"){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WJ6
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ6 = function()
{
			var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ6_stub();
			
			return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WJ6_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
		
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan"); 
	
	if(shaNum >= 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WC3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC3 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC3_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC3_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		
		var liuRiGongWei = section.getDayGongWei();
		
		if(liuRiGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
			var liuYueGongWei = section.getMonthGongWei();
			
			if(liuYueGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_FUDEGONG") >= 0){
				
				var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
				var totalStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui'], caiboSanFangSiZhengStars['dui']);
				
				for(var j = 0; j < totalStars.length; j ++){
					if(totalStars[j].getSiHuaOfLiuYue() == "SIHUA_LU" || totalStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
				
				var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuRiMingPan, "LiuRiMingPan");
				
				var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
				
				for(var j = 0; j < xiongdiSanFangStars.length; j ++){
					if(xiongdiSanFangStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WC8
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC8 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC8_stub();

	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WC8_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasKongJie = false;
	var hasLiuRiHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
		
		if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_LU"){
			hasLiuRiHuaLu = true;
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3 && !hasKongJie){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3 && !hasKongJie){
			if(hasLiuRiHuaLu){
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}else{
				return JSON.stringify({
					'request' : 'B',
					'useful' : true
				});
			}
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}
};

// 明天-WD1
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD1 = function()
{
	var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD1_stub();
	
	return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD1_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++){
		var starName = mingSanFangSiZhengStars['zuo'][i].getName();
		
		if("MAINSTAR_TANLANGXING" == starName){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_ZINVGONG', liuRiMingPan, "LiuRiMingPan");
	
	for(var i = 0; i < zinvSanFangSiZhengStars['zuo'].length; i ++){
		var starName = zinvSanFangSiZhengStars['zuo'][i].getName();
		
		if(("MAINSTAR_ZIWEIXING" == starName) || ("MAINSTAR_TIANXIANGXING" == starName) ||
		   ("MAINSTAR_POJUNXING" == starName) || ("MAINSTAR_TANLANGXING" == starName) ||
		   ("MAINSTAR_LIANZHENXING" == starName) || ("MAINSTAR_TIANTONGXING" == starName) ||
		   ("MAINSTAR_TAIYINXING" == starName) ){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 明天-WD2
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD2 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD2_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WD2_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}

	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '品牌酒店',
		'MAINSTAR_TIANFUXING' : '高档大酒店',
		'MAINSTAR_TIANXIANGXING' : '豪华酒店',
		'MAINSTAR_LIANZHENXING' : '情侣酒店',
		'MAINSTAR_WUQUXING' : '经济酒店',
		'MAINSTAR_QISHAXING' : '酒店',
		'MAINSTAR_POJUNXING' : '旅游景区',
		'MAINSTAR_TANLANGXING' : '夜店 会所 情调酒店',
		'MAINSTAR_TAIYANGXING' : '郊外',
		'MAINSTAR_TAIYINXING' : '海景房 湖景别墅',
		'MAINSTAR_TIANLIANGXING' : '古镇',
		'MAINSTAR_TIANTONGXING' : '露营',
		'MAINSTAR_JUMENXING' : '便捷酒店 厨房',
		'MAINSTAR_TIANJIXING' : '客厅 车里'
	};
	
	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_ZINVGONG', liuRiMingPan, "LiuRiMingPan");
	
	var resultArray = new Array();
	
	for(var i = 0; i < zinvSanFangSiZhengStars['zuo'].length; i ++){
		var starName = zinvSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : resultArray.join(" ")
	});
};

// 明天-WX6
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WX6 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WX6_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Tomo_WX6_stub = function()
{
	var liuRiMingPan = VipPrivilegeQuestionAlgorithm.getLiuRiMingPan('TOMO');
	
	if(!liuRiMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 上月-WJ3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WJ3 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WJ3_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WJ3_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('LAST_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var mingHasHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	var jieHasLiuNianHuaLu = false;
	for(var i = 0; i < mingSanFangStars.length; i ++){
		var liuYueSiHua = mingSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = mingSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua || "SIHUA_JI" == liuNianSiHua){
			mingHasHuaJi = true;
			
			break;
		}
	}
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieTotalStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
		
		if("SIHUA_LU" == liuNianSiHua){
			jieHasLiuNianHuaLu = true;
		}
	}
	
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuNianHuaJi = false;
	
	for(var i = 0; i < jieSanFangSiZhengStars['zuo'].length; i ++){
		var liuYueSiHua = jieSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
	}
	
	var jieSanFangHasLiuYueHuaJi = false;
	var jieSanFangHasLiuYueHuaLu = false;
	for(var i = 0; i < jieSanFangStars.length; i ++){
		var liuYueSiHua = jieSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieSanFangHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_JI" == liuNianSiHua){
			jieHasLiuNianHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieSanFangHasLiuYueHuaLu = true;
		}
	}
	
	var mingShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuYueMingPan");
	var jieShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieTotalStars, "LiuYueMingPan");
	var jieZuoShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangSiZhengStars['zuo'], "LiuYueMingPan"); 
	var jieSanFangShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuYueMingPan"); 
	
	if(mingHasHuaJi && jieZuoShaNum >= 1 && (jieHasLiuYueHuaLu || jieHasLiuNianHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieShaNum >= 3 && jieHasLiuYueHuaLu){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieHasLiuYueHuaJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(mingShaNum >= 4 && (jieSanFangHasLiuYueHuaJi || jieSanFangHasLiuYueHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieHasLiuNianHuaJi){
		jieSanFangShaNum ++;
	}
	
	if(jieSanFangShaNum >= 4){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 上月-WC1
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC1 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC1_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC1_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('LAST_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuYueMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

// 上月-WC4
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC4 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC4_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WC4_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('LAST_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var caiboSanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var caiboShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(caiboSanFangStars, "LiuYueMingPan");

	var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuYueMingPan, "LiuYueMingPan");
	
	var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
	
	var xiongdiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(xiongdiSanFangStars, "LiuYueMingPan");
	
	var xiongdiHasLiuYueHasJi = false;
	
	var caiboZuoJi = false;
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = caiboSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == siHua){
			caiboZuoJi = true;
			break;
		}
	}
	
	var caiboSanFangHasKongJie = false;
	for(var i = 0; i < caiboSanFangStars.length; i ++){
		var starName = caiboSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			caiboSanFangHasKongJie = true;
			
			break;
		}
	}
	
	
	var xiongdiSanFangHasKongJie = false;
	for(var i = 0; i < xiongdiSanFangStars.length; i ++){
		if(xiongdiSanFangStars[i].getSiHuaOfLiuYue() == "SIHUA_JI"){
			xiongdiHasLiuYueHasJi = true;
		}
		
		var starName = xiongdiSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			xiongdiSanFangHasKongJie = true;
		}
	}
	
	
	
	if(caiboShaNum <= 2 && !xiongdiHasLiuYueHasJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 4){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboZuoJi && xiongdiSanFangHasKongJie && xiongdiShaNum >= 3){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 3 && xiongdiHasLiuYueHasJi && caiboSanFangHasKongJie){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 上月-WX5
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WX5 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WX5_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Last_Month_WX5_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('LAST_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuYueMingPan, "LiuYueMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 下月-WJ3
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WJ3 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WJ3_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WJ3_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('NEXT_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var mingHasHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	var jieHasLiuNianHuaLu = false;
	for(var i = 0; i < mingSanFangStars.length; i ++){
		var liuYueSiHua = mingSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = mingSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua || "SIHUA_JI" == liuNianSiHua){
			mingHasHuaJi = true;
			
			break;
		}
	}
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieTotalStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
		
		if("SIHUA_LU" == liuNianSiHua){
			jieHasLiuNianHuaLu = true;
		}
	}
	
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuNianHuaJi = false;
	
	for(var i = 0; i < jieSanFangSiZhengStars['zuo'].length; i ++){
		var liuYueSiHua = jieSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
	}
	
	var jieSanFangHasLiuYueHuaJi = false;
	var jieSanFangHasLiuYueHuaLu = false;
	for(var i = 0; i < jieSanFangStars.length; i ++){
		var liuYueSiHua = jieSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieSanFangHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_JI" == liuNianSiHua){
			jieHasLiuNianHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieSanFangHasLiuYueHuaLu = true;
		}
	}
	
	var mingShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuYueMingPan");
	var jieShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieTotalStars, "LiuYueMingPan");
	var jieZuoShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangSiZhengStars['zuo'], "LiuYueMingPan"); 
	var jieSanFangShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuYueMingPan"); 
	
	if(mingHasHuaJi && jieZuoShaNum >= 1 && (jieHasLiuYueHuaLu || jieHasLiuNianHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieShaNum >= 3 && jieHasLiuYueHuaLu){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieHasLiuYueHuaJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(mingShaNum >= 4 && (jieSanFangHasLiuYueHuaJi || jieSanFangHasLiuYueHuaLu)){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(jieHasLiuNianHuaJi){
		jieSanFangShaNum ++;
	}
	
	if(jieSanFangShaNum >= 4){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

// 下月-WC1
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC1 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC1_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC1_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('NEXT_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuYueMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

// 下月-WC4
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC4 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC4_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WC4_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('NEXT_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var caiboSanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var caiboShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(caiboSanFangStars, "LiuYueMingPan");

	var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuYueMingPan, "LiuYueMingPan");
	
	var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
	
	var xiongdiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(xiongdiSanFangStars, "LiuYueMingPan");
	
	var xiongdiHasLiuYueHasJi = false;
	
	var caiboZuoJi = false;
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = caiboSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == siHua){
			caiboZuoJi = true;
			break;
		}
	}
	
	var caiboSanFangHasKongJie = false;
	for(var i = 0; i < caiboSanFangStars.length; i ++){
		var starName = caiboSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			caiboSanFangHasKongJie = true;
			
			break;
		}
	}
	
	
	var xiongdiSanFangHasKongJie = false;
	for(var i = 0; i < xiongdiSanFangStars.length; i ++){
		if(xiongdiSanFangStars[i].getSiHuaOfLiuYue() == "SIHUA_JI"){
			xiongdiHasLiuYueHasJi = true;
		}
		
		var starName = xiongdiSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			xiongdiSanFangHasKongJie = true;
		}
	}
	
	
	
	if(caiboShaNum <= 2 && !xiongdiHasLiuYueHasJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 4){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboZuoJi && xiongdiSanFangHasKongJie && xiongdiShaNum >= 3){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 3 && xiongdiHasLiuYueHasJi && caiboSanFangHasKongJie){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

// 下月-WX5
VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WX5 = function()
{
		var result = VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WX5_stub();
		
		return result;
};

VipPrivilegeQuestionAlgorithm.jsMethod4Vip_Next_Month_WX5_stub = function()
{
	var liuYueMingPan = VipPrivilegeQuestionAlgorithm.getLiuYueMingPan('NEXT_MONTH');
	
	if(!liuYueMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuYueMingPan, "LiuYueMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};