/**
 * EnergyCalculator.js
 * 能量计算器
 *
 * @date 2014-02-11
 * @version 0.1
 */
 
 function EnergyCalculator(){
 	
 }
 
 EnergyCalculator.getLevel = function(mingPan, type){
	var gongWeis = ["GONGWEI_MINGGONG", "GONGWEI_SHIYEGONG", "GONGWEI_CAIBOGONG", "GONGWEI_FUQIGONG", "GONGWEI_QIANYIGONG"];
	var energyLevels = new Array();
	
	for(var i = 0; i < gongWeis.length; i ++){
		var energyLevel = false;
		
		if(type == "LiuNianMingPan")
		{
			energyLevel = ZiWeiUtils.getLiuNianEnergy(mingPan, gongWeis[i]);
		}
		else if(type == "LiuRiMingPan")
		{
			energyLevel = ZiWeiUtils.getLiuRiEnergy(mingPan, gongWeis[i]);
		}
		else
		{
			energyLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWeis[i], mingPan, type);
		}

		/*
		if(i >= 1 && "LiuRiMingPan" == type && energyLevels[0] < 6 && energyLevel > 8)
		{
			energyLevel = 8;
		}
		*/
		
		energyLevels.push(energyLevel);
	}
	
	var qianYiGongShaNum = EnergyCalculator.calculateEnergy("GONGWEI_QIANYIGONG", mingPan, type);
	var fuMuGongShaNum = EnergyCalculator.calculateEnergy("GONGWEI_FUMUGONG", mingPan, type);
	var driving = "适宜";
	
	if(qianYiGongShaNum['energy'] >= 4){
		driving = "不宜(注意遵守交规！)";
	}
	
	if(fuMuGongShaNum['energy'] >= 4){
		driving = "不宜(注意摄像头)";
	}
	
	if("LiuRiMingPan" == type)
	{	
		var liuRiTZSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_TIANZHAIGONG", mingPan, "LiuRiMingPan");
		
		for(var c = 0; c < liuRiTZSanFangSiZhengStars['zuo'].length; c ++)
		{
			if(liuRiTZSanFangSiZhengStars['zuo'][c].getSiHuaOfLiuRi() == "SIHUA_JI")
			{
				driving = "不宜(注意磕碰)";
				break;
			}
		}

		/*
		for(var m = 0; m < energyLevels.length; m ++)
		{
			var level = energyLevels[m];
		
			if(level > 8)
			{
				var sections = mingPan.getItems();
		
				for(var i = 0; i < sections.length; i ++)
				{
					if(sections[i].getDayGongWei() == gongWeis[m])
					{
						var stars = sections[i].getStars();
						
						for(var j = 0; j < stars.length; j ++)
						{
							if(stars[j].getName() == "FIENDSTAR_DIJIEXING")
							{
								level = 6;
							}
							
							if(stars[j].getName() == "FIENDSTAR_TUOLUOXING" || stars[j].getName() == "FIENDSTAR_QINGYANGXING" ||stars[j].getName() == "FIENDSTAR_HUOXING" ||stars[j].getName() == "FIENDSTAR_LINGXING")
							{
								if(stars[j].getDescriptor() == "MIAOWANG_XIAN")
								{
									level = 6;
								}
							}
						}
						
						break;
					}
				}
				
				if(level != 6)
				{
					var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWeis[m], mingPan, "LiuRiMingPan");
					var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);
					
					for(var i = 0; i < sanFangStars.length; i ++)
					{
						if("SIHUA_JI" == sanFangStars[i].getSiHuaOfLiuRi())
						{
							level = 6;
							break;
						}
					}
				}

				energyLevels[m] = level;
			}
		}
		*/
	}
	
	var result = {
		"level" : energyLevels[0],
/*		"work" : EnergyCalculator.findDescriptionByEnergyLevel("work", energyLevels[1]),
		"money" : EnergyCalculator.findDescriptionByEnergyLevel("money", energyLevels[2]),
		"emotion" : EnergyCalculator.findDescriptionByEnergyLevel("emotion", energyLevels[3]),
		"out" : EnergyCalculator.findDescriptionByEnergyLevel("out", energyLevels[4]), */
		"work" : energyLevels[1],
		"money" : energyLevels[2],
		"emotion" : energyLevels[3],
		"out" : energyLevels[4], 
		"driving" : driving
	};
	
	return result;
 };
 
 EnergyCalculator.findDescriptionByEnergyLevel = function(type, level){
	var index = Math.ceil(level / 4);
	switch(type.toUpperCase()){
		case "WORK" : {
			return ["负能量", "正负能量", "正能量"][index - 1];
		}
		case "MONEY" : {
			return ["负能量(破财)", "正负能量", "正能量(赚财)"][index - 1];
		}
		case "EMOTION" : {
			return ["负能量", "正负能量", "正能量"][index - 1];
		}
		case "OUT" : {
			return ["负能量", "正负能量", "正能量"][index - 1];
		}
	}
 };
 
 	/**
	 * 重新计算财帛宫能量
	 */
 EnergyCalculator.recalcCaiBoLevel = function(level, mingPan, mingPanType)
{
	if ("XianTianMingPan" == mingPanType)
	{
		if (level < 9)
		{
			return level;
		}

		var c2Result = eval("("+ MingShuQuestionsAlgorithm.iosInvoked_C2_al() +")");
		var c3Result = eval("("+ MingShuQuestionsAlgorithm.iosInvoked_C3_al() +")");
		var c4Result = eval("("+ MingShuQuestionsAlgorithm.iosInvoked_C4_al() +")");

		var meetNum = 0;

		if (c2Result.request == "A")
		{
			meetNum++;
		}

		if (c3Result.request == "A")
		{
			meetNum++;
		}

		if (c4Result.request == "A")
		{
			meetNum++;
		}

		if (meetNum == 3)
		{
			return 12;
		}

		if (meetNum > 1)
		{
			return 11;
		}

		if (meetNum > 0)
		{
			return 10;
		}

		return 9;
	}

	if ("DaYunMingPan" == mingPanType)
	{
		var daYunMingPan = mingPan;
		var caiBoSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_CAIBOGONG", daYunMingPan, "DaYunMingPan");
		var zuoStars = caiBoSanFangSiZhengStars['zuo'];

		var hasLu = false;
		var wuQuTanLangHuaLu = false;

		for (var i = 0; i < zuoStars.length; i ++)
		{
			var star = zuoStars[i];
			
			if (star.getSiHuaOfDaYun() == "SIHUA_LU")
			{
				hasLu = true;

				if (star.getName() == "MAINSTAR_WUQUXING" || star.getName() == "MAINSTAR_TANLANGXING")
				{
					wuQuTanLangHuaLu = true;
					break;
				}
			}
		}

		var tianZhaiSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_TIANZHAIGONG", daYunMingPan, "DaYunMingPan");
		var tianZhaiZuoStars = tianZhaiSanFangSiZhengStars['zuo'];
		var dyTianZhaiHasResult = [false, false, false];
		
		for(var i = 0; i < tianZhaiZuoStars.length; i ++)
		{
			var star = tianZhaiZuoStars[i];
			var starName = star.getName();
			
			if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_LIANZHENXING" || starName == "MAINSTAR_WUQUXING" || starName == "MAINSTAR_TIANFUXING" || starName == "MAINSTAR_TIANXIANGXING")
			{
				dyTianZhaiHasResult[0] = true;
			}
			
			if(starName == "GEMSTAR_LUCUNXING")
			{
				dyTianZhaiHasResult[1] = true;
			}
			
			if(star.getSiHuaOfDaYun() == "SIHUA_LU")
			{
				dyTianZhaiHasResult[2] = true;
			}
		}			

		var dyTzStars = daYunMingPan.getDaYunGongWei("GONGWEI_TIANZHAIGONG").getDaYunStars();
		var dyTzHasYunLu = false;

		if (!dyTzStars)
		{
			for (var m = 0; m < dyTzStars.length; m ++)
			{
				if (dyTzStars[m].starName == "YUN_GEMSTAR_LUCUNXING")
				{
					dyTzHasYunLu = true;
					break;
				}
			}
		}
		
		var tianZhaiSanFangStars = tianZhaiSanFangSiZhengStars['zuo'].concat(tianZhaiSanFangSiZhengStars['dui']);
		var dyTianZhaiSanFangHasResult = [false, false];
		var xtTianZhaiSanFangHasResult = false;
		
		for(var i = 0; i < tianZhaiSanFangStars.length; i ++)
		{
			var star = tianZhaiSanFangStars[i];
			
			if(star.getName() == "GEMSTAR_LUCUNXING")
			{
				dyTianZhaiSanFangHasResult[0] = true;
			}
			
			if(star.getSiHuaOfDaYun() == "SIHUA_LU")
			{
				dyTianZhaiSanFangHasResult[1] = true;
			}
			
			if(star.getSiXiang() == "SIHUA_LU")
			{
				xtTianZhaiSanFangHasResult = true;
			}
		}

		if (ZiWeiUtils.hasStrongStar(zuoStars))
		{
			if (hasLu)
			{
				if (level > 9)
				{
					return 12;
				}

				return 11;
			}

			if (wuQuTanLangHuaLu)
			{
				return 12;
			}

			if (dyTianZhaiSanFangHasResult[0] && dyTianZhaiSanFangHasResult[1])
			{
				return 10;
			}
		}
		else
		{
			if (hasLu && dyTianZhaiHasResult[0] && (dyTianZhaiSanFangHasResult[0] || dyTianZhaiSanFangHasResult[1]
					|| xtTianZhaiSanFangHasResult))
			{
				return 11;
			}

			if (dyTianZhaiHasResult[2] || dyTianZhaiHasResult[1] || dyTianZhaiSanFangHasResult[1]
					|| xtTianZhaiSanFangHasResult || dyTzHasYunLu)
			{
				return 10;
			}
		}

		var sections = ZiWeiUtils.getGongWeiBySiHua(daYunMingPan, "DaYunMingPan", ["SIHUA_LU"]);

		for (var i = 0; i < sections.length; i ++)
		{
			var dyGongWei = sections[i].getDaYunGongWei();

			if (dyGongWei == "GONGWEI_CAIBOGONG" || dyGongWei == "GONGWEI_TIANZHAIGONG")
			{
				return 9;
			}
		}

		var mingSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", daYunMingPan, "DaYunMingPan");
		var mingZuoStars = mingSanFangSiZhengStars['zuo'];

		if (dyTianZhaiSanFangHasResult[0] || dyTianZhaiSanFangHasResult[1] || dyTzHasYunLu)
		{
			for(var i = 0; i < mingZuoStars.length; i ++)
			{
				var starName = mingZuoStars[i].getName();
				
				if(starName == "MAINSTAR_TIANFUXING" || starName == "MAINSTAR_WUQUXING")
				{
					return 9;
				}
			}
		}

		if (dyTianZhaiSanFangHasResult[1] || dyTzHasYunLu)
		{
			for(var i = 0; i < mingZuoStars.length; i ++)
			{
				if(mingZuoStars[i].getSiXiang() == "SIHUA_LU")
				{
					var starName = mingZuoStars[i].getName();
				
					if(starName == "MAINSTAR_TIANFUXING" || starName == "MAINSTAR_WUQUXING")
					{
						return 9;
					}
				}
			}
		}

		if (level > 8)
		{
			return 9;
		}

		return level;
	}

	if ("LiuNianMingPan" == mingPanType)
	{
		var liuNianMingPan = mingPan;
		var meetNum = 0;
		var tianZhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(
				"GONGWEI_TIANZHAIGONG", liuNianMingPan, "LiuNianMingPan");
		var tianZhaiZuoStars = tianZhaiSanFangSiZhengStars['zuo'];
		var tianZhaiTotalStars = tianZhaiSanFangSiZhengStars['zuo'].concat(tianZhaiSanFangSiZhengStars['hui'], tianZhaiSanFangSiZhengStars['dui']);
		
		for(var i  = 0; i < tianZhaiZuoStars.length; i ++)
		{
			var starName = tianZhaiZuoStars[i].getName();
			
			if(starName == "MAINSTAR_TIANFUXING" || starName == "MAINSTAR_WUQUXING")
			{
				meetNum++;
			}
		}
		
		for(var i = 0; i < tianZhaiTotalStars.length; i ++)
		{
			if(tianZhaiTotalStars[i].getSiHuaOfLiuNian() == "SIHUA_LU" || tianZhaiTotalStars[i].getSiHuaOfLiuNian() == "SIHUA_KE")
			{
				meetNum++;
			}
		}

		var caiBoSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars("GONGWEI_CAIBOGONG", liuNianMingPan, "LiuNianMingPan");
		var caiBoZuoStars = caiBoSanFangSiZhengStars['zuo'];
		var gemStarNum = 0;	
		
		for(var i = 0; i < caiBoZuoStars.length; i ++)
		{
			var star = caiBoZuoStars[i];
			var starName = star.getName();
			
			if(star.getSiHuaOfDaYun() == "SIHUA_LU")
			{
				meetNum++;
			}
			
			if (star.getSiHuaOfLiuNian() == "SIHUA_LU")
			{
				if(starName == "MAINSTAR_TAIYINXING" || starName == "MAINSTAR_WUQUXING")
				{
					meetNum++;
				}
			}
			
			if(starName.indexOf("GEMSTAR_") >= 0)
			{
				gemStarNum++;
			}
		}

		var mingGongLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuNianMingPan,
				"LiuNianMingPan");

		if (mingGongLevel > 8 || level > 8)
		{
			meetNum++;
		}

		if (gemStarNum >= 2)
		{
			meetNum++;
		}

		var totalStars = caiBoSanFangSiZhengStars['zuo'].concat(caiBoSanFangSiZhengStars['hui'], caiBoSanFangSiZhengStars['dui']);
		var hasTianMa = false;
		var hasLiuNianHuaLu = false;
		var hasDaYunHuaLu = false;

		for (var i  = 0; i < totalStars.length; i ++)
		{
			var star = totalStars[i];
			
			if (star.getName() == "GEMSTAR_TIANMAXING")
			{
				hasTianMa = true;
			}

			if (star.getSiHuaOfLiuNian() == "SIHUA_LU")
			{
				hasLiuNianHuaLu = true;
			}

			if (star.getSiHuaOfDaYun() == "SIHUA_LU")
			{
				hasDaYunHuaLu = true;
			}
		}

		var liuNianMingPanCaiBoSection = liuNianMingPan.getLiuNianGongWei("GONGWEI_CAIBOGONG");
		var sections = liuNianMingPan.getItems();
		var sanFangSiZhengSections = [];
		sanFangSiZhengSections[0] = liuNianMingPanCaiBoSection;
		sanFangSiZhengSections[1] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 6) % 12];
		sanFangSiZhengSections[2] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 4) % 12];
		sanFangSiZhengSections[3] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 8) % 12];

		var hasDaYunLuCun = false;
		var hasLiuNianLuCun = false;

		for (var i = 0; i < sanFangSiZhengSections.length; i ++)
		{
			var liuNianMingPanSection = sanFangSiZhengSections[i];
			var daYunStars = liuNianMingPanSection.getDaYunStars();

			if (!daYunStars)
			{
				for (var m = 0; m < daYunStars.length; m ++)
				{
					if (daYunStars[m].starName == "YUN_GEMSTAR_LUCUNXING")
					{
						hasDaYunLuCun = true;
						break;
					}
				}
			}

			var liuNianStars = liuNianMingPanSection.getLiuNianStars();

			if (liuNianStars)
			{
				for (var m = 0; m < liuNianStars.length; m ++)
				{					
					if (liuNianStars[m].starName == "LIU_GEMSTAR_LUCUNXING")
					{
						hasLiuNianLuCun = true;
						break;
					}
				}
			}
		}

		if ((hasLiuNianHuaLu || hasDaYunHuaLu || hasDaYunLuCun || hasLiuNianLuCun) && hasTianMa)
		{
			meetNum++;
		}

		if (meetNum >= 4)
		{
			return 12;
		}

		if (meetNum == 3)
		{
			return 11;
		}

		if (meetNum == 2)
		{
			return 10;
		}

		if (level > 9)
		{
			return 9;
		}

		return level;
	}

	if ("LiuYueMingPan" == mingPanType)
	{
		var liuYueMingPan = mingPan;
		var meetNum = 0;
		var tianZhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_TIANZHAIGONG", liuYueMingPan, "LiuYueMingPan");
		var tianZhaiZuoStars = tianZhaiSanFangSiZhengStars['zuo'];
		
		for(var i = 0; i < tianZhaiZuoStars.length; i ++)
		{
			if(tianZhaiZuoStars[i].getName() == "MAINSTAR_WUQUXING" || tianZhaiZuoStars[i].getName() == "MAINSTAR_TIANFUXING")
			{
				meetNum++;
				break;
			}
		}

		var tianZhaiTotalStars = tianZhaiSanFangSiZhengStars['zuo'].concat(tianZhaiSanFangSiZhengStars['hui'], tianZhaiSanFangSiZhengStars['dui']);
		
		for(var i = 0; i < tianZhaiTotalStars.length; i ++)
		{
			if(tianZhaiTotalStars[i].getSiHuaOfLiuYue() == "SIHUA_LU" || tianZhaiTotalStars[i].getSiHuaOfLiuYue() == "SIHUA_KE")
			{
				meetNum++;
				break;
			}
		}

		var caiBoSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStarsWithAllStars("GONGWEI_CAIBOGONG", liuYueMingPan, "LiuYueMingPan");
		var caiBoZuoStars = caiBoSanFangSiZhengStars['zuo'];
		var gemStarNum = 0;

		for(var i  = 0 ; i < caiBoZuoStars.length; i ++)
		{
			if(caiBoZuoStars[i].getSiHuaOfLiuNian() == "SIHUA_LU")
			{
				meetNum++;
			}
			
			if (caiBoZuoStars[i].getSiHuaOfLiuYue() == "SIHUA_LU")
			{
				if (caiBoZuoStars[i].getName() == "MAINSTAR_WUQUXING" || caiBoZuoStars[i].getName() == "MAINSTAR_TAIYINXING")
				{
					meetNum++;
				}
			}
			
			if(caiBoZuoStars[i].getName().indexOf("GEMSTAR_") >= 0)
			{
				gemStarNum++;
			}
		}

		var mingGongLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuYueMingPan,
				"LiuYueMingPan");

		if (mingGongLevel > 8 || level > 8)
		{
			meetNum++;
		}

		if (gemStarNum >= 2)
		{
			meetNum++;
		}

		var totalStars = caiBoSanFangSiZhengStars['zuo'].concat(caiBoSanFangSiZhengStars['hui'], caiBoSanFangSiZhengStars['dui']);
		var hasTianMa = false;
		var hasLiuNianHuaLu = false;
		var hasLiuYueHuaLu = false;

		for (var i = 0; i < totalStars.length; i ++)
		{
			var star = totalStars[i];
			
			if (star.getName() == "GEMSTAR_TIANMAXING")
			{
				hasTianMa = true;
			}

			if (star.getSiHuaOfLiuNian() == "SIHUA_LU")
			{
				hasLiuNianHuaLu = true;
			}

			if (star.getSiHuaOfLiuYue() == "SIHUA_LU")
			{
				hasLiuYueHuaLu = true;
			}
		}

		var liuNianMingPanCaiBoSection = liuYueMingPan.getLiuYueGongWei("GONGWEI_CAIBOGONG");
		var sections = liuYueMingPan.getItems();
		var sanFangSiZhengSections = [];
		sanFangSiZhengSections[0] = liuNianMingPanCaiBoSection;
		sanFangSiZhengSections[1] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 6) % 12];
		sanFangSiZhengSections[2] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 4) % 12];
		sanFangSiZhengSections[3] = sections[(liuNianMingPanCaiBoSection.getIndex() - 1 + 8) % 12];

		var hasLiuNianLuCun = false;

		for (var i = 0; i < sanFangSiZhengSections.length; i ++)
		{
			var liuNianStars = sanFangSiZhengSections[i].getLiuNianStars();

			if (liuNianStars)
			{
				for (var m = 0; m < liuNianStars.length; m ++)
				{					
					if (liuNianStars[m].starName == "LIU_GEMSTAR_LUCUNXING")
					{
						hasLiuNianLuCun = true;
						break;
					}
				}
			}
		}

		if ((hasLiuNianHuaLu || hasLiuYueHuaLu || hasLiuNianLuCun) && hasTianMa)
		{
			meetNum++;
		}

		if (meetNum >= 4)
		{
			return 12;
		}

		if (meetNum == 3)
		{
			return 11;
		}

		if (meetNum == 2)
		{
			return 10;
		}

		if (level > 9)
		{
			return 9;
		}

		return level;
	}

	if ("LiuRiMingPan" == mingPanType)
	{
		var liuRiMingPan = mingPan;
		var meetNum = 0;
		var tianZhaiSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_TIANZHAIGONG", liuRiMingPan, "LiuRiMingPan");
		var caiBoSanFangSiZhengStars = EnergyCalculator
					.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_CAIBOGONG", liuRiMingPan, "LiuRiMingPan");
		var sanFangStars = tianZhaiSanFangSiZhengStars['zuo'].concat(tianZhaiSanFangSiZhengStars['hui']);
		var totalStars = sanFangStars.concat(tianZhaiSanFangSiZhengStars['dui']);
		var caiBoZuoStars = caiBoSanFangSiZhengStars['zuo'];
		
		for (var i = 0; i < sanFangStars.length; i ++)
		{
			var star = sanFangStars[i];
			
			if (star.getSiHuaOfLiuRi() == "SIHUA_LU")
			{
				if (star.getName() == "MAINSTAR_WUQUXING")
				{
					meetNum++;
				}
			}
		}
		
		for(var i = 0; i < caiBoZuoStars.length; i ++)
		{
			if(caiBoZuoStars[i].getSiHuaOfLiuYue() == "SIHUA_LU")
			{
				meetNum++;
			}
		}

		for (var i = 0; i < totalStars.length; i ++)
		{
			var star = totalStars[i];
			
			if (star.getSiHuaOfLiuRi() == "SIHUA_LU")
			{
				meetNum++;
			}

			if (star.getSiHuaOfLiuRi() == "SIHUA_KE")
			{
				meetNum++;
			}
		}

		var zuoStars = tianZhaiSanFangSiZhengStars['zuo'];
		var meetTip5 = false;

		for (var i = 0; i < zuoStars.length; i ++)
		{
			var star = zuoStars[i];
			
			if (star.getSiHuaOfLiuYue() == "SIHUA_LU")
			{
				meetNum++;
				
				var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(
						"GONGWEI_MINGGONG", liuRiMingPan, "LiuRiMingPan");
				var mingZuoStars = mingSanFangSiZhengStars['zuo'];
				
				for(var j = 0; j < mingZuoStars.length; j ++)
				{
					var siHua = mingZuoStars[j].getSiHuaOfLiuRi();
					
					if(siHua == "SIHUA_LU" || siHua == "SIHUA_QUAN" || siHua == "SIHUA_KE")
					{
						meetNum++;
						meetTip5 = true;
						break;
					}
					else
					{
						for (var j = 0; j < liuRiMingPan.getItems().length; j ++)
						{
							var section = liuRiMingPan.getItems()[j];
							var stars = section.getStars();

							for (var m  = 0; m < stars.length; m ++)
							{
								var sectionStar = stars[m];
								
								if (sectionStar.getSiHuaOfLiuRi() == "SIHUA_JI")
								{
									if (section.getDiZhi() == "DIZHI_CHEN" || section.getDiZhi() == "DIZHI_XU"
											|| section.getDiZhi() == "DIZHI_CHOU" || section.getDiZhi() == "DIZHI_WEI")
									{
										meetNum++;
										meetTip5 = true;
										break;
									}
								}
							}
						}
					}
				}
			}
		}

		if (meetNum >= 3)
		{
			return 12;
		}

		if (meetNum == 2)
		{
			return 11;
		}

		if (meetNum == 1)
		{
			if (meetTip5)
			{
				return 9;
			}
			else
			{
				return 10;
			}
		}

		if (level > 8)
		{
			return 9;
		}

		var caiBoSanFangStars = caiBoSanFangSiZhengStars['zuo'].concat(caiBoSanFangSiZhengStars['hui']);

		if (level < 5)
		{
			for(var i = 0; i < caiBoSanFangStars.length; i ++)
			{
				if(caiBoSanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_JI")
				{
					return 1;
				}
			}
		}

		var liuRiTianZhaiLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_TIANZHAIGONG", liuRiMingPan, "LiuRiMingPan");

		if (liuRiTianZhaiLevel < 5)
		{
			for(var i = 0; i < sanFangStars.length; i ++)
			{
				if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_JI")
				{
					return 1;
				}
			}
		}

		var gongWei = ZiWeiUtils.getGongWeiByStar(liuRiMingPan, "FIENDSTAR_DIJIEXING").getDayGongWei();
		var gongWeiSanFangSiZhengStars = EnergyCalculator
				.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuRiMingPan, "LiuRiMingPan");
		var gongWeiTotalStars = gongWeiSanFangSiZhengStars['zuo'].concat(gongWeiSanFangSiZhengStars['hui'], gongWeiSanFangSiZhengStars['dui']);
				
		for(var i = 0; i < gongWeiTotalStars.length; i ++)
		{
			if(gongWeiTotalStars[i].getSiHuaOfLiuRi() == "SIHUA_JI")
			{
				return 2;
			}
		}
		
		var caiBoSanFangHasJi = false;
		var caiBoSanFangHasLu = false;
		var caiBoSanFangHasKongJieQingYang = false;
		
		for(var i = 0; i < caiBoSanFangStars.length; i ++)
		{
			var star = caiBoSanFangStars[i];
			var starName = star.getName();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING" || starName == "FIENDSTAR_QINGYANGXING")
			{
				caiBoSanFangHasKongJieQingYang = true;
			}
			
			if(star.getSiHuaOfLiuRi() == "SIHUA_JI")
			{
				caiBoSanFangHasJi = true;
			}
			
			if(star.getSiHuaOfLiuRi() == "SIHUA_LU")
			{
				caiBoSanFangHasLu = true;
			}
		}

		if (caiBoSanFangHasJi && caiBoSanFangHasKongJieQingYang)
		{
			return 2;
		}

		var tianZhaiSanFangHasJi = false;
		var tianZhaiSanFangHasLu = false;
		var tianZhaiSanFangHasKongJieQingYang = false;
		
		for(var i = 0; i < sanFangStars.length; i ++)
		{
			var star = sanFangStars[i];
			var starName = star.getName();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING" || starName == "FIENDSTAR_QINGYANGXING")
			{
				tianZhaiSanFangHasKongJieQingYang = true;
			}
			
			if(star.getSiHuaOfLiuRi() == "SIHUA_JI")
			{
				tianZhaiSanFangHasJi = true;
			}
			
			if(star.getSiHuaOfLiuRi() == "SIHUA_LU")
			{
				tianZhaiSanFangHasLu = true;
			}
		}

		if (tianZhaiSanFangHasJi && tianZhaiSanFangHasKongJieQingYang)
		{
			return 2;
		}

		if(caiBoSanFangHasJi && !caiBoSanFangHasLu)
		{
			return 3;
		}
		
		if(tianZhaiSanFangHasJi && !tianZhaiSanFangHasLu)
		{
			return 3;
		}

		if (level < 5)
		{
			return 4;
		}

		return level;
	}

	return 1;
}

EnergyCalculator.recalcLiuRiEnergy = function(liuRiMingPan, level, gongWei)
{
	if (level < 9 && level != 1)
	{
		return level;
	}

	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei,
			liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);

	var hasLiuRiHuaJi = false;
	var sanFangSiZhengHasKongJie = false;

	for (var i = 0; i < sanFangStars.length; i++)
	{
		var star = sanFangStars[i];
		var starName = star.getName();

		if ("FIENDSTAR_DIJIEXING" == starName || "FIENDSTAR_DIKONGXING" == starName)
		{
			if (star.getDescriptor() != "MIAOWANG_MIAO" && star.getDescriptor() != "MIAOWANG_WANG")
			{
				sanFangSiZhengHasKongJie = true;
			}
		}

		if ("SIHUA_JI" == star.getSiHuaOfLiuRi())
		{
			hasLiuRiHuaJi = true;
		}
	}

	if (level > 8 && sanFangSiZhengHasKongJie)
	{
		level = 8;
	}

	if (level >= 9)
	{
		var sections = liuRiMingPan.getItems();

		for (var i = 0; i < sections.length; i++)
		{
			if (sections[i].getDayGongWei() == gongWei)
			{
				var stars = sections[i].getStars();

				for (var j = 0; j < stars.length; j++)
				{
					var star = stars[j];

					if (star.getName() == "FIENDSTAR_DIJIEXING")
					{
						return 6;
					}

					if (star.getName() == "FIENDSTAR_TUOLUOXING" || star.getName() == "FIENDSTAR_QINGYANGXING"
							|| star.getName() == "FIENDSTAR_HUOXING" || star.getName() == "FIENDSTAR_LINGXING")
					{
						if (star.getDescriptor() == "MIAOWANG_XIAN")
						{
							return 6;
						}
					}
				}

				break;
			}
		}

		if (level != 6 && hasLiuRiHuaJi)
		{
			level = 6;
		}
	}

	var liuYueLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuRiMingPan, "LiuYueMingPan");

	if (level == 12 || level == 1)
	{
		if (level == 12 && liuYueLevel < 9)
		{
			level = 11;
		}

		if (level == 1 && liuYueLevel > 4)
		{
			level = 2;
		}
	}

	if (liuYueLevel < 4 && level > 8)
	{
		level = 8;
	}

	return level;
}

 
 EnergyCalculator.getSpecifyGongWeiEnergyLevel= function(gongWei, mingPan, mingPanType)
 {
	 	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel2(gongWei, mingPan, mingPanType);

		if ("GONGWEI_MINGGONG" == gongWei && mingPanType == "LiuRiMingPan")
		{
			if (level < 5)
			{
				if (ZiWeiUtils.isEmptyGongWei(mingPan.getLiuRiGongWei("GONGWEI_MINGGONG")))
				{
					return 7;
				}
			}
			
			return EnergyCalculator.recalcLiuRiEnergy(mingPan, level, gongWei);
		}

		if ("GONGWEI_CAIBOGONG" == gongWei && mingPanType != "LiuShiMingPan" && mingPanType != "LiuFenMingPan")
		{
			return EnergyCalculator.recalcCaiBoLevel(level, mingPan, mingPanType);
		}
		
		if ("XianTianMingPan" == mingPanType || "DaYunMingPan" == mingPanType || "LiuNianMingPan" == mingPanType)
		{
			return level;
		}

		var meetCondition = false;

		var xtMingLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel2("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");

		if (xtMingLevel > 10)
		{
			var xtFMLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel2("GONGWEI_FUMUGONG", mingPan, "XianTianMingPan");
			meetCondition = xtFMLevel < 5;

			if (!meetCondition)
			{
				var xtZNLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel2("GONGWEI_ZINVGONG", mingPan, "XianTianMingPan");
				meetCondition = xtZNLevel < 5;
			}

			if (!meetCondition)
			{
				var xtTZLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel2("GONGWEI_TIANZHAIGONG", mingPan, "XianTianMingPan");
				meetCondition = xtTZLevel < 5;
			}
		}

		if (meetCondition)
		{
			var sangFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, mingPan,
					mingPanType);
			var totalStars = sangFangSiZhengStars['zuo'].concat(sangFangSiZhengStars['hui'], sangFangSiZhengStars['dui']);
			var hasLu = false, hasQuan = false, hasKe = false, hasJi = false;
			var selectSiHuaMethod = false;
			switch(mingPanType)
			{				
			case "LiuYueMingPan" : {
				selectSiHuaMethod = "_siHuaOfLiuYue";
				break;
			}
			case "LiuRiMingPan" : {
				selectSiHuaMethod = "_siHuaOfLiuRi";
				break;
			}
			case "LiuShiMingPan" : {
				selectSiHuaMethod = "_siHuaOfLiuShi";
				break;
			}
			}
			
			for(var i = 0; i < totalStars.length; i ++)
			{
				var star = totalStars[i];
				var siXiang = star[selectSiHuaMethod];
				
				if(siXiang == "SIHUA_LU")
				{
					hasLu = true;
				}
				
				if(siXiang == "SIHUA_QUAN")
				{
					hasQuan = true;
				}
				
				if(siXiang == "SIHUA_KE")
				{
					hasKe = true;
				}
				
				if(siXiang == "SIHUA_JI")
				{
					hasJi = true;
				}
			}
			
			if (level > 8)
			{
				if (hasLu)
				{
					return level;
				}

				if (hasQuan || hasKe)
				{
					return level - 2;
				}

				if (!(hasLu || hasQuan || hasKe))
				{
					return 8;
				}
			}

			if (level < 5)
			{
				if (hasQuan || hasJi)
				{
					return level;
				}

				if (hasLu || hasKe)
				{
					return level + 2;
				}

				if (!(hasLu || hasQuan || hasKe || hasJi))
				{
					return 5;
				}
			}
		}

		return level;
 }
 
 EnergyCalculator.getSpecifyGongWeiEnergyLevel2 = function(gongWei, mingPan, type){
	var totalEnergy = EnergyCalculator.calculateEnergy(gongWei, mingPan, type);
	
	if(!totalEnergy){
		return false;
	}
	
	var energy = totalEnergy['energy'];
	var timePointLu = totalEnergy['timePointLu'];
	var mainStarIsStrong = totalEnergy['mainStarIsStrong'];
	var huiGemStarsNum = totalEnergy['huiGemStarsNum'];
	var zuoGemStarsNum = totalEnergy['zuoGemStarsNum'];
	var duiGemStarsNum = totalEnergy['duiGemStarsNum'];
	var zuoMainStarIsGood = totalEnergy['zuoMainStarIsGood'];
	var totalGemStarsNum = huiGemStarsNum + zuoGemStarsNum + duiGemStarsNum;
	
	zuoMainStarIsGood = zuoMainStarIsGood ? 1 : 0;
	
	if(mainStarIsStrong){
		if(energy <= 1 && timePointLu > 0){
			return 12;
		}
		
		if(energy <= 2){
			return 11 + zuoMainStarIsGood;
		}
		
		if(energy >= 2.25 && energy <= 3 &&  timePointLu > 0){
			return 10 + zuoMainStarIsGood;
		}
		
		if(energy >= 2.25 && energy <= 3){
			return 9 + zuoMainStarIsGood;
		}
		
		if(energy >= 3.25 && energy <= 4.5 && totalGemStarsNum >= 2){
			return 8 + zuoMainStarIsGood;
		}
		
		if(energy >= 3.25 && energy <= 4.5 && totalGemStarsNum < 2){
			return 7 + zuoMainStarIsGood;
		}
		
		if(energy <= 5 && energy >= 4.75 && totalGemStarsNum >= 3){
			return 5 + zuoMainStarIsGood;
		}
		
		if(energy <= 5 && energy >= 4.75 && totalGemStarsNum <= 2){
			return 4 + zuoMainStarIsGood;
		}
		
		if(energy <= 5.25){
			return 3 + zuoMainStarIsGood;
		}
		
		if(energy <= 5.75 && energy >= 5.5){
			return 2 + zuoMainStarIsGood;
		}
		
		if(energy >= 6){
			return 1 + zuoMainStarIsGood;
		}
	}else{
		if(energy <= 0.5 && timePointLu > 0){
			return 10 + zuoMainStarIsGood;
		}
	
		if(energy <= 0.75){
			return 9 + zuoMainStarIsGood;
		}
		
		if(energy <= 1.5 && energy >= 0.75 && timePointLu > 0){
			return 9 + zuoMainStarIsGood;
		}
		
		if(energy <= 1.5 && energy >= 0.75){
			return 8 + zuoMainStarIsGood;
		}
		
		if(energy <= 2.5 && energy >= 1.75){
			return 7 + zuoMainStarIsGood;
		}
		
		if(energy <= 4.5 && energy >= 3 && zuoGemStarsNum >= 3){
			return 7 + zuoMainStarIsGood;
		}
		
		if(energy <= 3 && energy >= 2.75){
			return 6 + zuoMainStarIsGood;
		}
		
		if(energy <= 4.5 && energy >= 3 && zuoGemStarsNum >= 2 && (huiGemStarsNum + duiGemStarsNum) >= 1){
			return 6 + zuoMainStarIsGood;
		}
		
		if(energy <= 4.5 && energy >= 3 && totalGemStarsNum >= 3){
			return 5 + zuoMainStarIsGood;
		}
		
		if(energy <= 4.5 && energy >= 3 && totalGemStarsNum <= 2){
			return 3 + zuoMainStarIsGood;
		}
		
		if(energy <= 5 && energy >= 4.75){
			return 2 + zuoMainStarIsGood;
		}
		
		if(energy >= 5.25){
			return 1 + zuoMainStarIsGood;
		}
	}
	
	return false;
 };
 
 EnergyCalculator.ifIsGood = function(gongWei, mingPan, type){
 	
 };
 
 EnergyCalculator.calculateEnergy = function(gongWei, mingPan, type){
	if(!mingPan){
		return false;
	}
	
	if(mingPan.constructor.name != 'MingPan'){
		return false;
	}
	
	var sanFangSiZheng = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, mingPan, type);
	
	if(!sanFangSiZheng){
		return false;
	}
	
	var energy = 0;
	var timePointLu = 0;
	var mainStarIsStrong = false;
	var huiGemStarsNum = 0;
	var zuoGemStarsNum = 0;
	var duiGemStarsNum = 0;
	var zuoMainStarIsGood = false;
	
	var zuoStars = sanFangSiZheng['zuo'];
	var huiStars = sanFangSiZheng['hui'];
	var duiStars = sanFangSiZheng['dui'];
	
	var siHua = EnergyCalculator.getParentSiHua(type);
	
	var mainStarAllBad = false;
	// 坐
	for(var i = 0; i < zuoStars.length; i ++){
		var hasJi = false;
		var hasSha = false;
		var hasZiWeiAndDescriptorIsGood = false;
		
		var starName = zuoStars[i].getName();
		var descriptor = zuoStars[i].getDescriptor();

		if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_WUQUXING" || starName == "MAINSTAR_TIANFUXING" ||
		   starName == "MAINSTAR_TIANXIANGXING" || starName == "MAINSTAR_LIANZHENXING" || starName == "MAINSTAR_QISHAXING" ||
		   starName == "MAINSTAR_POJUNXING" || starName == "MAINSTAR_TANLANGXING"){
			mainStarIsStrong = true;
		}
		
		if(starName == "MAINSTAR_ZIWEIXING" && ("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor)){
			hasZiWeiAndDescriptorIsGood = true;
		}
		
		var ji = "";
		eval("ji = zuoStars[i]." +siHua['parentSiHua']);    // 上一代

		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.5;
			}else{
				energy ++;
			}
			
			hasJi = true;
		}
		
		eval("ji = zuoStars[i]." +siHua['selfSiHua']);      // 本代
		
		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy ++;
			}else{
				energy += 2;
			}
			
			hasJi = true;
		}
		
		var lu = "";
			
		eval("lu = zuoStars[i] ." +siHua['selfSiHua']);
		
		if("SIHUA_LU" == lu){
			timePointLu ++;
			
			zuoGemStarsNum ++;
		}
		
		// 主星
		if(starName.indexOf("MAINSTAR_") >= 0){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				mainStarAllBad = true;
			}
		}
		
		// 煞星
		if(starName.indexOf("FIENDSTAR_") >= 0){			
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy ++;
			}else{
				energy += 2;
			}
			
			hasSha = true;
		}
		
		// 吉星
		if(starName.indexOf("GEMSTAR_") >= 0){		
			zuoGemStarsNum ++;
		}
	}
	
	if(hasZiWeiAndDescriptorIsGood && !(hasJi || hasSha)){
		zuoMainStarIsGood = true;
	}
	
	// 坐的主星落陷平也算一个煞
	if(!mainStarAllBad){
		energy ++;
	}
	
	// 会
	for(var i = 0; i < huiStars.length; i ++){
		var starName = huiStars[i].getName();
		var descriptor = huiStars[i].getDescriptor();
		
		var ji = "";
		eval("ji = huiStars[i]." +siHua['parentSiHua']);    // 上一代
		
		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.25;
			}else{
				energy += 0.5;
			}
		}
		
		eval("ji = huiStars[i]." +siHua['selfSiHua']);      // 本代
		
		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.5;
			}else{
				energy ++;
			}
		}
		
		var lu = "";
		
		eval("lu = huiStars[i]." +siHua['selfSiHua']);
		
		if("SIHUA_LU" == lu){
			timePointLu ++;
			huiGemStarsNum ++;
		}
		
		// 主星
		if(starName.indexOf("MAINSTAR_") >= 0){
			
		}
		
		// 煞星
		if(starName.indexOf("FIENDSTAR_") >= 0){			
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.5;
			}else{
				energy ++ ;
			}
		}
		
		// 吉星
		if(starName.indexOf("GEMSTAR_") >= 0){	
			huiGemStarsNum ++;
		}
	}
	
	// 对
	for(var i = 0; i < duiStars.length; i ++){
		var starName = duiStars[i].getName();
		var descriptor = duiStars[i].getDescriptor();
		
		var ji = "";
		eval("ji = duiStars[i]." +siHua['parentSiHua']);    // 上一代
		
		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.25;
			}else{
				energy += 0.25;
			}
		}
		
		eval("ji = duiStars[i]." +siHua['selfSiHua']);      // 本代
		
		if("SIHUA_JI" == ji){
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.25;
			}else{
				energy += 0.5;
			}
		}
		
		var lu = "";
		
		eval("lu = duiStars[i]." +siHua['selfSiHua']);
		
		if("SIHUA_LU" == lu){
			timePointLu ++;
			
	//		huiGemStarsNum ++;
		}
		
		// 主星
		if(starName.indexOf("MAINSTAR_") >= 0){
		
		}
		
		// 煞星
		if(starName.indexOf("FIENDSTAR_") >= 0){			
			if("MIAOWANG_MIAO" == descriptor || "MIAOWANG_WANG" == descriptor){
				energy += 0.25;
			}else{
				energy += 0.5 ;
			}
		}
		
		// 吉星
		if(starName.indexOf("GEMSTAR_") >= 0){	
	//		huiGemStarsNum ++;
			duiGemStarsNum ++;
		}
	}
	
	return {
		"energy" : energy,
		"timePointLu" : timePointLu,
		"mainStarIsStrong" : mainStarIsStrong,
		"huiGemStarsNum" : huiGemStarsNum,
		"zuoGemStarsNum" : zuoGemStarsNum,
		"duiGemStarsNum" : duiGemStarsNum,
		"zuoMainStarIsGood" : zuoMainStarIsGood
	};
 };
 
 EnergyCalculator.getParentSiHua = function(type){
	if(!type){
		return false;
	}
	
	var parentSiHua = "";
	switch(type){
		case "XianTianMingPan" : {
			parentSiHua = "false";
			selfSiHua = "_siXiang";
			break;
		}
		case "DaYunMingPan" : {
			parentSiHua = "_siXiang";
			selfSiHua = "_siHuaOfDaYun";
			break;
		}
		case "LiuNianMingPan" : {
			parentSiHua = "_siHuaOfDaYun";
			selfSiHua = "_siHuaOfLiuNian";
			break;
		}
		case "LiuYueMingPan" : {
			parentSiHua = "_siHuaOfLiuNian";
			selfSiHua = "_siHuaOfLiuYue";
			break;
		}
		case "LiuRiMingPan" : {
			parentSiHua = "_siHuaOfLiuYue";
			selfSiHua = "_siHuaOfLiuRi";
			break;
		}
		case "LiuShiMingPan" : {
			parentSiHua = "_siHuaOfLiuRi";
			selfSiHua = "_siHuaOfLiuShi";
			break;
		}
		case "LiuFenMingPan" : {
			parentSiHua = "_siHuaOfLiuShi";
			selfSiHua = "_siHuaOfLiuFen";
			break;
		}
		case "DaYunMingPan" : {
			parentSiHua = "_siXiang";
			selfSiHua = "_siHuaOfDaYun";
			break;
		}
		case "XianTianMingPan" : {
			parentSiHua = false;
			selfSiHua = "_siXiang";
			break;
		}
		default: break;
	}
	
	return {
		"parentSiHua" : parentSiHua,
		"selfSiHua" : selfSiHua
	};
 };
 
 EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa = function(gongWei, mingPan, type, useTianMa){
	if(!mingPan){
		return false;
	}
	
	type = type || "LiuShiMingPan";
	
	var attrName = "_hourGongWei";
	switch(type){
		case "XianTianMingPan" : {
			attrName = "_gongWei";
			break;
		}
		case "DaYunMingPan" : {
			attrName = "_daYunGongWei";
			break;
		}
		case "LiuNianMingPan" : {
			attrName = "_liuNianGongWei";
			break;
		}
		case "LiuYueMingPan" : {
			attrName = "_monthGongWei";
			break;
		}
		case "LiuRiMingPan" : {
			attrName = "_dayGongWei";
			break;
		}
		case "LiuShiMingPan" : {
			attrName = "_hourGongWei";
			break;
		}
		case "LiuFenMingPan" : {
			attrName = "_minGongWei";
			break;
		}
		default: break;
	}
	
	var items = mingPan.getItems();
	
	var zhuGongIsEmpty = false;
	
	for(var i = 0; i < items.length; i ++){
		var item = items[i];
		
		if(item[attrName].indexOf(gongWei) >= 0){
			var mingGongIndex = i, hui1Index = (i - 4 + 12) %12, hui2Index = (i + 4) % 12, dui = (i - 6 + 12) % 12;
			
			var indexArr = [mingGongIndex, hui1Index, hui2Index, dui];
			
			var result = new Array();
			
			for(var j = 0; j < indexArr.length; j ++){
				var starArr = new Array();
			
				var index = indexArr[j];
				var section = items[index];
				
				var stars = section.getStars();
				
				var mainStarCount = 0;
				for(var m = 0; m < stars.length; m ++){
					var starName = stars[m].getName();
					
					if(starName.indexOf("MAINSTAR_") >= 0 || starName.indexOf("GEMSTAR_") >= 0 || starName.indexOf("FIENDSTAR_") >= 0){
						if(starName.indexOf("MAINSTAR_") >= 0){
							mainStarCount ++;
						}
						
						if("GEMSTAR_TIANMAXING" == starName){
							if(useTianMa){
								starArr.push(stars[m]);
							}
						}else{
							starArr.push(stars[m]);
						}
					}
				}
				
				if(mainStarCount == 0 && j < 3){
					if(j == 0){
						zhuGongIsEmpty = true;
					}
				
					section = items[(index + 6) % 12];
					
					stars = section.getStars();
					
					for(var n = 0; n < stars.length; n ++){
						var starName = stars[n].getName();
					
						if(starName.indexOf("MAINSTAR_") >= 0 || starName.indexOf("GEMSTAR_") >= 0 || starName.indexOf("FIENDSTAR_") >= 0){
							starArr.push(stars[n]);
						}
					}
				}
				
				result.push(starArr);
			}
			
			var huiArray = result[1].concat(result[2]);
			
			return {
				"zuo" : result[0],
				"hui" :  huiArray,
				"dui" : zhuGongIsEmpty ? new Array() : result[3]
			};
		}
	}
	
	return false;
 };
 
 EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars = function(gongWei, mingPan, type){
	if(!mingPan){
		return false;
	}
	
	type = type || "LiuShiMingPan";
	
	var attrName = "_hourGongWei";
	switch(type){
		case "XianTianMingPan" : {
			attrName = "_gongWei";
			break;
		}
		case "DaYunMingPan" : {
			attrName = "_daYunGongWei";
			break;
		}
		case "LiuNianMingPan" : {
			attrName = "_liuNianGongWei";
			break;
		}
		case "LiuYueMingPan" : {
			attrName = "_monthGongWei";
			break;
		}
		case "LiuRiMingPan" : {
			attrName = "_dayGongWei";
			break;
		}
		case "LiuShiMingPan" : {
			attrName = "_hourGongWei";
			break;
		}
		case "LiuFenMingPan" : {
			attrName = "_minGongWei";
			break;
		}
		default: break;
	}
	
	var items = mingPan.getItems();
	
	var zhuGongIsEmpty = false;
	
	for(var i = 0; i < items.length; i ++){
		i = parseInt(i);
		
		if(i < 0)
		{
			i = 0;
		}
		
		var item = items[i];
		
		if(item[attrName].indexOf(gongWei) >= 0){
			var mingGongIndex = i, hui1Index = (i - 4 + 12) %12, hui2Index = (i + 4) % 12, dui = (i - 6 + 12) % 12;
			
			var indexArr = [mingGongIndex, hui1Index, hui2Index, dui];
			
			var result = new Array();
			
			for(var j = 0; j < indexArr.length; j ++){
				var starArr = new Array();
			
				var index = indexArr[j];
				var section = items[index];
				
				var stars = section.getStars();
				
				var mainStarCount = 0;
				for(var m = 0; m < stars.length; m ++){
					var starName = stars[m].getName();
					
					if(starName.indexOf("MAINSTAR_") >= 0 || starName.indexOf("GEMSTAR_") >= 0 || starName.indexOf("FIENDSTAR_") >= 0){
						if(starName.indexOf("MAINSTAR_") >= 0){
							mainStarCount ++;
						}
						
						if("GEMSTAR_TIANMAXING" != starName){
							starArr.push(stars[m]);
						}
					}
				}
				
				if(mainStarCount == 0 && j < 3){
					if(j == 0){
						zhuGongIsEmpty = true;
					}
				
					section = items[(index + 6) % 12];
					
					stars = section.getStars();
					
					for(var n = 0; n < stars.length; n ++){
						var starName = stars[n].getName();
					
						if(starName.indexOf("MAINSTAR_") >= 0 || starName.indexOf("GEMSTAR_") >= 0 || starName.indexOf("FIENDSTAR_") >= 0){
							starArr.push(stars[n]);
						}
					}
				}
				
				result.push(starArr);
			}
			
			var huiArray = result[1].concat(result[2]);
			
			return {
				"zuo" : result[0],
				"hui" :  huiArray,
				"dui" : zhuGongIsEmpty ? new Array() : result[3]
			};
		}
	}
	
	return false;
 }
 
EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars = function(gongWei, mingPan, type){
	if(!mingPan){
		return false;
	}
	
	type = type || "LiuShiMingPan";
	
	var attrName = "_hourGongWei";
	switch(type){
		case "XianTianMingPan" : {
			attrName = "_gongWei";
			break;
		}
		case "DaYunMingPan" : {
			attrName = "_daYunGongWei";
			break;
		}
		case "LiuNianMingPan" : {
			attrName = "_liuNianGongWei";
			break;
		}
		case "LiuYueMingPan" : {
			attrName = "_monthGongWei";
			break;
		}
		case "LiuRiMingPan" : {
			attrName = "_dayGongWei";
			break;
		}
		case "LiuShiMingPan" : {
			attrName = "_hourGongWei";
			break;
		}
		case "LiuFenMingPan" : {
			attrName = "_minGongWei";
			break;
		}
		default: break;
	}
	
	var items = mingPan.getItems();
	
	var zhuGongIsEmpty = false;
	
	for(var i = 0; i < items.length; i ++){
		var item = items[i];
		
		if(item[attrName].indexOf(gongWei) >= 0){
			var mingGongIndex = i, hui1Index = (i - 4 + 12) %12, hui2Index = (i + 4) % 12, dui = (i - 6 + 12) % 12;
			
			var indexArr = [mingGongIndex, hui1Index, hui2Index, dui];
			
			var result = new Array();
			
			for(var j = 0; j < indexArr.length; j ++){
				var starArr = new Array();
			
				var index = indexArr[j];
				var section = items[index];
				
				var stars = section.getStars();
				
				var mainStarCount = 0;
				for(var m = 0; m < stars.length; m ++){
					var starName = stars[m].getName();
					
					if(starName.indexOf("MAINSTAR_") >= 0){
							mainStarCount ++;
					}
						
					starArr.push(stars[m]);
				}
				
				if(mainStarCount == 0 && j < 3){
					if(j == 0){
						zhuGongIsEmpty = true;
					}
				
					section = items[(index + 6) % 12];
					
					stars = section.getStars();
					
					for(var n = 0; n < stars.length; n ++){
						var starName = stars[n].getName();
					
						if(starName.indexOf("MAINSTAR_") >= 0 || starName.indexOf("GEMSTAR_") >= 0 || starName.indexOf("FIENDSTAR_") >= 0){
							starArr.push(stars[n]);
						}
					}
				}
				
				result.push(starArr);
			}
			
			var huiArray = result[1].concat(result[2]);
			
			return {
				"zuo" : result[0],
				"hui" :  huiArray,
				"dui" : zhuGongIsEmpty ? new Array() : result[3]
			};
		}
	}
	
	return false;
 }