/**
 * 获得先天格局优点
 */ 
function getXianTianGeJuAdvantage()
{
	if(arguments.length < 1){
		return false;
	}
	
	var user = arguments[0];
	
	try{
		eval('user = (' + user + ')');
	}catch(e){
		return false;
	}
	
	var sysFont = user.sysFont || 0;
	
	sysFont = parseInt(sysFont);
	
	var name = user.name || '用户';
	
	if(!user.gender || !(user.gender == "男" || user.gender == "女")){
		return false;
	}
	
	if(!user.birthday){
		return false;
	}
	
	var gender = user.gender;
	var birthday = user.birthday;
	
	birthday = birthday.split("-");
	
	var year, month, day, hour, isRunYue;
	
	year = parseInt(birthday[0]);
	
	eval("user.isLunarDate = " + user.isLunarDate);
	
	if(user.isLunarDate){
		month = birthday[1]; 
		day = birthday[2];
	
		if(month.indexOf("闰") >= 0){
			isRunYue = true;
			month = month.replace("闰", "");
		}
		
		month = Util.convertLunarMonthStr2Integer(month);
		day = Util.convertLunarDayStr2Integer(day);
	}else{
		month = parseInt(birthday[1]);
		day = parseInt(birthday[2]);
		
	}
	
	birthday[3] = birthday[3].replace("时", "");
	hour = Util.parseLunarHour(birthday[3]);
	
	hour = Util.getHourByLunarStr(hour);
	
	var curUser = User.newInstance(name, gender, year, month, day, hour, user.isLunarDate, isRunYue);
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	
	var mingGong = (xianTianMingPan.getItems())[mingGongIndex];
	
	var diZhi = mingGong.getDiZhi();
	
	var stars = mingGong.getStars();
	
	var mainStars = new Array();
	
	for(var i = 0; i < stars.length; i ++){
		if(stars[i].getName().indexOf("MAINSTAR_") >= 0){
			mainStars.push(stars[i].getName());
		}
	}
	
	if(mainStars.length == 0){
		mingGong = (xianTianMingPan.getItems())[(mingGongIndex + 6) % 12];
		diZhi = mingGong.getDiZhi();
		stars = mingGong.getStars();
		
		for(var i = 0; i < stars.length; i ++){
			if(stars[i].getName().indexOf("MAINSTAR_") >= 0){
				mainStars.push(stars[i].getName());
			}
		}
	}
	
	var level = MingShuQuestionsAlgorithm.commonUtil_G(mainStars, diZhi);
	
	var gender = curUser.getUserInfo().getGender();
	
	if(gender == "GENDER_NV"){
		level += 64;
	}
	
	var result = {
		'request' : level,
		'useful' : true
	};
	
	return JSON.stringify(result);
}
 
/**
 * 获取个人扩展信息
 */ 
function getPersonalExtendInfo()
{
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var gender = curUser.getUserInfo().getGender();
	
	var career,wealth,charm,vanves,/* hamornic, */keepHouse;
	
	if(gender == "GENDER_NAN")
	{
		// 男性
		// 事业
		career = getPersonalCareerInfo();
		
		// 财富
		wealth = getPersonalWealthInfo();
		
		// 桃花
		charm = getPersonalCharmInfo();
	}
	else
	{
		// 女性
		// 旺夫
		vanves = getPersonalVanvesInfo();
		
		// 性谐
		//hamornic = getPersonalHamornicInfo();
		
		// 持家
		keepHouse = getPersonalKeepHouseInfo();
	}
	
	var result = {
		'male' : {
			'career' : career,
			'wealth' : wealth,
			'charm' : charm
		},
		'female' : {
			'vanves' : vanves,
		//	'hamornic' : hamornic,
			'keepHouse' : keepHouse
		}
	};
	
	return JSON.stringify(result);
}

MingShuQuestionsAlgorithm.iosInvoked_S4_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var sections = xianTianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		
		var gongwei = section.getGongWei();
		
		if(gongwei.indexOf("GONGWEI_SHIYEGONG") >= 0){
			var stars = section.getStars();
			
			var mainStars = MingShuQuestionsAlgorithm.common_getSectionMainStars(sections, i);
			
			var starName = mainStars[0].getName();
			var isStrong = MingShuQuestionsAlgorithm.common_mainStarIsStrong(starName);
			
			var isMiaoWang = false;
			for(var j = 0; j < mainStars.length; j ++){
				var descriptor = mainStars[j].getDescriptor()
				if(descriptor == "MIAOWANG_MIAO" || descriptor == "MIAOWANG_WANG"){
					isMiaoWang = true;
					break;
				}
			}
			
			var totalSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_SHIYEGONG", xianTianMingPan, "XianTianMingPan");
			
			var zuoStars = totalSanFangSiZhengStars['zuo'];
			var totalStars = zuoStars.concat(totalSanFangSiZhengStars['hui'], totalSanFangSiZhengStars['dui']);
			
			var zuoZuoYouNum = 0,
				zuoKuiYueNum = 0,
				zuoChangQuNum = 0,
				zuoHasLuCun = 0,
				zuoHasHuaLu = 0,
				zuoHasHuaQuan = 0,
				zuoHasHuaKe = 0,
				huiZuoYouNum = 0,
				huiKuiYueNum = 0,
				huiChangQuNum = 0,
				huiHasLuCun = 0,
				huiHasHuaLu = 0,
				huiHasHuaQuan = 0,
				huiHasHuaKe = 0;
				
			for(var j = 0; j < zuoStars.length; j ++){
				var starName = zuoStars[j].getName();
				var descriptor = zuoStars[j].getSiXiang();
				
				if("GEMSTAR_ZUOFUXING" == starName || "GEMSTAR_YOUBIXING" == starName){
					zuoZuoYouNum ++;
				}
				
				if("GEMSTAR_TIANKUIXING" == starName || "GEMSTAR_TIANYUEXING" == starName){
					zuoKuiYueNum ++;
				}
				
				if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
					zuoChangQuNum ++;
				}
				
				if("GEMSTAR_LUCUNXING" == starName){
					zuoHasLuCun ++;
				}
				
				if("SIHUA_LU" == descriptor){
					zuoHasHuaLu  ++;
				}
				
				if("SIHUA_QUAN" == descriptor){
					zuoHasHuaQuan ++;
				}
				
				if("SIHUA_KE" == descriptor){
					zuoHasHuaKe ++;
				}
			}
			
			for(var j = 0; j < totalStars.length; j ++){
				var starName = totalStars[j].getName();
				var descriptor = totalStars[j].getSiXiang();
				
				if("GEMSTAR_ZUOFUXING" == starName || "GEMSTAR_YOUBIXING" == starName){
					huiZuoYouNum ++;
				}
				
				if("GEMSTAR_TIANKUIXING" == starName || "GEMSTAR_TIANYUEXING" == starName){
					huiKuiYueNum ++;
				}
				
				if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
					huiChangQuNum ++;
				}
				
				if("GEMSTAR_LUCUNXING" == starName){
					huiHasLuCun ++;
				}
				
				if("SIHUA_LU" == descriptor){
					huiHasHuaLu ++;
				}
				
				if("SIHUA_QUAN" == descriptor){
					huiHasHuaQuan ++;
				}
				
				if("SIHUA_KE" == descriptor){
					huiHasHuaKe ++;
				}
			}
			
			var zuoGemStarNum = zuoZuoYouNum + zuoKuiYueNum + zuoChangQuNum + zuoHasLuCun + zuoHasHuaLu + zuoHasHuaQuan + zuoHasHuaKe;
			var totalGemStarNum = huiZuoYouNum + huiKuiYueNum + huiChangQuNum + huiHasLuCun + huiHasHuaLu + huiHasHuaQuan + huiHasHuaKe;
			
			if(isStrong && isMiaoWang){
				if(totalGemStarNum >= 3){
					var result = {
						'request' : 'A',
						'useful' : true
					};
					
					return result;
				}
			}
			
			if(!isStrong && isMiaoWang){
				if(zuoGemStarNum >= 1 && totalGemStarNum >= 4){
					var result = {
						'request' : 'A',
						'useful' : true
					};
					
					return result;
				}
			}
			
			var mingHasLuCun = false,
				mingHasTianMa = false,
				shiyeHasLuCun = false,
				shiyeHasTianMa = false,
				caiboHasLuCun = false,
				caibohasTianMa = false;
				
			var totalShiYeSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_SHIYEGONG", xianTianMingPan, "XianTianMingPan", true);
					
			totalShiYeSanFangSiZhengStars = totalShiYeSanFangSiZhengStars['zuo'].concat(totalShiYeSanFangSiZhengStars['hui'], totalShiYeSanFangSiZhengStars['dui']);
			
			var totalMingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", xianTianMingPan, "XianTianMingPan", true);
			
			totalMingSanFangSiZhengStars = totalMingSanFangSiZhengStars['zuo'].concat(totalMingSanFangSiZhengStars['hui'], totalMingSanFangSiZhengStars['dui']);
			
			var totalCaiBoSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_CAIBOGONG", xianTianMingPan, "XianTianMingPan", true);
			
			totalCaiBoSanFangSiZhengStars = totalCaiBoSanFangSiZhengStars['zuo'].concat(totalCaiBoSanFangSiZhengStars['hui'], totalCaiBoSanFangSiZhengStars['dui']);
			
			for(var s = 0; s < totalShiYeSanFangSiZhengStars.length; s ++){
				if(totalShiYeSanFangSiZhengStars[s].getName() == "GEMSTAR_LUCUNXING"){
					shiyeHasLuCun = true;
				}
				
				if(totalShiYeSanFangSiZhengStars[s].getName() == "GEMSTAR_TIANMAXING"){
					shiyeHasTianMa = true;
				}
			}
			
			for(var s = 0; s < totalMingSanFangSiZhengStars.length; s ++){
				if(totalMingSanFangSiZhengStars[s].getName() == "GEMSTAR_LUCUNXING"){
					mingHasLuCun = true;
				}
				
				if(totalMingSanFangSiZhengStars[s].getName() == "GEMSTAR_TIANMAXING"){
					mingHasTianMa = true;
				}
			}
			
			for(var s = 0; s < totalCaiBoSanFangSiZhengStars.length; s ++){
				if(totalCaiBoSanFangSiZhengStars[s].getName() == "GEMSTAR_LUCUNXING"){
					caiboHasLuCun = true;
				}
				
				if(totalCaiBoSanFangSiZhengStars[s].getName() == "GEMSTAR_TIANMAXING"){
					caibohasTianMa = true;
				}
			}
			
			if((mingHasLuCun && mingHasTianMa) || (shiyeHasLuCun && shiyeHasTianMa) || (caiboHasLuCun && caibohasTianMa)){
				var result = {
					'request' : 'A',
					'useful' : true
				};
				
				return result;
			}
		}
	}
	
	var result = {
		'request' : 'B',
		'useful' : true
	};
	
	return result;
};

 MingShuQuestionsAlgorithm.iosInvoked_G6_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	if(!xianTianMingPan){
		return false;
	}
 
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", xianTianMingPan, "XianTianMingPan");
	
	var result = {
		"request" : level,
		"useful" : true
	};
	
	return result;
 };
 
  MingShuQuestionsAlgorithm.iosInvoked_S2_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_SHIYEGONG", xianTianMingPan, "XianTianMingPan");
	
	var result = {
			'request' : ['C', 'B', 'A'][Math.ceil(level / 4) - 1],
			'useful' : true
		};
		
	return result;
 };

/**
 * 获取男性事业信息
 */
function getPersonalCareerInfo()
{
	//6颗星 G6正能量 S2正能量
	//5颗星 G6正能量 S2正负能量   G6正负能量 S2正能量
	//4颗星 G6正能量 S2负能量     G6负能量 S2正能量
	//3颗星 G6负能量 S2正负能量   G6正负能量 S2正负能量
	//2颗星 G6正负能量 S2负能量
	//1颗星 G6负能量 S2负能量

	var g6Result = MingShuQuestionsAlgorithm.iosInvoked_G6_al_4_hehun();
	var g6Index = Math.ceil(g6Result.request / 4);
	
	var s2Result = MingShuQuestionsAlgorithm.iosInvoked_S2_al_4_hehun();
	var s2Index = s2Result.request;
	
	if(g6Index == 3)
	{
		if(s2Index == 'A')
		{
			return 6;
		}
		
		if(s2Index == 'B')
		{
			return 5;
		}
		
		if(s2Index == 'C')
		{
			return 4;
		}
	}
	
	if(g6Index == 2)
	{
		if(s2Index == 'A')
		{
			return 5;
		}
		
		if(s2Index == 'B')
		{
			return 3;
		}
		
		if(s2Index == 'C')
		{
			return 2;
		}
	}
	
	if(g6Index == 1)
	{
		if(s2Index == 'A')
		{
			return 4;
		}
		
		if(s2Index == 'B')
		{
			return 3;
		}
		
		if(s2Index == 'C')
		{
			return 1;
		}
	}
	
	return false;
}

MingShuQuestionsAlgorithm.iosInvoked_C2_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var caiBoGongSanFangSiZheng = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_CAIBOGONG", xianTianMingPan, "XianTianMingPan");
	var caiBoTotalStars = caiBoGongSanFangSiZheng['zuo'].concat(caiBoGongSanFangSiZheng['hui']);
	
	var sections = xianTianMingPan.getItems();
	
	var hasKongJie = false;
	var caiboHasKongJie = false;
	var tianzhaiHasKongJie = false;
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		var gongWei = section.getGongWei();
		
		if(gongWei.indexOf("GONGWEI_CAIBOGONG") >= 0 || gongWei.indexOf("GONGWEI_TIANZHAIGONG") >= 0){
			var stars = section.getStars();
		
			for(var j = 0; j < stars.length; j ++){
				if(stars[j].getName() == "FIENDSTAR_DIKONGXING" || stars[j].getName() == "FIENDSTAR_DIJIEXING"){
					if(gongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
						caiboHasKongJie = true;
					}
					
					if(gongWei.indexOf("GONGWEI_TIANZHAIGONG") >= 0){
						tianzhaiHasKongJie = true;
					}
					
					break;
				}
			}
		}
	}
	
	var caiBoHasLuCun = false,
		caiBoHuiLu = false;
		
	for(var i = 0; i < caiBoTotalStars.length; i ++){
		if(caiBoTotalStars[i].getName() == "GEMSTAR_LUCUNXING"){
			caiBoHasLuCun = true;
		}
		
		if(caiBoTotalStars[i].getSiXiang() == "SIHUA_LU"){
			caiBoHuiLu = true;
		}
	}
	
	if(!caiboHasKongJie && (caiBoHasLuCun || caiBoHuiLu)){
		var result = {
				'request' : 'A',
				'useful' : true
			};
			
		return result;
	}
	
	var tianZhaiGongSanFangSiZheng = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_TIANZHAIGONG", xianTianMingPan, "XianTianMingPan");
	var tianZhaiTotalStars = tianZhaiGongSanFangSiZheng['zuo'].concat(tianZhaiGongSanFangSiZheng['hui'], tianZhaiGongSanFangSiZheng['dui']);
	
	var tianZhaiHasLuCun = false,
		tianZhaiHuiLu = false;
		
	for(var i = 0; i < tianZhaiTotalStars.length; i ++){
		if(tianZhaiTotalStars[i].getName() == "GEMSTAR_LUCUNXING"){
			tianZhaiHasLuCun = true;
		}
		
		if(tianZhaiTotalStars[i].getSiXiang() == "SIHUA_LU"){
			tianZhaiHuiLu = true;
		}
	}
	
	if(!hasKongJie && tianZhaiHasLuCun){
		var result = {
				'request' : 'A',
				'useful' : true
			};
			
		return result;
	}
	
	for(var i = 0; i < tianZhaiGongSanFangSiZheng['zuo'].length; i ++){
		var star = tianZhaiGongSanFangSiZheng['zuo'][i];
		
		if(star.getName() == "MAINSTAR_WUQUXING" || star.getName() == "MAINSTAR_TAIYINXING"){
			if(star.getSiXiang() == "SIHUA_LU"){
				var result = {
						'request' : 'A',
						'useful' : true
					};
					
				return result;
			}
		}
	}
	
	var cbTotalStars = caiBoGongSanFangSiZheng['zuo'].concat(caiBoGongSanFangSiZheng['hui'], caiBoGongSanFangSiZheng['dui']);
	 
	var cbShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(cbTotalStars);
	
	if(caiboHasKongJie || (!(caiBoHasLuCun || caiBoHuiLu) && cbShaNum >= 3)){
		var result = {
				'request' : 'C',
				'useful' : true
			};
			
		return result;
	}
	
	var result = {
			'request' : 'B',
			'useful' : true
		};
		
	return result;
};

/**
 * 获取个人财富积累信息
 */
function getPersonalWealthInfo()
{
	//6颗星 C2正能量 C3正能量
	//5颗星 C2正负能量 C3正能量
	//4颗星 C2负能量 C3正能量
	//3颗星 C2正能量 C3负能量
	//2颗星 C2正负能量 C3负能量
	//1颗星 C2负能量 C3负能量

	var c2Result = MingShuQuestionsAlgorithm.iosInvoked_C2_al_4_hehun();
	var c2Index = c2Result.request;
	
	var c3Result = MingShuQuestionsAlgorithm.iosInvoked_S4_al_4_hehun();
	var c3Index = c3Result.request;
	
	if(c2Index == 'A')
	{
		if(c3Index == 'A')
		{
			return 6;
		}
		else
		{
			return 3;
		}
	}
	
	if(c2Index == 'B')
	{
		if(c3Index == 'A')
		{
			return 5;
		}
		else
		{
			return 2;
		}
	}
	
	if(c2Index == 'C')
	{
		if(c3Index == 'A')
		{
			return 4;
		}
		else
		{
			return 1;
		}
	}
	
	return false;
}

 MingShuQuestionsAlgorithm.iosInvoked_H6_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', xianTianMingPan, "XianTianMingPan");
	var mingGongFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', xianTianMingPan, "XianTianMingPan");
	
	var fuqiHasZuoFu = false,
		fuqiHasYouBi = false,
		fuqiHasWenChang = false,
		fuqiHasWenQu = false,
		fuqiHasLu = false,
		minggongHasZuoFu = false,
		minggongHasYouBi = false,
		minggongHasWenChang = false,
		minggongHasWenQu = false;
		
	var fuqiTotalStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui'], fuqiSanFangSiZhengStars['dui']);
	
	var mingGongTotalStars = mingGongFangSiZhengStars['zuo'].concat(mingGongFangSiZhengStars['hui'], mingGongFangSiZhengStars['dui']);
	
	for(var i = 0; i < fuqiTotalStars.length; i ++){
		if("GEMSTAR_WENCHANGXING" == fuqiTotalStars[i].getName()){
			fuqiHasWenChang = true;
		}
		
		if("GEMSTAR_WENQUXING" == fuqiTotalStars[i].getName()){
			fuqiHasWenQu = true;
		}
		
		if("GEMSTAR_ZUOFUXING" == fuqiTotalStars[i].getName()){
			fuqiHasZuoFu = true;
		}
		
		if("GEMSTAR_YOUBIXING" == fuqiTotalStars[i].getName()){
			fuqiHasYouBi = true;
		}
		
		if("GEMSTAR_LUCUNXING" == fuqiTotalStars[i].getName()){
			fuqiHasLu = true;
		}
		
		if("SIHUA_LU" == fuqiTotalStars[i].getSiXiang()){
			fuqiHasLu = true;
		}
	}
	
	if((fuqiHasZuoFu || fuqiHasYouBi) && (fuqiHasWenChang || fuqiHasWenQu) && fuqiHasLu){
		var result = {
			'request' : 'B',
			'useful' : true
		};
		
		return result;
	}
	
	for(var i = 0; i < mingGongTotalStars.length; i ++){
		if("GEMSTAR_WENCHANGXING" == mingGongTotalStars[i].getName()){
			minggongHasWenChang = true;
		}
		
		if("GEMSTAR_WENQUXING" == mingGongTotalStars[i].getName()){
			minggongHasWenQu = true;
		}
		
		if("GEMSTAR_ZUOFUXING" == mingGongTotalStars[i].getName()){
			minggongHasZuoFu = true;
		}
		
		if("GEMSTAR_YOUBIXING" == mingGongTotalStars[i].getName()){
			minggongHasYouBi = true;
		}
	}
	
	if((((minggongHasZuoFu || minggongHasYouBi) && (fuqiHasWenChang || fuqiHasWenQu)) || ((minggongHasWenChang || minggongHasWenQu) && (fuqiHasZuoFu || fuqiHasYouBi)) ) && fuqiHasLu){
		var result = {
			'request' : 'B',
			'useful' : true
		};
		
		return result;
	}
	
	var result = {
			'request' : 'A',
			'useful' : true
		};
		
	return result;
 };
 
MingShuQuestionsAlgorithm.iosInvoked_H8_al_4_hehun = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var sections = xianTianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		
		if(section.getGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			var stars = section.getStars();
			
			for(var j = 0; j < stars.length; j ++){
				if(stars[j].getName() == "FIENDSTAR_DIKONGXING" || stars[j].getName() == "FIENDSTAR_DIJIEXING"){
					var result = {
						'request' : 'B',
						'useful' : true
					};
					
					return result;
				}
			}
		}
	}
	
	var result = {
			'request' : 'A',
			'useful' : true
		};
		
	return result;
 };
 
/**
 * 获取个人桃花信息
 */
function getPersonalCharmInfo()
{
	//6颗星 H6负能量 H8负能量 命宫有贪狼星
	//5颗星 H6负能量 H8负能量
	//4颗星 H6负能量 H8正能量
	//3颗星 H6正能量 H8负能量
	//2颗星 H6正能量 H8正能量

	var h6Result = MingShuQuestionsAlgorithm.iosInvoked_H6_al_4_hehun();
	var h6Index = h6Result.request;
	
	var h8Result = MingShuQuestionsAlgorithm.iosInvoked_H8_al_4_hehun();
	var h8Index = h8Result.request;

	if(h6Index == "A")
	{
		if(h8Index == "A")
		{
			return 2;
		}
		else
		{
			return 3;
		}
	}
	
	if(h6Index == "B")
	{
		if(h8Index == "A")
		{
			return 4;
		}
		else
		{
			var curUser = getCurrentUser() ? getCurrentUser().user : false;
			var xianTianMingPan = curUser.getXianTianMingPan();
			var mingGongIndex = xianTianMingPan.getMingGongIndex();
			var sections = mingpan.getItems();
			var mingGong = sections[mingGongIndex];
			var stars = mingGong.getStars();
			
			for(var i = 0; i < stars.length; i ++)
			{
				if(stars[i].getName() == "MAINSTAR_TANLANGXING")
				{
					return 6;
				}
			}
			
			return 5;
		}
	}
}

/**
 * 获取个人旺夫信息
 */
function getPersonalVanvesInfo()
{
	//6颗星夫妻宫强主星无煞星  田宅宫有化禄或禄存    子女宫主星有一个主星为庙旺无煞星
	//5颗星夫妻宫弱主星无煞星  田宅宫有化禄或禄存    子女宫主星有一个主星为庙旺无煞星
	//4颗星夫妻宫无煞星  
	//3颗星夫妻宫有1颗煞星 三方四正少于1颗煞星
	//2颗星夫妻宫有1颗煞星 三方四正多于1颗煞星
	//1颗星夫妻宫有2颗以上煞星

	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	var fuqiGongIndex = (mingGongIndex - 2 + 12) % 12;
	var tianzhaiGongIndex = (mingGongIndex + 3) % 12;
	var zinvGongIndex = (fuqiGongIndex - 1 + 12) % 12;
	
	var sections = xianTianMingPan.getItems();
	var fuqiGongStars = sections[fuqiGongIndex].getStars();
	var tianzhaiGongStars = sections[tianzhaiGongIndex].getStars();
	var zinvGongStars = sections[zinvGongIndex].getStars();
	
	var fuqiGongIsStrong = false;
	var fuqiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(fuqiGongStars);
	var fuQiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_FUQIGONG", xianTianMingPan, "XianTianMingPan", true);
	var fuQiSanFangSiZhengShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(fuQiSanFangSiZhengStars['zuo'].concat(fuQiSanFangSiZhengStars['hui'], fuQiSanFangSiZhengStars['dui']));
	
	for(var i = 0; i < fuqiGongStars.length; i ++)
	{
		if(fuqiGongStars[i].getName().indexOf("MAINSTAR_") >= 0)
		{
			fuqiGongIsStrong = MingShuQuestionsAlgorithm.common_mainStarIsStrong(fuqiGongStars[i].getName());
			
			break;
		}
	}
	
	var tianzhaiHasHuaLuLuCun = false;
	
	for(var i = 0; i < tianzhaiGongStars.length; i ++)
	{
		if(tianzhaiGongStars[i].getName() == "GEMSTAR_LUCUNXING")
		{
			tianzhaiHasHuaLuLuCun = true;
			break;
		}
		
		if(tianzhaiGongStars[i].getSiXiang() == "SIHUA_LU")
		{
			tianzhaiHasHuaLuLuCun = true;
			break;
		}
	}
	
	var zinvMainStarIsMiaoWang = false;
	var zinvShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(zinvGongStars);
	
	for(var i = 0; i < zinvGongStars.length; i ++)
	{
		if(zinvGongStars[i].getDescriptor() == "MIAOWANG_MIAO" || zinvGongStars[i].getDescriptor() == "MIAOWANG_WANG")
		{
			zinvMainStarIsMiaoWang = true;
			
			break;
		}
	}
	
	if(fuqiGongIsStrong && fuqiShaNum == 0 && tianzhaiHasHuaLuLuCun && zinvMainStarIsMiaoWang && zinvShaNum)
	{
		return 6;
	}
	
	if(!fuqiGongIsStrong && fuqiShaNum == 0 && tianzhaiHasHuaLuLuCun && zinvMainStarIsMiaoWang && zinvShaNum)
	{
		return 5;
	}
	
	if(fuqiShaNum == 0)
	{
		return 4;
	}
	
	if(fuqiShaNum == 1 )
	{
		if(fuQiSanFangSiZhengShaNum >= 2)
		{
			return 2;
		}
		else
		{
			return 3;
		}
	}
	
	if(fuqiShaNum >= 2 )
	{
		return 1;
	}
}

/**
 * 获取个人性谐信息
 */
function getPersonalHamornicInfo()
{
	//6颗星 对方的命宫主星是你先天子女宫主星一样。
	//5颗星 你的先天命宫主星是对方先天子女宫主星一样
	//4颗星 你的先天子女宫主星与对方先天子女宫的主星一样
	//3颗星 你的先天子女宫主星与对方先天子女宫的三方四正主星一样
	//2颗星 以上均无为2
	//1颗星 无1
	
	// 需要在服务器后台计算
}

/**
 * 获取个人持家信息
 */
function getPersonalKeepHouseInfo()
{
	//6颗星 田宅宫三方四正3颗以上吉星并且有化禄或禄存    
	//5颗星 田宅宫三方四正3颗以上吉星
	//4颗星 田宅宫三方四正1-2颗吉星有化禄或禄存
	//3颗星 田宅宫三方四正1-2颗吉星
	//2颗星 除以上答案为2颗
	//1颗星 无1颗

	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	var xianTianMingPan = curUser.getXianTianMingPan();
	var tianZhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_TIANZHAIGONG", xianTianMingPan, "XianTianMingPan", true);

	var totalStars = tianZhaiSanFangSiZhengStars['zuo'].concat(tianZhaiSanFangSiZhengStars['hui'], tianZhaiSanFangSiZhengStars['dui']);
	
	var gemStarNum = 0;
	var hasHuaLuLuCun = false;
	
	for(var i = 0; i < totalStars.length; i ++)
	{
		var starName = totalStars[i].getName();
		
		if(starName.indexOf("GEMSTAR_") >= 0)
		{
			gemStarNum ++;
		}
		
		if(starName == "GEMSTAR_LUCUNXING")
		{
			hasHuaLuLuCun = true;
		}
		
		if(totalStars[i].getSiXiang() == "SIHUA_LU")
		{
			hasHuaLuLuCun = true;
		}
	}
	
	if(gemStarNum >= 3)
	{
		if(hasHuaLuLuCun)
		{
			return 6;
		}
		else
		{
			return 5;
		}
	}
	
	if(gemStarNum >= 1)
	{
		if(hasHuaLuLuCun)
		{
			return 4;
		}
		else
		{
			return 3;
		}
	}
	
	return 2;
}

/**
 * 获取个人命盘主星属相信息
 */
function getPersonalMingPanInfo()
{
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var myXianTianMingPan = curUser.getXianTianMingPan();
	var myMingStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", myXianTianMingPan, "XianTianMingPan", true);
	var myFuQiStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_FUQIGONG", myXianTianMingPan, "XianTianMingPan", true);
	var myZiNvStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_ZINVGONG", myXianTianMingPan, "XianTianMingPan", true);
	var myMingZuoStars = myMingStars['zuo'];
	var myFuQiSanFangSiZhengStars = myFuQiStars['zuo'].concat(myFuQiStars['hui'], myFuQiStars['dui']);

	// 我的先天命宫主星
	var myMingZuoMainStars = getMainStars(myMingZuoStars);
	// 我的先天夫妻宫三方四正主星
	var myFuQiSanFangSiZhengMainStars = getMainStars(myFuQiSanFangSiZhengStars);
	
	var myZiNvMainStars = getMainStars(myZiNvStars['zuo']);
	var myZiNvSanFangSiZhengMainStars = getMainStars(myZiNvStars['zuo'].concat(myZiNvStars['hui'], myZiNvStars['hui']));
	
	// 我的出生属相
	var myZodiac = Util.getZodiacByDiZhi(curUser.getUserInfo().getBaZi().nianZhu.split("$")[1]);
	// 我的先天命宫三方属相
	var myMingSanFangZodiac = getZodiac(getSanFangSections(myXianTianMingPan,1));
	// 我的先天夫妻三方属相
	var myFuQiSanFangZodiac = getZodiac(getSanFangSections(myXianTianMingPan,2));

	var thisYear = WeiSuanQuestionUtil.getCurrentLunarDate().year;
	var myBirthLunarYear = curUser.getUserInfo().getBirthday().getLunarYear();
	var myMingJu = curUser.getUserInfo().getMingJu().index;
	var myXuSui = thisYear - myBirthLunarYear + 1;
	var myDaYunIndex = ((myXuSui - myMingJu) / 10) + 1;
	var myDaYunMingPan = curUser.getDaYunMingPan(myDaYunIndex);
	var myDaYunFuQiStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_FUQIGONG", myDaYunMingPan, "DaYunMingPan", true);
	// 我的大运夫妻宫三方四正主星
	var myDaYunFuQiSanFangSiZhengMainStars = getMainStars(myDaYunFuQiStars['zuo'].concat(myDaYunFuQiStars['hui'], myDaYunFuQiStars['dui']));
	
	var result = {
		xtMingMainStars	: myMingZuoMainStars.unique(),
		xtFuQiMainStars	: myFuQiSanFangSiZhengMainStars.unique(),
		xtZiNvMainStars : myZiNvMainStars.unique(),
		xtZiNvSFSZMainStars : myZiNvSanFangSiZhengMainStars.unique(),
		xtZodiac : myZodiac,	
		xtMingZodiacs : myMingSanFangZodiac.unique(),		
		xtFuQiZodiacs : myFuQiSanFangZodiac.unique(),		
		dyFuQiMainStars	: myDaYunFuQiSanFangSiZhengMainStars.unique()		
	};
	
	return JSON.stringify(result);
}

/**
 * 获取属相(进空劫的属相不算)
 */
function getZodiac(sections)
{
	if(sections && sections.length > 0)
	{
		var zodiacArray = new Array();
		
		for(var i = 0; i < sections.length; i ++)
		{
			var stars = sections[i].getStars();
			
			var hasKongJie = false;
			
			for(var j = 0; j < stars.length; j ++)
			{
				if("FIENDSTAR_DIJIEXING" == stars[j].getName() || "FIENDSTAR_DIKONGXING" == stars[j].getName())
				{
					hasKongJie = true;
					break;
				}
			}
			
			if(!hasKongJie)
			{
				var index = sections[i].getIndex();
				zodiacArray.push(Util.getZodiacByIndex(index - 1));
			}
		}
		
		return zodiacArray;
	}
	
	return false;
}

/**
 * 获取主星
 */
function getMainStars(stars)
{
	if(stars && stars.length > 0)
	{
		var mainStars = new Array();
		
		for(var i = 0; i < stars.length; i ++)
		{
			if(stars[i].getName().indexOf("MAINSTAR_") >= 0)
			{
				mainStars.push(stars[i].getName());
			}
		}
		
		return mainStars;
	}
	
	return false;
}

/**
 * 获取三方宫位
 */
function getSanFangSections(mingpan, type)
{
	var mingGongIndex = mingpan.getMingGongIndex();
	
	var sections = mingpan.getItems();
	
	// 命宫
	if(type == 1)
	{
		return [sections[mingGongIndex], sections[(mingGongIndex+ 4) % 12], sections[(mingGongIndex + 8)% 12]];
	}

	// 夫妻宫
	if(type == 2)
	{
		var fuQiIndex = (mingGongIndex - 2 + 12) % 12;
		
		return [sections[fuQiIndex], sections[(fuQiIndex+ 4) % 12], sections[(fuQiIndex + 8)% 12]];
	}
	
	return false;
}