/**
 * LiuNianMingPanSection.js
 * 流年命盘块
 *
 * @date 2014-01-09
 * @version 0.1
 */

function LiuNianMingPanSection(){
	this._daYunStars = false;             // 大运星曜
	this._liuNianStars = false;           // 流年星曜
	this._month = false;                  // 月份
	this._monthOfGanZhi = false;          // 月份干支
	this._daYunGongWei = false;           // 大运宫位
	this._liuNianGongWei = false;         // 流年宫位
	this._daYunAgePeriod = false;
 }
 
 LiuNianMingPanSection.prototype = new Section();
 
 LiuNianMingPanSection.prototype.getDaYunAgePeriod = function(){
	return this._daYunAgePeriod;
 };
 
 LiuNianMingPanSection.prototype.setDaYunAgePeriod = function(daYunAgePeriod){
	this._daYunAgePeriod = daYunAgePeriod;
 };
 
 LiuNianMingPanSection.prototype.setMonth = function(month){
	this._month = month;
 };
 
 LiuNianMingPanSection.prototype.setLunarMonth = function(){
	var tianGanStartIndex = -1;
 
	var tiangan = this._nianZhu.split("$")[0];
	switch(tiangan){
		case "TG_JIA" :
		case "TG_JI" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_BING");
			break;
		}
		case "TG_YI" :
		case "TG_GENG" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_WU");
			break;
		}
		case "TG_BING" :
		case "TG_XIN" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_GENG");
			break;
		}
		case "TG_DING" :
		case "TG_REN" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_REN");
			break;
		}
		case "TG_WU" :
		case "TG_GUI" : {
			tianGanStartIndex = Util.getIndexByTianGan("TG_JIA");
			break;
		}
	}
	
	var gregorianDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, day, hour, isRunYue);
	
	var feastName = SimpleFeastCalculator.getFeastByDate(gregorianDate.getFullYear(), gregorianDate.getMonth() + 1, gregorianDate.getDate());

	var monthIndex = Util.getMonthIndexByFeastName(feastName);
	
	var diZhiStartIndex = Util.getIndexByTianGan("DZ_YIN");
	
	var tianGanIndex = (tianGanStartIndex + monthIndex - 1) % 10;
	var diZhiIndex = (diZhiStartIndex + monthIndex - 1) % 12;
	
	this._monthOfGanZhi = Util.getTianGanByIndex(tianGanIndex) + Util.getDiZhiByIndex(diZhiIndex);
 };
 
 LiuNianMingPanSection.prototype.getMonth = function(){
	return this._month;
 };
 
 LiuNianMingPanSection.prototype.addDaYunStar = function(daYunStar){
	if(!this._daYunStars){
		this._daYunStars = new Array();
	}
	
	this._daYunStars.push(daYunStar);
	
	return this;
 };
 
 LiuNianMingPanSection.prototype.getDaYunStars = function(){
	return this._daYunStars;
 };
 
  LiuNianMingPanSection.prototype.addLiuNianStar = function(liuNianStar){
	if(!this._liuNianStars){
		this._liuNianStars = new Array();
	}
	
	this._liuNianStars.push(liuNianStar);
	
	return this;
 };
 
 LiuNianMingPanSection.prototype.getLiuNianStars = function(){
	return this._liuNianStars;
 };
 
 LiuNianMingPanSection.prototype.setDaYunGongWei = function(daYunGongWei){
	this._daYunGongWei = daYunGongWei;
 };
 
 LiuNianMingPanSection.prototype.getDaYunGongWei = function(){
	return this._daYunGongWei;
 };
 
  LiuNianMingPanSection.prototype.setLiuNianGongWei = function(liuNianGongWei){
	this._liuNianGongWei = liuNianGongWei;
 };
 
 LiuNianMingPanSection.prototype.getLiuNianGongWei = function(){
	return this._liuNianGongWei;
 };