/**
 * 新版首页
 */
function NewHome()
{
	
}

NewHome.getLiuNianGongWeiYunShi = function(liuNianMingPan, gongWei, mergeDKDJ)
{	
	var liuNianMingSFSZStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuNianMingPan, "LiuNianMingPan");
	var gongStars = liuNianMingSFSZStars['zuo'];
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuNianMingPan, "LiuNianMingPan");
	var dz = false;
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		if(sections[i].getLiuNianGongWei().indexOf(gongWei) >= 0)
		{
			dz = Translator.translate(sections[i].getDiZhi());
			break;
		}
	}
	
	var stars = new Array();
	
	for(var i = 0; i < gongStars.length; i ++)
	{
		var starName = gongStars[i].getName();
		
		if(starName == "GEMSTAR_WENQUXING")
		{
			starName = "GEMSTAR_WENCHANGXING";
		}
		
		if(starName == "GEMSTAR_TIANYUEXING")
		{
			starName = "GEMSTAR_TIANKUIXING";
		}
		
		if(starName == "GEMSTAR_YOUBIXING")
		{
			starName = "GEMSTAR_ZUOFUXING";
		}
		
		if(starName == "FIENDSTAR_QINGYANGXING")
		{
			starName = "FIENDSTAR_TUOLUOXING";
		}
		
		if(mergeDKDJ)
		{
			if(starName == "FIENDSTAR_DIJIEXING")
			{
				starName = "FIENDSTAR_DIKONGXING";
			}
		}

		stars.push(starName);
	}
	
	stars.unique();
	
	var desp = "";
	
	for(var i = 0; i < stars.length; i ++)
	{
		var starName = stars[i];
		
		if(starName in NewHome._liuNianStarEnergyDescription[gongWei])
		{
			if(level > 6)
			{
				desp += NewHome._liuNianStarEnergyDescription[gongWei][starName][0];
				desp += "\r\n";
			}
			else
			{
				desp += NewHome._liuNianStarEnergyDescription[gongWei][starName][1];
				desp += "\r\n";
			}
		}
	}
	
	return {
		'dz' : dz,
		'description' : desp,
		'level' : level
	};
};

NewHome.getLiuNianYunShi = function()
{
	var user = getCurrentUser();
	
	if(!user)
	{
		return false;
	}
	
	user = user.user;
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	var year = curLunarDate.year;
	
	if(curLunarDate.month > 9)
	{
		year ++;
	}
	
	if(year < 2016)
	{
		year = 2016;
	}
	
	var liuNianMingPan = user.getLiuNianMingPan(year);
	var liuNianMingYunShi = NewHome.getLiuNianGongWeiYunShi(liuNianMingPan, "GONGWEI_MINGGONG", true);
	var liuNianLevel = ZiWeiUtils.getLiuNianEnergy(liuNianMingPan, "GONGWEI_MINGGONG");
	var liuNianFuQiYunShi = NewHome.getLiuNianGongWeiYunShi(liuNianMingPan, "GONGWEI_FUQIGONG", true);
	var liuNianCaiBoYunShi = NewHome.getLiuNianGongWeiYunShi(liuNianMingPan, "GONGWEI_CAIBOGONG", true);
	var liuNianShiYeYunShi = NewHome.getLiuNianGongWeiYunShi(liuNianMingPan, "GONGWEI_SHIYEGONG", false);
	
	var result = {
		'liuNian' : liuNianMingPan.getYear(),
		'total' : {
			'dz' : liuNianMingYunShi.dz,
			'description' : liuNianMingYunShi.description,
			'level' : liuNianLevel
		},
		'aiqing' : {
			'dz' : liuNianFuQiYunShi.dz,
			'description' : liuNianFuQiYunShi.description,
			'level' : liuNianFuQiYunShi.level
		},
		'caibo' : {
			'dz' : liuNianCaiBoYunShi.dz,
			'description' : liuNianCaiBoYunShi.description,
			'level' : liuNianCaiBoYunShi.level
		},
		'shiye' : {
			'dz' : liuNianShiYeYunShi.dz,
			'description' : liuNianShiYeYunShi.description,
			'level' : liuNianShiYeYunShi.level
		}
	};
	
	return JSON.stringify(result);
};

/**
 * @param mergeDKDJ 合并地空地劫
 * @param mergeQYTL 合并擎羊陀罗
 * @param mergeHL   合并火铃
 */
NewHome.getLiuYueMingYunShi = function(liuYueMingPan, gongWei, mergeDKDJ, mergeQYTL, mergeHL)
{	
	var liuYueMingSFSZStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuYueMingPan, "LiuYueMingPan");
	var gongStars = liuYueMingSFSZStars['zuo'];
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuYueMingPan, "LiuYueMingPan");
	var dz = false;
	var sections = liuYueMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		if(sections[i].getMonthGongWei().indexOf(gongWei) >= 0)
		{
			dz = Translator.translate(sections[i].getDiZhi());
			break;
		}
	}
	
	var stars = new Array();
	
	for(var i = 0; i < gongStars.length; i ++)
	{
		var starName = gongStars[i].getName();
		
		if(starName == "GEMSTAR_WENQUXING")
		{
			starName = "GEMSTAR_WENCHANGXING";
		}
		
		if(starName == "GEMSTAR_TIANYUEXING")
		{
			starName = "GEMSTAR_TIANKUIXING";
		}
		
		if(starName == "GEMSTAR_YOUBIXING")
		{
			starName = "GEMSTAR_ZUOFUXING";
		}
		
		if(mergeQYTL)
		{
			if(starName == "FIENDSTAR_QINGYANGXING")
			{
				starName = "FIENDSTAR_TUOLUOXING";
			}
		}
		
		if(mergeDKDJ)
		{
			if(starName == "FIENDSTAR_DIJIEXING")
			{
				starName = "FIENDSTAR_DIKONGXING";
			}
		}

		stars.push(starName);
	}
	
	stars.unique();
	
	var desp = "";
	
	for(var i = 0; i < stars.length; i ++)
	{
		var starName = stars[i];
		
		if(starName in NewHome._liuYueMingStarEnergyDescription[gongWei])
		{
			if(level > 6)
			{
				desp += NewHome._liuYueMingStarEnergyDescription[gongWei][starName][0];
				desp += "\r\n";
			}
			else
			{
				desp += NewHome._liuYueMingStarEnergyDescription[gongWei][starName][1];
				desp += "\r\n";
			}
		}
	}
	
	return {
		'dz' : dz,
		'description' : desp,
		'level' : level
	};
};

NewHome.getLiuYueYunShi = function()
{
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	var liuYue = (liuYueMingPan.monthIsRunYue ? "闰" : "") + Translator.translate(Util.getLunarMonthByIndex(liuYueMingPan.month - 1).name);
	var calendar = new PerpetualCalendar();
	var monthInfo = calendar.getCalendar()[liuYueMingPan._year-1901].monthInfo;
	var fromDay = PerpetualCalendar.convertLunarDate2GregorianDate(liuYueMingPan._year, liuYueMingPan.month, 1, 0, liuYueMingPan.monthIsRunYue);
	var toDay = PerpetualCalendar.convertLunarDate2GregorianDate(liuYueMingPan._year, liuYueMingPan.month, monthInfo[liuYueMingPan.monthIsRunYue ? liuYueMingPan.month : liuYueMingPan.month-1], 0, liuYueMingPan.monthIsRunYue);

	var liuYueMingYunShi = NewHome.getLiuYueMingYunShi(liuYueMingPan, "GONGWEI_MINGGONG", true, false, false);
	var liuYueFuQiYunShi = NewHome.getLiuYueMingYunShi(liuYueMingPan, "GONGWEI_FUQIGONG", true, false, false);
	var liuYueCaiBoYunShi = NewHome.getLiuYueMingYunShi(liuYueMingPan, "GONGWEI_CAIBOGONG", true, false, false);
	var liuYueShiYeYunShi = NewHome.getLiuYueMingYunShi(liuYueMingPan, "GONGWEI_SHIYEGONG", false, false, false);
	
	var result = {
		'liuYue' : liuYue,
		'fromDay' : {
			'y' : fromDay.getFullYear(),
			'm' : fromDay.getMonth() + 1,
			'd' : fromDay.getDate()
		},
		'toDay' : {
			'y' : toDay.getFullYear(),
			'm' : toDay.getMonth() + 1,
			'd' : toDay.getDate()
		},
		'total' : {
			'dz' : liuYueMingYunShi.dz,
			'description' : liuYueMingYunShi.description,
			'level' : liuYueMingYunShi.level
		},
		'aiqing' : {
			'dz' : liuYueFuQiYunShi.dz,
			'description' : liuYueFuQiYunShi.description,
			'level' : liuYueFuQiYunShi.level
		},
		'caibo' : {
			'dz' : liuYueCaiBoYunShi.dz,
			'description' : liuYueCaiBoYunShi.description,
			'level' : liuYueCaiBoYunShi.level
		},
		'shiye' : {
			'dz' : liuYueShiYeYunShi.dz,
			'description' : liuYueShiYeYunShi.description,
			'level' : liuYueShiYeYunShi.level
		}
	};
	
	return JSON.stringify(result);
};

NewHome.getLiuRiGanZhiAndYunShiDesp = function()
{
	if(arguments.length == 0)
	{
		return false;
	}
	
	var curUser = getCurrentUser().user;
	
	var param = eval("(" + arguments[0] + ")")
	var hour = parseInt(param.hour);
	var min = parseInt(param.min);
	
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	var dizhi = NewHome.getLiuRiMingGongGanZhi(liuRiMingPan);
	var desp = NewHome.getLiuRiYunShiDescription(liuRiMingPan, curUser, hour, min);
	var level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
	
	return JSON.stringify({
		'dz' : dizhi,
		'description' : desp,
		'level' : level
	});
}

/**
 * 获取流日命宫干支
 */
NewHome.getLiuRiMingGongGanZhi = function(liuRiMingPan)
{
	if(!liuRiMingPan)
	{
		liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	}
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		if(sections[i].getDayGongWei().indexOf("GONGWEI_MINGGONG") >= 0)
		{
			return Translator.translate(sections[i].getDiZhi());
		}
	}
	
	return false;
};

/**
 * 获取流日运势描述
 */
NewHome.getLiuRiYunShiDescription = function(liuRiMingPan, curUser, hour, min)
{
	if(!liuRiMingPan)
	{
		liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	}
	
	var huaLuInfo, huaJiInfo, huaLuGongWei, huaJiGongWei;
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		var stars = sections[i].getStars();
		
		for(var j = 0; j < stars.length; j ++)
		{
			var liuRiSiHua = stars[j].getSiHuaOfLiuRi();
			
			if("SIHUA_LU" == liuRiSiHua)
			{
				var gongWei = sections[i].getDayGongWei();
				huaLuInfo = NewHome._liuRiGongWeiEnergyDescription['SIHUA_LU'][gongWei];
				huaLuGongWei = gongWei;
			}
			
			if("SIHUA_JI" == liuRiSiHua)
			{
				var gongWei = sections[i].getDayGongWei();
				huaJiInfo = NewHome._liuRiGongWeiEnergyDescription['SIHUA_JI'][gongWei];
				huaJiGongWei = gongWei;
			}
		}
	}
	
	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	var mingGongStars = sanFangSiZhengStars['zuo'];
	var level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
	
	var stars = new Array();
	
	for(var i = 0; i < mingGongStars.length; i ++)
	{
		var starName = mingGongStars[i].getName();
		
		if(starName == "GEMSTAR_WENQUXING")
		{
			starName = "GEMSTAR_WENCHANGXING";
		}
		
		if(starName == "GEMSTAR_TIANYUEXING")
		{
			starName = "GEMSTAR_TIANKUIXING";
		}
		
		if(starName == "GEMSTAR_YOUBIXING")
		{
			starName = "GEMSTAR_ZUOFUXING";
		}
		
		/*
		if(starName == "FIENDSTAR_QINGYANGXING")
		{
			starName = "FIENDSTAR_TUOLUOXING";
		}
		*/
		
		if(starName == "FIENDSTAR_DIJIEXING")
		{
			starName = "FIENDSTAR_DIKONGXING";
		}
		
		stars.push(starName);
	}
	
	stars.unique();

	var liuShiMingPan = curUser.getLiuShiMingPan(liuRiMingPan.getYear(), liuRiMingPan.month, liuRiMingPan.day, hour, liuRiMingPan.monthIsRunYue);
	var liuShiLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuShiMingPan, "LiuShiMingPan");
	
	var energyDesp = ['负能量 暴强', '负能量 强', '负能量 中强', '负能量 次强', '正负能量 2:8', '正负能量 4:6', '正负能量 5:5', '正负能量 7:3', '正能量 次强', '正能量 中强', '正能量 强', '正能量 暴强'];
	var desp = "◎紫微大师能量报时：";
	desp += Translator.translate(Util.getLunarHour(hour)) + "时" + (hour < 10 ? "0"+hour : hour) + ":" + (min < 10 ? "0"+min : min) + "，能量运势为：";
	desp += energyDesp[liuShiLevel - 1];
	
	if(liuShiLevel > 8)
	{
		desp += "，请从此刻开始事半功倍。";
	}
	
	if(liuShiLevel < 5)
	{
		desp += "，休息一下放松身心。";
	}
	
	desp += "\r\n";
	
	desp += "◎今日流日化禄入" + Translator.translate(huaLuGongWei) + "，" + huaLuInfo + "。今天流日化忌入"+ Translator.translate(huaJiGongWei) + "，" + huaJiInfo + "。";
	desp += NewHome.getLiuRiEnergyTimePeriod(curUser, liuRiMingPan, level) + "\r\n";
	
	var liuRiGongWeiEnergyDesp = NewHome.calcLiuRiGongWeiEnergy(liuRiMingPan, level);
	
	if(liuRiGongWeiEnergyDesp)
	{
		desp += liuRiGongWeiEnergyDesp;
		desp += "\r\n";
	}
	
	var allDesp = [];
	allDesp.push(desp);
	desp = "";
	
	for(var i = 0; i < stars.length; i ++)
	{
		if(stars[i] in NewHome._liuRiStarEnergyDescription)
		{
			if(level > 6)
			{
				desp += NewHome._liuRiStarEnergyDescription[stars[i]][0];
				desp += "\r\n";
			}
			else
			{
				desp += NewHome._liuRiStarEnergyDescription[stars[i]][1];
				desp += "\r\n";
			}
		}
	}
	
	allDesp.push(desp);
	
	return allDesp;
};

NewHome.calcLiuRiGongWeiEnergy = function(liuRiMingPan, liuRiLevel)
{
	var result = [];
	
	if(liuRiLevel < 3 || liuRiLevel > 10)
		{
			result.push({
				'gongWei' : "GONGWEI_MINGGONG",
				'level' : liuRiLevel
			});
		}
	
	for(var i = 1; i < BizEnum.GONGWEI.length; i ++)
	{
		var gongWei = BizEnum.GONGWEI[i];
		var liuRiGongWeiLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuRiMingPan, "LiuRiMingPan");
		
		if(liuRiLevel < 6 && liuRiGongWeiLevel > 8)
		{
			if(gongWei == "GONGWEI_SHIYEGONG" || gongWei == "GONGWEI_CAIBOGONG" || gongWei == "GONGWEI_FUQIGONG" || gongWei == "GONGWEI_QIANYIGONG")
			{
				liuRiGongWeiLevel = 8;
			}
		}
		
		if(liuRiGongWeiLevel < 3 || liuRiGongWeiLevel > 10)
		{
			result.push({
				'gongWei' : gongWei,
				'level' : liuRiGongWeiLevel
			});
		}
	}
	
	var resultStr = "◎今日12宫必读：";
	var hasText = false;
	
	for(var i = 0; i < result.length; i ++)
	{
		var gongWeiObj = result[i];
		
		if(gongWeiObj.level < 3)
		{
			hasText = true;
			resultStr += Translator.translate(gongWeiObj.gongWei) + "," + NewHome._liuRiGongWeiEnergyDescription1['NEGATIVE'][gongWeiObj.gongWei] + "。";
		}
		
		if(gongWeiObj.level > 10 && gongWeiObj.gongWei != "GONGWEI_JIEGONG" && gongWeiObj.gongWei != "GONGWEI_FUDEGONG")
		{
			hasText = true;
			resultStr += Translator.translate(gongWeiObj.gongWei) + "," + NewHome._liuRiGongWeiEnergyDescription1['POSITIVE'][gongWeiObj.gongWei] + "。";
		}
	}
	
	return hasText ? resultStr : false;
}

NewHome.getLiuRiEnergyTimePeriod = function(curUser, liuRiMingPan, liuRiEnergyLevel)
{
	var resultZhengArr = [];
	var resultFuArr = [];
	var zhengArr = [];
	var fuArr = [];
	var liuRiLevelType = Math.ceil(liuRiEnergyLevel/4);
	
	var liuShiMingPan = curUser.getLiuShiMingPan(liuRiMingPan.getYear(), liuRiMingPan.month, liuRiMingPan.day, 0 , liuRiMingPan.monthIsRunYue);
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuShiMingPan, "LiuShiMingPan");

	if(Math.ceil(level/4) == 3)
	{
		resultZhengArr.push("0点");
	}
	
	if(Math.ceil(level/4) == 1)
	{
		resultFuArr.push("0点");
	}
	
	for(var i = 8; i <= 22; i += 2)
	{
		liuShiMingPan = curUser.getLiuShiMingPan(liuRiMingPan.getYear(), liuRiMingPan.month, liuRiMingPan.day, i, liuRiMingPan.monthIsRunYue);
		level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuShiMingPan, "LiuShiMingPan");
		
		if(Math.ceil(level/4) == 3)
		{
			zhengArr.push(i-1);
			zhengArr.push(i);
			zhengArr.push(i+1);
		}
		
		if(Math.ceil(level/4) == 1)
		{
			fuArr.push(i-1);
			fuArr.push(i);
			fuArr.push(i+1);
		}
	}

	zhengArr.push(25);
	zhengArr.unique();
	fuArr.push(25);
	fuArr.unique();
	
	if(zhengArr.length > 1)
	{
		var from = false;
		var to = false;

		for(var i = 0; i <zhengArr.length; i ++)
		{
			if(!from)
			{
				from = zhengArr[i];
				continue;
			}
			
			if(!to)
			{
				to = zhengArr[i];
				continue;
			}
			
			if(zhengArr[i] == to + 1)
			{
				to = zhengArr[i];
				continue;
			}
			
			if(zhengArr[i] - to > 1)
			{
				resultZhengArr.push(from + "-" + to + "点");
				
				from = zhengArr[i];
				to = false;
			}
		}
	}
	
	if(fuArr.length > 1)
	{
		var from = false;
		var to = false;

		for(var i = 0; i < fuArr.length; i ++)
		{
			if(!from)
			{
				from = fuArr[i];
				continue;
			}
			
			if(!to)
			{
				to = fuArr[i];
				continue;
			}
			
			if(fuArr[i] == to + 1)
			{
				to = fuArr[i];
				continue;
			}
			
			if(fuArr[i] - to > 1)
			{
				resultFuArr.push(from + "-" + to + "点");
				
				from = fuArr[i];
				to = false;
			}
		}
	}
	
	
	var resultStr = "";
	
	if(resultZhengArr.length > 0 || resultFuArr.length > 0)
	{
		resultStr = "今日";
		
		if(resultZhengArr.length > 0 && liuRiLevelType >= 2)
		{
			resultStr += "正能量时间易出现在" + resultZhengArr.join("、")+"好好利用。";
		}
		
		if(resultFuArr.length > 0 && liuRiLevelType <= 2)
		{
			resultStr += "负能量时间易出现在" + resultFuArr.join("、")+"多多注意。";
		}
	}

	return resultStr;
}

NewHome._liuRiGongWeiEnergyDescription1 = 
{
	'POSITIVE' : {
		"GONGWEI_MINGGONG" : "正能量适易发力提升自身整体运势",
		"GONGWEI_XIONGDIGONG" : "正能量适易借助兄弟姐妹的助力",
		"GONGWEI_FUQIGONG" : "正能量适易与另一半情感互动",
		"GONGWEI_ZINVGONG" : "正能量适易与孩子或员工互动",
		"GONGWEI_CAIBOGONG" : "能量适易在赚钱上发力",
		"GONGWEI_JIEGONG" : "身体易出现小毛病建议多活动运动",
		"GONGWEI_QIANYIGONG" : "正能量适易出门外出",
		"GONGWEI_JIAOYOUGONG" : "正能量适易借助朋友下属的助力",
		"GONGWEI_SHIYEGONG" : "正能量适易积极专注工作学习提升效率",
		"GONGWEI_TIANZHAIGONG" : "正能量适易打扫房间清洗车子",
		"GONGWEI_FUDEGONG" : "正能量适易精神放松享受生活",
		"GONGWEI_FUMUGONG" : "正能量适易与父母上司的互动寻求帮助"
	},
	'NEGATIVE' : {
		"GONGWEI_MINGGONG" : "负能量适易放平心态以静制动",
		"GONGWEI_XIONGDIGONG" : "负能量不适易兄弟姐妹的互动",
		"GONGWEI_FUQIGONG" : "负能量不适易与另一半情感互动避免矛盾",
		"GONGWEI_ZINVGONG" : "负能量不适易与孩子或员工亲密互动",
		"GONGWEI_CAIBOGONG" : "负能量预防破财",
		"GONGWEI_JIEGONG" : "负能量易应在身体健康",
		"GONGWEI_QIANYIGONG" : "负能量不适易出门外出",
		"GONGWEI_JIAOYOUGONG" : "负能量不适易与朋友下属的互动",
		"GONGWEI_SHIYEGONG" : "负能量预防工作学习上负面干扰",
		"GONGWEI_TIANZHAIGONG" : "负能量易应在房子车子",
		"GONGWEI_FUDEGONG" : "负能量提升抗压力与情绪控制",
		"GONGWEI_FUMUGONG" : "负能量不适易与父母上司的互动"
	}
};

NewHome._liuRiGongWeiEnergyDescription = 
{
	'SIHUA_LU' : {
		"GONGWEI_MINGGONG" : "正能量易应在自身整体运势上升",
		"GONGWEI_XIONGDIGONG" : "正能量易应在兄弟姐妹母亲",
		"GONGWEI_FUQIGONG" : "正能量易应在另一半",
		"GONGWEI_ZINVGONG" : "正能量易应在孩子宠物员工",
		"GONGWEI_CAIBOGONG" : "正能量易应在钱财",
		"GONGWEI_JIEGONG" : "身体易出现小毛病建议多活动运动",
		"GONGWEI_QIANYIGONG" : "正能量易应在出门外出",
		"GONGWEI_JIAOYOUGONG" : "正能量易应在朋友下属",
		"GONGWEI_SHIYEGONG" : "正能量易应在工作学业事业",
		"GONGWEI_TIANZHAIGONG" : "正能量易应在房子车子",
		"GONGWEI_FUDEGONG" : "正能量易应在精神情绪享受",
		"GONGWEI_FUMUGONG" : "正能量易应在父母文书上司"
	},
	'SIHUA_JI' : {
		"GONGWEI_MINGGONG" : "负能量易应在自身整体运势下降",
		"GONGWEI_XIONGDIGONG" : "负能量易应在兄弟姐妹母亲",
		"GONGWEI_FUQIGONG" : "负能量易应在另一半",
		"GONGWEI_ZINVGONG" : "负能量易应在孩子宠物员工",
		"GONGWEI_CAIBOGONG" : "负能量易应在钱财",
		"GONGWEI_JIEGONG" : "负能量易应在身体健康",
		"GONGWEI_QIANYIGONG" : "负能量易应在出门外出",
		"GONGWEI_JIAOYOUGONG" : "负能量易应在朋友下属",
		"GONGWEI_SHIYEGONG" : "负能量易应在工作学业事业",
		"GONGWEI_TIANZHAIGONG" : "负能量易应在房子车子",
		"GONGWEI_FUDEGONG" : "负能量易应在精神情绪享受",
		"GONGWEI_FUMUGONG" : "负能量易应在父母文书上司"
	}
};

NewHome._liuNianStarEnergyDescription = {
	'GONGWEI_MINGGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎今年紫微星主导整体运势：正能量极高，很适积极开展各项事情。好好利用好今年的能量，让自己更加优秀。今年开始自我要求显著提升，控制欲、领导力增强。做事更希望掌握主动权。自我表现欲强。尤其对于管理经营者是发号施令施展管理才能的最好时机。同样感情上也会占主导权总想控制对方，多给对方点空间也是经营感情的一种技巧。', '◎今年紫微星主导紫微的负面能量会释放出来，表现为自己过于强势，与他人关系紧张，遭人反感或远离，容易有孤独感，无助的苦恼。同时需要保持高度的警惕性防止自己做出过激的举动带来错误的判断导致金钱或名誉的损失。'],
		'MAINSTAR_TIANJIXING' : ['◎今年天机星主导整体运势：偏向好的变动。积极发挥今年头脑灵活思维敏捷的正能量，多多思考好好做个整体规划。让自己更加有目标有动力。今年还容易有拜访长辈、朋友聚会、出差等，外出频繁而忙碌。', '◎今年天机星主导负面能量的干扰：很容易因为某些事情思绪烦躁，越想越心烦。建议多出去走走，多运动，运动是释放负能量最佳方法。放空自己等好的年份再来处理解决。'], 
		'MAINSTAR_TAIYINXING' : ['◎今年太阴星主导整体运势：相对顺利。温柔体贴关爱的正能量可以增进情侣间的感情，今年找个时间一起去有水的地方游玩是个不错的选择。工作上还是可以按部就班的推进。今年可以开始自己的理财行动了，好的理财开始，是财富累积成功的一半。外地打拼的紫薯们可以多多给父母打打电话说说自己的事情都是很不错的正能量。', '◎今年太阴星主导负面能量的干扰：很容易因为感情的事纠葛苦恼。内心有种无力感。也会容易因为女性亲人或朋友产生不愉快的事情。容易发生计划好的事情中途出现偏差。调整修正慢慢就会走向正轨。太过柔弱会让自己错失很多机会，多去晒晒太阳，心情开朗起来，找回自信，你可以的。'],
		'MAINSTAR_TAIYANGXING' : ['◎今年太阳星主导整体运势：更加积极充满正能量。积极进取的心态让今年开展工作的效率更高也会更加顺利做出不错的成绩，名誉大大提升。内心更加愿意帮助需要帮助的人，行动起来，让朋友或同事更能感受到你的温暖吧。单身的紫薯们在心仪的对象面前要好好展现自我最棒的一面，恋爱运势大大提升。女性容易有不错的正桃花缘哦。', '◎今年太阳星主导负面能量的干扰是很容易发生：工作、考试、事业、名誉等负面的事情，招人抱怨等。容易与男性亲人发生不愉快的事情，女性也容易遇到不太好的桃花。'],
		'MAINSTAR_WUQUXING' : ['◎今年武曲星主导整体运势：对赚钱更加积极。今年最适宜跟人竞争比拼胜率极高，武曲为正财星，难得的利财年份一定要多多创造赚钱的机会努力争取创造好的财运基础。做事头脑冷静更加果敢，成功概率大大提升。', '◎今年武曲星主导的负面能量的干扰：容易为赚钱的事情发愁与困扰。今年最好开源节流，理性消费，保证现金流稳定，减少投资决策。股票等也建议今年不要参与。'],
		'MAINSTAR_TIANTONGXING' : ['◎今年天同星主导整体运势：偏向放松休闲正能量。今年很适宜吃喝玩乐放松身心,买点自己想买很久的宝贝对开运也是不错的选择哦，多约朋友聚会游玩，对于友情或爱情都是很好的增进方式。', '◎今年天同星主导的负能量会有干扰，很容易被感伤情绪带入。什么也不想做，懒散无力，整个人不在状态。情感相处也会发生不太合拍的状况，建议多鼓励和赞扬对方，坚持每天一个吻、一个拥抱、一句爱你，让爱情常鲜。'],
		'MAINSTAR_LIANZHENXING' : ['◎今年廉贞星主导整体运势：创新想法正能量极强。好的想法也会极其靠谱，快去实现出来，会有意想不到的惊喜哦。今年您恋爱运极强也很容易遇到心仪的对象。异地恋的情侣非常适宜视频聊天增加情感交流。今年也容易有突发性的好机遇发生，出现一定要好好把握。', '◎今年廉贞星主导的负能量会有干扰，容易因感情事纠结困扰。情绪不稳定，会发生与别人因一言不和，不遂己意而产生冲突的情况。'],
		'MAINSTAR_TIANFUXING' : ['◎今年天府星主导整体运势：更加顺利。今年工作生活表现都会很不错。很容易进入状态的月份，沉稳的心态即使出现的小麻烦你也能轻松解决。今年也是财运不错的年份哦！', '◎今年天府星主导的负能量会有干扰，容易心态不平衡，包容心差，会遇到困难挫折，计划难实现。内心会有些许空虚失落感。'],
		'MAINSTAR_TANLANGXING' : ['◎今年贪狼星主导欲望，桃花极强的一年。今年最适合约会交友。异性缘如此好的年份快快约吧，帝王合婚走起，邂逅喜欢的TA。工作上也适合交际拓展人脉关系，请客送礼最佳。事业机遇多多，异性的助力很大。今年也适合把自己和自己的家好好打扮一下，会带来好运气哦。', '◎今年贪狼星主导的负能量会有干扰，情绪不太稳定，容易欲望大，招惹桃花是非，有对象的容易感情不合。过贪而导致投资出现问题，偏财损失。'],
		'MAINSTAR_JUMENXING' : ['◎今年巨门星主导整体运势：表达能力大大提升，工作中沟通更加顺畅更具说服力。今年也是蛮有口福的呦。', '◎今年巨门星主导的负能量会有干扰，很容易与人发生口角与争执，或说话得罪到别人。建议说话注意方式，把握好分寸，言多必失。情侣、夫妻之间要注意互相理解，多包容对方一些。吃东西一定要注意饮食卫生，肠胃不好的就更要注意了。'],
		'MAINSTAR_TIANXIANGXING' : ['◎今年天相星主导整体运势：很适合与位高权重的人谈谈，争取给自己一些新的机会。好的心态帮助你工作中更敢于担当，今年也蛮适合研究学问，突破知识瓶颈，提升专业水平。今年开运法就是买些新衣服或配饰，心情也会大好哦！', '◎今年天相星主导的负能量会有干扰，总有一种有力无法施展的困境，要特别注意不要被他人的谎言而蒙蔽，小心受骗、破财。'],
		'MAINSTAR_TIANLIANGXING' : ['◎今年天梁星主导整体运势：贵人正能量极强。最近遇到困难可以在本月找人求助哦，他们都会给你极大的助力。体质弱的人今年也适宜看中医调养一下身体。相对来说你今年内心会更成熟，得到别人帮助的你也可以帮助其他需要帮助的小伙伴，会留下很好的声誉。', '◎今年天梁星主导的负能量会有干扰，很容易会发生突然的变故与挫折，让自己措手不及。感情或学业工作遇到瓶颈无法突破。'],
		'MAINSTAR_QISHAXING' : ['◎今年七杀星主导整体运势：全年出成绩的最好年份。事业工作上遗留的问题统统斩尽杀绝，大刀阔斧的干劲很有可能一举成名，地位高升。生活中一拖再拖始终未完成的的事情，也是可以完成的最佳时机。', '◎今年七杀星主导的负能量会有干扰，工作上有些刚愎自用，越是急于求成越是容易受挫。情绪复杂，易弄巧成拙，先调整好心态再行动也不迟，需注意防小人。'],
		'MAINSTAR_POJUNXING' : ['◎今年破军星主导整体运势：一生契机开始发力的最佳年份。今年一定要尽可能的激发自我潜能，提升自我。要好好利用如此极佳的正能量不要荒废掉。让自己能进步多少进步多少。工作、学业、生活统统发力吧。', '◎今年破军星主导的负能量会有干扰，工作上杂事特别多，有乱糟糟的感觉。很容易会发生工作事业突然进展不顺利，宜平心静气的来面对。易受伤需注意安全。'],
		'GEMSTAR_TIANMAXING' : ['◎今年天马星进入，容易有机会旅游、升迁、迁动的事情发生。动是正能量，积极拥抱变化吧。', ''],
		'GEMSTAR_WENCHANGXING' : ['◎今年昌曲星进入，艺术灵感很不错，可以好好利用到工作与生活中。学习知识是不错的年份，会发现学习的过程容易很多也更容易出成绩，适合报班提升自己。工作中专业技能的提升与发挥让你在自己的岗位表现更加出色。事业上也容易遇到签单、签约的好事情。感情方面也有利表达出来，可以买些小礼物送给对方。', '◎今年很容易会发生口舌是非，一定要注意表达。文字、数字方面一定要细心多检查几遍。契约、合同上容易有波折。'],
		'GEMSTAR_TIANKUIXING' : ['◎今年魁钺星进入，很容易得到长辈相助，机遇多多。感觉自己最近很不顺利也可以在今年借助宗教的力量改善运势。', '◎今年很容易遇到麻烦的事情，需要借助他人的力量来解决。多打电话寻求帮助是个不错的方法。如果感觉自己很不顺利也可以借助宗教的力量改善运势。'],
		'GEMSTAR_ZUOFUXING' : ['◎今年左右星进入，容易得到同事或朋友的帮助。工作上很适合团队协同作战。', '◎今年很容易有人跟你竞争，从而丢失很好的机会或利益，一定要注意哦。'],
		'GEMSTAR_LUCUNXING' : ['◎今年会比通常更加忙碌，有很多事情需要处理。同时也是个赚钱不错的好年份。', '◎今年化解负能量的最好方法是让自己忙碌起来，忘记烦恼，多用心工作赚钱吧。'],
		'FIENDSTAR_QINGYANGXING' : ['◎今年负能量来源于工作上的阻力和考虑欠佳的决定。多多听取同事领导的建议，再发挥超强的执行力去解决，做事不宜同时兼顾多项事务，择重优先完成，避免分心哪个都做不好。', '◎今年擎羊星负能量干扰大，务必要控制好心情减少过激的行为，做事控制好节奏，不能急于求成。'],
		'FIENDSTAR_TUOLUOXING' : ['◎今年的负能量：拖延与波折。好的心态是化解负能量的最佳良药。用内心强大的韧劲去征服挑战困难，学会坚持与忍耐你一定行。', '◎今年陀罗星负能量干扰大，纠结、郁闷、压抑无法摆脱，原定的事情总是反复没有结果。考验自己，磨练意志的时候到了。'],
		'FIENDSTAR_HUOXING' : ['◎今年的负能量来源于突如其来的困难与麻烦。情绪极其没有耐性，脾气急躁一点就着。要控制情绪，与麻烦减少互动，问题适当放一放再解决。', '◎今年火星负能量干扰大，很容易发生突如其来的麻烦与伤害，情绪若控制不好全部爆发出来反而让事情和结果变的更糟糕。一定要稳定情绪，冷静处理。'],
		'FIENDSTAR_LINGXING' : ['◎今年的负能量：精神上的压力或内心的伤害。控制心态，对生活多一点耐心，信心与坚持。不要半途而废，！','◎今年铃星负能量干扰大，虽有快速的行动力，也需要完整的计划与落实的执行，欠缺这两者，事情常常就会有头无尾，变化无常了。'],
		'FIENDSTAR_DIKONGXING' : ['◎今年的负能量：失去与结束。有得有失，才是人生，切忌忿忿不平。情感上遇到争执与矛盾，要尽量换位思考，尽最大程度迁就理解对方。 金钱上可以选择今年主动消费买自己想买喜欢的东西。请朋友吃饭，送家人礼物都是不错的选择。主动的破财可以有利释放被动的破财。工作上可以把好的创意与想法运用其中，多修改、多调整方案或文稿，直到自己满意。 ','◎今年空劫负能量干扰大，强大的负能量可能会令你的感情和工作很不顺利，如果实在坚持不下去，学会放弃也是为了迎接新的开始与希望。']
	},
	'GONGWEI_FUQIGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎今年另一半的自我要求提升，感情相处控制欲、占有欲大大提高。容易自以为是，听不进别人的意见，单身的朋友相亲的化有机会遇到条件不错的人哦。', '◎今年另一半的自我要求提升，感情相处控制欲、占有欲大大提高。容易自以为是，听不进别人的意见，单身的朋友相亲的化有机会遇到条件不错的人哦。'],
		'MAINSTAR_TIANJIXING' : ['◎今年有伴侣的小伙伴很容易因为感情失眠焦虑、神经衰弱。相处上为些小事钻牛角尖，造成一些不必要的误会。另一半最近会比较忙碌，聚少离多难免。单身的朋友可以多出去参加些活动和聚会，很有机会认识不错异性！', '◎今年有伴侣的小伙伴很容易因为感情失眠焦虑、神经衰弱。相处上为些小事钻牛角尖，造成一些不必要的误会。另一半最近会比较忙碌，聚少离多难免。单身的朋友可以多出去参加些活动和聚会，很有机会认识不错异性！'], 
		'MAINSTAR_TAIYINXING' : ['◎今年有伴侣的小伙伴可以充分发挥温柔体贴关爱的正能量，增进彼此的感情。找个时间一起去山清水秀的地方游玩是个不错的选择。单身的朋友很容易感情幻想多，行动起来发挥今年异性缘不错的正能量。', '◎今年有伴侣的小伙伴可以充分发挥温柔体贴关爱的正能量，增进彼此的感情。找个时间一起去山清水秀的地方游玩是个不错的选择。单身的朋友很容易感情幻想多，行动起来发挥今年异性缘不错的正能量。'],
		'MAINSTAR_TAIYANGXING' : ['◎今年另一半事业会比较忙碌从而忽略对家庭的照顾与情感交流。多多理解包容对方，不要胡思乱想，好好调整状态。单身的女性今年的桃花很旺，去帝王合婚看看，桃花还是要主动去争取的哦！', '◎今年另一半事业会比较忙碌从而忽略对家庭的照顾与情感交流。多多理解包容对方，不要胡思乱想，好好调整状态。单身的女性今年的桃花很旺，去帝王合婚看看，桃花还是要主动去争取的哦！'],
		'MAINSTAR_WUQUXING' : ['◎今年有伴侣的朋友生活中会有些沉闷，或因家里大小琐碎事情造成彼此的不愉快，许多事情还是要克制情绪，夫妻之间的是是非非，绝不是简单的对与错的问题。互相关爱、互相妥协才是维持美满婚姻的上策。单身的朋友今年建议把主要精力集中在工作和赚钱上。', '◎今年有伴侣的朋友生活中会有些沉闷，或因家里大小琐碎事情造成彼此的不愉快，许多事情还是要克制情绪，夫妻之间的是是非非，绝不是简单的对与错的问题。互相关爱、互相妥协才是维持美满婚姻的上策。单身的朋友今年建议把主要精力集中在工作和赚钱上。'],
		'MAINSTAR_TIANTONGXING' : ['◎今年另一半比较容易懒散，上进心不足，彼此依赖加强。放松的年份不妨一起去旅行游玩，放松身心的同时还能增进感情。单身的朋友今年很容易陷入苦恋或单恋或者喜欢上不该喜欢的人。参考解盘感情婚姻H3从中找到答案。', '◎今年另一半比较容易懒散，上进心不足，彼此依赖加强。放松的年份不妨一起去旅行游玩，放松身心的同时还能增进感情。单身的朋友今年很容易陷入苦恋或单恋或者喜欢上不该喜欢的人。参考解盘感情婚姻H3从中找到答案。'],
		'MAINSTAR_LIANZHENXING' : ['◎今年有伴侣的朋友会发生观念不同意见不合的争执。假如今年能聚少离多的化反而能增进彼此之间感情。异地恋的男性朋友每天养成给女朋友打电话的习惯吧，这是你每天除了工作、学习最重要的一件事，必须雷打不动哦。单身的朋友今年姻缘运还是很不错的。抓紧机会脱单吧。', '◎今年有伴侣的朋友会发生观念不同意见不合的争执。假如今年能聚少离多的化反而能增进彼此之间感情。有误会或矛盾一定不能冷战哦，敞开了说清楚比较好。单身的朋友今年很容易陷入一段纠结的爱情中。'],
		'MAINSTAR_TIANFUXING' : ['◎今年有伴侣的朋友感情关系还算和谐，相互可以得到彼此的助力。单身的朋友有机会认识相似的家世、目标、理想、嗜好、职业的异性。', '◎今年有伴侣的朋友感情关系还算和谐，相互可以得到彼此的助力。单身的朋友有机会认识相似的家世、目标、理想、嗜好、职业的异性。'],
		'MAINSTAR_TANLANGXING' : ['◎今年有伴侣的朋友感情比以往会更注重生活情趣，性欲也更旺盛。培养共同的兴趣可以增进感情。单身的朋友今年的桃花极强，今年最适合约会谈情说爱。异性缘如此好的年份快快约吧，帝王合婚走起，邂逅喜欢的TA。', '◎有伴侣的朋友今年很容易因为桃花多而相互猜忌，造成感情上的冲突与争吵。建议今年提高爱爱频率，有效释放桃花旺的负能量。单身的朋友也很容易招惹到烂桃花或者因为桃花招惹是非纠葛。建议今年减少参加活动与聚会,利用时间培养些兴趣爱好。'],
		'MAINSTAR_JUMENXING' : ['◎有伴侣的朋友今年很容易因为家庭琐事或者隐藏很久的感情问题而发生口角争执。或者因为没有沟通清楚，不理解对方引起误会造成语言上的伤害。今年相处之道多些赞扬对方的话语，温柔甜蜜的吻总能很快俘获她的心。建议今年还可以多去外面吃吃饭可以释放负能量的干扰。单身的朋友和喜欢的异性相处时也要注意说话方式，避免惹对方不高兴。', '◎有伴侣的朋友今年很容易因为家庭琐事或者隐藏很久的感情问题而发生口角争执。或者因为没有沟通清楚，不理解对方引起误会造成语言上的伤害。今年相处之道多些赞扬对方的话语，温柔甜蜜的吻总能很快俘获她的心。建议今年还可以多去外面吃吃饭可以释放负能量的干扰。单身的朋友和喜欢的异性相处时也要注意说话方式，避免惹对方不高兴。'],
		'MAINSTAR_TIANXIANGXING' : ['◎今年有伴侣的朋友很容易因为对方好面子或好管闲事而发生不愉快。今年培养感情的最好方法就是送对方礼物，给平淡的生活制造点小惊喜。单身的朋友可以主动要求同学、同事、朋友帮忙介绍对象。第一次见面时记得要送小礼物哦！', '◎今年有伴侣的朋友很容易因为对方好面子或好管闲事而发生不愉快。今年培养感情的最好方法就是送对方礼物，给平淡的生活制造点小惊喜。单身的朋友可以主动要求同学、同事、朋友帮忙介绍对象。第一次见面时记得要送小礼物哦！'],
		'MAINSTAR_TIANLIANGXING' : ['◎今年有伴侣的朋友要多包容及体贴另一半，不要总是说教或指责对方的不好。闲暇的时候两个人一起在近郊的公园走走也不错，单身的朋友今年很容易受父母长者的影响，家人会很着急你的感情婚姻。多多利用好交友平台比如帝王合婚，多多主动打招呼哦！', '◎今年有伴侣的朋友要多包容及体贴另一半，不要总是说教或指责对方的不好。闲暇的时候两个人一起在近郊的公园走走也不错，单身的朋友今年很容易受父母长者的影响，家人会很着急你的感情婚姻。多多利用好交友平台比如帝王合婚，多多主动打招呼哦！'],
		'MAINSTAR_QISHAXING' : ['◎今年有伴侣的朋友会内心会感到比较孤独，由于对方工作会比较忙碌会有聚少离多的现象，不要因为对方的忙碌而抱怨产生矛盾和争执。控制好情绪，多点包容，让彼此的心智成熟些。周末一起参加下家庭活动，逛街、运动健身都是不错的选择。单身的朋友今年很容易产生急迫的心态。内心很着急想找到满意的对象。恋爱中的朋友感情会发生变动。感情今年为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。', '◎今年有伴侣的朋友会内心会感到比较孤独，由于对方工作会比较忙碌会有聚少离多的现象，不要因为对方的忙碌而抱怨产生矛盾和争执。控制好情绪，多点包容，让彼此的心智成熟些。周末一起参加下家庭活动，逛街、运动健身都是不错的选择。单身的朋友今年很容易产生急迫的心态。内心很着急想找到满意的对象。恋爱中的朋友感情会发生变动。感情今年为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。'],
		'MAINSTAR_POJUNXING' : ['◎今年有伴侣的朋友好胜心加强，很容易固执己见，对另一半管的比较紧，往往因此争吵不休。最好一起培养点共同兴趣，增加生活上的乐趣。多沟通，工作忙碌之余抽空关心关心对方。单身的朋友今年很容易突然遇到喜欢的异性。大胆的释放出爱意，让对方感觉到你充足的正能量结果并不重要。恋爱中的朋友感情会发生变动。感情今年为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。', '◎今年有伴侣的朋友好胜心加强，很容易固执己见，对另一半管的比较紧，往往因此争吵不休。最好一起培养点共同兴趣，增加生活上的乐趣。多沟通，工作忙碌之余抽空关心关心对方。单身的朋友今年很容易突然遇到喜欢的异性。大胆的释放出爱意，让对方感觉到你充足的正能量结果并不重要。恋爱中的朋友感情会发生变动。感情今年为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。'],
		'GEMSTAR_WENCHANGXING' : ['◎今年感情方面很有利表达出来。对于大声表白和各种浪漫爱情宣言都是不错的年份。但也要注意感情过于丰富会面临第三者的干扰，严重的话因为感情复杂惹出婚姻的问题。', '◎今年感情方面很有利表达出来。对于大声表白和各种浪漫爱情宣言都是不错的年份。但也要注意感情过于丰富会面临第三者的干扰，严重的话因为感情复杂惹出婚姻的问题。'],
		'GEMSTAR_TIANKUIXING' : ['◎今年感情上很容易得到长辈相助，机遇多多。为感情纠结的紫薯们可以在今年借助宗教的力量。', '◎今年感情上很容易得到长辈相助，机遇多多。为感情纠结的紫薯们可以在今年借助宗教的力量。'],
		'GEMSTAR_ZUOFUXING' : ['◎今年感情方面多抱抱对方有助提升婚姻正能量。但切记要抱对人哦。', '◎今年感情方面多抱抱对方有助提升婚姻正能量。但切记要抱对人哦。'],
		'GEMSTAR_LUCUNXING' : ['◎今年多一些情感的行动表现可以化解感情相处出现的问题。', '◎今年多一些情感的行动表现可以化解感情相处出现的问题。'],
		'FIENDSTAR_QINGYANGXING' : ['◎今年感情方面有擎羊星的负能量干扰。很容易产生争执，发生暴力倾向。或因为言语攻击伤害到对方。一定要克制自己的情绪。已经提醒你了，你还犯错那就不应该了。', '◎今年感情方面有擎羊星的负能量干扰。很容易产生争执，发生暴力倾向。或因为言语攻击伤害到对方。一定要克制自己的情绪。已经提醒你了，你还犯错那就不应该了。'],
		'FIENDSTAR_TUOLUOXING' : ['◎今年感情方面有陀罗星的负能量干扰。感情最近反复会出现不顺的负能量让自己纠结。或者夫妻感情表面相安无事但已经貌合神离。合合分分反复不定的负能量在干扰。负能量的强弱取决你今年的感情整体运势。不管怎样还是蛮考验两个人相处之道的。两人在一起就是修行的过程。加油！', '◎今年感情方面有陀罗星的负能量干扰。感情最近反复会出现不顺的负能量让自己纠结。或者夫妻感情表面相安无事但已经貌合神离。合合分分反复不定的负能量在干扰。负能量的强弱取决你今年的感情整体运势。不管怎样还是蛮考验两个人相处之道的。两人在一起就是修行的过程。加油！'],
		'FIENDSTAR_HUOXING' : ['◎今年感情方面有火星的负能量干扰。负能量来源于突如其来的困难与麻烦。情绪很容易失控，言辞犀利，导致家人朋友都为你们担心。化解方法就是冷静应对。两人平静下来共同面对解决。', '◎今年感情方面有火星的负能量干扰。负能量来源于突如其来的困难与麻烦。情绪很容易失控，言辞犀利，导致家人朋友都为你们担心。化解方法就是冷静应对。两人平静下来共同面对解决。'],
		'FIENDSTAR_LINGXING' : ['◎今年感情方面有铃星的负能量干扰。已有恋人或家庭的男性需注意少和着装时尚前卫的异性单独接触，以免引起不必要的误会。负能量来源于感情上的精神压力。','◎今年感情方面有铃星的负能量干扰。已有恋人或家庭的男性需注意少和着装时尚前卫的异性单独接触，以免引起不必要的误会。负能量来源于感情上的精神压力。'],
		'FIENDSTAR_DIKONGXING' : ['◎今年感情方面最大的负能量来源于失去与结束。化解方法：情感上遇到争执与矛盾快速放弃互动关系。尽量换位思考，尽最大程度迁就理解对方。务必不能拿分手或离婚来吓唬对方。珍惜缘分，善待对方也是善待自己。另一半多创造出差工作或回父母家的机会，让两人分开一段时间或者是异地恋都可以有效释放负能量的干扰。','◎今年感情方面最大的负能量来源于失去与结束。化解方法：情感上遇到争执与矛盾快速放弃互动关系。尽量换位思考，尽最大程度迁就理解对方。务必不能拿分手或离婚来吓唬对方。珍惜缘分，善待对方也是善待自己。另一半多创造出差工作或回父母家的机会，让两人分开一段时间或者是异地恋都可以有效释放负能量的干扰。']
	},
	'GONGWEI_CAIBOGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎今年财帛对待上更偏向珍惜，理财的意识大大增强。自由职业或老板今年赚钱容易有贵人相助。赚钱的能量很不错。', '◎今年财帛对待上更偏向珍惜，理财的意识大大增强。自由职业或老板今年赚钱容易有贵人相助。赚钱的能量很不错。'],
		'MAINSTAR_TIANJIXING' : ['◎今年财帛对待上流动性增大，钱在手中不安慰，财来财去。建议今年适量开源节流。投机要谨慎。', '◎今年财帛对待上流动性增大，钱在手中不安慰，财来财去。建议今年适量开源节流。投机要谨慎。'], 
		'MAINSTAR_TAIYINXING' : ['◎今年财帛对待上偏向稳定。进财相对平顺。工薪人士今年适合开始做些固定理财产品。让自己财富稳定增长。', '◎今年财帛对待上偏向稳定。进财相对平顺。工薪人士今年适合开始做些固定理财产品。让自己财富稳定增长。'],
		'MAINSTAR_TAIYANGXING' : ['◎今年财帛对待上容易因为面子产生花销。整体属于花销比较大的年份。职场人士适合利用名气与专业影响力提升赚钱正能量。', '◎今年财帛对待上容易因为面子产生花销。整体属于花销比较大的年份。职场人士适合利用名气与专业影响力提升赚钱正能量。'],
		'MAINSTAR_WUQUXING' : ['◎今年财帛对待上对赚钱的欲望大增。今年正财星武曲驾到是非常适合投资理财，争取赚钱机会的好年份。老板管理人员适合加大投入，利用好赚钱的正能量。', '◎今年财帛对待上对赚钱的欲望大增。今年正财星武曲驾到是非常适合投资理财，争取赚钱机会的好年份。老板管理人员适合加大投入，利用好赚钱的正能量。'],
		'MAINSTAR_TIANTONGXING' : ['◎今年财帛对待上属于精打细算，钱财出入比较大。很容易在吃喝玩乐上开销增大。', '◎今年财帛对待上属于精打细算，钱财出入比较大。很容易在吃喝玩乐上开销增大。'],
		'MAINSTAR_LIANZHENXING' : ['◎今年财帛对待上处理与运用钱财的能力大大增强。适宜钱流通起来。不适合有赌博行为。', '◎今年财帛对待上处理与运用钱财的能力大大增强。适宜钱流通起来。不适合有赌博行为。'],
		'MAINSTAR_TIANFUXING' : ['◎今年财帛对待上储蓄的意识提升，守财能力变强。手上留有现金，会心情大好。自由职业或老板今年可以开拓更多财源，会有更多赚钱的门路。', '◎今年财帛对待上储蓄的意识提升，守财能力变强。手上留有现金，会心情大好。自由职业或老板今年可以开拓更多财源，会有更多赚钱的门路。'],
		'MAINSTAR_TANLANGXING' : ['◎今年财帛对待上投机的意识增强，求财心切。很容易物欲大增花销变大。尽量避免投机心态，花销也应该节制。流年正能量强易有偏财。', '◎今年财帛对待上投机的意识增强，求财心切。很容易物欲大增花销变大。尽量避免投机心态，花销也应该节制。流年正能量强易有偏财。'],
		'MAINSTAR_JUMENXING' : ['◎今年财帛对待上财源不太稳定，比较辛劳费力。需要付出更多。也要留意意外破财及支出。', '◎今年财帛对待上财源不太稳定，比较辛劳费力。需要付出更多。也要留意意外破财及支出。'],
		'MAINSTAR_TIANXIANGXING' : ['◎今年财帛对待上很容易因为生活享受而产生浪费。但整体来说财运不错，在处理赚钱上也更理性更有计划。 ', '◎今年财帛对待上很容易因为生活享受而产生浪费。但整体来说财运不错，在处理赚钱上也更理性更有计划。 '],
		'MAINSTAR_TIANLIANGXING' : ['◎今年财帛对待上更容易得到长辈的帮助。意外的财运大大增强。可以经由介绍得到额外收入。创业融资的小伙伴今年可以好好争取哦。', '◎今年财帛对待上更容易得到长辈的帮助。意外的财运大大增强。可以经由介绍得到额外收入。创业融资的小伙伴今年可以好好争取哦。'],
		'MAINSTAR_QISHAXING' : ['◎今年财帛对待上变动很大，易大起大落。赚钱的动力与冲劲十足。流年财运正能量今年偏财运会很不错。', '◎今年财帛对待上变动很大，易大起大落。赚钱的动力与冲劲十足。流年财运正能量今年偏财运会很不错。'],
		'MAINSTAR_POJUNXING' : ['◎今年财帛对待上多进财机会。但很容易来的快去的快，消耗极大。钱财不太稳定。应有周密的钱财运用计划，不要太急。', '◎今年财帛对待上多进财机会。但很容易来的快去的快，消耗极大。钱财不太稳定。应有周密的钱财运用计划，不要太急。'],
		'GEMSTAR_WENCHANGXING' : ['◎今年是进钱很不错的年份。要账要钱借钱都可以多用用心了。', '◎今年是进钱很不错的年份。要账要钱借钱都可以多用用心了。'],
		'GEMSTAR_TIANKUIXING' : ['◎今年在钱财上很容易得到长辈帮助。也适合借钱哦。', '◎今年在钱财上很容易得到长辈帮助。也适合借钱哦。'],
		'GEMSTAR_ZUOFUXING' : ['◎今年是偏财最好的年份。股票、投资、回扣你懂得…....', '◎今年是偏财最好的年份。股票、投资、回扣你懂得…....'],
		'GEMSTAR_LUCUNXING' : ['◎今年财帛对待上节俭意识增强，赚钱更加用心努力。', '◎今年财帛对待上节俭意识增强，赚钱更加用心努力。'],
		'FIENDSTAR_QINGYANGXING' : ['◎今年财帛对待上有擎羊负能量干扰。很容易无金钱概念花销没有节制。或者竞争激烈赚钱难度加大。', '◎今年财帛对待上有擎羊负能量干扰。很容易无金钱概念花销没有节制。或者竞争激烈赚钱难度加大。'],
		'FIENDSTAR_TUOLUOXING' : ['◎今年财帛对待上有陀罗负能量干扰。很容易钱财不稳定。说好到账的钱迟迟不来。', '◎今年财帛对待上有陀罗负能量干扰。很容易钱财不稳定。说好到账的钱迟迟不来。'],
		'FIENDSTAR_HUOXING' : ['◎今年财帛对待上有火星负能量干扰。钱财的起伏大。开支大，容易意外破财。', '◎今年财帛对待上有火星负能量干扰。钱财的起伏大。开支大，容易意外破财。'],
		'FIENDSTAR_LINGXING' : ['◎今年财帛对待上有铃星负能量干扰。收入不稳定，用钱没节制。赚钱压力大增。','◎今年财帛对待上有铃星负能量干扰。收入不稳定，用钱没节制。赚钱压力大增。'],
		'FIENDSTAR_DIKONGXING' : ['◎今年财帛对待上有空劫星负能量干扰。是破财最严重的年份。很容易感觉没钱了，为钱困扰。莫名的开支加大，钱也赚不到，还有意外支出。总之入不敷出。','◎今年财帛对待上有空劫星负能量干扰。是破财最严重的年份。很容易感觉没钱了，为钱困扰。莫名的开支加大，钱也赚不到，还有意外支出。总之入不敷出。']
	},
	'GONGWEI_SHIYEGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎今年事业的关键词是地位与命令。职场人士本月要力争上游，对权利欲望强。容易固执、主观，建议多参与团队配合，提高团队协作能力。管理者今年领导能力更强可以充分发挥提升地位与效率。', '◎今年事业的关键词是地位与命令。职场人士本月要力争上游，对权利欲望强。容易固执、主观，建议多参与团队配合，提高团队协作能力。管理者今年领导能力更强可以充分发挥提升地位与效率。'],
		'MAINSTAR_TIANJIXING' : ['◎今年事业的关键词是灵活与多虑、不稳定。职场人士今年主要表现为不稳定，在开展工作时会想的太多，做事情畏首畏尾，怕这怕那，工作效率低。又或者遇到一点不顺利就考虑要换工作。建议要心怀必胜、积极的想法，提高执行力。', '◎今年事业的关键词是灵活与多虑、不稳定。职场人士今年主要表现为不稳定，在开展工作时会想的太多，做事情畏首畏尾，怕这怕那，工作效率低。又或者遇到一点不顺利就考虑要换工作。建议要心怀必胜、积极的想法，提高执行力。'], 
		'MAINSTAR_TAIYINXING' : ['◎今年事业的关键词是计划与完美。职场人士今年主要表现为计划性很强，可以按部就班的开展工作。对工作也会尽善尽美，颇能得到领导和客户的认可，但要多多留意竞争对手的干扰。', '◎今年事业的关键词是计划与完美。职场人士今年主要表现为计划性很强，可以按部就班的开展工作。对工作也会尽善尽美，颇能得到领导和客户的认可，但要多多留意竞争对手的干扰。'],
		'MAINSTAR_TAIYANGXING' : ['◎今年事业的关键词是奉献与消耗、持续力。职场人士今年属于稳扎稳打，机遇与挑战并存。更愿意积极主动的参与工作。', '◎今年事业的关键词是奉献与消耗、持续力。职场人士今年属于稳扎稳打，机遇与挑战并存。更愿意积极主动的参与工作。'],
		'MAINSTAR_WUQUXING' : ['◎今年事业的关键词是现实与计划性、失衡。职场人士今年工作中擅长计算与评估，对自己有更切实的要求，可能时常计算投入和收益。进而有失衡的现象，譬如失去持续力。工作中收敛下固执强势的一面，注意人际关系的处理,提防小人。,提防小人。', '◎今年事业的关键词是现实与计划性、失衡。职场人士今年工作中擅长计算与评估，对自己有更切实的要求，可能时常计算投入和收益。进而有失衡的现象，譬如失去持续力。工作中收敛下固执强势的一面，注意人际关系的处理,提防小人。,提防小人。'],
		'MAINSTAR_TIANTONGXING' : ['◎今年事业的关键词是耐受性。职场人士今年工作的看法可以用知足来形容。对状况的适应性很强。即使工作很辛苦也依然会坚持做下去，耐力十足。', '◎今年事业的关键词是耐受性。职场人士今年工作的看法可以用知足来形容。对状况的适应性很强。即使工作很辛苦也依然会坚持做下去，耐力十足。'],
		'MAINSTAR_LIANZHENXING' : ['◎今年事业的关键词是果断与自负、纷争。职场人士今年工作非常有行动力，创新精神极强，做事情积极、有效率，常认为自己做的是对的。但有时别人不领情反而带来误解与抱怨。切勿感情用事，多处理好人际关系。', '◎今年事业的关键词是果断与自负、纷争。职场人士今年工作非常有行动力，创新精神极强，做事情积极、有效率，常认为自己做的是对的。但有时别人不领情反而带来误解与抱怨。切勿感情用事，多处理好人际关系。'],
		'MAINSTAR_TIANFUXING' : ['◎今年事业的关键词是授权与回报、两手策略。职场人士今年工作更善于汇报工作。更细心算计。管理者更擅长授权以及重视汇报。对下属的表现也更多的还是鼓励。  ', '◎今年事业的关键词是授权与回报、两手策略。职场人士今年工作更善于汇报工作。更细心算计。管理者更擅长授权以及重视汇报。对下属的表现也更多的还是鼓励。  '],
		'MAINSTAR_TANLANGXING' : ['◎今年事业的关键词是资源、交际。职场人士今年工作喜欢做自己感兴趣的项目，工作中更加重视人际关系，尝试建立自己的人脉，对外开展业务更加积极。改善急躁，束缚贪念，多干实事少说话，改善华而不实的现象。', '◎今年事业的关键词是资源、交际。职场人士今年工作喜欢做自己感兴趣的项目，工作中更加重视人际关系，尝试建立自己的人脉，对外开展业务更加积极。改善急躁，束缚贪念，多干实事少说话，改善华而不实的现象。'],
		'MAINSTAR_JUMENXING' : ['◎今年事业的关键词是口才与纠纷。职场人士今年工作积极发挥口才表达，分析能力提升，但疑心变大。如今年事业为负能量建议要慎言，远离公司是非，切忌锋芒毕露，招人嫉妒，提高自身心理素质。', '◎今年事业的关键词是口才与纠纷。职场人士今年工作积极发挥口才表达，分析能力提升，但疑心变大。如今年事业为负能量建议要慎言，远离公司是非，切忌锋芒毕露，招人嫉妒，提高自身心理素质。'],
		'MAINSTAR_TIANXIANGXING' : ['◎今年事业的关键词是地位与现实、服务。职场人士今年工作重视自我实现，不太讲人情。不宜在名义上占取高位，否则容易受人攻击与排挤。协助上司开展工作,培养果断决策的工作习惯，以及坚韧的意志力，不要受外界环境和人事干扰。', '◎今年事业的关键词是地位与现实、服务。职场人士今年工作重视自我实现，不太讲人情。不宜在名义上占取高位，否则容易受人攻击与排挤。协助上司开展工作,培养果断决策的工作习惯，以及坚韧的意志力，不要受外界环境和人事干扰。'],
		'MAINSTAR_TIANLIANGXING' : ['◎今年事业的关键词是协调与稳定、处理。职场人士今年工作稳定性较高，对于工作中的意外状况能够很快的处理解决。协调组织都能拿捏到位。可以发挥协调者的正能量。', '◎今年事业的关键词是协调与稳定、处理。职场人士今年工作稳定性较高，对于工作中的意外状况能够很快的处理解决。协调组织都能拿捏到位。可以发挥协调者的正能量。'],
		'MAINSTAR_QISHAXING' : ['◎今年事业的关键词是规划与统合、管理。职场人士今年自我发挥意识更强，希望上司可以放权。在职场表现更加积极。工作中的执行力与效率更高。今年可以发挥管理及策划的正能量。', '◎今年事业的关键词是规划与统合、管理。职场人士今年自我发挥意识更强，希望上司可以放权。在职场表现更加积极。工作中的执行力与效率更高。今年可以发挥管理及策划的正能量。'],
		'MAINSTAR_POJUNXING' : ['◎今年事业的关键词是行动与执行、领导。职场人士今年干劲十足,开创力大增。但防止在工作中太过随性。今年管理者要在投资或经营管理上注意不要意气用事、感情用事。避免三分钟热度的事情发生。', '◎今年事业的关键词是行动与执行、领导。职场人士今年干劲十足,开创力大增。但防止在工作中太过随性。今年管理者要在投资或经营管理上注意不要意气用事、感情用事。避免三分钟热度的事情发生。'],
		'GEMSTAR_WENCHANGXING' : ['◎今年事业的关键词是技能。职场人士今年可以积极发挥专业技能提升的正能量，帮助工作能力进一步提升。可以多多参与职业培训，参加资格考证。今年也利于签约、签合同。', '◎今年事业的关键词是技能。职场人士今年可以积极发挥专业技能提升的正能量，帮助工作能力进一步提升。可以多多参与职业培训，参加资格考证。今年也利于签约、签合同。'],
		'GEMSTAR_TIANKUIXING' : ['◎今年事业的关键词是帮助。今年工作中很容易得到长辈相助，机遇多多。如遇到问题也可以主动找领导上司提供帮助。', '◎今年事业的关键词是帮助。今年工作中很容易得到长辈相助，机遇多多。如遇到问题也可以主动找领导上司提供帮助。'],
		'GEMSTAR_ZUOFUXING' : ['◎今年事业的关键词是协助。工作中一定要积极利用团队协作的正能量。遇到困难可以找同事或朋友帮忙。他们的助力可以帮你有效解决工作中遇到的问题。', '◎今年事业的关键词是协助。工作中一定要积极利用团队协作的正能量。遇到困难可以找同事或朋友帮忙。他们的助力可以帮你有效解决工作中遇到的问题。'],
		'GEMSTAR_LUCUNXING' : ['◎今年事业方面会比较忙碌而充实。机会也比往常会多不少。让自己动起来创造更多工作表现。', '◎今年事业方面会比较忙碌而充实。机会也比往常会多不少。让自己动起来创造更多工作表现。'],
		'FIENDSTAR_QINGYANGXING' : ['◎今年工作事业方面有擎羊星的负能量干扰。很容易产生明显的阻力与波折。通常属于来的快去的快，所有要有耐心，不要急于求成。等待激发的能量，稳定住心态。', '◎今年工作事业方面有擎羊星的负能量干扰。很容易产生明显的阻力与波折。通常属于来的快去的快，所有要有耐心，不要急于求成。等待激发的能量，稳定住心态。'],
		'FIENDSTAR_TUOLUOXING' : ['◎今年工作事业方面有陀罗星的负能量干扰。工作事业容易反复会出现不顺的负能量让自己纠结，迟迟没有结果，不能立即解决。建议可以反复打磨项目产品，化解负能量干扰。心态非常关键。', '◎今年工作事业方面有陀罗星的负能量干扰。工作事业容易反复会出现不顺的负能量让自己纠结，迟迟没有结果，不能立即解决。建议可以反复打磨项目产品，化解负能量干扰。心态非常关键。'],
		'FIENDSTAR_HUOXING' : ['◎今年工作事业方面有火星的负能量干扰。负能量来源于如其来的困难与麻烦。爆发力极强无法阻挡无法招架。一定要精力辛苦一番才能有所收获。', '◎今年工作事业方面有火星的负能量干扰。负能量来源于如其来的困难与麻烦。爆发力极强无法阻挡无法招架。一定要精力辛苦一番才能有所收获。'],
		'FIENDSTAR_LINGXING' : ['◎今年工作事业方面有铃星的负能量干扰。负能量来源于暗藏危机，杀伤力持久。工作中磨练自己的意志，经历过后在挫折中成长。','◎今年工作事业方面有铃星的负能量干扰。负能量来源于暗藏危机，杀伤力持久。工作中磨练自己的意志，经历过后在挫折中成长。'],
		'FIENDSTAR_DIKONGXING' : ['◎今年工作事业方面有地空星负能量干扰。负能量来源于想法很好但现实并非如此。太过于幻想虚而不实。职场人士也要注意自己的错误的想法导致离职的冲动。经营创业者要注意想法无法落地导致的失败。','◎今年工作事业方面有地空星负能量干扰。负能量来源于想法很好但现实并非如此。太过于幻想虚而不实。职场人士也要注意自己的错误的想法导致离职的冲动。经营创业者要注意想法无法落地导致的失败。'],
		'FIENDSTAR_DIJIEXING' : ['◎今年工作事业方面有地劫星负能量干扰。负能量来源于工作中的波折与失利，项目合作丢失等。更偏向物质层面并且频繁。职场人士也要注意因为物质因素导致离职的冲动。经营创业者要注意创业失败或者项目失败或者投入打了水漂。','◎今年工作事业方面有地劫星负能量干扰。负能量来源于工作中的波折与失利，项目合作丢失等。更偏向物质层面并且频繁。职场人士也要注意因为物质因素导致离职的冲动。经营创业者要注意创业失败或者项目失败或者投入打了水漂。']
	}
};

NewHome._liuYueMingStarEnergyDescription = {
	'GONGWEI_MINGGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎本月紫微星主导整体运势：正能量极高，很适积极开展各项事情。好好利用好这个月的能量，让自己更加优秀。本月开始自我要求显著提升，控制欲、领导力增强。做事更希望掌握主动权。自我表现欲强。尤其对于管理经营者是发号施令施展管理才能的最好时机。同样感情上也会占主导权总想控制对方，多给对方点空间也是经营感情的一种技巧', '◎本月紫微星主导紫微的负面能量会释放出来，表现为自己过于强势，与他人关系紧张，遭人反感或远离，容易有孤独感，无助的苦恼。同时需要保持高度的警惕性防止自己做出过激的举动带来错误的判断导致金钱或名誉的损失。'],
		'MAINSTAR_TIANJIXING' : ['◎本月天机星主导整体运势：偏向好的变动。积极发挥本月头脑灵活思维敏捷的正能量，多多思考好好做个整体规划。让自己更加有目标有动力。本月还容易有拜访长辈、朋友聚会、出差等，外出频繁而忙碌。', '◎本月天机星主导负面能量的干扰：很容易因为某些事情思绪烦躁，越想越心烦。建议多出去走走，多运动，运动是释放负能量最佳方法。放空自己等好的月份再来处理解决。'], 
		'MAINSTAR_TAIYINXING' : ['◎本月太阴星主导整体运势：相对顺利。温柔体贴关爱的正能量可以增进情侣间的感情，本月找个时间一起去有水的地方游玩是个不错的选择。工作上还是可以按部就班的推进。本月可以开始自己的理财行动了，好的理财开始，是财富累积成功的一半。外地打拼的紫薯们可以多多给父母打打电话说说自己最近的事情都是很不错的正能量。', '◎本月太阴星主导负面能量的干扰：很容易因为感情的事纠葛苦恼。内心有种无力感。也会容易因为女性亲人或朋友产生不愉快的事情。容易发生计划好的事情中途出现偏差。调整修正慢慢就会走向正轨。太过柔弱会让自己错失很多机会，多去晒晒太阳，心情开朗起来，找回自信，你可以的。'],
		'MAINSTAR_TAIYANGXING' : ['◎本月太阳星主导整体运势：更加积极充满正能量。积极进取的心态让本月开展工作的效率更高也会更加顺利做出不错的成绩，名誉大大提升。内心更加愿意帮助需要帮助的人，行动起来，让朋友或同事更能感受到你的温暖吧。单身的紫薯们在心仪的对象面前要好好展现自我最棒的一面，恋爱运势大大提升。女性容易有不错的正桃花缘哦。', '◎本月太阳星主导负面能量的干扰是很容易发生：工作、考试、事业、名誉等负面的事情，招人抱怨等。容易与男性亲人发生不愉快的事情，女性也容易遇到不太好的桃花。'],
		'MAINSTAR_WUQUXING' : ['◎本月武曲星主导整体运势：对赚钱更加积极。本月最适宜跟人竞争比拼胜率极高，武曲为正财星，整年难得的利财月份一定要多多创造赚钱的机会努力争取为本年创造好的财运基础。做事头脑冷静更加果敢，成功概率大大提升。', '◎本月武曲星主导的负面能量的干扰：容易为赚钱的事情发愁与困扰。本月最好开源节流，理性消费，保证现金流稳定，减少投资决策。股票等也建议本月不要参与。'],
		'MAINSTAR_TIANTONGXING' : ['◎本月天同星主导整体运势：偏向放松休闲正能量。本月很适宜吃喝玩乐放松身心,买点自己想买很久的宝贝对开运也是不错的选择哦，多约朋友聚会游玩，对于友情或爱情都是很好的增进方式。', '◎本月天同星主导的负能量会有干扰，很容易被感伤情绪带入。什么也不想做，懒散无力，整个人不在状态。情感相处也会发生不太合拍的状况，建议多鼓励和赞扬对方，坚持每天一个吻、一个拥抱、一句爱你，让爱情常鲜。'],
		'MAINSTAR_LIANZHENXING' : ['◎本月廉贞星主导整体运势：创新想法正能量极强。好的想法也会极其靠谱，快去实现出来，会有意想不到的惊喜哦。本月您恋爱运极强也很容易遇到心仪的对象。异地恋的情侣非常适宜视频聊天增加情感交流。本月也容易有突发性的好机遇发生，出现一定要好好把握。', '◎本月廉贞星主导的负能量会有干扰，容易因感情事纠结困扰。情绪不稳定，会发生与别人因一言不和，不遂己意而产生冲突的情况。'],
		'MAINSTAR_TIANFUXING' : ['◎本月天府星主导整体运势：更加顺利。本月工作生活表现都会很不错。很容易进入状态的月份，沉稳的心态即使出现的小麻烦你也能轻松解决。本月也是财运不错的月份哦！', '◎本月天府星主导的负能量会有干扰，容易心态不平衡，包容心差，会遇到困难挫折，计划难实现。内心会有些许空虚失落感。'],
		'MAINSTAR_TANLANGXING' : ['◎本月贪狼星主导欲望，桃花极强的一个月。本月最适合约会交友。异性缘如此好的月份快快约吧，帝王合婚走起，邂逅喜欢的TA。工作上也适合交际拓展人脉关系，请客送礼最佳月份。事业机遇多多，异性的助力很大。本月也适合把自己和自己的家好好打扮一下，会带来好运气哦。', '◎本月贪狼星主导的负能量会有干扰，情绪不太稳定，容易欲望大，招惹桃花是非，有对象的容易感情不合。过贪而导致投资出现问题，偏财损失。'],
		'MAINSTAR_JUMENXING' : ['◎本月巨门星主导整体运势：表达能力大大提升，工作中沟通更加顺畅更具说服力。本月也是蛮有口福的一个月。', '◎本月巨门星主导的负能量会有干扰，很容易与人发生口角与争执，或说话得罪到别人。建议说话注意方式，把握好分寸，言多必失。情侣、夫妻之间要注意互相理解，多包容对方一些。吃东西一定要注意饮食卫生，肠胃不好的就更要注意了。'],
		'MAINSTAR_TIANXIANGXING' : ['◎本月天相星主导整体运势：很适合与位高权重的人谈谈，争取给自己一些新的机会。好的心态帮助你工作中更敢于担当，本月也蛮适合研究学问，突破知识瓶颈，提升专业水平。本月开运法就是买些新衣服或配饰，心情也会大好哦！', '◎本月天相星主导的负能量会有干扰，总有一种有力无法施展的困境，要特别注意不要被他人的谎言而蒙蔽，小心受骗、破财。'],
		'MAINSTAR_TIANLIANGXING' : ['◎本月天梁星主导整体运势：贵人正能量极强。最近遇到困难可以在本月找人求助哦，他们都会给你极大的助力。体质弱的人这个月也适宜看中医调养一下身体。相对来说你这个月内心会更成熟，得到别人帮助的你也可以帮助其他需要帮助的小伙伴，会留下很好的声誉。', '◎本月天梁星主导的负能量会有干扰，很容易会发生突然的变故与挫折，让自己措手不及。感情或学业工作遇到瓶颈无法突破。'],
		'MAINSTAR_QISHAXING' : ['◎本月七杀星主导整体运势：全年出成绩的最好月份。事业工作上遗留的问题统统斩尽杀绝，大刀阔斧的干劲很有可能一举成名，地位高升。生活中一拖再拖始终未完成的的事情，也是可以完成的最佳时机。', '◎本月七杀星主导的负能量会有干扰，工作上有些刚愎自用，越是急于求成越是容易受挫。情绪复杂，易弄巧成拙，先调整好心态再行动也不迟，需注意防小人。'],
		'MAINSTAR_POJUNXING' : ['◎本月破军星主导整体运势：全年契机开始发力的最佳月份。本月一定要尽可能的激发自我潜能，提升自我。要好好利用如此极佳的正能量不要荒废掉。让自己能进步多少进步多少。工作、学业、生活统统发力吧。', '◎本月破军星主导的负能量会有干扰，工作上杂事特别多，有乱糟糟的感觉。很容易会发生工作事业突然进展不顺利，宜平心静气的来面对。易受伤需注意安全。'],
		'GEMSTAR_TIANMAXING' : ['◎本月天马星进入，容易有机会旅游、升迁、迁动的事情发生。动是正能量，积极拥抱变化吧。', ''],
		'GEMSTAR_WENCHANGXING' : ['◎本月昌曲星进入，艺术灵感很不错，可以好好利用到工作与生活中。学习知识是不错的月份，会发现学习的过程容易很多也更容易出成绩，适合报班提升自己。工作中专业技能的提升与发挥让你在自己的岗位表现更加出色。事业上也容易遇到签单、签约的好事情。感情方面也有利表达出来，可以买些小礼物送给对方。', '◎本月很容易会发生口舌是非，一定要注意表达。文字、数字方面一定要细心多检查几遍。契约、合同上容易有波折。'],
		'GEMSTAR_TIANKUIXING' : ['◎本月魁钺星进入，很容易得到长辈相助，机遇多多。感觉自己最近很不顺利也可以在本月借助宗教的力量改善运势。', '◎本月很容易遇到麻烦的事情，需要借助他人的力量来解决。多打电话寻求帮助是个不错的方法。如果感觉自己最近很不顺利也可以在今天借助宗教的力量改善运势。'],
		'GEMSTAR_ZUOFUXING' : ['◎本月左右星进入，容易得到同事或朋友的帮助。工作上很适合团队协同作战。', '◎本月很容易有人跟你竞争，从而丢失很好的机会或利益，一定要注意哦。'],
		'GEMSTAR_LUCUNXING' : ['◎本月会比通常更加忙碌，有很多事情需要处理。同时也是个赚钱不错的好月份。', '◎本月化解负能量的最好方法是让自己忙碌起来，忘记烦恼，多用心工作赚钱吧。'],
		'FIENDSTAR_QINGYANGXING' : ['◎本月负能量来源于工作上的阻力和考虑欠佳的决定。多多听取同事领导的建议，再发挥超强的执行力去解决，做事不宜同时兼顾多项事务，择重优先完成，避免分心哪个都做不好。', '◎本月擎羊星负能量干扰大，务必要控制好心情减少过激的行为，做事控制好节奏，不能急于求成。'],
		'FIENDSTAR_TUOLUOXING' : ['◎本月的负能量：拖延与波折。好的心态是化解负能量的最佳良药。用内心强大的韧劲去征服挑战困难，学会坚持与忍耐你一定行。', '◎本月陀罗星负能量干扰大，纠结、郁闷、压抑无法摆脱，原定的事情总是反复没有结果。考验自己，磨练意志的时候到了。'],
		'FIENDSTAR_HUOXING' : ['◎本月的负能量来源于突如其来的困难与麻烦。情绪极其没有耐性，脾气急躁一点就着。要控制情绪，与麻烦减少互动，问题适当放一放再解决。', '◎本月火星负能量干扰大，很容易发生突如其来的麻烦与伤害，情绪若控制不好全部爆发出来反而让事情和结果变的更糟糕。一定要稳定情绪，冷静处理。'],
		'FIENDSTAR_LINGXING' : ['◎本月的负能量：精神上的压力或内心的伤害。控制心态，对生活多一点耐心，信心与坚持。不要半途而废！','◎本月铃星负能量干扰大，虽有快速的行动力，也需要完整的计划与落实的执行，欠缺这两者，事情常常就会有头无尾，变化无常了。'],
		'FIENDSTAR_DIKONGXING' : ['◎本月的负能量：失去与结束。有得有失，才是人生，切忌忿忿不平。情感上遇到争执与矛盾，要尽量换位思考，尽最大程度迁就理解对方。 金钱上可以选择本月主动消费买自己想买喜欢的东西。请朋友吃饭，送家人礼物都是不错的选择。主动的破财可以有利释放被动的破财。工作上可以把好的创意与想法运用其中，多修改、多调整方案或文稿，直到自己满意。 ','◎本月空劫负能量干扰大，强大的负能量可能会令你的感情和工作很不顺利，如果实在坚持不下去，学会放弃也是为了迎接新的开始与希望。']
	},
	'GONGWEI_FUQIGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎本月另一半的自我要求提升，感情相处控制欲、占有欲大大提高。容易自以为是，听不进别人的意见，单身的朋友相亲的化有机会遇到条件不错的人哦。', '◎本月另一半的自我要求提升，感情相处控制欲、占有欲大大提高。容易自以为是，听不进别人的意见，单身的朋友相亲的化有机会遇到条件不错的人哦。'],
		'MAINSTAR_TIANJIXING' : ['◎本月有伴侣的小伙伴很容易因为感情失眠焦虑、神经衰弱。相处上为些小事钻牛角尖，造成一些不必要的误会。另一半最近会比较忙碌，聚少离多难免。单身的朋友可以多出去参加些活动和聚会，很有机会认识不错异性！', '◎本月有伴侣的小伙伴很容易因为感情失眠焦虑、神经衰弱。相处上为些小事钻牛角尖，造成一些不必要的误会。另一半最近会比较忙碌，聚少离多难免。单身的朋友可以多出去参加些活动和聚会，很有机会认识不错异性！'], 
		'MAINSTAR_TAIYINXING' : ['◎本月有伴侣的小伙伴可以充分发挥温柔体贴关爱的正能量，增进彼此的感情。找个时间一起去山清水秀的地方游玩是个不错的选择。单身的朋友很容易感情幻想多，行动起来发挥本月异性缘不错的正能量。', '◎本月有伴侣的小伙伴可以充分发挥温柔体贴关爱的正能量，增进彼此的感情。找个时间一起去山清水秀的地方游玩是个不错的选择。单身的朋友很容易感情幻想多，行动起来发挥本月异性缘不错的正能量。'],
		'MAINSTAR_TAIYANGXING' : ['◎本月另一半事业会比较忙碌从而忽略对家庭的照顾与情感交流。多多理解包容对方，不要胡思乱想，好好调整状态。单身的女性本月的桃花很旺，去帝王合婚看看，桃花还是要主动去争取的哦！', '◎本月另一半事业会比较忙碌从而忽略对家庭的照顾与情感交流。多多理解包容对方，不要胡思乱想，好好调整状态。单身的女性本月的桃花很旺，去帝王合婚看看，桃花还是要主动去争取的哦！'],
		'MAINSTAR_WUQUXING' : ['◎本月有伴侣的朋友生活中会有些沉闷，或因家里大小琐碎事情造成彼此的不愉快，许多事情还是要克制情绪，夫妻之间的是是非非，绝不是简单的对与错的问题。互相关爱、互相妥协才是维持美满婚姻的上策。单身的朋友本月建议把主要精力集中在工作和赚钱上。', '◎本月有伴侣的朋友生活中会有些沉闷，或因家里大小琐碎事情造成彼此的不愉快，许多事情还是要克制情绪，夫妻之间的是是非非，绝不是简单的对与错的问题。互相关爱、互相妥协才是维持美满婚姻的上策。单身的朋友本月建议把主要精力集中在工作和赚钱上。'],
		'MAINSTAR_TIANTONGXING' : ['◎本月另一半比较容易懒散，上进心不足，彼此依赖加强。放松的月份不妨一起去旅行游玩，放松身心的同时还能增进感情。单身的朋友本月很容易陷入苦恋或单恋或者喜欢上不该喜欢的人。参考解盘感情婚姻H3从中找到答案。', '◎本月另一半比较容易懒散，上进心不足，彼此依赖加强。放松的月份不妨一起去旅行游玩，放松身心的同时还能增进感情。单身的朋友本月很容易陷入苦恋或单恋或者喜欢上不该喜欢的人。参考解盘感情婚姻H3从中找到答案。'],
		'MAINSTAR_LIANZHENXING' : ['◎本月有伴侣的朋友会发生观念不同意见不合的争执。假如本月能聚少离多的化反而能增进彼此之间感情。异地恋的男性朋友每天养成给女朋友打电话的习惯吧，这是你每天除了工作、学习最重要的一件事，必须雷打不动哦。单身的朋友本月姻缘运还是很不错的。抓紧机会脱单吧。', '◎本月有伴侣的朋友会发生观念不同意见不合的争执。假如本月能聚少离多的化反而能增进彼此之间感情。有误会或矛盾一定不能冷战哦，敞开了说清楚比较好。单身的朋友本月很容易陷入一段纠结的爱情中。'],
		'MAINSTAR_TIANFUXING' : ['◎本月有伴侣的朋友感情关系还算和谐，相互可以得到彼此的助力。单身的朋友有机会认识相似的家世、目标、理想、嗜好、职业的异性。', '◎本月有伴侣的朋友感情关系还算和谐，相互可以得到彼此的助力。单身的朋友有机会认识相似的家世、目标、理想、嗜好、职业的异性。'],
		'MAINSTAR_TANLANGXING' : ['◎本月有伴侣的朋友感情比以往会更注重生活情趣，性欲也更旺盛。培养共同的兴趣可以增进感情。单身的朋友本月的桃花极强，本月最适合约会谈情说爱。异性缘如此好的月份快快约吧，帝王合婚走起，邂逅喜欢的TA。', '◎有伴侣的朋友本月很容易因为桃花多而相互猜忌，造成感情上的冲突与争吵。建议本月提高爱爱频率，有效释放桃花旺的负能量。单身的朋友也很容易招惹到烂桃花或者因为桃花招惹是非纠葛。建议本月减少参加活动与聚会,利用时间培养些兴趣爱好。'],
		'MAINSTAR_JUMENXING' : ['◎有伴侣的朋友本月很容易因为家庭琐事或者隐藏很久的感情问题而发生口角争执。或者因为没有沟通清楚，不理解对方引起误会造成语言上的伤害。本月相处之道多些赞扬对方的话语，温柔甜蜜的吻总能很快俘获她的心。建议本月还可以多去外面吃吃饭可以释放负能量的干扰。单身的朋友和喜欢的异性相处时也要注意说话方式，避免惹对方不高兴。', '◎有伴侣的朋友本月很容易因为家庭琐事或者隐藏很久的感情问题而发生口角争执。或者因为没有沟通清楚，不理解对方引起误会造成语言上的伤害。本月相处之道多些赞扬对方的话语，温柔甜蜜的吻总能很快俘获她的心。建议本月还可以多去外面吃吃饭可以释放负能量的干扰。单身的朋友和喜欢的异性相处时也要注意说话方式，避免惹对方不高兴。'],
		'MAINSTAR_TIANXIANGXING' : ['◎本月有伴侣的朋友很容易因为对方好面子或好管闲事而发生不愉快。本月培养感情的最好方法就是送对方礼物，给平淡的生活制造点小惊喜。单身的朋友可以主动要求同学、同事、朋友帮忙介绍对象。第一次见面时记得要送小礼物哦！', '◎本月有伴侣的朋友很容易因为对方好面子或好管闲事而发生不愉快。本月培养感情的最好方法就是送对方礼物，给平淡的生活制造点小惊喜。单身的朋友可以主动要求同学、同事、朋友帮忙介绍对象。第一次见面时记得要送小礼物哦！'],
		'MAINSTAR_TIANLIANGXING' : ['◎本月有伴侣的朋友要多包容及体贴另一半，不要总是说教或指责对方的不好。闲暇的时候两个人一起在近郊的公园走走也不错，单身的朋友本月很容易受父母长者的影响，家人会很着急你的感情婚姻。多多利用好交友平台比如帝王合婚，多多主动打招呼哦！', '◎本月有伴侣的朋友要多包容及体贴另一半，不要总是说教或指责对方的不好。闲暇的时候两个人一起在近郊的公园走走也不错，单身的朋友本月很容易受父母长者的影响，家人会很着急你的感情婚姻。多多利用好交友平台比如帝王合婚，多多主动打招呼哦！'],
		'MAINSTAR_QISHAXING' : ['◎本月有伴侣的朋友会内心会感到比较孤独，由于对方工作会比较忙碌会有聚少离多的现象，不要因为对方的忙碌而抱怨产生矛盾和争执。控制好情绪，多点包容，让彼此的心智成熟些。周末一起参加下家庭活动，逛街、运动健身都是不错的选择。单身的朋友本月很容易产生急迫的心态。内心很着急想找到满意的对象。恋爱中的朋友感情会发生变动。感情本月为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。', '◎本月有伴侣的朋友会内心会感到比较孤独，由于对方工作会比较忙碌会有聚少离多的现象，不要因为对方的忙碌而抱怨产生矛盾和争执。控制好情绪，多点包容，让彼此的心智成熟些。周末一起参加下家庭活动，逛街、运动健身都是不错的选择。单身的朋友本月很容易产生急迫的心态。内心很着急想找到满意的对象。恋爱中的朋友感情会发生变动。感情本月为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。'],
		'MAINSTAR_POJUNXING' : ['◎本月有伴侣的朋友好胜心加强，很容易固执己见，对另一半管的比较紧，往往因此争吵不休。最好一起培养点共同兴趣，增加生活上的乐趣。多沟通，工作忙碌之余抽空关心关心对方。单身的朋友本月很容易突然遇到喜欢的异性。大胆的释放出爱意，让对方感觉到你充足的正能量结果并不重要。恋爱中的朋友感情会发生变动。感情本月为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。', '◎本月有伴侣的朋友好胜心加强，很容易固执己见，对另一半管的比较紧，往往因此争吵不休。最好一起培养点共同兴趣，增加生活上的乐趣。多沟通，工作忙碌之余抽空关心关心对方。单身的朋友本月很容易突然遇到喜欢的异性。大胆的释放出爱意，让对方感觉到你充足的正能量结果并不重要。恋爱中的朋友感情会发生变动。感情本月为正能量偏向好的变动。为负能量就要格外注意了。相处一定要注意减少矛盾发生。'],
		'GEMSTAR_WENCHANGXING' : ['◎本月感情方面很有利表达出来。对于大声表白和各种浪漫爱情宣言都是不错的月份。但也要注意感情过于丰富会面临第三者的干扰，严重的话因为感情复杂惹出婚姻的问题。', '◎本月感情方面很有利表达出来。对于大声表白和各种浪漫爱情宣言都是不错的月份。但也要注意感情过于丰富会面临第三者的干扰，严重的话因为感情复杂惹出婚姻的问题。'],
		'GEMSTAR_TIANKUIXING' : ['◎本月感情上很容易得到长辈相助，机遇多多。为感情纠结的紫薯们可以在本月借助宗教的力量。', '◎本月感情上很容易得到长辈相助，机遇多多。为感情纠结的紫薯们可以在本月借助宗教的力量。'],
		'GEMSTAR_ZUOFUXING' : ['◎本月感情方面多抱抱对方有助提升婚姻正能量。但切记要抱对人哦。', '◎本月感情方面多抱抱对方有助提升婚姻正能量。但切记要抱对人哦。'],
		'GEMSTAR_LUCUNXING' : ['◎多一些情感的行动表现可以化解感情相处出现的问题。', '◎多一些情感的行动表现可以化解感情相处出现的问题。'],
		'FIENDSTAR_QINGYANGXING' : ['◎本月感情方面有擎羊星的负能量干扰。很容易产生争执，发生暴力倾向。或因为言语攻击伤害到对方。一定要克制自己的情绪。已经提醒你了，你还犯错那就不应该了。', '◎本月感情方面有擎羊星的负能量干扰。很容易产生争执，发生暴力倾向。或因为言语攻击伤害到对方。一定要克制自己的情绪。已经提醒你了，你还犯错那就不应该了。'],
		'FIENDSTAR_TUOLUOXING' : ['◎本月感情方面有陀罗星的负能量干扰。感情最近反复会出现不顺的负能量让自己纠结。或者夫妻感情表面相安无事但已经貌合神离。合合分分反复不定的负能量在干扰。负能量的强弱取决你今年的感情整体运势。不管怎样这个月还是蛮考验两个人相处之道的。两人在一起就是修行的过程。加油！', '◎本月感情方面有陀罗星的负能量干扰。感情最近反复会出现不顺的负能量让自己纠结。或者夫妻感情表面相安无事但已经貌合神离。合合分分反复不定的负能量在干扰。负能量的强弱取决你今年的感情整体运势。不管怎样这个月还是蛮考验两个人相处之道的。两人在一起就是修行的过程。加油！'],
		'FIENDSTAR_HUOXING' : ['◎本月感情方面有火星的负能量干扰。负能量来源于突如其来的困难与麻烦。情绪很容易失控，言辞犀利，导致家人朋友都为你们担心。化解方法就是冷静应对。两人平静下来共同面对解决。', '◎本月感情方面有火星的负能量干扰。负能量来源于突如其来的困难与麻烦。情绪很容易失控，言辞犀利，导致家人朋友都为你们担心。化解方法就是冷静应对。两人平静下来共同面对解决。'],
		'FIENDSTAR_LINGXING' : ['◎本月感情方面有铃星的负能量干扰。已有恋人或家庭的男性需注意少和着装时尚前卫的异性单独接触，以免引起不必要的误会。负能量来源于感情上的精神压力。','◎本月感情方面有铃星的负能量干扰。已有恋人或家庭的男性需注意少和着装时尚前卫的异性单独接触，以免引起不必要的误会。负能量来源于感情上的精神压力。'],
		'FIENDSTAR_DIKONGXING' : ['◎本月感情方面最大的负能量来源于失去与结束。化解方法：情感上遇到争执与矛盾快速放弃互动关系。尽量换位思考，尽最大程度迁就理解对方。务必不能拿分手或离婚来吓唬对方。珍惜缘分，善待对方也是善待自己。另一半多创造出差工作或回父母家的机会，让两人分开一段时间或者是异地恋都可以有效释放负能量的干扰。','◎本月感情方面最大的负能量来源于失去与结束。化解方法：情感上遇到争执与矛盾快速放弃互动关系。尽量换位思考，尽最大程度迁就理解对方。务必不能拿分手或离婚来吓唬对方。珍惜缘分，善待对方也是善待自己。另一半多创造出差工作或回父母家的机会，让两人分开一段时间或者是异地恋都可以有效释放负能量的干扰。']
	},
	'GONGWEI_CAIBOGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎本月财帛对待上更偏向珍惜，理财的意识大大增强。自由职业或老板本月赚钱容易有贵人相助。赚钱的能量很不错。', '◎本月财帛对待上更偏向珍惜，理财的意识大大增强。自由职业或老板本月赚钱容易有贵人相助。赚钱的能量很不错。'],
		'MAINSTAR_TIANJIXING' : ['◎本月财帛对待上流动性增大，钱在手中不安慰，财来财去。建议本月适量开源节流。投机要谨慎。', '◎本月财帛对待上流动性增大，钱在手中不安慰，财来财去。建议本月适量开源节流。投机要谨慎。'], 
		'MAINSTAR_TAIYINXING' : ['◎本月财帛对待上偏向稳定。进财相对平顺。工薪人士本月适合开始做些固定理财产品。让自己财富稳定增长。', '◎本月财帛对待上偏向稳定。进财相对平顺。工薪人士本月适合开始做些固定理财产品。让自己财富稳定增长。'],
		'MAINSTAR_TAIYANGXING' : ['◎本月财帛对待上容易因为面子产生花销。整体属于花销比较大的月份。职场人士适合利用名气与专业影响力提升赚钱正能量。', '◎本月财帛对待上容易因为面子产生花销。整体属于花销比较大的月份。职场人士适合利用名气与专业影响力提升赚钱正能量。'],
		'MAINSTAR_WUQUXING' : ['◎本月财帛对待上对赚钱的欲望大增。本月正财星武曲驾到是非常适合投资理财，争取赚钱机会的好月份。老板管理人员适合加大投入，利用好赚钱的正能量。', '◎本月财帛对待上对赚钱的欲望大增。本月正财星武曲驾到是非常适合投资理财，争取赚钱机会的好月份。老板管理人员适合加大投入，利用好赚钱的正能量。'],
		'MAINSTAR_TIANTONGXING' : ['◎本月财帛对待上属于精打细算，钱财出入比较大。很容易在吃喝玩乐上开销增大。', '◎本月财帛对待上属于精打细算，钱财出入比较大。很容易在吃喝玩乐上开销增大。'],
		'MAINSTAR_LIANZHENXING' : ['◎本月财帛对待上处理与运用钱财的能力大大增强。适宜钱流通起来。不适合有赌博行为。', '◎本月财帛对待上处理与运用钱财的能力大大增强。适宜钱流通起来。不适合有赌博行为。'],
		'MAINSTAR_TIANFUXING' : ['◎本月财帛对待上储蓄的意识提升，守财能力变强。手上留有现金，会心情大好。自由职业或老板本月可以开拓更多财源，会有更多赚钱的门路。', '◎本月财帛对待上储蓄的意识提升，守财能力变强。手上留有现金，会心情大好。自由职业或老板本月可以开拓更多财源，会有更多赚钱的门路。'],
		'MAINSTAR_TANLANGXING' : ['◎本月财帛对待上投机的意识增强，求财心切。很容易物欲大增花销变大。尽量避免投机心态，花销也应该节制。流年正能量强易有偏财。', '◎本月财帛对待上投机的意识增强，求财心切。很容易物欲大增花销变大。尽量避免投机心态，花销也应该节制。流年正能量强易有偏财。'],
		'MAINSTAR_JUMENXING' : ['◎本月财帛对待上财源不太稳定，比较辛劳费力。需要付出更多。也要留意意外破财及支出。', '◎本月财帛对待上财源不太稳定，比较辛劳费力。需要付出更多。也要留意意外破财及支出。'],
		'MAINSTAR_TIANXIANGXING' : ['◎本月财帛对待上很容易因为生活享受而产生浪费。但整体来说财运不错，在处理赚钱上也更理性更有计划。', '◎本月财帛对待上很容易因为生活享受而产生浪费。但整体来说财运不错，在处理赚钱上也更理性更有计划。'],
		'MAINSTAR_TIANLIANGXING' : ['◎本月财帛对待上更容易得到长辈的帮助。意外的财运大大增强。可以经由介绍得到额外收入。创业融资的小伙伴本月可以好好争取哦。', '◎本月财帛对待上更容易得到长辈的帮助。意外的财运大大增强。可以经由介绍得到额外收入。创业融资的小伙伴本月可以好好争取哦。'],
		'MAINSTAR_QISHAXING' : ['◎本月财帛对待上变动很大，易大起大落。赚钱的动力与冲劲十足。流年财运正能量本月偏财运会很不错。', '◎本月财帛对待上变动很大，易大起大落。赚钱的动力与冲劲十足。流年财运正能量本月偏财运会很不错。'],
		'MAINSTAR_POJUNXING' : ['◎本月财帛对待上多进财机会。但很容易来的快去的快，消耗极大。钱财不太稳定。应有周密的钱财运用计划，不要太急。', '◎本月财帛对待上多进财机会。但很容易来的快去的快，消耗极大。钱财不太稳定。应有周密的钱财运用计划，不要太急。'],
		'GEMSTAR_WENCHANGXING' : ['◎本月是进钱很不错的月份。要账要钱借钱都可以在本月多用用心了。', '◎本月是进钱很不错的月份。要账要钱借钱都可以在本月多用用心了。'],
		'GEMSTAR_TIANKUIXING' : ['◎本月在钱财上很容易得到长辈帮助。本月也适合借钱哦。', '◎本月在钱财上很容易得到长辈帮助。本月也适合借钱哦。'],
		'GEMSTAR_ZUOFUXING' : ['◎本月是全年偏财最好的月份。股票、投资、回扣你懂得…..', '◎本月是全年偏财最好的月份。股票、投资、回扣你懂得…..'],
		'GEMSTAR_LUCUNXING' : ['◎本月财帛对待上节俭意识增强，赚钱更加用心努力。', '◎本月财帛对待上节俭意识增强，赚钱更加用心努力。'],
		'FIENDSTAR_QINGYANGXING' : ['◎本月财帛对待上有擎羊负能量干扰。很容易无金钱概念花销没有节制。或者竞争激烈赚钱难度加大。', '◎本月财帛对待上有擎羊负能量干扰。很容易无金钱概念花销没有节制。或者竞争激烈赚钱难度加大。'],
		'FIENDSTAR_TUOLUOXING' : ['◎本月财帛对待上有陀罗负能量干扰。很容易钱财不稳定。说好到账的钱迟迟不来。', '◎本月财帛对待上有陀罗负能量干扰。很容易钱财不稳定。说好到账的钱迟迟不来。'],
		'FIENDSTAR_HUOXING' : ['◎本月财帛对待上有火星负能量干扰。钱财的起伏大。开支大，容易意外破财。', '◎本月财帛对待上有火星负能量干扰。钱财的起伏大。开支大，容易意外破财。'],
		'FIENDSTAR_LINGXING' : ['◎本月财帛对待上有铃星负能量干扰。收入不稳定，用钱没节制。赚钱压力大增。','◎本月财帛对待上有铃星负能量干扰。收入不稳定，用钱没节制。赚钱压力大增。'],
		'FIENDSTAR_DIKONGXING' : ['◎本月财帛对待上有空劫星负能量干扰。是破财最严重的月份。很容易感觉没钱了，为钱困扰。莫名的开支加大，钱也赚不到，还有意外支出。总之入不敷出。','◎本月财帛对待上有空劫星负能量干扰。是破财最严重的月份。很容易感觉没钱了，为钱困扰。莫名的开支加大，钱也赚不到，还有意外支出。总之入不敷出。']
	},
	'GONGWEI_SHIYEGONG' : {
		'MAINSTAR_ZIWEIXING' : ['◎本月事业的关键词是地位与命令。职场人士本月要力争上游，对权利欲望强。容易固执、主观，建议多参与团队配合，提高团队协作能力。管理者本月领导能力更强可以充分发挥提升地位与效率。', '◎本月事业的关键词是地位与命令。职场人士本月要力争上游，对权利欲望强。容易固执、主观，建议多参与团队配合，提高团队协作能力。管理者本月领导能力更强可以充分发挥提升地位与效率。'],
		'MAINSTAR_TIANJIXING' : ['◎本月事业的关键词是灵活与多虑、不稳定。职场人士本月主要表现为不稳定，在开展工作时会想的太多，做事情畏首畏尾，怕这怕那，工作效率低。又或者遇到一点不顺利就考虑要换工作。建议要心怀必胜、积极的想法，提高执行力。', '◎本月事业的关键词是灵活与多虑、不稳定。职场人士本月主要表现为不稳定，在开展工作时会想的太多，做事情畏首畏尾，怕这怕那，工作效率低。又或者遇到一点不顺利就考虑要换工作。建议要心怀必胜、积极的想法，提高执行力。'], 
		'MAINSTAR_TAIYINXING' : ['◎本月事业的关键词是计划与完美。职场人士本月主要表现为计划性很强，可以按部就班的开展工作。对工作也会尽善尽美，颇能得到领导和客户的认可，但要多多留意竞争对手的干扰。', '◎本月事业的关键词是计划与完美。职场人士本月主要表现为计划性很强，可以按部就班的开展工作。对工作也会尽善尽美，颇能得到领导和客户的认可，但要多多留意竞争对手的干扰。'],
		'MAINSTAR_TAIYANGXING' : ['◎本月事业的关键词是奉献与消耗、持续力。职场人士本月属于稳扎稳打，机遇与挑战并存。更愿意积极主动的参与工作。', '◎本月事业的关键词是奉献与消耗、持续力。职场人士本月属于稳扎稳打，机遇与挑战并存。更愿意积极主动的参与工作。'],
		'MAINSTAR_WUQUXING' : ['◎本月事业的关键词是现实与计划性、失衡。职场人士本月工作中擅长计算与评估，对自己有更切实的要求，可能时常计算投入和收益。进而有失衡的现象，譬如失去持续力。工作中收敛下固执强势的一面，注意人际关系的处理,提防小人。', '◎本月事业的关键词是现实与计划性、失衡。职场人士本月工作中擅长计算与评估，对自己有更切实的要求，可能时常计算投入和收益。进而有失衡的现象，譬如失去持续力。工作中收敛下固执强势的一面，注意人际关系的处理,提防小人。'],
		'MAINSTAR_TIANTONGXING' : ['◎本月事业的关键词是耐受性。职场人士本月工作的看法可以用知足来形容。对状况的适应性很强。即使工作很辛苦也依然会坚持做下去，耐力十足。', '◎本月事业的关键词是耐受性。职场人士本月工作的看法可以用知足来形容。对状况的适应性很强。即使工作很辛苦也依然会坚持做下去，耐力十足。'],
		'MAINSTAR_LIANZHENXING' : ['◎本月事业的关键词是果断与自负、纷争。职场人士本月工作非常有行动力，创新精神极强，做事情积极、有效率，常认为自己做的是对的。但有时别人不领情反而带来误解与抱怨。切勿感情用事，多处理好人际关系。', '◎本月事业的关键词是果断与自负、纷争。职场人士本月工作非常有行动力，创新精神极强，做事情积极、有效率，常认为自己做的是对的。但有时别人不领情反而带来误解与抱怨。切勿感情用事，多处理好人际关系。'],
		'MAINSTAR_TIANFUXING' : ['◎本月事业的关键词是授权与回报、两手策略。职场人士本月工作更善于汇报工作。更细心算计。管理者更擅长授权以及重视汇报。对下属的表现也更多的还是鼓励。 ', '◎本月事业的关键词是授权与回报、两手策略。职场人士本月工作更善于汇报工作。更细心算计。管理者更擅长授权以及重视汇报。对下属的表现也更多的还是鼓励。 '],
		'MAINSTAR_TANLANGXING' : ['◎本月事业的关键词是资源、交际。职场人士本月工作喜欢做自己感兴趣的项目，工作中更加重视人际关系，尝试建立自己的人脉，对外开展业务更加积极。改善急躁，束缚贪念，多干实事少说话，改善华而不实的现象。', '◎本月事业的关键词是资源、交际。职场人士本月工作喜欢做自己感兴趣的项目，工作中更加重视人际关系，尝试建立自己的人脉，对外开展业务更加积极。改善急躁，束缚贪念，多干实事少说话，改善华而不实的现象。'],
		'MAINSTAR_JUMENXING' : ['◎本月事业的关键词是口才与纠纷。职场人士本月工作积极发挥口才表达，分析能力提升，但疑心变大。如本月事业为负能量建议要慎言，远离公司是非，切忌锋芒毕露，招人嫉妒，提高自身心理素质。', '◎本月事业的关键词是口才与纠纷。职场人士本月工作积极发挥口才表达，分析能力提升，但疑心变大。如本月事业为负能量建议要慎言，远离公司是非，切忌锋芒毕露，招人嫉妒，提高自身心理素质。'],
		'MAINSTAR_TIANXIANGXING' : ['◎本月事业的关键词是地位与现实、服务。职场人士本月工作重视自我实现，不太讲人情。不宜在名义上占取高位，否则容易受人攻击与排挤。协助上司开展工作,培养果断决策的工作习惯，以及坚韧的意志力，不要受外界环境和人事干扰。', '◎本月事业的关键词是地位与现实、服务。职场人士本月工作重视自我实现，不太讲人情。不宜在名义上占取高位，否则容易受人攻击与排挤。协助上司开展工作,培养果断决策的工作习惯，以及坚韧的意志力，不要受外界环境和人事干扰。'],
		'MAINSTAR_TIANLIANGXING' : ['◎本月事业的关键词是协调与稳定、处理。职场人士本月工作稳定性较高，对于工作中的意外状况能够很快的处理解决。协调组织都能拿捏到位。可以发挥协调者的正能量。', '◎本月事业的关键词是协调与稳定、处理。职场人士本月工作稳定性较高，对于工作中的意外状况能够很快的处理解决。协调组织都能拿捏到位。可以发挥协调者的正能量。'],
		'MAINSTAR_QISHAXING' : ['◎本月事业的关键词是规划与统合、管理。职场人士本月自我发挥意识更强，希望上司可以放权。在职场表现更加积极。工作中的执行力与效率更高。本月可以发挥管理及策划的正能量。', '◎本月事业的关键词是规划与统合、管理。职场人士本月自我发挥意识更强，希望上司可以放权。在职场表现更加积极。工作中的执行力与效率更高。本月可以发挥管理及策划的正能量。'],
		'MAINSTAR_POJUNXING' : ['◎本月事业的关键词是行动与执行、领导。职场人士本月干劲十足,开创力大增。但防止在工作中太过随性。本月管理者要在投资或经营管理上注意不要意气用事、感情用事。避免三分钟热度的事情发生。', '◎本月事业的关键词是行动与执行、领导。职场人士本月干劲十足,开创力大增。但防止在工作中太过随性。本月管理者要在投资或经营管理上注意不要意气用事、感情用事。避免三分钟热度的事情发生。'],
		'GEMSTAR_WENCHANGXING' : ['◎本月事业的关键词是技能。职场人士本月可以积极发挥专业技能提升的正能量，帮助工作能力进一步提升。可以多多参与职业培训，参加资格考证。本月也利于签约、签合同。', '◎本月事业的关键词是技能。职场人士本月可以积极发挥专业技能提升的正能量，帮助工作能力进一步提升。可以多多参与职业培训，参加资格考证。本月也利于签约、签合同。'],
		'GEMSTAR_TIANKUIXING' : ['◎本月事业的关键词是帮助。本月工作中很容易得到长辈相助，机遇多多。如遇到问题也可以主动找领导上司提供帮助。', '◎本月事业的关键词是帮助。本月工作中很容易得到长辈相助，机遇多多。如遇到问题也可以主动找领导上司提供帮助。'],
		'GEMSTAR_ZUOFUXING' : ['◎本月事业的关键词是协助。工作中一定要积极利用团队协作的正能量。遇到困难可以找同事或朋友帮忙。他们的助力可以帮你有效解决工作中遇到的问题。', '◎本月事业的关键词是协助。工作中一定要积极利用团队协作的正能量。遇到困难可以找同事或朋友帮忙。他们的助力可以帮你有效解决工作中遇到的问题。'],
		'GEMSTAR_LUCUNXING' : ['◎本月事业方面会比较忙碌而充实。机会也比往常会多不少。让自己动起来创造更多工作表现。', '◎本月事业方面会比较忙碌而充实。机会也比往常会多不少。让自己动起来创造更多工作表现。'],
		'FIENDSTAR_QINGYANGXING' : ['◎本月工作事业方面有擎羊星的负能量干扰。很容易产生明显的阻力与波折。通常属于来的快去的快，所以要有耐心，不要急于求成。等待激发的能量，稳定住心态。', '◎本月工作事业方面有擎羊星的负能量干扰。很容易产生明显的阻力与波折。通常属于来的快去的快，所以要有耐心，不要急于求成。等待激发的能量，稳定住心态。'],
		'FIENDSTAR_TUOLUOXING' : ['◎本月工作事业方面有陀罗星的负能量干扰。工作事业容易反复会出现不顺的负能量让自己纠结，迟迟没有结果，不能立即解决。建议可以反复打磨项目产品，化解负能量干扰。心态非常关键。', '◎本月工作事业方面有陀罗星的负能量干扰。工作事业容易反复会出现不顺的负能量让自己纠结，迟迟没有结果，不能立即解决。建议可以反复打磨项目产品，化解负能量干扰。心态非常关键。'],
		'FIENDSTAR_HUOXING' : ['◎本月工作事业方面有火星的负能量干扰。负能量来源于如其来的困难与麻烦。爆发力极强无法阻挡无法招架。一定要精力辛苦一番才能有所收获。', '◎本月工作事业方面有火星的负能量干扰。负能量来源于如其来的困难与麻烦。爆发力极强无法阻挡无法招架。一定要精力辛苦一番才能有所收获。'],
		'FIENDSTAR_LINGXING' : ['◎本月工作事业方面有铃星的负能量干扰。负能量来源于暗藏危机，杀伤力持久。工作中磨练自己的意志，经历过后在挫折中成长。','◎本月工作事业方面有铃星的负能量干扰。负能量来源于暗藏危机，杀伤力持久。工作中磨练自己的意志，经历过后在挫折中成长。'],
		'FIENDSTAR_DIKONGXING' : ['◎本月工作事业方面有地空星负能量干扰。负能量来源于想法很好但现实并非如此。太过于幻想虚而不实。职场人士也要注意自己的错误的想法导致离职的冲动。经营创业者要注意想法无法落地导致的失败。','◎本月工作事业方面有地空星负能量干扰。负能量来源于想法很好但现实并非如此。太过于幻想虚而不实。职场人士也要注意自己的错误的想法导致离职的冲动。经营创业者要注意想法无法落地导致的失败。'],
		'FIENDSTAR_DIJIEXING' : ['◎本月工作事业方面有地劫星负能量干扰。负能量来源于工作中的波折与失利，项目合作丢失等。更偏向物质层面并且频繁。职场人士也要注意因为物质因素导致离职的冲动。经营创业者要注意创业失败或者项目失败或者投入打了水漂。','◎本月工作事业方面有地劫星负能量干扰。负能量来源于工作中的波折与失利，项目合作丢失等。更偏向物质层面并且频繁。职场人士也要注意因为物质因素导致离职的冲动。经营创业者要注意创业失败或者项目失败或者投入打了水漂。']
	}
};

NewHome._liuRiStarEnergyDescription = {
	'MAINSTAR_ZIWEIXING' : ['◎今天的控制力、领导力大大提升，尤其对于管理经营者是非常有利开展工作的一天，职场人士工作中也能得心应手，也更容易得到领导同事的认可与肯定。', '◎今天容易有孤独感，无助的苦恼。工作或投资方面需要警惕错误的判断导致金钱或名誉的损失，可从专业的朋友和前辈处吸取经验。已婚者对待另一半显得较强势，易引起对方不满。'],
	'MAINSTAR_TIANJIXING' : ['◎今日头脑灵活，思维敏捷适宜思考、计划工作，容易会发生拜访、交际、应酬、变动、外出、搬家的事情，建议积极的行动起来。', '◎今天容易会发生负面的变动。建议减少行动。也会有沮丧的心境，头痛心烦事情。建议减少思考，出去走走看看，看场娱乐电影放松放松心情。'], 
	'MAINSTAR_TAIYINXING' : ['◎今天适宜旅游、看房，与女性亲属或朋友增进情感交流。在工作、生活中异性朋友也会给你很大的帮助，适合去山清水秀的地方游玩。同时也是理财不错的好日子！', '◎今天容易会发生情感不愉快的事情。也容易产生感情纠葛，伤神伤心。内心忧愁、情绪压抑会让心中充满郁结之气，尤其女性朋友要找到适合自身的运动来释放自己，例如跑步、健身都很不错。'],
	'MAINSTAR_TAIYANGXING' : ['◎今天开展工作会变的更加积极主动也会更加顺利做出不错的成绩，名誉大大提升。更加愿意帮助需要帮助的人，关心同事朋友，让大家感受到你的温暖。单身的紫薯们要好好展现自我最棒的一面给心仪的TA秀出了，恋爱运势大大提升。女性容易有不错的桃花缘哦。', '◎今天容易会有工作、考试、事业、名誉等负面的事情，招人抱怨等。女性容易遇到烂桃花。建议控制心态、稳住情绪冷静处理！'],
	'MAINSTAR_WUQUXING' : ['◎今天工作适宜提报、竞标，做事头脑冷静更加果敢，成功概率大大提升。做销售要更加努力提高工作效率，提升赚钱的机会。利用好绝佳的利财日。', '◎今天容易会发生：与人竞争或者为赚钱发愁。进入负能量周期今天财运欠佳，不宜冒险投资，孤注一掷只可能带来更坏的结果。情绪不是很稳定，肝火相对也比较旺，尽量要让自己保持平和的心境。'],
	'MAINSTAR_TIANTONGXING' : ['◎今天适宜与异性一起逛街游玩，容易擦出爱情的火花。整体状态较为懒散但运势还不错，容易有人宴请，多多结交好友吃喝玩乐放松身心也是不错的选择。', '◎今天容易会发生：事业工作中多有阻碍，表现不佳，工作吃力。情侣之前会为点小事产生争执。缺少享受乐趣不在状态。内心很容易进入感伤情境。建议约上朋友聊天吃饭，朋友的陪伴会增强你对外界的信任感与依托感，有利于放松心情。'],
	'MAINSTAR_LIANZHENXING' : ['◎今天是个想法多多创意棒棒的一天，好好把这正能量运用到自己工作中去，很久没想明白的事情也会迎刃而解。今天也容易有突发性的好机遇，出现一定要好好把握。异地恋的情侣非常适宜视频聊天增加情感交流。单身的小伙伴也容易遇到心仪的TA。赶快帝王合婚约起来吧！', '◎今天容易会脾气变得暴躁，很容易和别人产生矛盾与纠纷。负能量周期今天很容易招惹是非。同时也要预防意外与出行安全。'],
	'MAINSTAR_TIANFUXING' : ['◎今天适宜理财投资。工作中更加容易进入状态，责任心倍增。工作推进的更加顺利。即使出现的小麻烦你也能很快解决。假如正好进入正能量周期的化今天还容易遇到升职、加薪的机会。约会不需要太费心思，与对方到公园散散步、到小吃店品尝下，同样能感受到甜蜜开心。', '◎今天容易遇到困难挫折，计划难实现，产生空虚感都有可能。对于意外变化调整好心态很重要。出行需注意安全。'],
	'MAINSTAR_TANLANGXING' : ['◎今天异性缘很旺，如此好的日子快快约吧，帝王合婚走起，邂逅喜欢的TA。工作上也适合交际拓展人脉关系，请客送礼绝佳日子，事业机遇多多。艺术细胞活跃，不妨抽时间阅读这方面书籍，或看艺术展等也不错。今天也适合把自己和自己的家好好打扮一下，会有意想不到的好运气哦。', '◎今天容易遇到夫妻感情不合，女孩子易有感情困扰。适合静心修养，不宜想感情之事。注意意外的金钱损失。控制自己的贪欲，遇上应酬请注意少饮酒。'],
	'MAINSTAR_JUMENXING' : ['◎今天表达能力大大提升，工作中沟通更加顺畅，更具说服力。今天也是蛮有口福的一天，把你今天吃的好吃的都晒出来吧！', '◎今天容易做事进退不定，工作不如意，夫妻或情侣之间口角争执。须及时、积极地处理才能化解误会。建议今天少说话多做事，饮食注意卫生。'],
	'MAINSTAR_TIANXIANGXING' : ['◎今天适合与地位高的人相识往来从中提升自己。好的心态帮助你工作中更敢于担当，帮助同事处理各种遇到的问题。会容易有出差的事情。今天也蛮适合研究学问突破知识瓶颈提升专业水平。学紫微的小伙伴今天要加油哦！多多在微圈与大家交流心得吧！', '◎今天要特别小心受人欺骗、破财、意外。运势平平，有能力施展不开的境况。'],
	'MAINSTAR_TIANLIANGXING' : ['◎今天对求职者特别有利，正能量满满。官员或公务员往日的努力与表现容易获得领导的赏识和肯定。成熟稳重的正能量会感染身边的朋友、同事，热心帮助同时留下很好的声誉与口碑。今天也很适合去看中医，调理身体。', '◎今天很容易会发生突然的变故让自己措手不及。稍晚时间又会化险为夷。'],
	'MAINSTAR_QISHAXING' : ['◎今天精力旺盛，工作上遗留的问题统统都斩尽杀绝，干劲十足，即使会犯一些小错误，也多能得到大家的谅解和帮助，要记得心存感激。事业上也容易有好的变动或者外出。', '◎今天很容易会发生纷争、工作反复失败，工作上陷入瓶颈，遇阻碍应立即向前辈请教，避免一个人无头绪的处理，既浪费时间又浪费精力。不要太重义气，反而招惹太多是非与麻烦。'],
	'MAINSTAR_POJUNXING' : ['◎今天很容易会碰到意想不到的事情发生。工作中领导能力大大被激发。很容易攻克难关而做出成绩。一定要好好利用如此极佳的正能量不要荒废掉。拖了很久的事情今天也是不错的决定之日，还等什么呢。', '◎今天很容易会发生：工作事业进展不太顺利。自以为是，不愿听别人的意见，易得罪别人，要特别注意小人，建议今天不要太锋芒毕露，低调行事的好。'],
	'GEMSTAR_TIANMAXING' : ['◎今天容易有机会旅游，升迁，迁动的事情发生。旅游更适合选择轻松而简单的旅游行程。', ''],
	'GEMSTAR_WENCHANGXING' : ['◎今天艺术灵感很不错可以好好利用到工作与生活中。学习知识是不错的一天，会发现学习的过程容易很多也更容易出成绩。工作中专业技能的提升与发挥让你在自己的岗位表现更加出色。事业上也容易遇到签单、签约的好事情。感情方面给对方一个浪漫的惊喜也是不错的正能量日。', '◎今天很容易有口舌是非，一定要注意表达。文字数字方面一定要细心多检查几遍。契约、合同上易有波折。'],
	'GEMSTAR_TIANKUIXING' : ['◎今天很容易得到长辈或朋友相助，事业机遇多多。要学会勇于表现自己，让更多的人看到你的实力。感情上不妨给对方一个小小的惊喜，精致礼物烘托下的爱情会更加分。', '◎今天很容易遇到麻烦的事情，需要借助他人的力量来解决。多打电话主动寻求帮助是个不错的方法。如果感觉自己最近很不顺利也可以在今天借助宗教的力量改善运势。'],
	'GEMSTAR_ZUOFUXING' : ['◎今天容易得到同事朋友的帮助。工作上很适合团队协同作战。', '◎今天很容易有人跟你竞争，丢失很好的机会与利益，一定要注意提防哦。'],
	'GEMSTAR_LUCUNXING' : ['◎今天会比通常更加忙碌，有很多事情需要处理。同时也是个赚钱不错的好日子，紫薯们要加油哦，今天的努力和积累在随后的日子一定能有所收获。', '◎今天会比通常更加忙碌，有很多事情需要处理。同时也是个赚钱不错的好日子，紫薯们要加油哦，今天的努力和积累在随后的日子一定能有所收获。'],
	'FIENDSTAR_QINGYANGXING' : ['◎今天最大的负能量来源于工作上的阻力和考虑欠佳的决定。多多听取同事和领导的建议，再发挥超强的执行力去解决，克服难关，提升自我。', '◎今天最大的负能量来源于工作上的阻力和考虑欠佳的决定。多多听取同事和领导的建议，再发挥超强的执行力去解决，克服难关，提升自我。'],
	'FIENDSTAR_TUOLUOXING' : ['◎今天最大的负能量来源于拖延与波折。好的心态是化解负能量的最佳良药。用内心强大的韧劲去征服挑战困难，你一定行。', '◎今天最大的负能量来源于拖延与波折。好的心态是化解负能量的最佳良药。用内心强大的韧劲去征服挑战困难，你一定行。'],
	'FIENDSTAR_HUOXING' : ['◎今天的负能量来源于突如其来的困难与麻烦，脾气会异常暴躁，欠思虑，求速战速决，粗心大意，有头无尾。建议放一段时间以后再处理。', '◎今天的负能量来源于突如其来的困难与麻烦，脾气会异常暴躁，欠思虑，求速战速决，粗心大意，有头无尾。建议放一段时间以后再处理。'],
	'FIENDSTAR_LINGXING' : ['◎今天的负能量来源于对精神的压力和伤害，内心困苦，行事会较迟疑不决。需减少得失心，放平心态。','◎今天的负能量来源于对精神的压力和伤害，内心困苦，行事会较迟疑不决。需减少得失心，放平心态。'],
	'FIENDSTAR_DIKONGXING' : ['◎今天最大的负能量来源于失去与结束。情感上今天易遇到争执与矛盾，别太固执，尽最大程度迁就理解对方。可以选择今天主动消费买自己心仪许久的东西。请朋友吃饭，送家人礼物都是不错的选择。主动的破财可以有利释放被动的破财。工作中可以发挥好的创意与想法运用到工作中。多修改多调整自己的方案与计划，重复的次数越多越完美! ','◎今天最大的负能量来源于失去与结束。情感上今天易遇到争执与矛盾，别太固执，尽最大程度迁就理解对方。可以选择今天主动消费买自己心仪许久的东西。请朋友吃饭，送家人礼物都是不错的选择。主动的破财可以有利释放被动的破财。工作中可以发挥好的创意与想法运用到工作中。多修改多调整自己的方案与计划，重复的次数越多越完美! ']
};