/**
 * 排盘API
 */
function PaiPanAPI()
{
	
	
}

PaiPanAPI.__getMingPan = function(type, param)
{
	var user = window.paipan.user;
	
	if(!user)
	{
		return {
			'success' : false,
			'result' : ReturnValue.newExceptionResult("没有保存用户信息.")
		};
	}
	
	// 先天命盘
	if("XianTianMingPan" == type)
	{
		return {
			'success' : true,
			'result' : user.getXianTianMingPan()
		};
	}
	
	// 大运命盘
	if("DaYunMingPan" == type)
	{
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("大运参数不能为空.")
			};
		}
		
		param = parseInt(param);
	
		if(param > 12 || (param < 1))
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("大运数值非法.")
			};
		}
		
		return {
			'success' : true,
			'result' : user.getDaYunMingPan(param)
		};
	}
	
	if("LiuNianMingPan" == type)
	{
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流年参数不能为空.")
			};
		}
		
		param = parseInt(param);
		var birthYear = user.getUserInfo().getBirthday().getLunarYear();
		
		if(birthYear > param || (birthYear + 120 < param))
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流年数值非法.")
			};
		}
		
		return {
			'success' : true,
			'result' : user.getLiuNianMingPan(param)
		};
	}
	
	if("LiuYueMingPan" == type)
	{
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流月参数不能为空.")
			};
		}
		
		param = JSON.parse(param);
		
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流月参数格式错误.")
			};
		}
		
		var liuNian = parseInt(param.year);
		
		if(liuNian < 1901 || liuNian > 2099)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流年超过限制.")
			};
		}
		
		var liuYue = param.month;
		var isRunYue = false;
		
		if(liuYue.charAt(0) == "闰")
		{
			isRunYue = true;
			liuYue = liuYue.replace("闰", "");
		}
		
		liuYue = Util.convertLunarMonthStr2Integer(liuYue);
		
		if(!liuYue)
		{
			liuYue = 1;
		}
		
		return {
			'success' : true,
			'result' : user.getLiuYueMingPan(liuNian, liuYue, isRunYue)
		};
	}

	if("LiuRiMingPan" == type)
	{
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流日参数不能为空.")
			};
		}
		
		param = JSON.parse(param);
		
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流日参数格式错误.")
			};
		}
		
		var liuNian = parseInt(param.year);
		
		if(liuNian < 1901 || liuNian > 2099)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流年超过限制.")
			};
		}
		
		var liuYue = param.month;
		var isRunYue = false;
		
		if(liuYue.charAt(0) == "闰")
		{
			isRunYue = true;
			liuYue = liuYue.replace("闰", "");
		}
		
		liuYue = Util.convertLunarMonthStr2Integer(liuYue);
		
		if(!liuYue)
		{
			liuYue = 1;
		}
		
		var liuRi = param.day;
		liuRi = Util.convertLunarDayStr2Integer(liuRi);
		
		return {
			'success' : true,
			'result' : user.getLiuRiMingPan(liuNian, liuYue, liuRi, isRunYue)
		};
	}

	if("LiuShiMingPan" == type)
	{
		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流时参数不能为空.")
			};
		}

		param = JSON.parse(param);

		if(!param)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流时参数格式错误.")
			};
		}

		var liuNian = parseInt(param.year);

		if(liuNian < 1901 || liuNian > 2099)
		{
			return {
				'success' : false,
				'result' : ReturnValue.newExceptionResult("流年超过限制.")
			};
		}

		var liuYue = param.month;
		var isRunYue = false;

		if(liuYue.charAt(0) == "闰")
		{
			isRunYue = true;
			liuYue = liuYue.replace("闰", "");
		}

		liuYue = Util.convertLunarMonthStr2Integer(liuYue);

		if(!liuYue)
		{
			liuYue = 1;
		}

		var liuRi = param.day;
		liuRi = Util.convertLunarDayStr2Integer(liuRi);

		var liuShi = param.hour;
		liuShi = Util.getHourByLunarStr(Util.parseLunarHour(liuShi.replace("时", "")));
	
		return {
			'success' : true,
			'result' : user.getLiuShiMingPan(liuNian, liuYue, liuRi, liuShi, isRunYue)
		};
	}

	return {
		'success' : false,
		'result' : ReturnValue.newExceptionResult("没有对应的排盘类型.")
	};
}

/**
 * {"year" : 2014, "month" : "五月", "day" : "初一", "hour" : "子时"} / {"year" : 2014, "month" : "闰五月", "day" : "初一", "hour" : "子时"}
 */
/**
 * 获取流时命盘
 */
PaiPanAPI.getLiuShiMingPan = function(param)
{
	var mingPanResult = PaiPanAPI.__getMingPan("LiuShiMingPan", param);
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var liuShiMingPan = mingPanResult.result;
	var sections = liuShiMingPan.getItems();
	var user = window.paipan.user;
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = new Object();
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.siHua = star.getSiXiang();
			starArrayItem.daYunSiHua = star.getSiHuaOfDaYun();
			starArrayItem.liuNianSiHua = star.getSiHuaOfLiuNian();
			starArrayItem.liuYueSiHua = star.getSiHuaOfLiuYue();
			starArrayItem.liuRiSiHua = star.getSiHuaOfLiuRi();
			starArrayItem.liuShiSiHua = star.getSiHuaOfLiuShi();
			starArray.push(starArrayItem);
		}
		
		var dyStars = section.getDaYunStars();
		
		if(dyStars)
		{
			var translateDYStars = [];
			
			for(var m = 0; m < dyStars.length; m ++)
			{
				translateDYStars.push(Translator.translateObject({
					'name' : dyStars[m].starName,
					'shortName' : dyStars[m].shortName
				}, 0));
			}
			
			dyStars = translateDYStars;
		}
		
		var lnStars = section.getLiuNianStars();
	
		if(lnStars)
		{
			var translateLNStars = [];
			
			for(var m = 0; m < lnStars.length; m ++)
			{
				translateLNStars.push(Translator.translateObject({
					'name' : lnStars[m].starName,
					'shortName' : lnStars[m].shortName
				}, 0));
			}
			
			lnStars = translateLNStars;
		}
		
	
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),
			"diZhi" : section.getDiZhi(),
			"gongWei" : section.getGongWei(),
			"changSheng" : section.getChangSheng12Shen(),
			"taiSuiShaLu" : section.getTaiSuiShaLu(),
			"liuNianSuiQian" : section.getLiuNianSuiQian(),
			"liuNianJiangQian" : section.getLiuNianJiangQian(),
			"month" : section.getMonth().name,
			"daYunGongWei" : section.getDaYunGongWei(),
			"liuNianGongWei" : section.getLiuNianGongWei(),
			"xuSui" : liuShiMingPan.getXuSui(),
			"hour" : section.getLunarHour(),
			"liuNianGanZhi" : liuShiMingPan.getYearOfGanZhi(),
			"liuNianDouJun" : liuShiMingPan.getLiuNianDouJun(),
			"liuYueGongWei" : section.getMonthGongWei(),
			"liuRiGongWei" : section.getDayGongWei(),
			"liuShiGongWei" : section.getHourGongWei(),
			"liuYueGanZhi" : liuShiMingPan.monthOfGanZhi,
			"liuRiGanZhi" : liuShiMingPan.dayOfGanZhi,
			"liuShiGanZhi" : liuShiMingPan.hourOfGanZhi,
			"xiaoXianIndex" : liuShiMingPan.getXiaoXianIndex(),
			'stars' :  Translator.translateStars(starArray),
			'daYunStars' : dyStars,
			'liuNianStars' : lnStars
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

/**
 * {"year" : 2014, "month" : "五月", "day" : "初一"} / {"year" : 2014, "month" : "闰五月", "day" : "初一"}
 */
/**
 * 获取流日命盘
 */
PaiPanAPI.getLiuRiMingPan = function(param)
{
	var mingPanResult = PaiPanAPI.__getMingPan("LiuRiMingPan", param);
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var liuRiMingPan = mingPanResult.result;
	var sections = liuRiMingPan.getItems();
	var user = window.paipan.user;
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = new Object();
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.siHua = star.getSiXiang();
			starArrayItem.daYunSiHua = star.getSiHuaOfDaYun();
			starArrayItem.liuNianSiHua = star.getSiHuaOfLiuNian();
			starArrayItem.liuYueSiHua = star.getSiHuaOfLiuYue();
			starArrayItem.liuRiSiHua = star.getSiHuaOfLiuRi();
			starArray.push(starArrayItem);
		}
		
		var dyStars = section.getDaYunStars();
		
		if(dyStars)
		{
			var translateDYStars = [];
			
			for(var m = 0; m < dyStars.length; m ++)
			{
				translateDYStars.push(Translator.translateObject({
					'name' : dyStars[m].starName,
					'shortName' : dyStars[m].shortName
				}, 0));
			}
			
			dyStars = translateDYStars;
		}
		
		var lnStars = section.getLiuNianStars();
	
		if(lnStars)
		{
			var translateLNStars = [];
			
			for(var m = 0; m < lnStars.length; m ++)
			{
				translateLNStars.push(Translator.translateObject({
					'name' : lnStars[m].starName,
					'shortName' : lnStars[m].shortName
				}, 0));
			}
			
			lnStars = translateLNStars;
		}
		
	
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),
			"diZhi" : section.getDiZhi(),
			"gongWei" : section.getGongWei(),
			"changSheng" : section.getChangSheng12Shen(),
			"taiSuiShaLu" : section.getTaiSuiShaLu(),
			"liuNianSuiQian" : section.getLiuNianSuiQian(),
			"liuNianJiangQian" : section.getLiuNianJiangQian(),
			"month" : section.getMonth().name,
			"daYunGongWei" : section.getDaYunGongWei(),
			"liuNianGongWei" : section.getLiuNianGongWei(),
			"xuSui" : liuRiMingPan.getXuSui(),
			"liuNianGanZhi" : liuRiMingPan.getYearOfGanZhi(),
			"liuNianDouJun" : liuRiMingPan.getLiuNianDouJun(),
			"liuYueGongWei" : section.getMonthGongWei(),
			"liuRiGongWei" : section.getDayGongWei(),
			"liuYueGanZhi" : liuRiMingPan.monthOfGanZhi,
			"liuRiGanZhi" : liuRiMingPan.dayOfGanZhi,
			"xiaoXianIndex" : liuRiMingPan.getXiaoXianIndex(),
			'stars' :  Translator.translateStars(starArray),
			'daYunStars' : dyStars,
			'liuNianStars' : lnStars
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

/**
 * {"year" : 2014, "month" : "五月"} / {"year" : 2014, "month" : "闰五月"}
 */
/**
 * 获取流月命盘
 */
PaiPanAPI.getLiuYueMingPan = function(param)
{
	var mingPanResult = PaiPanAPI.__getMingPan("LiuYueMingPan", param);
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var liuYueMingPan = mingPanResult.result;
	var sections = liuYueMingPan.getItems();
	var user = window.paipan.user;
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = new Object();
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.siHua = star.getSiXiang();
			starArrayItem.daYunSiHua = star.getSiHuaOfDaYun();
			starArrayItem.liuNianSiHua = star.getSiHuaOfLiuNian();
			starArrayItem.liuYueSiHua = star.getSiHuaOfLiuYue();
			starArray.push(starArrayItem);
		}
		
		var dyStars = section.getDaYunStars();
		
		if(dyStars)
		{
			var translateDYStars = [];
			
			for(var m = 0; m < dyStars.length; m ++)
			{
				translateDYStars.push(Translator.translateObject({
					'name' : dyStars[m].starName,
					'shortName' : dyStars[m].shortName
				}, 0));
			}
			
			dyStars = translateDYStars;
		}
		
		var lnStars = section.getLiuNianStars();
	
		if(lnStars)
		{
			var translateLNStars = [];
			
			for(var m = 0; m < lnStars.length; m ++)
			{
				translateLNStars.push(Translator.translateObject({
					'name' : lnStars[m].starName,
					'shortName' : lnStars[m].shortName
				}, 0));
			}
			
			lnStars = translateLNStars;
		}
		
	
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),
			"diZhi" : section.getDiZhi(),
			"gongWei" : section.getGongWei(),
			"changSheng" : section.getChangSheng12Shen(),
			"taiSuiShaLu" : section.getTaiSuiShaLu(),
			"liuNianSuiQian" : section.getLiuNianSuiQian(),
			"liuNianJiangQian" : section.getLiuNianJiangQian(),
			"month" : section.getMonth().name,
			"daYunGongWei" : section.getDaYunGongWei(),
			"liuNianGongWei" : section.getLiuNianGongWei(),
			"xuSui" : liuYueMingPan.getXuSui(),
			"liuNianGanZhi" : liuYueMingPan.getYearOfGanZhi(),
			"liuNianDouJun" : liuYueMingPan.getLiuNianDouJun(),
			"liuYueGongWei" : section.getMonthGongWei(),
			"liuYueGanZhi" : liuYueMingPan.monthOfGanZhi,
			"xiaoXianIndex" : liuYueMingPan.getXiaoXianIndex(),
			'stars' :  Translator.translateStars(starArray),
			'daYunStars' : dyStars,
			'liuNianStars' : lnStars
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

/**
 * 获取大运命盘
 */
PaiPanAPI.getDaYunMingPan = function(daYun)
{
	var mingPanResult = PaiPanAPI.__getMingPan("DaYunMingPan", daYun);
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var daYunMingPan = mingPanResult.result;
	var user = window.paipan.user;
	var sections = daYunMingPan.getItems();
	
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = new Object();
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.siHua = star.getSiXiang();
			starArrayItem.daYunSiHua = star.getSiHuaOfDaYun();
			starArray.push(starArrayItem);
		}
		
		var dyStars = section.getDaYunStars();
		
		if(dyStars)
		{
			var translateDYStars = [];
			
			for(var m = 0; m < dyStars.length; m ++)
			{
				translateDYStars.push(Translator.translateObject({
					'name' : dyStars[m].starName,
					'shortName' : dyStars[m].shortName
				}, 0));
			}
			
			dyStars = translateDYStars;
		}
		
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),
			"diZhi" : section.getDiZhi(),
			"gongWei" : section.getGongWei(),
			"agePeriod_begin" :	section.getDaYunAgePeriod().begin,
			"agePeriod_end" : section.getDaYunAgePeriod().end,	
			"changSheng" : section.getChangSheng12Shen(),
			"daYunGongWei" : section.getDaYunGongWei(),
			"xuSui" : daYunMingPan.getXuSui(),
			"liuNian" : daYunMingPan.getYear(),
			"liuNianGanZhi" : daYunMingPan.getYearOfGanZhi(),
			"liuNianDouJun" : daYunMingPan.getLiuNianDouJun(),
			'stars' :  Translator.translateStars(starArray),
			'daYunStars' : dyStars
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

/**
 * 获取流年命盘
 */
PaiPanAPI.getLiuNianMingPan = function(liuNian)
{
	var mingPanResult = PaiPanAPI.__getMingPan("LiuNianMingPan", liuNian);
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var liuNianMingPan = mingPanResult.result;
	var sections = liuNianMingPan.getItems();
	var user = window.paipan.user;
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = new Object();
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
				starArrayItem.descriptorFore = BizEnum.COLORCONFIG.MIAOWANG.color;
				starArrayItem.descriptorBg = BizEnum.COLORCONFIG.MIAOWANG.bgcolor;
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.xianTianSiHua = star.getSiXiang();
			starArrayItem.xianTianSiHuaFore = BizEnum.COLORCONFIG.XIANTIANSIHUA.color; //	先天四化前景色	
			starArrayItem.xianTianSiHuaBg = BizEnum.COLORCONFIG.XIANTIANSIHUA.bgcolor; //	先天四化背景色	
			starArrayItem.daYunSiHua = star.getSiHuaOfDaYun();
			starArrayItem.daYunSiHuaFore = BizEnum.COLORCONFIG.DAYUNSIHUA.color;       //   大运四化前景色  
			starArrayItem.daYunSiHuaBg = BizEnum.COLORCONFIG.DAYUNSIHUA.bgcolor;       //   大运四化背景色
			starArrayItem.liuNianSiHua = star.getSiHuaOfLiuNian();
			starArrayItem.liuNianSiHuaFore = BizEnum.COLORCONFIG.LIUNIANSIHUA.color;   //   流年四化前景色
			starArrayItem.liuNianSiHuaBg = BizEnum.COLORCONFIG.LIUNIANSIHUA.bgcolor;   //   流年四化背景色
			starArray.push(starArrayItem);
		}
		
		var dyStars = section.getDaYunStars();
		
		if(dyStars)
		{
			var translateDYStars = [];
			
			for(var m = 0; m < dyStars.length; m ++)
			{
				translateDYStars.push(Translator.translateObject({
					'name' : dyStars[m].starName,
					'shortName' : dyStars[m].shortName
				}, 0));
			}
			
			dyStars = translateDYStars;
		}
		
		var lnStars = section.getLiuNianStars();
	
		if(lnStars)
		{
			var translateLNStars = [];
			
			for(var m = 0; m < lnStars.length; m ++)
			{
				translateLNStars.push(Translator.translateObject({
					'name' : lnStars[m].starName,
					'shortName' : lnStars[m].shortName
				}, 0));
			}
			
			lnStars = translateLNStars;
		}
		
	
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),
			"diZhi" : section.getDiZhi(),
			"gongWei" : section.getGongWei(),
			"changSheng" : section.getChangSheng12Shen(),
			"taiSuiShaLu" : section.getTaiSuiShaLu(),
			"liuNianSuiQian" : section.getLiuNianSuiQian(),
			"liuNianJiangQian" : section.getLiuNianJiangQian(),
			"month" : section.getMonth().name,
			"daYunGongWei" : section.getDaYunGongWei(),
			"liuNianGongWei" : section.getLiuNianGongWei(),
			"xuSui" : liuNianMingPan.getXuSui(),
			"liuNian" : liuNian,
			"liuNianGanZhi" : liuNianMingPan.getYearOfGanZhi(),
			"liuNianDouJun" : liuNianMingPan.getLiuNianDouJun(),
			"xiaoXianIndex" : liuNianMingPan.getXiaoXianIndex(),
			'stars' :  Translator.translateStars(starArray),
			'daYunStars' : dyStars,
			'liuNianStars' : lnStars
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		gongWei.gongWei = gongWei.gongWei.substr(0, 2);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

/**
 * 获取先天命盘
 */
PaiPanAPI.getXianTianMingPan = function()
{
	var mingPanResult = PaiPanAPI.__getMingPan("XianTianMingPan");
	
	if(!mingPanResult.success)
	{
		return mingPanResult.result;
	}
	
	var xianTianMingPan = mingPanResult.result;
	
	var user = window.paipan.user;
	var sections = xianTianMingPan.getItems();
	var result = {};
	result.userInfo = PaiPanAPI.__buildUserInfo(user);
	result.pan  = [];
	var normalStarCfg = SystemConfig.getConfig()._normalStarMiaoWang;
		
	for(var i = 0; i < sections.length; i ++)
	{
		var section = sections[i];
		var starArray = new Array();
		
		for(var j = 0 ; j < section.getStars().length; j ++)
		{
			var star = section.getStars()[j];
			
			var starArrayItem = {};
			starArrayItem.index = j + 1;
			starArrayItem.name = star.getName();
			
			if(starArrayItem.name.indexOf("NORMALSTAR_") >= 0 && normalStarCfg == 'OFF')
			{
				starArrayItem.descriptor = false;
			}
			else
			{
				starArrayItem.descriptor = star.getDescriptor();
				starArrayItem.descriptorFore = BizEnum.COLORCONFIG.MIAOWANG.color;
				starArrayItem.descriptorBg = BizEnum.COLORCONFIG.MIAOWANG.bgcolor;
			}
			
			var color = ColorConfig.getStarColor(star.getName());
			starArrayItem.color = color.color;
			starArrayItem.bgcolor = color.bgcolor;
			starArrayItem.xianTianSiHua = star.getSiXiang();
			starArrayItem.xianTianSiHuaFore = BizEnum.COLORCONFIG.XIANTIANSIHUA.color; //	先天四化前景色	
			starArrayItem.xianTianSiHuaBg = BizEnum.COLORCONFIG.XIANTIANSIHUA.bgcolor; //	先天四化背景色	
			starArray.push(starArrayItem);
		}
	
		var gongWei =  
		{
			"index" : section.getIndex(),
			"tianGan" : section.getTianGan(),                   // 天干
			"tianGanFore" : BizEnum.COLORCONFIG.TIANGAN.color,  // 天干前景色
			"tianGanBg" : BizEnum.COLORCONFIG.TIANGAN.bgcolor,  // 天干背景色
			"diZhi" : section.getDiZhi(),                       // 地支
			"diZhiFore" : BizEnum.COLORCONFIG.DIZHI.color,      // 地支前景色	
			"diZhiBg" : BizEnum.COLORCONFIG.DIZHI.bgcolor,      // 地支背景色
			"xianTianGongWei" : section.getGongWei().replace("(GONGWEI_SHENGONG)", ""),           // 宫位
			"xianTianGongWeiFore" : BizEnum.COLORCONFIG.XIANTIANGONGWEI.color, //	先天宫位前景色	
			"xianTianGongWeiBg" : BizEnum.COLORCONFIG.XIANTIANGONGWEI.bgcolor, //	先天宫位背景色	
			"daXianBeginYear" : section.getAgePeriod().begin,   // 大运开始年龄
			"daXianEndYear" : section.getAgePeriod().end,       // 大运结束年龄
			"daXianFore" : BizEnum.COLORCONFIG.AGEPERIOD.color, // 大运年龄前景色	
			"daXianBg" : BizEnum.COLORCONFIG.AGEPERIOD.bgcolor, // 大运年龄背景色	
			"changSheng" : section.getChangSheng12Shen(),
			"changShengFore" : BizEnum.COLORCONFIG.CHANGSHENG.color,
			"changShengBg" : BizEnum.COLORCONFIG.CHANGSHENG.bgcolor,
			"taiSuiShaLu" : section.getTaiSuiShaLu(),
			"taiSuiShaLuFore" : BizEnum.COLORCONFIG.TAISUISHALU.color,
			"taiSuiShaLuBg" : BizEnum.COLORCONFIG.TAISUISHALU.bgcolor,
			"liuNianSuiQian" : section.getLiuNianSuiQian(),
			"liuNianSuiQianFore" : BizEnum.COLORCONFIG.LIUNIANSUIQIAN.color,
			"liuNianSuiQianBg" : BizEnum.COLORCONFIG.LIUNIANSUIQIAN.bgcolor,
			"liuNianJiangQian" : section.getLiuNianJiangQian(),
			"liuNianJiangQianFore" : BizEnum.COLORCONFIG.LIUNIANJIANGQIAN.color,
			"liuNianJiangQianBg" : BizEnum.COLORCONFIG.LIUNIANJIANGQIAN.bgcolor,
			"isShenGong" : section.getGongWei().indexOf("(GONGWEI_SHENGONG)") >= 0 ? "Y" : "N",
			"shenGongFore" : BizEnum.COLORCONFIG.SHENGONG.color, //	身宫前景色	
			"shenGongBg" : BizEnum.COLORCONFIG.SHENGONG.bgcolor, //	身宫背景色	
			'stars' :  Translator.translateStars(starArray)
		};
		
		gongWei = Translator.translateObject(gongWei, 0);
		gongWei.xianTianGongWei = gongWei.xianTianGongWei.substr(0, 2);
		result.pan.push(gongWei);
	}
	
	return ReturnValue.newSuccessResult(result);
}

PaiPanAPI.__buildUserInfo = function(user)
{
	var usrInfo = user.getUserInfo();
				
	var name = usrInfo.getName();
	var gender = usrInfo.getGender();
	var genderDescriptor = usrInfo.getGenderDescriptor();
	var birthDate = usrInfo.getBirthday();
	var birthHour = Translator.translate(Util.getLunarHour(birthDate.getHour()));
	var birthday = birthDate.getYear() + "年" + birthDate.getMonth() + "月" + birthDate.getDay() + "日" + birthHour + "时";
	var lunarBirthday = birthDate.getLunarYear() + "年" + (birthDate.isLunarRunYue() ? "闰" : "") + birthDate.getLunarMonth().index + "月" + birthDate.getLunarDay().index + "日" + birthHour + "时";
	var bazi = usrInfo.getBaZi();
	
	var xianTianMingPan = user.getXianTianMingPan();
	var mingGongIndex = xianTianMingPan.getMingGongIndex();		
	var mingGongItem = xianTianMingPan.getItems()[mingGongIndex];
	var mingGongDiZhi = mingGongItem.getDiZhi();
	var mingGongMainStarNameArray = ZiWeiUtils.getMainStars(xianTianMingPan);
	mingGongMainStarNameArray.push(mingGongDiZhi);
	
	return Translator.translateUserInfo({
		"gender" : gender, 
		"genderDescriptor" : genderDescriptor, 
		"birthday" : birthday, 
		"lunarBirthday" : lunarBirthday, 
		"zodiac" : Util.getZodiacByDiZhi(bazi.nianZhu.split("$")[1]),
		"baZi" : 
		{
			"nianZhu" : bazi.nianZhu,
			"yueZhu" : bazi.yueZhu,
			"riZhu" : bazi.riZhu,
			"shiZhu" : bazi.shiZhu
		},
		"mingZhu" : xianTianMingPan.getMingZhu(),
		"shenZhu" : xianTianMingPan.getShenZhu(),
		"mingJu" : usrInfo.getMingJu().name,
		"mingGong" : mingGongMainStarNameArray.join(" ")
	}, 0);
}

/*
'user' : 
{
	'gender' : '男', 
	'birthday' : '1978-二月-十五-辰时'
},
'cfg' :
{
	'wugansihua' : '',
	'genggansihua' : '',
	'rengansihua' : '',
	'tianmacfg' : '',
	'runyue' : '',
	'miaowang' : ''
}
*/
/**
 * 保存用户信息
 */
PaiPanAPI.saveUserInfo = function()
{
	if(arguments.length == 0)
	{
		return ReturnValue.newExceptionResult("参数不能为空.");
	}
	
	var param = arguments[0];
	var userInfo = JSON.parse(param);
	
	if(!userInfo)
	{
		return ReturnValue.newExceptionResult("参数解析失败，请检查参数格式.");
	}
	
	var user = userInfo.user;
	var gender = user.gender;
	
	if(!gender || !(gender == "男" || gender == "女"))
	{
		return ReturnValue.newExceptionResult("性别参数不能为空，且必须是'男'或'女'.");
	}
	
	if(!user.birthday)
	{
		return ReturnValue.newExceptionResult("出生日期不能为空.");
	}
	
	if(!userInfo.cfg)
	{
		userInfo.cfg = 
		{
			'wuGanSiHua' : 0,
			'gengGanSiHua' : 0,
			'renGanSiHua' : 0,	
			'tianmaStar' : 0,
			'runYue' : 0,
			'miaowang' : 0
		};
	}
		
	var birthday = user.birthday;
	birthday = birthday.split("-");
	var year = parseInt(birthday[0]);
	var month = birthday[1]; 
	var day = birthday[2];
	var isRunYue = false;
	
	if(month.indexOf("闰") >= 0)
	{
		isRunYue = true;
		month = month.replace("闰", "");
	}
	
	month = Util.convertLunarMonthStr2Integer(month);
	day = Util.convertLunarDayStr2Integer(day);
	birthday[3] = birthday[3].replace("时", "");
	var hour = Util.parseLunarHour(birthday[3]);
	hour = Util.getHourByLunarStr(hour);
	
	var user = User.newInstance('user', gender, year, month, day, hour, true, isRunYue);
	
	window.paipan = {};
	window.paipan.user = user;
	
	var sysCfg = SystemConfig.newInstance();
	
	sysCfg.setSiHuaOfWu(userInfo.cfg.wuGanSiHua);
	sysCfg.setSiHuaOfGeng(userInfo.cfg.gengGanSiHua);
	sysCfg.setSiHuaOfRen(userInfo.cfg.renGanSiHua);
	sysCfg.setTianMaStarConfig(userInfo.cfg.tianmaStar);
	sysCfg.setRunYueConfig(userInfo.cfg.runYue);
	sysCfg.showMiaoWang(0,0,0,userInfo.cfg.miaowang);
	window.paipan.cfg = sysCfg;
	
	return ReturnValue.newSuccessResult();
}