/**
 * SystemConfig.js
 * 系统配置
 * 
 * @date 2014-02-19
 * @version 0.1
 */
 
 function SystemConfig(){
	this._language = false;                 // 语言
	this._siHuaOfWu = false;                // 戊干四化
	this._siHuaOfGeng = false;              // 庚干四化
	this._siHuaOfRen = false;               // 壬干四化
	this._tianMaStar = false;               // 天马星配置
	this._runYue = false;                   // 闰月配置
	this._mainStarMiaoWang = false;         // 14主星的庙旺显示配置
	this._gemStarMiaoWang = false;          // 8吉星的庙旺显示配置
	this._fiendStarMiaoWang = false;        // 6煞星的庙旺显示配置
	this._normalStarMiaoWang = false;       // 小星的庙旺显示配置
 }
 
 SystemConfig.newInstance = function(){
	var cfg = new SystemConfig();
	
	cfg.setLanguage();
	cfg.setSiHuaOfWu();
	cfg.setSiHuaOfGeng();
	cfg.setSiHuaOfRen();
	cfg.setTianMaStarConfig();
	cfg.setRunYueConfig();
	cfg.showMiaoWang();
	
	return cfg;
 };
 
 SystemConfig.getConfig = function(){
	if(!window.com.taxen.framework.ziwei.systemcfg){
		window.com.taxen.framework.ziwei.systemcfg = SystemConfig.newInstance();
	}
	
	return window.com.taxen.framework.ziwei.systemcfg;
 };
 
 SystemConfig.setConfig = function(cfg){
	if(!cfg){
		return ;
	}
	
	window.com.taxen.framework.ziwei.systemcfg = cfg;
	
	return true;
 };
 
 /**
  * 设置语言
  */
 SystemConfig.prototype.setLanguage = function(language){
	if(language != 1){           // 中文繁体
		language = 0;           // 中文简体 
	}
	
	this._language = BizEnum.CONFIG.LANGUAGE[language];
	
	return this;
 };
 
 /**
  * 设置戊干四化
  */
 SystemConfig.prototype.setSiHuaOfWu = function(siHua){
	// 0 : 贪阴弼机
	// 1 : 贪阴阳机
	
	siHua = (1 != siHua)? 0 : 1;
	
	this._siHuaOfWu = BizEnum.CONFIG.WUGANSIHUA[siHua];
	
	return this;
 };
 
 SystemConfig.prototype.getSiHuaOfWu = function(){
	return this._siHuaOfWu;
 };
 
 /** 
  * 设置庚干四化
  */
 SystemConfig.prototype.setSiHuaOfGeng = function(siHua){
	if(1 != siHua && 2 != siHua){
		siHua = 0;
	}
	
	this._siHuaOfGeng = BizEnum.CONFIG.GENGGANSIHUA[siHua];
	
	return this;
 };
 
 SystemConfig.prototype.getSiHuaOfGeng = function(){
	return this._siHuaOfGeng;
 };
 
 SystemConfig.prototype.setSiHuaOfRen = function(siHua){
	siHua = (1 != siHua)? 0 : 1;
	
	this._siHuaOfRen = BizEnum.CONFIG.RENGANSIHUA[siHua];
	
	return this;
 };
 
 SystemConfig.prototype.getSiHuaOfRen = function(){
	return this._siHuaOfRen;
 };
 
 SystemConfig.prototype.setTianMaStarConfig = function(cfg){
	cfg = (1 != cfg)? 0 : 1;
	
	this._tianMaStar = BizEnum.CONFIG.TIANMASTAR[cfg];
	
	return this;
 };
 
 SystemConfig.prototype.getTianMaStarConfig = function(){
	return this._tianMaStar;
 }
 
 SystemConfig.prototype.setRunYueConfig = function(cfg){
	cfg = (1 != cfg)? 0 : 1;
	
	this._runYue = BizEnum.CONFIG.RUNYUE[cfg];
	
	return this;
 };
 
 SystemConfig.prototype.getRunYueConfig = function(){
	return this._runYue;
 };
 
 SystemConfig.prototype.showMiaoWang = function(mainStar, gemStar, fiendStar, normalStar){
	mainStar = (1 != mainStar) ? 0 : 1;
	gemStar = (1 != gemStar) ? 0 : 1;
	fiendStar = (1 != fiendStar) ? 0 : 1;
	normalStar = (1 != normalStar) ? 0 : 1;
	
	this._mainStarMiaoWang = BizEnum.CONFIG.MIAOWANGSTATUS[mainStar];
	this._gemStarMiaoWang = BizEnum.CONFIG.MIAOWANGSTATUS[gemStar];
	this._fiendStarMiaoWang = BizEnum.CONFIG.MIAOWANGSTATUS[fiendStar];
	this._normalStarMiaoWang = BizEnum.CONFIG.MIAOWANGSTATUS[normalStar];
	
	return this;
 };