/**
 * TianGongGongInterface.js
 * 天公公接口
 *
 * @date 2014-02-11
 * @version 0.1
 */
 function getMingGe()
 {
	var user = getCurrentUser();
	
	if(!user)
	{
		return false;
	}
	
	var mingGe = ZiWeiUtils.calcMingGe(user.user);
	
	return JSON.stringify(mingGe);
 }

 function saveUserInfo(){
	if(arguments.length < 1){
		return false;
	}
	
	var user = arguments[0];
	
	//user = JSON.parse(user);
	try{
		eval('user = (' + user + ')');
	}catch(e){
		return false;
	}
	
	var sysFont = user.sysFont || 0;
	
	sysFont = parseInt(sysFont);
	
	var name = user.name || '用户';
	
	if(!user.gender || !(user.gender == "男" || user.gender == "女")){
		return false;
	}
	
	if(!user.birthday){
		return false;
	}
	
	var gender = user.gender;
	var birthday = user.birthday;
	
	birthday = birthday.split("-");
	
	var year, month, day, hour, isRunYue;
	
	year = parseInt(birthday[0]);
	
	eval("user.isLunarDate = " + user.isLunarDate);
	
	if(user.isLunarDate){
		month = birthday[1]; 
		day = birthday[2];
	
		if(month.indexOf("闰") >= 0){
			isRunYue = true;
			month = month.replace("闰", "");
		}
		
		month = Util.convertLunarMonthStr2Integer(month);
		day = Util.convertLunarDayStr2Integer(day);
	}else{
		month = parseInt(birthday[1]);
		day = parseInt(birthday[2]);
		
	}
	
	birthday[3] = birthday[3].replace("时", "");
	hour = Util.parseLunarHour(birthday[3]);
	
	hour = Util.getHourByLunarStr(hour);
	
	var user = User.newInstance(name, gender, year, month, day, hour, user.isLunarDate, isRunYue);
	
	window.tiangonggong = new Object();
	
	window.tiangonggong.user = {
		"languageConfig" : sysFont,
		"user" : user
	};
	
	/*
	if(!window.tiangonggong.users){
		window.tiangonggong.users = new Array();
	}
	
	window.tiangonggong.users.push({
		"languageConfig" : sysFont,
		"user" : user
	});
	
	*/
	return user.getToken();
 };
 
 function saveSession(){
	if(arguments.length == 0){
		return false;
	}
	
	var args = arguments[0];
	
	args = args.split(",");
	
	if(args.length < 3){
		return false;
	}
	
	var year = parseInt(args[0]);

	var month = parseInt(args[1]);
	
	var day = parseInt(args[2]);
	
	return Session.setSession(year, month, day);
 };
 
 function getLiuFenEnergy(){
	if(arguments.length == 0){
		return false;
	}
	
	var user = getCurrentUser();
	
	if(!user){
		return false;
	}
	
	user = user.user;
	
	var args = arguments[0];
	
	args = args.split(",");
	
	var year = parseInt(args[0]);
	var month = parseInt(args[1]);
	var day = parseInt(args[2]);
	var hour = parseInt(args[3]);
	var min = parseInt(args[4]);
	var mode = parseInt(args[5]);
	
	if(hour == 23){
		var oldDate = new Date(year, month - 1, day);
		
		var newDate = PerpetualCalendar.add(oldDate, 1);
		
		year = newDate.getFullYear();
		month = newDate.getMonth() + 1;
		day = newDate.getDate();
	}

	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(year, month, day, 0);
	
	var liuFenMingPan = user.getLiuFenMingPan(lunarDate.year, lunarDate.month, lunarDate.day, hour, min, lunarDate.isRunYue);
	
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuFenMingPan, "LiuFenMingPan");
	
	if(mode == 0){
		return level;
	}

	return Math.ceil(level / 4);
 };
 
 function getRiZhuAndMingGongInfo(){
	var user = getCurrentUser();
	
	if(!user){
		return false;
	}
	
	var sysLang = user.languageConfig;
	var user = user.user;
	
	var xianTianMingPan = user.getXianTianMingPan();
	
	var userInfo = user.getUserInfo();
	
	var riZhu = userInfo.getBaZi().riZhu;
	var nianZhu = userInfo.getBaZi().nianZhu;

	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	
	var mingGongSection = xianTianMingPan.getItems()[mingGongIndex];
	
	var stars = mingGongSection.getStars();
	
	var isEmpty = true;

	var mingGongStr = "";
	for(var j = 0; j < stars.length; j ++){
		if(stars[j].getName().indexOf("MAINSTAR_") >= 0){
			isEmpty = false;
			
			var starName = Translator.translate(stars[j].getName(), sysLang);
			
			mingGongStr += " " + starName;
		}
	}
	
	if(isEmpty){
		mingGongIndex = (mingGongIndex + 6) % 12;
	
		mingGongSection = xianTianMingPan.getItems()[mingGongIndex];
		
		stars = mingGongSection.getStars();
		
		for(var j = 0; j < stars.length; j ++){
			if(stars[j].getName().indexOf("MAINSTAR_") >= 0){
				var starName = Translator.translate(stars[j].getName(), sysLang);
				
				mingGongStr += " " + starName;
			}
		}
	}
	
	var diZhi = Util.getDiZhiByIndex(mingGongIndex);
	
	diZhi = Translator.translate(diZhi, sysLang);
		
	mingGongStr += "_" + diZhi;
	
	var result = {
		"riZhu" : Translator.translate(riZhu, sysLang),
		"mingGong" : mingGongStr,
		"nianZhu" : Translator.translateTianGanDiZhi(nianZhu, sysLang)
	};
		
	return JSON.stringify(result);
 }
 
 function convertGregorianDate2LunarDate(){
	if(arguments.length < 1){
		return false;
	}
	
	var date = arguments[0];
	
	eval("date = (" + date + ")");

	var curDate = new Date();
	
	var year = date.year ? parseInt(date.year) : curDate.getFullYear(); 
	var month = date.month ? parseInt(date.month) : curDate.getMonth() + 1; 
	var day = date.day ? parseInt(date.day) : curDate.getDate(); 
	
	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(year, month, day, 2);
	var siZhu = SiZhu.createSiZhu2(lunarDate.year, lunarDate.month, lunarDate.day, lunarDate.hour, lunarDate.isRunYue);
	
	siZhu = siZhu.getNianZhu() + "-" + siZhu.getYueZhu() + "-" + siZhu.getRiZhu() + "-" + siZhu.getShiZhu();
	
	var curUser = getCurrentUser();
	
	var langCfg = curUser ? curUser.languageConfig : 0;
	
	siZhu = Translator.translateBaZi(siZhu, langCfg);

	siZhu = siZhu.split("-");
	
	var result = {
		'year' : {
			'index' : lunarDate.year,
			'lunarName' : siZhu[0]
		},
		'month' : {
			'index' : lunarDate.month,
			'lunarName' : Translator.translate(Util.convertInteger2LunarMonth(lunarDate.month)),
			'monthGanZhi' : siZhu[1],
			'isRunYue' : lunarDate.isRunYue ? true : false
		},
		'day' : {
			'index' : lunarDate.day,
			'lunarName' : Translator.translateTianGanDiZhi(Util.convertInteger2LunarDayStr(lunarDate.day)),
			'dayGanZhi' : siZhu[2]
		}
	};
	
	return JSON.stringify(result);
 }
 
 function convertLunarDate2GregorianDate(){
	if(arguments.length < 1){
		return false;
	}
	
	var param = arguments[0];
	
	try{
		eval("param = (" + param + ")");
	}catch(e){
		return false;
	}
	
	var year = param.year;
	var month = param.month;
	var day = param.day;
	var isRunYue = false;
	
	if(!(year && month && day)){
		return false;
	}
	
	year = parseInt(year);
	
	if(year < 1901 || year > 2099){
		return false;
	}
	
	if(month.indexOf("闰") >= 0){
		isRunYue = true;
		month = month.replace("闰", "");
	}
	
	month = Util.convertLunarMonthStr2Integer(month);
	
	if(month < 1){
		return false;
	}
	
	day = Util.convertLunarDayStr2Integer(day);
	
	if(day < 1){
		return false;
	}
	
	var gDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, day, 0, isRunYue);
	
	gDate = {
		'year' : gDate.getFullYear(),
		'month' : gDate.getMonth() + 1,
		'day' : gDate.getDate()
	};
	
	return JSON.stringify(gDate);
 }
 
 function getSpecifiedDateTimeEnergyInfo(){
	if(arguments.length < 1){
		return false;
	}
	
	var curUser = getCurrentUser();
	
	if(!curUser){
		return false;
	}
	
	curUser = curUser.user;
	
	var param = arguments[0];
	
	//return param;
	try{
		eval("param = (" + param + ")");
	}catch(e){
		return false;
	}
	
	var date = param.date;
	var type = param.type;
	
	if(!(date && type)){
		return false;
	}
	
	if(!date.isRunYue){
		date.isRunYue = false;
	}else{
		eval("date.isRunYue = " + date.isRunYue);
	}
	
	var curDate = new Date();
	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(curDate.getFullYear(), curDate.getMonth() + 1, curDate.getDate(), 0);
	
	var year = date.year || lunarDate.year,
	    month = date.month  || lunarDate.month,
	    day = date.day || lunarDate.day,
	    hour = date.hour || lunarDate.hour,
	    isRunYue = date.isRunYue || lunarDate.isRunYue;
		
		year = parseInt(year);
		month = parseInt(month);
		day = parseInt(day);
	    
	var siZhu = SiZhu.createSiZhu(year, month, day, hour, isRunYue);	
	
	switch(type.toUpperCase()){
		case "HOUR" : {
			var liuShiMingPan = curUser.getLiuShiMingPan(year, month, day, hour, isRunYue);
			
			var result = EnergyCalculator.getLevel(liuShiMingPan, "LiuShiMingPan");
			
			if(!result){
				return false;
			}
			
			return result.level;
		}
		case "DAY" : {
			var liuRiMingPan = curUser.getLiuRiMingPan(year, month, day, isRunYue);
			
			var sanFangSiZheng = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", liuRiMingPan, "LiuRiMingPan", true);
			
			var result = EnergyCalculator.getLevel(liuRiMingPan, "LiuRiMingPan");
			
			if(!result){
				return false;
			}
			
			var liuRiEnergyLevel = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
			result.level = liuRiEnergyLevel;
			
		//	var tips = TianGongGongUtil.getTipsByStars(sanFangSiZheng['zuo']);
	//		var waiJieEnergy = TianGongGongUtil.getWaiJieEnergy(Util.convertJiaZi2GanZhi(siZhu.getRiZhu()).split("$")[0]);
			var tips = TianGongGongUtil.removeDuplicateStars(sanFangSiZheng['zuo']);
			var waiJieEnergy = Util.convertJiaZi2GanZhi(siZhu.getRiZhu()).split("$")[0];
			result = {
				"energy" : result,
				"tips" : tips,
				"outsideEnergy" : waiJieEnergy
			}
			
			return JSON.stringify(result);
		}
		case "MONTH" : {
			var liuYueMingPan = curUser.getLiuYueMingPan(year, month, isRunYue);
			
			var sanFangSiZheng = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", liuYueMingPan, "LiuYueMingPan", true);
			
			var result = EnergyCalculator.getLevel(liuYueMingPan, "LiuYueMingPan");
			
			if(!result){
				return false;
			}
			
			result.level = ZiWeiUtils.getLiuYueEnergy(liuYueMingPan);
			
			//var tips = TianGongGongUtil.getTipsByStars(sanFangSiZheng['zuo']);
			//var waiJieEnergy = TianGongGongUtil.getWaiJieEnergy(siZhu.getYueZhu().split("$")[0]);
			
			var tips = TianGongGongUtil.removeDuplicateStars(sanFangSiZheng['zuo']);
			
			var _siZhu = SiZhu.createSiZhu(year, month, 15, 0, isRunYue);
			
			var waiJieEnergy = _siZhu.getYueZhu().split("$")[0];
			
			result = {
				"energy" : result,
				"tips" : tips,
				"outsideEnergy" : waiJieEnergy
			}
			
			return JSON.stringify(result);
		}
		case "YEAR" : {
			var liuNianMingPan = curUser.getLiuNianMingPan(year);
			
			var sanFangSiZheng = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", liuNianMingPan, "LiuNianMingPan", true);
			
			var result = EnergyCalculator.getLevel(liuNianMingPan, "LiuNianMingPan");
			
			if(!result){
				return false;
			}
			
			//var tips = TianGongGongUtil.getTipsByStars(sanFangSiZheng['zuo']);
			//var waiJieEnergy = TianGongGongUtil.getWaiJieEnergy(siZhu.getNianZhu().split("$")[0]);
			var tips = TianGongGongUtil.removeDuplicateStars(sanFangSiZheng['zuo']);
			var waiJieEnergy = siZhu.getNianZhu().split("$")[0];
			
			result = {
				"energy" : result,
				"tips" : tips,
				"outsideEnergy" : waiJieEnergy
			}
			
			return JSON.stringify(result);
		}
		default : return false;
	}
 };

 function getEnergyCalendarData(){
	if(arguments.length < 1){
		return false;
	}
	
	var param = arguments[0];
	
	try{
		eval("param = ("+param+")");
	}catch(e){
		return false;
	}
	
	var year = param.year;
	var month = param.month;
	var isRunYue = param.isRunYue;
	
	if(!year){
		return false;
	}
	
	year = parseInt(year);
	
	if(year < 1901 || year > 2099){
		return false;
	}
	
	var curUser = getCurrentUser();
	
	var language = curUser.languageConfig;
	curUser = curUser.user;
	
	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[year-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;
	
	if(!month){
		var resultArray = new Array();
		var liuYueMingPan = false;
		
		for(var i = 0; i < monthInfo.length; i ++){
			var _isRunYue = false;
			
			if(runYueIndex == i){
				_isRunYue = true;
			}
			
			var monthStartDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, (runYueIndex > 0 && i >= runYueIndex )? i : i + 1, 1, 0, _isRunYue);
			
			var monthEndDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, (runYueIndex > 0 && i >= runYueIndex )? i : i + 1, monthInfo[i], 0, _isRunYue);
			
			
			
			if(!liuYueMingPan){
				liuYueMingPan = curUser.getLiuYueMingPan(year, (runYueIndex > 0 && i >= runYueIndex )? i : i + 1, _isRunYue);
			}else{
				liuYueMingPan = MingPanUtil.fastCreateNextLiuYueMingPan(liuYueMingPan, (runYueIndex > 0 && i >= runYueIndex )? i : i + 1, _isRunYue);
			}

			//var level = ZiWeiUtils.getLiuYueEnergy(liuYueMingPan);
			var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuYueMingPan, "LiuYueMingPan");
			
			var item = {
				"startDate" : {
					"year" : monthStartDate.getFullYear(),
					"month" : monthStartDate.getMonth() + 1,
					"day" : monthStartDate.getDate()
				},
				"endDate" : {
					"year" : monthEndDate.getFullYear(),
					"month" : monthEndDate.getMonth() + 1,
					"day" : monthEndDate.getDate()
				},
				"year" : {
					"index" : year,
					"lunarName" : Translator.translateTianGanDiZhi(PerpetualCalendar.getLunarYearGanZhiStr(year), language)
				},
				"month" : {
					"index" : (runYueIndex > 0 && i >= runYueIndex )? i : i + 1,
					"lunarName" :  Translator.translate(Util.convertInteger2LunarMonth((runYueIndex > 0 && i >= runYueIndex )? i : i + 1), language),
					"isRunYue" : _isRunYue
				},
				"data" : level
			};
			
			resultArray.push(item);
		}

		return JSON.stringify(resultArray);
	}else{
		var liuYueMingPan = curUser.getLiuYueMingPan(year, month, _isRunYue);
		var monthLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuYueMingPan, "LiuYueMingPan");
		/*
		var increaseNum = 0;
		
		if(monthLevel > 10)
		{
			increaseNum = 1;
		}
		
		if(monthLevel < 3)
		{
			increaseNum = -1;
		}
		*/
		var _isRunYue = false;
	
		var monthData = monthInfo[month - 1];
	
		if(isRunYue && runYueIndex == month){
			_isRunYue = true;
		}
		
		if((runYueIndex >= 1 && month > runYueIndex) || (isRunYue && runYueIndex == month))
		{
			monthData = monthInfo[month];
		}
		
		var dayDataArray = new Array();
		var liuRiMingPan = false;
	//	var startTime = new Date().getTime();
		for(var i = 0; i < monthData;  i ++){
			var gDate = PerpetualCalendar.convertLunarDate2GregorianDate(year, month, i + 1, 0, _isRunYue);
			
			
			if(!liuRiMingPan){
				liuRiMingPan = curUser.getLiuRiMingPan(year, month, i + 1, _isRunYue);
			}else{
				liuRiMingPan = MingPanUtil.fastCreateNextLiuRiMingPan(liuRiMingPan, monthData);
			}
			
			/*
			var sanFangSiZheng = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", liuRiMingPan, "LiuRiMingPan");
			var sanFangStars = sanFangSiZheng['hui'].concat(sanFangSiZheng['zuo']);
			
			for(var j = 0; j < sanFangStars.length; j ++)
			{
				var star = sanFangStars[j];
				
				if(star.getName().indexOf("MAINSTAR_") >= 0)
				{
					if(star.getDescriptor() == "MIAOWANG_XIAN" && star.getSiHuaOfLiuRi() == "SIHUA_JI")
					{
						increaseNum --;
						
						break;
					}
				}
			}
			*/
			
			//var level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
			var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuRiMingPan, "LiuRiMingPan");
			//level += increaseNum;
			
			if(level > 12)
			{
				level = 12;
			}
			
			if(level < 1)
			{
				level = 1;
			}
		
			var dayData = {
				"year" : {
					"gIndex" : gDate.getFullYear(),
					"lIndex" : year,
					"lunarName" : Translator.translateTianGanDiZhi(PerpetualCalendar.getLunarYearGanZhiStr(year), language)
				},
				"month" : {
					"gIndex" : gDate.getMonth() + 1,
					"lIndex" : month,
					"lunarName" : Translator.translate(Util.convertInteger2LunarMonth(month), language)
				},
				"day" : {
					"gIndex" : gDate.getDate(),
					"lIndex" : i + 1,
					"lunarName" : Translator.translateTianGanDiZhi(Util.convertInteger2LunarDayStr(i + 1), language)
				},
				"weekday" : ["日", "一", "二", "三", "四", "五", "六"][gDate.getDay()],
				"feast" : Translator.translate(SimpleFeastCalculator.ifEnterNextFeast(gDate.getFullYear(), gDate.getMonth() + 1, gDate.getDate()), language),
				"data" : level
			};
			
			dayDataArray.push(dayData);
		}
	//	console.log(new Date().getTime()-startTime);
		return JSON.stringify(dayDataArray);
	}
 };
 
 function getCurrentUser(){
	return window.tiangonggong.user;
 };
 
  function __getCurrentUser(){
	return JSON.stringify(window.tiangonggong.user);
 };
 
 function getNextDay(){
	if(arguments.length < 1){
		return false;
	}
	
	var param = arguments[0];
	
	eval('param = (' + param + ')');
	
	var year = param.year;
	var month = param.month;
	var day = param.day;
	
	if(!(year && month && day)){
		return false;
	}
	
	year = parseInt(year);
	month = parseInt(month);
	day = parseInt(day);
	
	var gYear = year, gMonth = month, gDay;
	if(month == 2 && day == 28){
		var isLeapYear = PerpetualCalendar.isLeapYear(year);
		
		if(isLeapYear){
			gYear = year;
			gMonth = month;
			gDay = 29;
		}else{
			gMonth ++;
			gDay = 1;
		}
	}
	else if(month == 2 && day == 29)
	{
		gMonth ++;
		gDay = 1;
	}else if(day == 31 && (month == 1 || month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12)){
		gMonth ++;
		gDay = 1;
	}else if(day == 30 && (month == 4 || month == 6 || month == 9 || month == 11)){
		gMonth ++;
		gDay = 1;
	}else{
		gDay = day + 1;
	}
	
	if(gMonth == 13){
		gYear ++;
		gMonth = 1;
		gDay = 1;
	}
	
	var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(gYear, gMonth, gDay, 0);
	
	var result = {
		'year' : {
			'gIndex' : gYear,
			'lIndex' : lunarDate.year,
			'lunarName' : Translator.translateTianGanDiZhi(PerpetualCalendar.getLunarYearGanZhiStr(lunarDate.year))
		},
		'month' : {
			'gIndex' : gMonth,
			'lIndex' : lunarDate.month,
			'lunarName' : Translator.translate(Util.convertInteger2LunarMonth(lunarDate.month)),
			'isRunYue' : lunarDate.isRunYue
		},
		'day' : {
			'gIndex' : gDay,
			'lIndex' : lunarDate.day,
			'lunarName' : Translator.translateTianGanDiZhi(Util.convertInteger2LunarDayStr(lunarDate.day))
		}
	};
	
	return JSON.stringify(result); 
 }
 
 function convertUnicode2Chinese(){
	if(arguments.length < 1){
		return false;
	}
	
	var metaStr = arguments[0];
	
	return metaStr.replace(/0[Xx][\d\w]{4}/gmi, function(word){return String.fromCharCode(word);});
 }
 
 function getCurrentFeast(){
	if(arguments.length < 1){
		return false;
	}
	
	/*
		{
			year : 2014,
			month : 4,
			day : 5,
			mode : 0
		}
	*/
	
	var curTime = arguments[0];
	
	curTime = eval("("+curTime+")");
	
	var year = curTime.year;
	var month = curTime.month;
	var day = curTime.day;
	var mode = curTime.mode;
	
	var curDate = new Date();
	
	year = parseInt(year);
	month = parseInt(month);
	day = parseInt(day);
	mode = parseInt(mode);
	
	
	if(year > 2099 || year < 1901){
		year = curDate.getFullYear();
	}
	
	if(month > 12 || month < 1){
		month = curDate.getMonth() + 1;
	}
	
	if(day > 31 || day < 1){
		day = curDate.getDate();
	}
	
	if(mode != 1){
		mode = 0;
	}
	
	var result = SimpleFeastCalculator.ifEnterNextFeast(year, month, day);
	
	if(mode == 1){
		result = SimpleFeastCalculator.getFeastByDate(year, month, day);
	}
	
	var curUser = getCurrentUser();
	
	var language = curUser.languageConfig;
	
	if(!result){
		return "";
	}else{
		return Translator.translate(result,language);
	}
 }
 
  function getYearBeginDateAndEndDate4Tgg()
 {
	if(arguments.length == 0){
		return false;
	}
	
	var args = arguments[0];
	
	var year = parseInt(args);
	
	var perpecalendar = new PerpetualCalendar();
	
	var thisYearCalendar = perpecalendar.getCalendar()[year - 1901];
	var nextYearCalendar = perpecalendar.getCalendar()[year + 1 - 1901];
	var endDate = addDate(nextYearCalendar.springFestivalDate, -1);
	
	var result = {
		"begin" : {
			'year' : thisYearCalendar.springFestivalDate.getFullYear(),
			'month' : thisYearCalendar.springFestivalDate.getMonth() + 1,
			'day' : thisYearCalendar.springFestivalDate.getDate()
		},
		"end" : {
			'year' : endDate.getFullYear(),
			'month' : endDate.getMonth() + 1,
			'day' : endDate.getDate()
		},
		'lunarYear' : Translator.translateTianGanDiZhi(PerpetualCalendar.getLunarYearGanZhiStr(year))
	};
	
	return JSON.stringify(result);
 }
 
 function getNextLunarMonthInfo()
 {
	if(arguments.length < 1){
		return false;
	}
	
	var param = arguments[0];
	
	eval('param = (' + param + ')');
	
	var lunarYear = param.year;
	var lunarMonth = param.month;
	var isRunYue = param.isRunYue;
	
	if(!(lunarYear && lunarMonth)){
		return false;
	}
	
	lunarYear = parseInt(lunarYear);
	lunarMonth = parseInt(lunarMonth)
	
	var calendar = new PerpetualCalendar();
	var basePerpetualCalenderItem = calendar.getCalendar()[lunarYear-1901];   // 获取该年的数据
	var monthInfo = basePerpetualCalenderItem.monthInfo;
	
	
	var yearIndex, monthIndex, nextMonthIsRunYue, maxDay;
	
	// 下一年第一月
	if(lunarMonth == 12 && basePerpetualCalenderItem != 12)
	{
		yearIndex = lunarYear + 1;
		var nextYearCalendar = calendar.getCalendar()[yearIndex -1901];   // 获取该年的数据
		monthIndex = 1;
		nextMonthIsRunYue = nextYearCalendar.runYueIndex == 1;
		maxDay = nextMonthIsRunYue ? nextYearCalendar.monthInfo[1] : nextYearCalendar.monthInfo[0]
	}
	// 当前年的下一月
	else
	{
		var thisYearHasRunYue = basePerpetualCalenderItem.runYueIndex > 0;
		
		yearIndex = lunarYear;
		
		if(thisYearHasRunYue && lunarMonth > basePerpetualCalenderItem.runYueIndex)
		{
			maxDay = monthInfo[lunarMonth + 1];
		}
		else
		{
			maxDay = monthInfo[lunarMonth];
		}
		
		if(thisYearHasRunYue && !isRunYue &&  lunarMonth == basePerpetualCalenderItem.runYueIndex)
		{
			monthIndex = lunarMonth;
			nextMonthIsRunYue = true;
		}
		else
		{
			monthIndex = lunarMonth + 1;
			nextMonthIsRunYue = false;
		}	
	}
	
	 var nextMonthBeginDate = PerpetualCalendar.convertLunarDate2GregorianDate(yearIndex, monthIndex, 1, 0, nextMonthIsRunYue);
	 
	 var nextMonthEndDate = PerpetualCalendar.convertLunarDate2GregorianDate(yearIndex, monthIndex, maxDay, 0, nextMonthIsRunYue);
	 
	 var nextLunarmonthInfo = Util.getLunarMonthByIndex(monthIndex - 1);
	 
	 var result =    {
		'lunarYearIndex' : yearIndex,
		'lunarYear' : Translator.translateTianGanDiZhi(PerpetualCalendar.getLunarYearGanZhiStr(yearIndex)),
		'lunarMonth' : Translator.translate(nextLunarmonthInfo.name),
		'lunarMonthIndex' : nextLunarmonthInfo.index,
		'isRunYue' : nextMonthIsRunYue,
		'begin' : {
			'gYear' : nextMonthBeginDate.getFullYear(),
			'gMonth' : nextMonthBeginDate.getMonth() + 1,
			'gDay' : nextMonthBeginDate.getDate()
		},
		'end' : {
			'gYear' : nextMonthEndDate.getFullYear(),
			'gMonth' : nextMonthEndDate.getMonth() + 1,
			'gDay' : nextMonthEndDate.getDate()
		}
    };
	
	return JSON.stringify(result);
 };
 
function get15DaysEnergyInfo(){
	var curUser = getCurrentUser();
	
	if(!curUser){
		return false;
	}
	
	curUser = curUser.user;
	var curDate = Session.getSession().getGregorianDate();
	var innerDate = null;
	var resultArray = new Array();
	
	// 每次取15天
	for(var i = 0; i < 15; i++)
	{
		innerDate = addDate(curDate, i);
		var lunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(innerDate.getFullYear(), innerDate.getMonth() + 1, innerDate.getDate(), 0);
		var liuRiMingPan = curUser.getLiuRiMingPan(lunarDate.year, lunarDate.month, lunarDate.day, lunarDate.isRunYue);		
		var result = EnergyCalculator.getLevel(liuRiMingPan, "LiuRiMingPan");
		var level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
		result.level = level;
		
		resultArray.push({
			'year' : innerDate.getFullYear(),
			'month' : innerDate.getMonth() + 1,
			'day' : innerDate.getDate(),
			'data' : result
		});
	}
	 
	return JSON.stringify(resultArray);
 }; 
 
function addDate(date,days)
{ 
   var d=new Date(date); 
   
   d.setDate(d.getDate()+days); 
   
   return d;
 }