/**
 * Translator.js
 * 翻译器
 *
 * @date 2014-01-14
 * @version 0.1
 */
 
 function Translator(){
 
 }
 
  /**
  * 翻译星星
  */
 Translator.translateStars = function(stars)
 {	 
	 for(var i in stars)
	 {
		stars[i].name = Translator.translate(stars[i].name);
		stars[i].descriptor = Translator.translate(stars[i].descriptor);
		stars[i].xianTianSiHua = Translator.translate(stars[i].xianTianSiHua);
		
		if(stars[i].daYunSiHua)
		{
			stars[i].daYunSiHua = Translator.translate(stars[i].daYunSiHua);
		}
		
		if(stars[i].liuNianSiHua)
		{
			stars[i].liuNianSiHua = Translator.translate(stars[i].liuNianSiHua);
		}
		
		if(stars[i].liuYueSiHua)
		{
			stars[i].liuYueSiHua = Translator.translate(stars[i].liuYueSiHua);
		}
		
		if(stars[i].liuRiSiHua)
		{
			stars[i].liuRiSiHua = Translator.translate(stars[i].liuRiSiHua);
		}
		
		if(stars[i].liuShiSiHua)
		{
			stars[i].liuShiSiHua = Translator.translate(stars[i].liuShiSiHua);
		}
	 }
	 
	 return stars;
 }
 
 /**
  * 翻译用户信息
  */
 Translator.translateUserInfo = function(userInfo)
 {
	 userInfo.gender = Translator.translate(userInfo.gender, 0);
	 userInfo.genderDescriptor = Translator.translate(userInfo.genderDescriptor, 0);
	 userInfo.zodiac = Translator.translate(userInfo.zodiac, 0);
	 userInfo.mingZhu = Translator.translate(userInfo.mingZhu, 0);
	 userInfo.shenZhu = Translator.translate(userInfo.shenZhu, 0);
	 userInfo.mingJu = Translator.translate(userInfo.mingJu, 0);
	 userInfo.baZi.nianZhu = Translator.translateTianGanDiZhi(userInfo.baZi.nianZhu, 0);
	 userInfo.baZi.yueZhu = Translator.translateTianGanDiZhi(userInfo.baZi.yueZhu, 0);
	 userInfo.baZi.riZhu = Translator.translate(userInfo.baZi.riZhu, 0);
	 userInfo.baZi.shiZhu = Translator.translateTianGanDiZhi(userInfo.baZi.shiZhu, 0);
	 userInfo.mingGong = Translator.translateMingGong(userInfo.mingGong);
	 
	 return userInfo;
 }
 
 /**
  * 翻译 
  */
 Translator.translate = function(metaStr, language){
	if(!metaStr){
		return false;
	}
	
	var result = false;
	
	if(language == 1){
		result = BizEnum_Traditional.MAP[metaStr];
	}else{
		result = BizEnum_Simplified.MAP[metaStr];
	}
	
	result = result || metaStr;
	
	return result;
 };
 
 /**
  * 翻译对象
  */
 Translator.translateObject = function(obj, language){
	if(typeof obj != "object"){
		return false;
	}
	
	for(var i in obj){
		var val = obj[i];
		
		var translatedVal = false;
		
		if("bazi" == i){
			translatedVal = Translator.translateBaZi(val, language);
		}else if("gongWei" == i){
			translatedVal = Translator.translateGongWei(val, language);
		}else if(i.toLowerCase().indexOf("birthday") >= 0){
			translatedVal = Translator.translateBirthday(val, language);
		}else if("mingGong" == i){
			translatedVal = Translator.translateMingGong(val, language);
		}else if(i.toLowerCase().indexOf("ganzhi") >= 0){
			translatedVal = Translator.translateTianGanDiZhi(val, language);
		}else{
			translatedVal = Translator.translate(val, language);
		}
		
		obj[i] = translatedVal;
	}
	
	return obj;
 };
 
 Translator.translateGongWei = function(mingGong, language){
	
 
	mingGong = mingGong.replace("(", " ").replace(")", "");
	
	mingGong = mingGong.split(" ");
	
	if(mingGong.length == 2){
		mingGong[0] = Translator.translate(mingGong[0], language);
		mingGong[1] = Translator.translate(mingGong[1], language);
		
		return mingGong[0] + "(" + mingGong[1] + ")";
	}else{
		return Translator.translate(mingGong[0], language);
	}
 };
 
 Translator.translateMingGong = function(mingGong, language){
	var parts = mingGong.split(" ");
	
	var result = "";
	for(var i = 0 ; i < parts.length; i ++){
		result += Translator.translate(parts[i], language) + " ";
	}
	
	return result;
 };
 
 /**
  * 翻译生日
  */
 Translator.translateBirthday = function(birthday, language){
 	
 	if(!birthday){
 		return "";
 	}
 	
	var parts = birthday.split("-");
	
	var hour = parts[3];
	hour = Translator.translate(hour, language);
	parts[3] = hour;
	
	var dateStr = "";
	
	for(var i = 0 ; i < parts.length; i ++){
		if(i != 0){
			dateStr += "-";
		}
	
		dateStr += parts[i];
	}
	
	return dateStr;
 };
 
 
 /**
  * 翻译八字
  */
 Translator.translateBaZi = function(baZi, language){
	var parts = baZi.split("-");
	var nianZhu = parts[0];
	var yueZhu = parts[1];
	var riZhu = parts[2];
	var shiZhu = parts[3];
	
	nianZhu = Translator.translateTianGanDiZhi(nianZhu, language);
	yueZhu = Translator.translateTianGanDiZhi(yueZhu, language);
	riZhu = Translator.translate(riZhu, language);
	shiZhu = Translator.translateTianGanDiZhi(shiZhu, language);
	
	return nianZhu + "-" + yueZhu + "-" + riZhu + "-" + shiZhu;
 };
 
 /** 
  * 翻译天干地支
  */
 Translator.translateTianGanDiZhi = function(ganZhi, language){
	var tiangan = ganZhi.split("$")[0];
	var dizhi = ganZhi.split("$")[1];
	
	tiangan = Translator.translate(tiangan, language);
	dizhi = Translator.translate(dizhi, language);
	
	return tiangan + dizhi;
 };
 
 /**
  * 翻译返回紫微斗数中的繁体字
  */
 Translator.translateZiWeiDouShu = function(srcText, language){
 	if(language == 1){
 		if(srcText.mingPanType.indexOf('时') > 0 || srcText.subType.indexOf('时') > 0 ){
			srcText.mingPanType = srcText.mingPanType.replace("时", BizEnum_Traditional.HOUR);
		}
		if(srcText.mingPanType.indexOf('盘') > 0){
			srcText.mingPanType = srcText.mingPanType.replace("盘", BizEnum_Traditional.MINGPAN);
		}
		if(srcText.subType.indexOf('运势') > 0){
			srcText.subType = srcText.subType.replace("运势", BizEnum_Traditional.YUNSHI);
		}
		if(srcText.energyLevel.indexOf('带') > 0){
			srcText.energyLevel = srcText.energyLevel.replace("带", BizEnum_Traditional.DAI);
		}  
		if(srcText.energyText.indexOf('负') > 0){
			srcText.energyText = srcText.energyText.replace("负", BizEnum_Traditional.POS);
		}  
 	}
	
	 return srcText;
 };