/**
 * Util.js
 * 紫微工具类,提供公共服务
 *
 * @date 2014-01-08
 * @version 0.1
 */
 
 namespace("com.taxen.framework.ziwei");
 
 var Util = function(){
 
 };
 
 Util.getHourByLunarStr = function(lunarStr){
	var index = Util.getIndexByDiZhi(lunarStr);
	
	return index * 2;
 };
 

 /**
  * 将小时数转化为地支计时法
  */
 Util.getLunarHour = function(hour){
	hour = hour || 0;

	if(hour < 0 || hour > 23){
		return false;
	}

	var index = -1;

	if(hour >= 23 || hour < 1){
		index = 0;
	}else if(hour < 3){
		index = 1;
	}else if(hour < 5){
		index = 2;
	}else if(hour < 7){
		index = 3;
	}else if(hour < 9){
		index = 4;
	}else if(hour < 11){
		index = 5;
	}else if(hour < 13){
		index = 6;
	}else if(hour < 15){
		index = 7;
	}else if(hour < 17){
		index = 8;
	}else if(hour < 19){
		index = 9;
	}else if(hour < 21){
		index = 10;
	}else if(hour < 23){
		index = 11;
	}

	if(index >= 0){
		return BizEnum.DIZHI[index];
	}

	return false;
 };

 /**
  * 根据地支获取阴阳对应关系
  */
 Util.getYinYangMapByDIZHI = function(dizhi){
	if(dizhi === "DZ_ZI" || dizhi === "DZ_YIN" || dizhi === "DZ_CHEN" || dizhi === "DZ_WU" || dizhi === "DZ_SHEN" || dizhi === "DZ_XU"){
		return BizEnum.YINYANG[1];
	}

	if(dizhi === "DZ_CHOU" || dizhi === "DZ_MAO" || dizhi === "DZ_SI" || dizhi === "DZ_WEI" || dizhi === "DZ_YOU" || dizhi === "DZ_HAI"){
		return BizEnum.YINYANG[0];
	}

	return false;
 };

 Util.getIndexByTianGan = function(tianGan){
	return Util.getIndexByItem("TIANGAN", tianGan);
 };

 Util.getTianGanByIndex = function(index){
	return Util.getItemByIndex("TIANGAN", index);
 };

 Util.getIndexByDiZhi = function(diZhi){
	return Util.getIndexByItem("DIZHI", diZhi);
 };

 Util.getDiZhiByIndex = function(index){
	return Util.getItemByIndex("DIZHI", index);
 };

  Util.getIndexByYinYang = function(yinYang){
	return Util.getIndexByItem("YINYANG", yinYang);
 };

  Util.getYinYangByIndex = function(index){
	return Util.getItemByIndex("YINYANG", index);
  };

  Util.getIndexByGender = function(gender){
	return Util.getIndexByItem("GENDER", gender);
  };

  Util.getGenderByIndex = function(index){
	return Util.getItemByIndex("GENDER", index);
  };

  Util.getIndexByZodiac = function(zodiac){
	return Util.getIndexByItem("ZODIAC", zodiac);
  };

  Util.getZodiacByIndex = function(index){
	return Util.getItemByIndex("ZODIAC", index);
  };

  Util.getZodiacByDiZhi = function(dizhi){
	var index = Util.getIndexByDiZhi(dizhi);

	return Util.getZodiacByIndex(index);
  };

  Util.getIndexByJiaZi = function(jiaZi){
	return Util.getIndexByItem("JIAZI", jiaZi);
  };

  Util.getJiaZiByIndex = function(index){
	return Util.getItemByIndex("JIAZI", index);
  };

  Util.getIndexByGongWei = function(gongWei){
	return Util.getIndexByItem("GONGWEI", gongWei);
  };

  Util.getGongWeiByIndex = function(index){
	return Util.getItemByIndex("GONGWEI", index);
  };

  Util.getIndexByChangSheng = function(changSheng){
	return Util.getIndexByItem("CHANGSHENG", changSheng);
  };

  Util.getChangShengByIndex = function(index){
	return Util.getItemByIndex("CHANGSHENG", index);
  };

  Util.getIndexByTaiSuiShaLu = function(taiSuiShaLu){
	return Util.getIndexByItem("TAISUISHALU", taiSuiShaLu);
  };

  Util.getTaiSuiShaLuByIndex = function(index){
	return Util.getItemByIndex("TAISUISHALU", index);
  };

  Util.getIndexByLiuNianSuiQian= function(liuNianSuiQian){
	return Util.getIndexByItem("LIUNIANSUIQIAN", liuNianSuiQian);
  };

  Util.getLiuNianSuiQianByIndex = function(index){
	return Util.getItemByIndex("LIUNIANSUIQIAN", index);
  };

  Util.getIndexByLiuNianJiangQian= function(liuNianJiangQian){
	return Util.getIndexByItem("LIUNIANJIANGQIAN", liuNianJiangQian);
  };

  Util.getLiuNianJiangQianByIndex = function(index){
	return Util.getItemByIndex("LIUNIANJIANGQIAN", index);
  };

  Util.getIndexByWeek= function(week){
	return Util.getIndexByItem("WEEK", week);
  };

  Util.getWeekByIndex = function(index){
	return Util.getItemByIndex("WEEK", index);
  };

  Util.getIndexByLunarMonth= function(lunarMonth){
	return Util.getIndexByItem("LUNARMONTH", lunarMonth);
  };

  Util.getLunarMonthByIndex = function(index){
	return Util.getItemByIndex("LUNARMONTH", index);
  };

  Util.getMingJuByIndex = function(index){
	return Util.getItemByIndex("MINGJU", index-2);
  };

  Util.getIndexByMingJu= function(mingJu){
	return Util.getIndexByItem("MINGJU", mingJu);
  };

  Util.getLunarDay = function(lunarDay){
	 if(lunarDay < 1 || lunarDay > 30){
		return false;
	 }

	 var lunarStr = "";
	 if(lunarDay < 10){
		lunarStr = BizEnum.LUNARDAY[9] + BizEnum.LUNARDAY[lunarDay - 1];
	 }else if(lunarDay == 10){
		lunarStr = BizEnum.LUNARDAY[9] + BizEnum.LUNARDAY[lunarDay];
	 }else if(lunarDay < 20){
		lunarStr = BizEnum.LUNARDAY[10] + BizEnum.LUNARDAY[(lunarDay % 10) - 1];
	 }else if(lunarDay == 20){
		lunarStr = BizEnum.LUNARDAY[1] + BizEnum.LUNARDAY[lunarDay];
	 }else if(lunarDay < 30){
		lunarStr = BizEnum.LUNARDAY[11] + BizEnum.LUNARDAY[(lunarDay % 20) - 1];
	 }else{
		lunarStr = BizEnum.LUNARDAY[2] + BizEnum.LUNARDAY[lunarDay];
	 }

	 return {
		"index" : lunarDay,
		"lunarDay" : lunarStr
	 };
  };

 Util.getIndexByItem = function(category, item){
	var obj = eval("BizEnum." + category);

	for(var i = 0; i < obj.length; i ++){
		if(item == obj[i]){
			return i;
		}
	}

	return false;
 };

 Util.getItemByIndex = function(category, index){
	var obj = eval("BizEnum." + category);

	if(index < 0 || index > obj.length){
		return false;
	}

	return obj[index];
 };

 Util.getMiaoWangByStarAndIndex = function(starName, index){
	for(var i in BizEnum.MIAOWANGCONFIG){
		if(starName === i){
			return BizEnum.MIAOWANGCONFIG[i][index];
		}
	}

	return false;
 };

 Util.convertJiaZi2GanZhi = function(jiazi){
	jiazi = jiazi.split("_")[1];

	jiazi = "TG_" + jiazi;

	for(var i = 4; i < jiazi.length; i ++){
		var testStr = jiazi.substring(0, i + 1);

		var index = Util.getIndexByTianGan(testStr);

		if(typeof(index) == 'number'){
			var dz = "DZ_" + jiazi.substr(i+1);

			var diZhiIndex = Util.getIndexByDiZhi(dz);

			if(typeof(diZhiIndex) == 'number'){
				return testStr + "$" + dz;
			}
		}
	}
 };

 Util.convertLunarDayStr2Integer = function(lunarDay){
	if(lunarDay == "初十"){
		return 10;
	}

	var shiWei = lunarDay.charAt(0);
	var geWei = lunarDay.charAt(1);

	var _geWei = 0;
	var _shiWei = 0;

	switch(shiWei){
		case "初" : {
			_shiWei = 0;
			break;
		}
		case "十" : {
			_shiWei = 1;
			break;
		}
		case "二" :
		case "廿" : {
			_shiWei = 2;
			break;
		}
		case "三" : {
			_shiWei = 3;
			break;
		}
		default : break;
	}

	switch(geWei){
		case "一" : {
			_geWei = 1;
			break;
		}
		case "二" : {
			_geWei = 2;
			break;
		}
		case "三" : {
			_geWei = 3;
			break;
		}
		case "四" : {
			_geWei = 4;
			break;
		}
		case "五" : {
			_geWei = 5;
			break;
		}
		case "六" : {
			_geWei = 6;
			break;
		}
		case "七" : {
			_geWei = 7;
			break;
		}
		case "八" : {
			_geWei = 8;
			break;
		}
		case "九" : {
			_geWei = 9 ;
			break;
		}
		case "十" : {
			_geWei = 0;
			break;
		}
		default : break;
	}

	return _shiWei * 10 + _geWei;
 };

 Util.convertLunarMonthStr2Integer = function(lunarMonth){
	var month = 0 ;

	switch(lunarMonth){
		case "正月" : {
			month = 1;
			break;
		}
		case "二月" : {
			month = 2;
			break;
		}
		case "三月" : {
			month = 3;
			break;
		}
		case "四月" : {
			month = 4;
			break;
		}
		case "五月" : {
			month = 5;
			break;
		}
		case "六月" : {
			month = 6;
			break;
		}
		case "七月" : {
			month = 7;
			break;
		}
		case "八月" : {
			month = 8;
			break;
		}
		case "九月" : {
			month = 9;
			break;
		}
		case "十月" : {
			month = 10;
			break;
		}
		case "冬月" : {
			month = 11;
			break;
		}
		case "腊月" : {
			month = 12;
			break;
		}
		default : break;
	}

	return month;
 };

 Util.parseLunarHour = function(lunarHour){
	if(!lunarHour){
		return false;
	}

	switch(lunarHour){
		case "子" : return "DZ_ZI";
		case "丑" : return "DZ_CHOU";
		case "寅" : return "DZ_YIN";
		case "卯" : return "DZ_MAO";
		case "辰" : return "DZ_CHEN";
		case "巳" : return "DZ_SI";
		case "午" : return "DZ_WU";
		case "未" : return "DZ_WEI";
		case "申" : return "DZ_SHEN";
		case "酉" : return "DZ_YOU";
		case "戌" : return "DZ_XU";
		case "亥" : return "DZ_HAI";
		default : return false;
	}
 };

 Util.getMonthIndexByFeastName = function(feastName){
	if(!feastName){
		return false;
	}

	var monthIndex = -1;

	switch(feastName){
		case "FEAST_LICHUN" :
		case "FEAST_YUSHUI" : {
			monthIndex = 1;
			break;
		}
		case "FEAST_JINGZHE" :
		case "FEAST_CHUNFEN" : {
			monthIndex = 2;
			break;
		}
		case "FEAST_QINGMING" :
		case "FEAST_GUYU" : {
			monthIndex = 3;
			break;
		}
		case "FEAST_LIXIA" :
		case "FEAST_XIAOMAN" : {
			monthIndex = 4;
			break;
		}
		case "FEAST_MANGZHONG" :
		case "FEAST_XIAZHI" : {
			monthIndex = 5;
			break;
		}
		case "FEAST_XIAOSHU" :
		case "FEAST_DASHU" : {
			monthIndex = 6;
			break;
		}
		case "FEAST_LIQIU" :
		case "FEAST_CHUSHU" : {
			monthIndex = 7;
			break;
		}
		case "FEAST_BAILU" :
		case "FEAST_QIUFEN" : {
			monthIndex = 8;
			break;
		}
		case "FEAST_HANLU" :
		case "FEAST_SHUANGJIANG" : {
			monthIndex = 9;
			break;
		}
		case "FEAST_LIDONG" :
		case "FEAST_XIAOXUE" : {
			monthIndex = 10;
			break;
		}
		case "FEAST_DAXUE" :
		case "FEAST_DONGZHI" : {
			monthIndex = 11;
			break;
		}
		case "FEAST_XIAOHAN" :
		case "FEAST_DAHAN" : {
			monthIndex = 12;
			break;
		}
		default : break;
	}

	return monthIndex;
 };

 Util.getDayArrayByLunarYearAndMonth = function(year, month, isRunYue){
	var calendar = new PerpetualCalendar();
	var yearData = calendar.getCalendar()[year - 1901];
	var monthInfo = yearData.monthInfo;
	var runYueIndex = yearData.runYueIndex;
	var monthIndex = 0;

	var monthIndex = (runYueIndex > 0 && (month > runYueIndex) || (month == runYueIndex && isRunYue)) ? month : month - 1;
	var dayNum = monthInfo[monthIndex];

	var result = new Array();

	for(var i = 1 ; i <= dayNum; i ++){
		result.push(Util.convertInteger2LunarDayStr(i));
	}

	return result;
 };

 Util.convertInteger2LunarMonth = function(monthIndex){
	if(monthIndex < 1 || monthIndex > 12){
		return false;
	}

	return BizEnum.LUNARMONTH[monthIndex - 1].name;
 };

 Util.convertInteger2LunarDayStr = function(dayIndex){
	if(dayIndex < 1 || dayIndex > 30){
		return false;
	}

	if(dayIndex < 11){
		if(dayIndex == 10){
			return BizEnum.LUNARDAY[9] + "$" + BizEnum.LUNARDAY[10];
		}

		return BizEnum.LUNARDAY[9] + "$" + BizEnum.LUNARDAY[dayIndex - 1];
	}else if(dayIndex < 21){
		if(dayIndex == 20){
			return BizEnum.LUNARDAY[1] + "$" + BizEnum.LUNARDAY[10];
		}

		return BizEnum.LUNARDAY[10] + "$" + BizEnum.LUNARDAY[dayIndex % 10 - 1];
	}else if(dayIndex < 31){
		if(dayIndex == 30){
			return BizEnum.LUNARDAY[2] + "$" + BizEnum.LUNARDAY[10];
		}

		return BizEnum.LUNARDAY[11] + "$" + BizEnum.LUNARDAY[dayIndex % 20 - 1];
	}
 };

 Util.getNextLunarDay = function(lunarYear, lunarMonth, lunarDay){
	lunarYear = parseInt(lunarYear);

	var isRunYue = lunarMonth.indexOf("闰") >= 0? true : false;

	lunarMonth = lunarMonth.replace("闰", "");

	lunarMonth = Util.convertLunarMonthStr2Integer(lunarMonth);

//	lunarDay = Util.convertLunarDayStr2Integer(lunarDay);

	lunarDay = parseInt(lunarDay);

	var gregorianDate = PerpetualCalendar.convertLunarDate2GregorianDate(lunarYear, lunarMonth, lunarDay, 2, isRunYue);

	gregorianDate = Util.getNextGregorianDay(gregorianDate.getFullYear(), gregorianDate.getMonth() + 1, gregorianDate.getDate());

	return PerpetualCalendar.convertGregorianDate2LunarDate(gregorianDate.getFullYear(), gregorianDate.getMonth() + 1, gregorianDate.getDate(), 2);
 };

 Util.getNextGregorianDay = function(year, month, day){
	if(!(year && month && day)){
		return false;
	}

	if(month == 2 && day == 28){
		var isLeapYear = PerpetualCalendar.isLeapYear(year);

		if(isLeapYear){
			return new Date(year, month - 1, 29);
		}else{
			month ++;
			day = 1;
		}

	}else if(day == 31 && (month == 1 || month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12)){
		month ++;
		day = 1;
	}else if(day == 30 && (month == 4 || month == 6 || month == 9 || month == 11)){
		month ++;
		day = 1;
	}else{
		return new Date(year, month - 1, day + 1);
	}

	if(month == 13){
		year ++;
		month = 1;
		day = 1;
	}

	return new Date(year, month - 1, day);
 };


Util.getPreGregorianDay= function(year, month, day){
	if(!(year && month && day)){
		return false;
	}

	if(month == 3 && day == 1){
		var isLeapYear = PerpetualCalendar.isLeapYear(year);

		if(isLeapYear){
			return new Date(year, month - 1, 29);
		}else{
			return new Date(year, month - 1, 28);
		}

	}else if(day == 1 && (month == 3 || month == 5 || month == 7 || month == 8 || month == 10 || month == 12)){
		month --;
		day = 30;
		return new Date(year, month , day);
	}else if(day == 1 && (month ==2 || month == 4 || month == 6 || month == 9 || month == 11)){
		month --;
		day = 31;
		return new Date(year, month , day);
	}else if(month ==1 && day == 1){
		year = year -1 ;
		month = 12;
		day = 31;
		return new Date(year, month , day);
	}
	return new Date(year, month , day -1 );
 };
 