function ZiWeiUtils()
{
	
}

ZiWeiUtils.getGongWeiByStar = function(mingpan, starName)
{
	var sections = mingpan.getItems();

	for (var i = 0; i < sections.length; i++)
	{
		var section = sections[i];
		var stars = section.getStars();

		for (var j = 0; j < stars.length; j++)
		{
			if (stars[j].getName() == starName)
			{
				return section;
			}
		}
	}

	return false;
}

ZiWeiUtils.getGongWeiBySiHua = function(mingpan, mingPanType, siHuas)
{
	var sections = mingpan.getItems();
	var result = [];
	var index = 0;

	for (var i = 0; i < sections.length; i++)
	{
		var section = sections[i];
		var stars = section.getStars();

		for (var j = 0; j < stars.length; j++)
		{
			var starSiHua = -1;

			switch (mingPanType)
			{
			case "XianTianMingPan":
				starSiHua = stars[j].getSiXiang();
				break;
			case "DaYunMingPan":
				starSiHua = stars[j].getSiHuaOfDaYun();
				break;
			case "LiuNianMingPan":
				starSiHua = stars[j].getSiHuaOfLiuNian();
				break;
			case "LiuYueMingPan":
				starSiHua = stars[j].getSiHuaOfLiuYue();
				break;
			case "LiuRiMingPan":
				starSiHua = stars[j].getSiHuaOfLiuRi();
				break;
			case "LiuShiMingPan":
				starSiHua = stars[j].getSiHuaOfLiuShi();
				break;
			}

			for (var j in siHuas)
			{
				if (starSiHua == siHuas[j])
				{
					result[index++] = section;
				}
			}
		}
	}

	return result;
}

ZiWeiUtils.hasStrongStar = function(stars)
{
	for (var i = 0; i < stars.length; i ++)
	{
		if (ZiWeiUtils.isStrongStar(stars[i].getName()))
		{
			return true;
		}
	}

	return false;
}

ZiWeiUtils.isEmptyGongWei = function(gong)
{
	var stars = gong.getStars();

	for (var i = 0; i < stars.length; i++)
	{
		if (ZiWeiUtils.isMainStar(stars[i].getName()))
		{
			return false;
		}
	}

	return true;
}
	
ZiWeiUtils.isMainStar = function(starName)
{
	return starName.indexOf("MAINSTAR_") >= 0;
}

/**
 * 计算流年能量
 */
ZiWeiUtils.getLiuNianEnergy = function(liuNianMingPan, gongWei)
{
	gongWei = gongWei || 'GONGWEI_MINGGONG';
	
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuNianMingPan, "LiuNianMingPan");
	
	if(level < 6)
	{
		return level;
	}
	
	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuNianMingPan, "LiuNianMingPan");
	
	for(var i = 0; i < sanFangSiZhengStars['zuo'].length; i ++)
	{
		var star = sanFangSiZhengStars['zuo'][i];
		
		if("SIHUA_JI" == star.getSiHuaOfLiuNian())
		{
			return 5;
		}
	}
	
	
	for(var i = 0; i < sanFangSiZhengStars['hui'].length; i ++)
	{
		var star = sanFangSiZhengStars['hui'][i];
		
		if("SIHUA_JI" == star.getSiHuaOfLiuNian())
		{
			return 6;
		}
	}
	
	return level;
}

/**
 * 获取主星
 */
ZiWeiUtils.getMainStars = function(mingPan)
{
	var sections = mingPan.getItems();
	var stars =sections[mingPan.getMingGongIndex()].getStars();
	var mingGongMainStarNameArray = new Array();
	
	for(var i = 0 ; i < stars.length; i ++)
	{
		if(stars[i].getName().indexOf("MAINSTAR_") == 0)
		{
			mingGongMainStarNameArray.push(stars[i].getName());
		}
	}
	
	if(mingGongMainStarNameArray.length == 0)
	{
		mingGongItem = sections[(mingPan.getMingGongIndex() - 6 + 12) % 12];
		stars = mingGongItem.getStars();
		
		for(var i = 0 ; i < stars.length; i ++)
		{
			if(stars[i].getName().indexOf("MAINSTAR_") == 0)
			{
				mingGongMainStarNameArray.push(stars[i].getName());
			}
		}
	}
	
	return mingGongMainStarNameArray;
}

/**
 * 根据虚岁计算大运
 */
ZiWeiUtils.calcDaYunByXuSui = function(mingJu, xuSui)
{
	return parseInt((xuSui - mingJu) / 10) + 1;
}

/**
 * 重新计算流年能量
 */ 
ZiWeiUtils.recalcLiuNianLevel = function(daYunLevel, liuNianLevel)
{	
	if(daYunLevel > 8)
	{
		return liuNianLevel;
	}
	
	if(daYunLevel > 6 && liuNianLevel > 8)
	{
		return liuNianLevel - 1;
	}
	
	if(daYunLevel > 4 && liuNianLevel > 8)
	{
		return liuNianLevel - 2;
	}
	
	if(daYunLevel < 5)
	{
		if(liuNianLevel > 10)
		{
			return 8;
		}
		
		if(liuNianLevel > 8)
		{
			return 7;
		}
		
		if(liuNianLevel > 6)
		{
			return liuNianLevel - 2;
		}
		
		if(liuNianLevel < 7)
		{
			liuNianLevel = liuNianLevel - 1;
			
			return liuNianLevel < 1 ? 1 : liuNianLevel;
		}
	}
	
	return liuNianLevel;
}

/**
 * 是否为空宫
 */
ZiWeiUtils.isEmptyGongWei = function(gongWei)
{
	var stars = gongWei.getStars();
	
	for(var i = 0; i < stars.length; i ++)
	{
		if(stars[i].getName().indexOf("MAINSTAR_") >= 0)
		{
			return false;
		}
	}
	
	return true;
}

/**
 * 计算命格
 */
ZiWeiUtils.calcMingGe = function(user)
{
	if(!user)
	{
		return false;
	}
	
	var xianTianMingPan = user.getXianTianMingPan();
	var mingGe = [];
	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	var sections = xianTianMingPan.getItems();
	var mingGong = sections[mingGongIndex];
	
	if(ZiWeiUtils._isZiFuChaoYuanGe(mingGong))
	{
		mingGe.push("紫府朝垣格");
	}
	
	if(ZiWeiUtils._isTianFuChaoYuanGe(mingGong))
	{
		mingGe.push("天府朝垣格");
	}
	
	if(ZiWeiUtils._isJunChenQingHuiGe(mingGong))
	{
		mingGe.push("君臣庆会格");
	}
	
	if(ZiWeiUtils._isFuXiangChaoYuanGe(mingGong, sections))
	{
		mingGe.push("府相朝垣格");
	}
	
	if(ZiWeiUtils._isJiYueTongLiangGe(mingGong))
	{
		mingGe.push("机月同梁格");
	}
	
	if(ZiWeiUtils._isJiLiangJiaHuiGe(mingGong))
	{
		mingGe.push("机梁加会格");
	}
	
	if(ZiWeiUtils._isWenLiangZhenJiGe(mingGong))
	{
		mingGe.push("文梁振纪格");
	}
	
	if(ZiWeiUtils._isJuRiTongGongGe(mingGong))
	{
		mingGe.push("巨日同宫格");
	}
	
	if(ZiWeiUtils._isJinCanGuangHuiGe(mingGong))
	{
		mingGe.push("金灿光辉格");
	}
	
	if(ZiWeiUtils._isRiZhaoLeiMenGe(mingGong))
	{
		mingGe.push("日照雷门格");
	}
	
	if(ZiWeiUtils._isMingZhuChuHaiGe(mingGong, sections))
	{
		mingGe.push("明珠出海格");
	}
	
	if(ZiWeiUtils._isYueLangTianMenGe(mingGong))
	{
		mingGe.push("月朗天门格");
	}
	
	if(ZiWeiUtils._isRiYueBingMingGe(mingGong))
	{
		mingGe.push("日月并明格");
	}
	
	if(ZiWeiUtils._isYueShengCangHaiGe(mingGong))
	{
		mingGe.push("月生沧海格");
	}
	
	if(ZiWeiUtils._isShouXingRuMiaoGe(mingGong))
	{
		mingGe.push("寿星入庙格");
	}
	
	if(ZiWeiUtils._isYingXingRuMiaoGe(mingGong))
	{
		mingGe.push("英星入庙格");
	}
	
	if(ZiWeiUtils._isShiZhongYinYuGe(mingGong))
	{
		mingGe.push("石中隐玉格");
	}
	
	if(ZiWeiUtils._isQiShaChaoDouGe(mingGong))
	{
		mingGe.push("七杀朝斗格");
	}
	
	if(ZiWeiUtils._isQiShaYangDouGe(mingGong))
	{
		mingGe.push("七杀仰斗格");
	}
	
	if(ZiWeiUtils._isJuJiTongLinGe(mingGong))
	{
		mingGe.push("巨机同临格");
	}
	
	if(ZiWeiUtils._isZuoGuiXiangGuiGe(xianTianMingPan))
	{
		mingGe.push("坐贵向贵格");
	}
		
	if(ZiWeiUtils._isSanQiJiaHuiGe(xianTianMingPan))
	{
		mingGe.push("三奇嘉会格");
	}
	
	if(ZiWeiUtils._isShuangLuJiaMingGe(xianTianMingPan))
	{
		mingGe.push("双禄夹命格");
	}
	
	if(ZiWeiUtils._isZuoYouTongGongGe(xianTianMingPan))
	{
		mingGe.push("左右同宫格");
	}
	
	if(ZiWeiUtils._isWenGuiWenHuaGe(mingGong))
	{
		mingGe.push("文桂文华格");
	}
	
	if(ZiWeiUtils._isTanWuTongXingGe(mingGong))
	{
		mingGe.push("贪武同行格");
	}
	
	if(ZiWeiUtils._isSanHeHuoTanGe(mingGong, xianTianMingPan))
	{
		mingGe.push("三合火贪格");
	}
	
	if(ZiWeiUtils._isTanLingChaoYuanGe(mingGong, xianTianMingPan))
	{
		mingGe.push("贪铃朝垣格");
	}
	
	if(ZiWeiUtils._isXiongSuChaoYuanGe(mingGong))
	{
		mingGe.push("雄宿朝垣格");
	}
	
	if(ZiWeiUtils._isLuWenGongMingGe(mingGong, xianTianMingPan))
	{
		mingGe.push("禄文拱命格");
	}
	
	if(ZiWeiUtils._isLuHeYuanYangGe(mingGong))
	{
		mingGe.push("禄合鸳鸯格");
	}
	
	if(ZiWeiUtils._isShuangLuChaoYuanGe(xianTianMingPan))
	{
		mingGe.push("双禄朝垣格");
	}
	
	if(ZiWeiUtils._isLuMaPeiYinGe(mingGong))
	{
		mingGe.push("禄马佩印格");
	}
	
	if(ZiWeiUtils._isLuMaJiaoChiGe(xianTianMingPan))
	{
		mingGe.push("禄马交驰格");
	}
	
	if(ZiWeiUtils._isErYaoTongLinGe(mingGong, sections))
	{
		mingGe.push("二曜同临格");
	}
	
	if(ZiWeiUtils._isDanChiGuiChiGe(mingGong))
	{
		mingGe.push("丹墀桂墀格");
	}
	
	if(ZiWeiUtils._isJiXiangLiMingGe(mingGong))
	{
		mingGe.push("极向离明格");
	}
	
	if(ZiWeiUtils._isJiangXingDeDiGe(mingGong))
	{
		mingGe.push("将星得地格");
	}
	
	if(ZiWeiUtils._isMingLuAnLuGe(user, xianTianMingPan))
	{
		mingGe.push("明禄暗禄格");
	}
	
	if(ZiWeiUtils._isKeQuanLuJiaGe(user, xianTianMingPan))
	{
		mingGe.push("科权禄夹格");
	}
	
	return mingGe;
};

ZiWeiUtils.getLiuYueEnergy = function(liuYueMingPan)
{
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel('GONGWEI_MINGGONG', liuYueMingPan, "LiuYueMingPan");
	
	if(level == 12)
	{
		var curUser = getCurrentUser();
		curUser = curUser.user;
		var liuNianMingPan = curUser.getLiuNianMingPan(liuYueMingPan.getYear());
		var liuNianLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");
		
		if(liuNianLevel < 9)
		{
			level = 11;
		}
	}
	
	return level;
}

ZiWeiUtils.getLiuRiEnergy = function(liuRiMingPan, gongWei)
{
	gongWei = gongWei || 'GONGWEI_MINGGONG';
	
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuRiMingPan, "LiuRiMingPan");
	
	if(level < 9 && level != 1)
	{
		return level;
	}

	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);

	var hasLiuRiHuaJi = false;
	var sanFangSiZhengHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++)
	{
		var starName = sanFangStars[i].getName();
		
		if("FIENDSTAR_DIJIEXING" == starName || "FIENDSTAR_DIKONGXING" == starName)
		{
			if(sanFangStars[i].getDescriptor() != "MIAOWANG_MIAO" && sanFangStars[i].getDescriptor() != "MIAOWANG_WANG")
			{
				sanFangSiZhengHasKongJie = true;
			}
		}
		
		if("SIHUA_JI" == sanFangStars[i].getSiHuaOfLiuRi())
		{
			hasLiuRiHuaJi = true;
		}
	}
	
	if(level > 8 && sanFangSiZhengHasKongJie)
	{
		level = 8;
	}
	
	if(level >= 9)
	{
		var sections = liuRiMingPan.getItems();
	
		for(var i = 0; i < sections.length; i ++)
		{
			if(sections[i].getDayGongWei() == gongWei)
			{
				var stars = sections[i].getStars();
				
				for(var j = 0; j < stars.length; j ++)
				{
					if(stars[j].getName() == "FIENDSTAR_DIJIEXING")
					{
						return 6;
					}
					
					if(stars[j].getName() == "FIENDSTAR_TUOLUOXING" || stars[j].getName() == "FIENDSTAR_QINGYANGXING" ||stars[j].getName() == "FIENDSTAR_HUOXING" ||stars[j].getName() == "FIENDSTAR_LINGXING")
					{
						if(stars[j].getDescriptor() == "MIAOWANG_XIAN")
						{
							return 6;
						}
					}
				}
				
				break;
			}
		}
		
		if(level != 6 && hasLiuRiHuaJi)
		{
			level = 6;
		}
	}

	var curUser = getCurrentUser();
	curUser = curUser.user;
	var liuYueMingPan = curUser.getLiuYueMingPan(liuRiMingPan.getYear(), liuRiMingPan.month, liuRiMingPan.monthIsRunYue);
	var liuYueLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel(gongWei, liuYueMingPan, "LiuYueMingPan");
	
	if(level == 12 || level == 1)
	{		
		if(level == 12 && liuYueLevel < 9)
		{
			level = 11;
		}
		
		if(level == 1 && liuYueLevel > 4)
		{
			level = 2;
		}
	}
	
	if(liuYueLevel < 4 && level > 8)
	{
		level = 8;
	}
	
	return level;
}

ZiWeiUtils.isStrongStar = function(starName)
{
	if(!starName)
	{
		return false;
	}
	
	if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_WUQUXING" || starName == "MAINSTAR_TIANFUXING" ||
	   starName == "MAINSTAR_TIANXIANGXING" || starName == "MAINSTAR_LIANZHENXING" || starName == "MAINSTAR_QISHAXING" ||
	   starName == "MAINSTAR_POJUNXING" || starName == "MAINSTAR_TANLANGXING")
    {
		return true;
	}
		
	return false;
}

/**
 * 计算八字
 */
ZiWeiUtils.calcBaZi = function()
{
	if(arguments.length < 1)
	{
		return false;
	}
	
	var user = arguments[0];
	user = ZiWeiUtils.parseUserInfoParam(user);
	var userInfo = user.getUserInfo();
	var nianZhu = userInfo.getBaZi().nianZhu; 
	var yueZhu = userInfo.getBaZi().yueZhu; 
	var riZhu = userInfo.getBaZi().riZhu;
	var shiZhu = userInfo.getBaZi().shiZhu;
	
	var baZi = Translator.translateBaZi(nianZhu + "-" + yueZhu + "-" + riZhu + "-" + shiZhu);
	
	return baZi;
}

/**
 * 解析用户信息参数
 */
ZiWeiUtils.parseUserInfoParam = function(user)
{
	try{
		eval('user = (' + user + ')');
	}catch(e){
		return false;
	}
	
	var sysFont = user.sysFont || 0;
	
	sysFont = parseInt(sysFont);
	
	var name = user.name || '用户';
	
	if(!user.gender || !(user.gender == "男" || user.gender == "女")){
		return false;
	}
	
	if(!user.birthday){
		return false;
	}
	
	var gender = user.gender;
	var birthday = user.birthday;
	
	birthday = birthday.split("-");
	
	var year, month, day, hour, isRunYue;
	
	year = parseInt(birthday[0]);
	
	eval("user.isLunarDate = " + user.isLunarDate);
	
	if(user.isLunarDate){
		month = birthday[1]; 
		day = birthday[2];
	
		if(month.indexOf("闰") >= 0){
			isRunYue = true;
			month = month.replace("闰", "");
		}
		
		month = Util.convertLunarMonthStr2Integer(month);
		day = Util.convertLunarDayStr2Integer(day);
	}else{
		month = parseInt(birthday[1]);
		day = parseInt(birthday[2]);
		
	}
	
	birthday[3] = birthday[3].replace("时", "");
	hour = Util.parseLunarHour(birthday[3]);
	
	hour = Util.getHourByLunarStr(hour);
	
	var user = User.newInstance(name, gender, year, month, day, hour, user.isLunarDate, isRunYue);
	
	return user;
}

/**
 * 宫位中包含某些星
 */
ZiWeiUtils.gongWeiContainsStars = function(gongWei, starNames)
{
	var stars = gongWei.getStars();
	
	for(var i = 0; i < starNames.length; i ++)
	{
		var has = false;
		
		for(var j = 0; j < stars.length; j ++)
		{
			if(starNames[i] == stars[j].getName())
			{
				has = true;
				break;
			}
		}
		
		if(!has)
		{
			return false;
		}
	}
	
	return true;
}

/**
 * 科权禄加工具方法
 *
 * @keQuanLuStatus 
 * {
 *      'lin'  :  {'MAINSTAR_POJUNXING' : 'SIHUA_QUAN', 'MAINSTAR_WUQUXING' : 'SIHUA_KE'}
 *      'ming' :  {'MAINSTAR_ZIWEIXING' : 'SIHUA_LU'}
 * }
 *
 */
ZiWeiUtils.util4KeQuanLuJia = function(sections, mingGongIndex, containStars, keQuanLuStatus)
{
	var mingGong = sections[mingGongIndex];
	var stars = mingGong.getStars();
	
	if(!stars.inArray(containStars))
	{
		return false;
	}
	
	var leftGong = sections[(mingGongIndex + 11) % 12];
	var leftStars = leftGong.getStars();
	var rightGong = sections[(mingGongIndex + 1) % 12];
	var rightStars = rightGong.getStars();
	
	var linGongStatus = keQuanLuStatus.lin;
	
	if(!linGongStatus)
	{
		return false;
	}
	
	var jiaXingStatusArr = [];
	
	for(var i in linGongStatus)
	{
		for(var m = 0; m < leftStars.length; m ++)
		{
			var star = leftStars[m];
			
			if(star.getName() == i)
			{
				if(star.getSiXiang() != linGongStatus.i)
				{
					return false;
				}
				
				jiaXingStatusArr.push({
					'name' : i,
					'siHua' : linGongStatus.i,
					'side' : 'left'
				});
			}
		}
		
		for(var n = 0; n < rightStars.length; n ++)
		{
			var star = rightStars[n];
			
			if(star.getName() == i)
			{
				if(star.getSiXiang() != linGongStatus.i)
				{
					return false;
				}
				
				jiaXingStatusArr.push({
					'name' : i,
					'siHua' : linGongStatus.i,
					'side' : 'right'
				});
			}
		}
	}
	
	if(jiaXingStatusArr[0].side == jiaXingStatusArr[1].side)
	{
		return false;
	}
	
	if(keQuanLuStatus.ming)
	{
		for(var i = 0; i < stars.length; i ++)
		{
			for(var arr in keQuanLuStatus.ming)
			
			if((stars[i].getName() == arr) && stars[i].getSiXiang() == keQuanLuStatus.ming[arr])
			{
				return true;
			}
		}
		
		return false;
	}
	
	return true;
}

/**
 * 宫位中包含某颗星
 */
ZiWeiUtils.gongWeiContainsStar = function(gongWei, starName)
{
	var stars = gongWei.getStars();
	
	for(var i = 0; i < stars.length; i ++)
	{
		if(stars[i].getName() == starName)
		{
			return true;
		}
	}
	
	return false;
}

// 科权禄夹格
ZiWeiUtils._isKeQuanLuJiaGe = function(user, xianTianMingPan)
{
	var baZi = user.getUserInfo().getBaZi();
	var nianZhu = baZi.nianZhu;
	var nianZhuGan = nianZhu.split("$")[0];
	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	var sections = xianTianMingPan.getItems();
	var mingGong = sections[mingGongIndex];
	var dz = mingGong.getDiZhi();
	
	switch(nianZhuGan)
	{
		case "TG_JIA" : 
		{
			if(dz == "DZ_SI" || dz == "DZ_HAI")
			{
				return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, "MAINSTAR_TIANTONGXING", {
					lin : {
						'MAINSTAR_POJUNXING' : 'SIHUA_QUAN',
						'MAINSTAR_WUQUXING' : 'SIHUA_KE'
					}
				});
			}
			
			return false;
		}
		case "TG_YI" : 
		{
			if(dz == "DZ_XU" || dz == "DZ_CHEN")
			{
				return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, ["MAINSTAR_ZIWEIXING", "MAINSTAR_TIANXIANGXING"], {
					lin : {
						'MAINSTAR_TIANJIXING' : 'SIHUA_LU',
						'MAINSTAR_TIANLIANGXING' : 'SIHUA_QUAN'
					},
					ming : {
						'MAINSTAR_ZIWEIXING' : 'SIHUA_KE'
					}
				});
			}
			
			return false;
		}
		case "TG_DING" : 
		{
			if(dz == "DZ_ZI" || dz == "DZ_WU")
			{
				return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, ["MAINSTAR_WUQUXING", "MAINSTAR_TIANFUXING"], {
					lin : {
						'MAINSTAR_TAIYINXING' : 'SIHUA_LU',
						'MAINSTAR_TIANTONGXING' : 'SIHUA_QUAN'
					}
				});
			}
			
			return false;
		}
		case "TG_JI" : 
		{
			if(dz == "DZ_CHOU" || dz == "DZ_WEI")
			{
				return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, ["MAINSTAR_TAIYANGXING", "MAINSTAR_TAIYINXING"], {
					lin : {
						'MAINSTAR_WUQUXING' : 'SIHUA_LU',
						'MAINSTAR_TANLANGXING' : 'SIHUA_QUAN'
					}
				});
			}
			
			return false;
		}
		case "TG_GENG" : 
		{
			return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, "MAINSTAR_WUQUXING", {
				lin : {
					'MAINSTAR_TAIYANGXING' : 'SIHUA_LU',
					'MAINSTAR_TIANTONGXING' : 'SIHUA_KE'
				},
				ming : {
					'MAINSTAR_WUQUXING' : 'SHUA_QUAN'
				}
			});
		}
		case "TG_GUI" : 
		{
			return ZiWeiUtils.util4KeQuanLuJia(sections, mingGongIndex, "MAINSTAR_TANLANGXING", {
				lin : {
					'MAINSTAR_JUMENXING' : 'SIHUA_QUAN',
					'MAINSTAR_TAIYINXING' : 'SIHUA_KE'
				},
				ming : {
					'MAINSTAR_TANLANGXING' : 'SHUA_JI'
				}
			});
		}
		default : return false;
	}
}

// 明禄暗禄格
ZiWeiUtils._isMingLuAnLuGe = function(user, xianTianMingPan)
{
	var baZi = user.getUserInfo().getBaZi();
	var nianZhu = baZi.nianZhu;
	var nianZhuGan = nianZhu.split("$")[0];
	var mingGongIndex = xianTianMingPan.getMingGongIndex();
	var sections = xianTianMingPan.getItems();
	var mingGong = sections[mingGongIndex];
	var dz = mingGong.getDiZhi();
	
	switch(nianZhuGan)
	{
		case "TG_JIA" : 
		{
			if(dz == "DZ_YIN" || dz == "DZ_HAI")
			{
				var haiGong = sections[11];
				
				if(!ZiWeiUtils.gongWeiContainsStars(haiGong, ["MAINSTAR_LIANZHENXING", "MAINSTAR_TANLANGXING"]))
				{
					return false;
				}
				
				var yinGong = sections[2];
				
				if(!ZiWeiUtils.gongWeiContainsStar(yinGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = haiGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_LIANZHENXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_YI" : 
		{
			if(dz == "DZ_XU" || dz == "DZ_MAO")
			{
				var xuGong = sections[10];
				
				if(!ZiWeiUtils.gongWeiContainsStars(xuGong, ["MAINSTAR_TIANJIXING", "MAINSTAR_TIANLIANGXING"]))
				{
					return false;
				}
				
				var maoGong = sections[3];
				
				if(!ZiWeiUtils.gongWeiContainsStar(maoGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = xuGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TIANJIXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_BING" : 
		{
			if(dz == "DZ_SHEN" || dz == "DZ_SI")
			{
				var shenGong = sections[8];
				
				if(!ZiWeiUtils.gongWeiContainsStars(shenGong, ["MAINSTAR_TIANTONGXING", "MAINSTAR_TIANLIANGXING"]))
				{
					return false;
				}
				
				var siGong = sections[5];
				
				if(!ZiWeiUtils.gongWeiContainsStar(siGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = shenGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TIANTONGXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_DING" : 
		{
			if(dz == "DZ_WEI" || dz == "DZ_WU")
			{
				var weiGong = sections[7];
				
				if(!ZiWeiUtils.gongWeiContainsStars(weiGong, ["MAINSTAR_TAIYANGXING", "MAINSTAR_TAIYINXING"]))
				{
					return false;
				}
				
				var wuGong = sections[6];
				
				if(!ZiWeiUtils.gongWeiContainsStar(wuGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = weiGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TAIYINXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_WU" : 
		{
			if(dz == "DZ_SHEN" || dz == "DZ_SI")
			{
				var shenGong = sections[8];
				
				if(!ZiWeiUtils.gongWeiContainsStar(shenGong, "MAINSTAR_TANLANGXING"))
				{
					return false;
				}
				
				var siGong = sections[5];
				
				if(!ZiWeiUtils.gongWeiContainsStar(siGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = shenGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TANLANGXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_JI" : 
		{
			if(dz == "DZ_WU" || dz == "DZ_WEI")
			{
				var weiGong = sections[7];
				
				if(!ZiWeiUtils.gongWeiContainsStars(weiGong, ["MAINSTAR_WUQUXING", "MAINSTAR_TANLANGXING"]))
				{
					return false;
				}
				
				var wuGong = sections[6];
				
				if(!ZiWeiUtils.gongWeiContainsStar(wuGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = weiGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_WUQUXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_GENG" : 
		{
			if(dz == "DZ_SHEN" || dz == "DZ_SI")
			{
				var siGong = sections[5];

				if(!ZiWeiUtils.gongWeiContainsStar(siGong, "MAINSTAR_TAIYANGXING"))
				{
					return false;
				}
				
				var shenGong = sections[8];
				
				if(!ZiWeiUtils.gongWeiContainsStar(shenGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = siGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TAIYANGXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_XIN" : 
		{
			if(dz == "DZ_YOU" || dz == "DZ_CHEN")
			{
				var chenGong = sections[4];
				
				if(!ZiWeiUtils.gongWeiContainsStar(chenGong, "MAINSTAR_JUMENXING"))
				{
					return false;
				}
				
				var youGong = sections[9];
				
				if(!ZiWeiUtils.gongWeiContainsStar(siGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = chenGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_JUMENXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_REN" : 
		{
			if(dz == "DZ_YIN" || dz == "DZ_HAI")
			{
				var yinGong = sections[2];
				
				if(!ZiWeiUtils.gongWeiContainsStars(yinGong, ["MAINSTAR_TIANTONGXING", "MAINSTAR_TIANLIANGXING"]))
				{
					return false;
				}
				
				var haiGong = sections[11];
				
				if(!ZiWeiUtils.gongWeiContainsStar(haiGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = yinGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_TIANLIANGXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		case "TG_GUI" : 
		{
			if(dz == "DZ_ZI" || dz == "DZ_CHOU")
			{
				var chouGong = sections[1];
				
				if(!ZiWeiUtils.gongWeiContainsStars(chouGong, ["MAINSTAR_ZIWEIXING", "MAINSTAR_POJUNXING"]))
				{
					return false;
				}
				
				var ziGong = sections[0];
				
				if(!ZiWeiUtils.gongWeiContainsStar(ziGong, "GEMSTAR_LUCUNXING"))
				{
					return false;
				}
				
				var stars = shenGong.getStars();
				
				for(var i = 0; i < stars.length; i ++)
				{
					if(stars[i].getName() == "MAINSTAR_POJUNXING")
					{
						if(stars[i].getSiXiang() == "SIHUA_LU")
						{
							return true;
						}
					
						return false;
					}
				}
			}
			
			return false;
		}
		default : return false;
	}
};

// 是否为将星得地格
ZiWeiUtils._isJiangXingDeDiGe = function(mingGong)
{
	var stars = mingGong.getStars();
	var mainStarCount = 0;
	var hasWuQuMiaoWang = false;
	
	for(var i = 0; i < stars.length; i ++)
	{
		if(stars[i].getName().indexOf("MAINSTAR_") >= 0)
		{
			mainStarCount ++;
		}
		
		if(stars[i].getName() == "MAINSTAR_WUQUXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasWuQuMiaoWang = true;
			}
			else
			{
				break;
			}
		}
	}
	
	if(mainStarCount == 1 && hasWuQuMiaoWang)
	{
		return true;
	}
	
	return false;
};

// 是否为极向离明格
ZiWeiUtils._isJiXiangLiMingGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_ZIWEIXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为丹墀桂墀格
ZiWeiUtils._isDanChiGuiChiGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHEN" || dz == "DZ_SI")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TAIYANGXING"))
		{
			return true;
		}
	}

	if(dz == "DZ_YOU" || dz == "DZ_XU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TAIYINXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为二曜同临格
ZiWeiUtils._isErYaoTongLinGe = function(mingGong, sections)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHOU")
	{
		var weiGong = sections[7];
		
		if(ZiWeiUtils.gongWeiContainsStars(weiGong, ["MAINSTAR_TAIYANGXING", "MAINSTAR_TAIYINXING"]))
		{
			return true;
		}
	}

	if(dz == "DZ_WEI")
	{
		var chouGong = sections[1];
		
		if(ZiWeiUtils.gongWeiContainsStars(chouGong, ["MAINSTAR_TAIYANGXING", "MAINSTAR_TAIYINXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为禄马交驰格
ZiWeiUtils._isLuMaJiaoChiGe = function(mingPan)
{
	var sanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_MINGGONG", mingPan, "XianTianMingPan", true);
	var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);

	var hasLuCun = false, hasHuaLu = false, hasTianMa = false;
	
	for(var i = 0; i < sanFangStars.length; i ++)
	{
		if(sanFangStars[i].getName() == "GEMSTAR_LUCUNXING")
		{
			hasLuCun = true;
		}
		
		if(sanFangStars[i].getSiXiang() == "SIHUA_LU")
		{
			hasHuaLu = true;
		}
		
		if(sanFangStars[i].getName() == "GEMSTAR_TIANMAXING")
		{
			hasTianMa = true;
		}
	}
	
	if((hasLuCun || hasHuaLu) && hasTianMa)
	{
		return true;
	}
	
	return false;
};

// 是否为禄马佩印格
ZiWeiUtils._isLuMaPeiYinGe = function(mingGong)
{
	var hasTianXiangMiaoWang = false,
	    hasTianMaMiaoWang = false,
		hasLuCunMiaoWangOrHuaLu = false;
	var stars = mingGong.getStars();

	for(var i = 0; i < stars.length; i ++)
	{
		if(stars[i].getName() == "MAINSTAR_TIANXIANGXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasTianXiangMiaoWang = true;
			}
			else
			{
				break;
			}
		}
		
		if(stars[i].getName() == "GEMSTAR_TIANMAXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasTianMaMiaoWang = true;
			}
			else
			{
				break;
			}
		}
		
		if(stars[i].getName() == "GEMSTAR_LUCUNXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasLuCunMiaoWangOrHuaLu = true;
			}
			else
			{
				break;
			}
		}
		
		if(stars[i].getSiXiang() == "SIHUA_LU")
		{
			hasLuCunMiaoWangOrHuaLu = true;
		}
	}
	
	if(hasTianXiangMiaoWang && hasTianMaMiaoWang && hasLuCunMiaoWangOrHuaLu)
	{
		return true;
	}
	
	return false;
};

// 是否为双禄朝垣格
ZiWeiUtils._isShuangLuChaoYuanGe = function(mingPan)
{
	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
	var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);

	var hasLuCun = false, hasHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++)
	{
		if(sanFangStars[i].getName() == "GEMSTAR_LUCUNXING")
		{
			hasLuCun = true;
		}
		
		if(sanFangStars[i].getSiXiang() == "SIHUA_LU")
		{
			hasHuaLu = true;
		}
	}
	
	if(hasLuCun && hasHuaLu)
	{
		return true;
	}
	
	return false;
};

// 是否为禄合鸳鸯格
ZiWeiUtils._isLuHeYuanYangGe = function(mingGong)
{
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "GEMSTAR_LUCUNXING"))
	{
		var stars = mingGong.getStars();

		for(var i = 0; i < stars.length; i ++)
		{
			if(stars[i].getSiXiang() == "SIHUA_LU")
			{
				return true;
			}
		}
	}
	
	return false;
};

// 是否为禄文拱命格
ZiWeiUtils._isLuWenGongMingGe = function(mingGong, mingPan)
{
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "GEMSTAR_LUCUNXING"))
	{
		var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
		var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);

		var hasWenChang = false, hasWenQu = false;
		
		for(var i = 0; i < sanFangStars.length; i ++)
		{
			if(sanFangStars[i].getName() == "GEMSTAR_WENCHANGXING")
			{
				hasWenChang = true;
			}
			
			if(sanFangStars[i].getName() == "GEMSTAR_WENQUXING")
			{
				hasWenQu = true;
			}
		}
		
		if(hasWenChang && hasWenQu)
		{
			return true;
		}
	}
	
	return false;
};

// 是否为雄宿朝垣格
ZiWeiUtils._isXiongSuChaoYuanGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WEI" || dz == "DZ_SHEN")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_LIANZHENXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为贪铃朝垣格
ZiWeiUtils._isTanLingChaoYuanGe = function(mingGong, mingPan)
{
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TANLANGXING"))
	{
		var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
		var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui']);

		for(var i = 0; i < sanFangStars.length; i ++)
		{
			if(sanFangStars[i].getName() == "FIENDSTAR_LINGXING")
			{
				return true;
			}
		}
	}
	
	return false;
};

// 是否为三合火贪格
ZiWeiUtils._isSanHeHuoTanGe = function(mingGong, mingPan)
{
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TANLANGXING"))
	{
		var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
		var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui']);

		for(var i = 0; i < sanFangStars.length; i ++)
		{
			if(sanFangStars[i].getName() == "FIENDSTAR_HUOXING")
			{
				return true;
			}
		}
	}
	
	return false;
};

// 是否为贪武同行格
ZiWeiUtils._isTanWuTongXingGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHOU" || dz == "DZ_WEI" || dz == "DZ_CHEN" || dz == "DZ_XU")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TANLANGXING", "MAINSTAR_WUQUXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为文桂文华格
ZiWeiUtils._isWenGuiWenHuaGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHOU" || dz == "DZ_WEI")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["GEMSTAR_WENCHANGXING", "GEMSTAR_WENQUXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为左右同宫格
ZiWeiUtils._isZuoYouTongGongGe = function(mingPan)
{
	var mingGongIndex = mingPan.getMingGongIndex();
	var sections = mingPan.getItems();
	var mingGong = sections[mingGongIndex];
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHOU" || dz == "DZ_WEI")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["GEMSTAR_ZUOFUXING", "GEMSTAR_YOUBIXING"]))
		{
			var stars = mingGong.getStars();
			
			for(var i = 0; i < stars.length; i ++)
			{
				if(stars[i].getName().indexOf("GEMSTAR_") >= 0 && stars[i].getName() != "GEMSTAR_ZUOFUXING" && stars[i].getName() != "GEMSTAR_YOUBIXING")
				{
					var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
					var huiStars = sanFangSiZhengStars['hui'];
	
					for(var j = 0; j < huiStars.length; j ++)
					{
						if(huiStars[j].getName().indexOf("GEMSTAR_") >= 0)
						{
							return true;
						}
					}
				}
			}
		}
	}
	
	return false;
};

// 是否为双禄夹命格
ZiWeiUtils._isShuangLuJiaMingGe = function(mingPan)
{
	var mingGongIndex = mingPan.getMingGongIndex();
	var prevGongIndex = (mingGongIndex + 11) % 12;
	var nextGongIndex = (mingGongIndex + 1) % 12;
	
	var sections = mingPan.getItems();
	var prevGong = sections[prevGongIndex];
	var nextGong = sections[nextGongIndex];
	
	if(ZiWeiUtils.gongWeiContainsStar(prevGong, "GEMSTAR_LUCUNXING"))
	{
		var stars = nextGong.getStars();
		
		for(var i = 0; i < stars.length; i ++)
		{
			if(stars[i].getSiXiang() == "SIHUA_LU")
			{
				return true;
			}
		}
	}
	
	if(ZiWeiUtils.gongWeiContainsStar(nextGong, "GEMSTAR_LUCUNXING"))
	{
		var stars = prevGong.getStars();
		
		for(var i = 0; i < stars.length; i ++)
		{
			if(stars[i].getSiXiang() == "SIHUA_LU")
			{
				return true;
			}
		}
	}
	
	return false;
}

// 是否为三奇嘉会格
ZiWeiUtils._isSanQiJiaHuiGe = function(mingPan)
{
	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", mingPan, "XianTianMingPan");
	var totalStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);
	
	var hasHuaLu = false, hasHuaQuan = false, hasHuaKe = false;
	
	for(var i = 0; i < totalStars.length; i ++)
	{
		var siXiang = totalStars[i].getSiXiang();
		
		if(siXiang == "SIHUA_LU")
		{
			hasHuaLu = true;
		}
	
		if(siXiang == "SIHUA_QUAN")
		{
			hasHuaQuan = true;
		}
		
		if(siXiang == "SIHUA_KE")
		{
			hasHuaKe = true;
		}
	}
	
	if(hasHuaLu && hasHuaQuan && hasHuaKe)
	{
		return true;
	}
	
	return false;
}

// 是否为坐贵向贵格
ZiWeiUtils._isZuoGuiXiangGuiGe = function(mingPan)
{
	var mingGongIndex = mingPan.getMingGongIndex();
	var shenGongIndex = mingPan._shenGongIndex;
	var qiYiGongIndex = (mingGongIndex + 6) % 12;
	
	var sections = mingPan.getItems();
	var mingGong = sections[mingGongIndex];
	var shenGong = sections[shenGongIndex];
	var qiYiGong = sections[qiYiGongIndex];
	
	var mingContainsTianKui = false, mingContainsTianYue = false;
	
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "GEMSTAR_TIANKUIXING"))
	{
		mingContainsTianKui = true;
	}
	
	if(ZiWeiUtils.gongWeiContainsStar(mingGong, "GEMSTAR_TIANYUEXING"))
	{
		mingContainsTianYue = true;
	}
	
	if(mingContainsTianKui)
	{
		if(ZiWeiUtils.gongWeiContainsStar(shenGong, "GEMSTAR_TIANYUEXING") || ZiWeiUtils.gongWeiContainsStar(qiYiGong, "GEMSTAR_TIANYUEXING"))
		{
			return true;
		}
	}
	
	if(mingContainsTianYue)
	{
		if(ZiWeiUtils.gongWeiContainsStar(shenGong, "GEMSTAR_TIANKUIXING") || ZiWeiUtils.gongWeiContainsStar(qiYiGong, "GEMSTAR_TIANKUIXING"))
		{
			return true;
		}
	}
	
	return false;
}

// 是否为巨机同临格
ZiWeiUtils._isJuJiTongLinGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_MAO")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_JUMENXING", "MAINSTAR_TIANJIXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为七杀仰斗格
ZiWeiUtils._isQiShaYangDouGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_ZI" || dz == "DZ_WU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_QISHAXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为七杀朝斗格
ZiWeiUtils._isQiShaChaoDouGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_YIN" || dz == "DZ_SHEN")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_QISHAXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为石中隐玉格
ZiWeiUtils._isShiZhongYinYuGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WU" || dz == "DZ_ZI")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_JUMENXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为英星入庙格
ZiWeiUtils._isYingXingRuMiaoGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WU" || dz == "DZ_ZI")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_POJUNXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为寿星入庙格
ZiWeiUtils._isShouXingRuMiaoGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TIANLIANGXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为月生沧海格
ZiWeiUtils._isYueShengCangHaiGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_ZI")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TAIYINXING", "MAINSTAR_TIANTONGXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为日月并明格
ZiWeiUtils._isRiYueBingMingGe = function(mingGong, sections)
{
	
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHOU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TIANLIANGXING") && ZiWeiUtils.gongWeiContainsStar(sections[5], "MAINSTAR_TAIYANGXING") && ZiWeiUtils.gongWeiContainsStar(sections[9], "MAINSTAR_TAIYINXING"))
		{
			return true;
		}
	}
	
	if(dz == "DZ_WU")
	{
		var mingStars = mingGong.getStars();
		var hasMainStar = false;

		for(var i = 0; i < mingStars.length; i ++)
		{
			if(mingStars[i].getName().indexOf("MAINSTAR_") >= 0)
			{
				hasMainStar = true;
				break;
			}
		}
		
		if(!hasMainStar)
		{
			if(ZiWeiUtils.gongWeiContainsStars(sections[2], ["MAINSTAR_TAIYANGXING", "MAINSTAR_JUMENXING"]) && ZiWeiUtils.gongWeiContainsStars(sections[0], ["MAINSTAR_TAIYINXING", "MAINSTAR_TIANTONGXING"]))
			{
				return true;
			}
		}
	}
	
	return false;
}

// 是否为月朗天门格
ZiWeiUtils._isYueLangTianMenGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_HAI")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TAIYINXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为明珠出海格
ZiWeiUtils._isMingZhuChuHaiGe = function(mingGong, sections)
{
	var dz = mingGong.getDiZhi();
		
	if(dz == "DZ_WEI")
	{
		var mingStars = mingGong.getStars();
		var hasMainStar = false;

		for(var i = 0; i < mingStars.length; i ++)
		{
			if(mingStars[i].getName().indexOf("MAINSTAR_") >= 0)
			{
				hasMainStar = true;
				break;
			}
		}
		
		if(!hasMainStar)
		{
			var maoGong = sections[3];
			var maoStars = maoGong.getStars();
			var taiYangMiaoWang = false, tianLiangMiaoWang = false;
			
			for(var i = 0; i < maoStars.length; i ++)
			{
				if(maoStars[i].getName() == "MAINSTAR_TAIYANGXING")
				{
					if(maoStars[i].getDescriptor() == "MIAOWANG_MIAO" || maoStars[i].getDescriptor() == "MIAOWANG_WANG")
					{
						taiYangMiaoWang = true;
					}
				}
				
				if(maoStars[i].getName() == "MAINSTAR_TIANLIANGXING")
				{
					if(maoStars[i].getDescriptor() == "MIAOWANG_MIAO" || maoStars[i].getDescriptor() == "MIAOWANG_WANG")
					{
						tianLiangMiaoWang = true;
					}
				}
			}
			
			if(taiYangMiaoWang && tianLiangMiaoWang)
			{
				var haiGong = sections[11];
				var haiStars = haiGong.getStars();
				var taiYinMiaoWang = false;
				
				for(var i = 0; i < haiStars.length; i ++)
				{
					if(haiStars[i].getName() == "MAINSTAR_TAIYINXING")
					{
						if(haiStars[i].getDescriptor() == "MIAOWANG_MIAO" || haiStars[i].getDescriptor() == "MIAOWANG_WANG")
						{
							return true;
						}
					}
				}
			}
		}
	}
	
	return false;
};

// 是否为日照雷门格
ZiWeiUtils._isRiZhaoLeiMenGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_MAO")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TAIYANGXING", "MAINSTAR_TIANLIANGXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为金灿光辉格
ZiWeiUtils._isJinCanGuangHuiGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_WU")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TAIYANGXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为巨日同宫格
ZiWeiUtils._isJuRiTongGongGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_YIN")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_JUMENXING", "MAINSTAR_TAIYANGXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为文梁振纪格
ZiWeiUtils._isWenLiangZhenJiGe = function(mingGong)
{
	var stars = mingGong.getStars();
	var hasChangQuWang = false;
	var hasTianLiangWang = false;
	
	for(var i = 0; i < stars.length; i ++) 
	{
		if(stars[i].getName() == "GEMSTAR_WENCHANGXING" || stars[i].getName() == "GEMSTAR_WENQUXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasChangQuWang = true;
			}
		}
		
		if(stars[i].getName() == "MAINSTAR_TIANLIANGXING")
		{
			if(stars[i].getDescriptor() == "MIAOWANG_MIAO" || stars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasTianLiangWang = true;
			}
		}
	}
	
	if(hasChangQuWang && hasTianLiangWang)
	{
		return true;
	}
	
	return false;
};

// 是否为机梁加会格
ZiWeiUtils._isJiLiangJiaHuiGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_CHEN" || dz == "DZ_XU")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TIANJIXING", "MAINSTAR_TIANLIANGXING"]))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为机月同梁格
ZiWeiUtils._isJiYueTongLiangGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_YIN" || dz == "DZ_SHEN")
	{
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TIANTONGXING", "MAINSTAR_TIANLIANGXING"]))
		{
			return true;
		}
		
		if(ZiWeiUtils.gongWeiContainsStars(mingGong, ["MAINSTAR_TIANJIXING", "MAINSTAR_TAIYINXING"]))
		{
			return true;
		}
	}
	
	if(dz == "DZ_ZI" || dz == "DZ_WEI")
	{
		if(ZiWeiUtils.gongWeiContainsStar(mingGong, "MAINSTAR_TIANJIXING"))
		{
			return true;
		}
	}
	
	return false;
};

// 是否为府相朝垣格
ZiWeiUtils._isFuXiangChaoYuanGe = function(mingGong, sections)
{
	var dz = mingGong.getDiZhi();
	var mingStars = mingGong.getStars();
	var hasTianFu = false;
	var hasMainStar = false;

	for(var i = 0; i < mingStars.length; i ++)
	{
		if(mingStars[i].getName().indexOf("MAINSTAR_") >= 0)
		{
			hasMainStar = true;
		}
		
		if(mingStars[i].getName() == "MAINSTAR_TIANFUXING")
		{
			hasTianFu = true;
		}
	}
		
	if(dz == "DZ_CHOU")
	{
		if(!hasMainStar)
		{
			var siGong = sections[5];
			var siStars = siGong.getStars();
			
			for(var i = 0; i < siStars.length; i ++)
			{
				if(siStars[i].getName() == "MAINSTAR_TIANFUXING")
				{
					var youGong = sections[9];
					var youStars = youGong.getStars();
					
					for(var j = 0; j < youStars.length; j ++)
					{
						if(youStars[j].getName() == "MAINSTAR_TIANXIANGXING")
						{
							return true;
						}
					}
				}
			}		
		}
	}
	
	if(hasTianFu)
	{
		if(dz == "DZ_CHOU")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[5], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
		
		if(dz == "DZ_WEI")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[11], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
		
		if(dz == "DZ_MAO")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[7], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
		
		if(dz == "DZ_YOU")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[1], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
		
		if(dz == "DZ_SI")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[9], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
		
		if(dz == "DZ_HAI")
		{
			if(ZiWeiUtils.gongWeiContainsStar(sections[3], "MAINSTAR_TIANXIANGXING"))
			{
				return true;
			}
		}
	}
	
	return false;
}

// 是否为君臣庆会格
ZiWeiUtils._isJunChenQingHuiGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_XU")
	{
		var hasZiWei = false, hasTianXiang = false;
		var stars = mingGong.getStars();
		
		for(var i = 0; i < stars.length; i ++)
		{
			var starName = stars[i].getName();
			
			if(starName == "MAINSTAR_ZIWEIXING")
			{
				hasZiWei = true;
			}
			
			if(starName == "MAINSTAR_TIANXIANGXING")
			{
				hasTianXiang = true;
			}
		}
		
		if(hasZiWei && hasTianXiang)
		{
			return true;
		}
	}
	
	return false;
}

// 是否为天府朝垣格
ZiWeiUtils._isTianFuChaoYuanGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	
	if(dz == "DZ_XU")
	{
		var hasTianFu = false, hasLianZhen = false;
		var stars = mingGong.getStars();
		
		for(var i = 0; i < stars.length; i ++)
		{
			var starName = stars[i].getName();
			
			if(starName == "MAINSTAR_TIANFUXING")
			{
				hasTianFu = true;
			}
			
			if(starName == "MAINSTAR_LIANZHENXING")
			{
				hasLianZhen = true;
			}
		}
		
		if(hasTianFu && hasLianZhen)
		{
			return true;
		}
	}
	
	return false;
}

// 是否为紫府朝垣格
ZiWeiUtils._isZiFuChaoYuanGe = function(mingGong)
{
	var dz = mingGong.getDiZhi();
	var inYinShen = false, inZiWu = false, inChouWei = false;
	
	switch(dz)
	{
		// 寅申坐命
		case 'DZ_YIN' : 
		case 'DZ_SHEN' : 
		{
			inYinShen = true;
			break;
		}
		// 子午坐命
		case 'DZ_ZI' : 
		case 'DZ_WU' :
		{
			inZiWu = true;
			break;
		}
		// 丑未坐命
		case 'DZ_CHOU' : 
		case 'DZ_WEI' : 
		{
			inChouWei = true;
			break;
		}
		default : return false;
	}
	
	var stars = mingGong.getStars();
	var hasZiWei = false, hasTianFu = false, hasTianXiang = false, hasWuQu = false, hasLianZhen = false;
	
	for(var i = 0; i < stars.length; i ++)
	{
		var starName = stars[i].getName();
		
		if(starName == "MAINSTAR_ZIWEIXING")
		{
			hasZiWei = true;
		}
		
		if(starName == "MAINSTAR_TIANFUXING")
		{
			hasTianFu = true;
		}
		
		if(starName == "MAINSTAR_TIANXIANGXING")
		{
			hasTianXiang = true;
		}
		
		if(starName == "MAINSTAR_WUQUXING")
		{
			hasWuQu = true;
		}
		
		if(starName == "MAINSTAR_LIANZHENXING")
		{
			hasLianZhen = true;
		}
	}
	
	if(inYinShen && hasZiWei && hasTianFu)
	{
		return true;
	}
	
	if(inYinShen && hasTianXiang && hasWuQu)
	{
		return true;
	}
	
	if(inYinShen && hasLianZhen)
	{
		return true;
	}
	
	if(inZiWu && hasLianZhen && hasTianXiang)
	{
		return true;
	}
	
	if(inChouWei && hasTianXiang)
	{
		return true;
	}

	return false;
};
