/**
 * MingPanUtil.js
 * 命盘工具
 *
 * @date 2014-02-18
 * @version 0.1
 */
 
function MingPanUtil(){

}

/**
 * 快速创建下一个流日命盘（注意：仅限于同一个流月内）
 */
MingPanUtil.fastCreateNextLiuRiMingPan = function(liuRiMingPan, monthLength){
	if(!(liuRiMingPan && monthLength)){
		return false;
	}

	var lunarYear = liuRiMingPan.getYear();
	var lunarMonth = liuRiMingPan.month;
	var lunarDay = liuRiMingPan.day;
	
	if(lunarDay == monthLength){
		return false;
	}
	
	var nextLiuRiMingPan = liuRiMingPan;
	
	nextLiuRiMingPan.day = lunarDay + 1;
	
	var siZhu = SiZhu.createSiZhu(lunarYear, lunarMonth, nextLiuRiMingPan.day, 0, liuRiMingPan.monthIsRunYue ? true : false);
	
	var riZhu = siZhu.getRiZhu();
	
	riZhu = Util.convertJiaZi2GanZhi(riZhu);	
	
	nextLiuRiMingPan.setLiuRiGongWei(nextLiuRiMingPan.day);
	
	nextLiuRiMingPan._yearOfGanZhi = siZhu.getNianZhu();
	nextLiuRiMingPan.monthOfGanZhi = siZhu.getYueZhu();
	nextLiuRiMingPan.dayOfGanZhi = riZhu;
	
	var items = nextLiuRiMingPan.getItems();
	
	for(var i = 0; i < items.length; i++){
		var stars = items[i].getStars();
		
		for(var j = 0; j < stars.length; j ++){
			stars[j]._siHuaOfLiuRi = false;
		}
	}
	
	nextLiuRiMingPan.setSiHuaStar(riZhu, "LiuRiMingPan");
	
	return nextLiuRiMingPan;
};

MingPanUtil.fastCreateNextLiuYueMingPan = function(liuYueMingPan, nextMonth, isRunYue){
	if(!(liuYueMingPan && nextMonth) || nextMonth < 2 || nextMonth > 12){
		return false;
	}

	var nextLiuYueMingPan = liuYueMingPan;
	
	
	var items = nextLiuYueMingPan.getItems();
	
	for(var i = 0; i < items.length; i++){
		var stars = items[i].getStars();
		
		for(var j = 0; j < stars.length; j ++){
			stars[j]._siHuaOfLiuYue = false;
		}
	}
	
	var siZhu = SiZhu.createSiZhu(nextLiuYueMingPan.getYear(), nextMonth, 15, 0, isRunYue);
	
	var yueZhu = siZhu.getYueZhu();
	
	nextLiuYueMingPan.setSiHuaStar(yueZhu, "LiuYueMingPan");
	
	nextLiuYueMingPan.setLiuYueGongWei(isRunYue ? nextMonth + 1 : nextMonth);
	
	nextLiuYueMingPan.month = nextMonth;
	nextLiuYueMingPan.monthOfGanZhi = yueZhu;
	nextLiuYueMingPan.monthIsRunYue = isRunYue ? true : false;
	
	return nextLiuYueMingPan;
};

