function WeiSuanQuestionAlgorithm(){
	
};

WeiSuanQuestionAlgorithm.iosInvoked_WL1_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var stars = WeiSuanQuestionUtil.getSpecifyDayGongWeiStars(sections, "GONGWEI_MINGGONG");
	
	var isStrong = false;
	var hasKongJie = false;
	
	for(var i = 0; i < stars.length; i ++){
		var starName = stars[i].getName();
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
		}
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
	}
	
	var choice;
	
	if(!(isStrong || hasKongJie)){
		choice = "A";
	}
	
	if(isStrong && !hasKongJie){
		choice = "B";
	}
	
	if(hasKongJie){
		choice = "C";
	}
	
	return JSON.stringify({
		'request' : choice,
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL2_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var stars = WeiSuanQuestionUtil.getSpecifyDayGongWeiStars(sections, "GONGWEI_MINGGONG");
	
	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '高档酒店',
		'MAINSTAR_TIANFUXING' : '大酒店',
		'MAINSTAR_TIANXIANGXING' : '咖啡厅',
		'MAINSTAR_LIANZHENXING' : '时尚创意餐厅',
		'MAINSTAR_WUQUXING' : '商业中心品牌餐饮',
		'MAINSTAR_QISHAXING' : '大排档、快餐',
		'MAINSTAR_POJUNXING' : '海鲜',
		'MAINSTAR_TANLANGXING' : '音乐餐厅',
		'MAINSTAR_TAIYANGXING' : '电影院',
		'MAINSTAR_TAIYINXING' : '西餐厅',
		'MAINSTAR_TIANLIANGXING' : '茶餐厅、中式餐厅',
		'MAINSTAR_TIANTONGXING' : '田园风格的餐厅、小吃',
		'MAINSTAR_JUMENXING' : '酒楼',
		'MAINSTAR_TIANJIXING' : '自助餐'
	};
	
	var resultArray = new Array();
	
	for(var i = 0; i < stars.length; i ++){
		var starName = stars[i].getName();
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '根据你的今日能量状况，建议吃饭地点选择：' + resultArray.join(',')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL3_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var stars = WeiSuanQuestionUtil.getSpecifyDayGongWeiStars(sections, "GONGWEI_MINGGONG");
	
	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '紫色系',
		'MAINSTAR_TIANFUXING' : '土黄色系',
		'MAINSTAR_TIANXIANGXING' : '灰色系',
		'MAINSTAR_LIANZHENXING' : '白色系',
		'MAINSTAR_WUQUXING' : '黑色系',
		'MAINSTAR_QISHAXING' : '红色系',
		'MAINSTAR_POJUNXING' : '浅蓝色系',
		'MAINSTAR_TANLANGXING' : '粉色系',
		'MAINSTAR_TAIYANGXING' : '黄色系',
		'MAINSTAR_TAIYINXING' : '蓝色系',
		'MAINSTAR_TIANLIANGXING' : '咖啡色系',
		'MAINSTAR_TIANTONGXING' : '浅绿色系',
		'MAINSTAR_JUMENXING' : '绿色系',
		'MAINSTAR_TIANJIXING' : '橙色系'
	};
	
	var resultArray = new Array();
	
	for(var i = 0; i < stars.length; i ++){
		var starName = stars[i].getName();
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '根据你的今日能量状况，建议你穿：' + resultArray.join(',') + " 衣服"
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL4_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	var sections = xianTianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var stars = sections[i].getStars();
		
		for(var j = 0; j < stars.length; j ++){
			var starName = stars[j].getName();
			
			if(starName == "MAINSTAR_WUQUXING"){
				var descriptor = stars[j].getDescriptor();
				
				if(descriptor == "MIAOWANG_MIAO" || descriptor == "MIAOWANG_WANG"){
					return JSON.stringify({
						'request' : 'A',
						'useful' : true
					});
				}else{
					return JSON.stringify({
						'request' : 'B',
						'useful' : true
					});
				}
			}
		}
	}
	
	return false;
};

WeiSuanQuestionAlgorithm.iosInvoked_WL5_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}

	var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");

	if(!sanFangSiZhengStars){
		return false;
	}
	
	var totalStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui']);
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
			
		if(starName == "MAINSTAR_WUQUXING"){
			return JSON.stringify({
					'request' : 'A',
					'useful' : true
			});
		}
	}
	
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL6_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var sections = liuYueMingPan.getItems();
	
	var stars = WeiSuanQuestionUtil.getSpecifyMonthGongWeiStars(sections, "GONGWEI_MINGGONG");
	
	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '电脑、给车加油、手机、平板电脑',
		'MAINSTAR_TIANFUXING' : '电脑、笔记本、手机、平板电脑、温度计、记录簿、日历  ',
		'MAINSTAR_TIANXIANGXING' : '箱子、模型、信用卡、衣服',
		'MAINSTAR_LIANZHENXING' : '电池、家用电器',
		'MAINSTAR_WUQUXING' : '健身器材、食物',
		'MAINSTAR_QISHAXING' : '工艺品',
		'MAINSTAR_POJUNXING' : '电动玩具、纪念品',
		'MAINSTAR_TANLANGXING' : '餐具、乐器、烟酒',
		'MAINSTAR_TAIYANGXING' : '眼镜、表、灯、汽车',
		'MAINSTAR_TAIYINXING' : '化妆品、汽车、照片、伞、女性用品',
		'MAINSTAR_TIANLIANGXING' : '医学器材、宗教用品、卫浴用品、古董',
		'MAINSTAR_TIANTONGXING' : '休闲食品、保健品、健康食品',
		'MAINSTAR_JUMENXING' : '围巾、窗帘、眼镜、内衣、药品',
		'MAINSTAR_TIANJIXING' : '编制品、镜子、眼镜、素斋食品',
		'GEMSTAR_WENCHANGXING' : '文具、办公用品、书',
		'GEMSTAR_WENQUXING' : '文具、书、礼品、乐器',
		'GEMSTAR_TIANKUIXING' : '装饰品、宝石、艺术品',
		'GEMSTAR_TIANYUEXING' : '珠宝饰品',
		'FIENDSTAR_DIKONGXING' : '鞋',
		'FIENDSTAR_DIJIEXING' : '鞋'
	};
	
	var resultArray = new Array();
	
	for(var i = 0; i < stars.length; i ++){
		var starName = stars[i].getName();
		
		if(defaultAnswer[starName]){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	resultArray.unique();
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '根据你的本月能量状况，建议购买以下物品可以起到开运的作用。它们是：' + resultArray.join(',') + " 。"
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL7_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var sections = liuYueMingPan.getItems();
	
	var stars = WeiSuanQuestionUtil.getSpecifyMonthGongWeiStars(sections, "GONGWEI_MINGGONG");
	
	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '紫色系',
		'MAINSTAR_TIANFUXING' : '土黄色系',
		'MAINSTAR_TIANXIANGXING' : '灰色系',
		'MAINSTAR_LIANZHENXING' : '白色系',
		'MAINSTAR_WUQUXING' : '黑色系',
		'MAINSTAR_QISHAXING' : '红色系',
		'MAINSTAR_POJUNXING' : '蓝色系',
		'MAINSTAR_TANLANGXING' : '粉色系',
		'MAINSTAR_TAIYANGXING' : '黄色系',
		'MAINSTAR_TAIYINXING' : '蓝色系',
		'MAINSTAR_TIANLIANGXING' : '咖啡色系',
		'MAINSTAR_TIANTONGXING' : '浅绿色系',
		'MAINSTAR_JUMENXING' : '绿色系',
		'MAINSTAR_TIANJIXING' : '橙色系'
	};
	
	var resultArray = new Array();
	
	for(var i = 0; i < stars.length; i ++){
		var starName = stars[i].getName();
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '根据你的本月能量状况，建议你购买或穿着' + resultArray.join(',') + " 的服装对开运起到积极作用（仅作参考）。"
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL8_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curLunarDate.year-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;
	
	var monthResultArray = new Array();
	
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
	for(var i = 0; i < monthInfo.length; i ++){
		var monthIndex = false, isRunYue = false;
		
		if(i < runYueIndex){
			monthIndex = i + 1;
		}else if(i == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(i > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = i;
			}else{
				monthIndex = i + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curLunarDate.year, monthIndex, isRunYue);
		
		if(!liuYueMingPan){
			return false;
		}
		
		var sanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa("GONGWEI_QIANYIGONG", liuYueMingPan, "LiuYueMingPan", true);
		
		var hasTianMa = false;
		for(var m = 0; m < sanFangSiZhengStars['zuo'].length; m ++){
			var starName = sanFangSiZhengStars['zuo'][m].getName();
			
			if("GEMSTAR_TIANMAXING" == starName){
				hasTianMa = true;
				
				break;
			}
		}
		
		if(hasTianMa){
			var monthName = defaultLunarMonth[monthIndex - 1];
						
			if(isRunYue){
				monthName = "闰" + monthName;
			}
			
			monthResultArray.push(monthName);
		
			continue;
		}
		
		var sections = liuYueMingPan.getItems();
		
		for(var j = 0; j < sections.length; j ++){
			if(sections[j].getMonthGongWei().indexOf("GONGWEI_MINGGONG") >= 0){
				var stars = sections[j].getStars();
				
				for(var s = 0; s < stars.length; s ++){
					var starName = stars[s].getName();
					
					if(starName == "MAINSTAR_POJUNXING" || starName == "MAINSTAR_TIANTONGXING" || starName == "MAINSTAR_TAIYINXING"){
						var monthName = defaultLunarMonth[monthIndex - 1];
						
						if(isRunYue){
							monthName = "闰" + monthName;
						}
						
						monthResultArray.push(monthName);
					}
				}
			}
		}
	}
	
	monthResultArray.unique();
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份为农历 ' + monthResultArray.join("、")
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WL9_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var liuNianMingPan = curUser.getLiuNianMingPan(curLunarDate.year);
	
	if(!liuNianMingPan){
		return false;
	}
	
	var defaultGongWeiAndCountries = ['俄罗斯', '韩国、南非', '韩国、南非', '日本', '台湾、塞班、智利、阿根廷', 
									  '澳洲、新西兰', '港澳、印尼',
									  '新马泰、马尔代夫', '新马泰、马尔代夫', '美国、加拿大', '欧洲','欧洲'
									 ];
									
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var stars = sections[i].getStars();
		
		for(var j = 0; j < stars.length; j ++){
			var siHua = stars[j].getSiHuaOfLiuNian();
			if(siHua && siHua == "SIHUA_LU"){
				return JSON.stringify({
					'request' : 'A',
					'useful' : true,
					'append' : '出国能量最强的国家：' + defaultGongWeiAndCountries[(sections[i].getIndex() - 1)]
				});
			}
		}
	}
	
	return false;
};

WeiSuanQuestionAlgorithm.iosInvoked_WA1_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var liuNianMingPan = curUser.getLiuNianMingPan(curLunarDate.year);
	
	var sections = liuNianMingPan.getItems();
	
	var zuoStars = false;
	var huiStars = false;
	
	for(var i = 0; i < sections.length; i ++){
		if(sections[i].getLiuNianGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			zuoStars = sections[i].getStars();
			
			huiStars = sections[(i + 4) % 12].getStars();
			
			huiStars.concat(sections[(i + 8) % 12].getStars());
		}
	}
	
	var sanFangStars = zuoStars.concat(huiStars);
	
	//var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	if(sanFangHasKongJie){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true,
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrongMainStar && shaNum < 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var hasLiuNianHuaLu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuNian() == "SIHUA_LU"){
			hasLiuNianHuaLu = true;
			
			break;
		}
	}
	
	if(!isStrongMainStar && shaNum <= 1 && hasLiuNianHuaLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA2_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var answer = WeiSuanQuestionAlgorithm.iosInvoked_WA1_al();
	
	answer = JSON.parse(answer);
	
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curLunarDate.year-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var monthArray = new Array();
	
	for(var i = 0; i < monthInfo.length; i ++){
		var monthIndex, isRunYue = false;
		
		if(i < runYueIndex){
			monthIndex = i + 1;
		}else if(i == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(i > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = i;
			}else{
				monthIndex = i + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curLunarDate.year, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
			
		var sections = liuYueMingPan.getItems();
		
		var zuoStars = false;
		var huiStars = false;
		
		for(var j = 0; j < sections.length; j ++){
			if(sections[j].getMonthGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
				zuoStars = sections[j].getStars();
				
				huiStars = sections[(j + 4) % 12].getStars();
				
				huiStars.concat(sections[(j + 8) % 12].getStars());
			}
		}
		
		var sanFangStars = zuoStars.concat(huiStars);
		
	//	var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
		
		var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuYueMingPan");

		var sanFangHasKongJie = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var star = sanFangStars[j];
			
			if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
				sanFangHasKongJie = true;
				
				break;
			}
		}
		
		if(sanFangHasKongJie){
			continue;
		}
		
		var isStrongMainStar = false;
		
		for(var j = 0; j < zuoStars.length; j ++){
			var starName = zuoStars[j].getName();
			
			if(starName.indexOf("MAINSTAR_") >= 0){
				isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
				
				break;
			}
		}
		
		if(isStrongMainStar && shaNum < 3){
			var monthName = defaultLunarMonth[monthIndex - 1];
						
			if(isRunYue){
				monthName = "闰" + monthName;
			}
		
			monthArray.push(monthName);
		}
		
		var hasLiuNianHuaLu = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var star = sanFangStars[j];
			
			if(star.getSiHuaOfLiuYue() == "SIHUA_LU"){
				hasLiuNianHuaLu = true;
				
				break;
			}
		}
		
		if(!isStrongMainStar && shaNum <= 1 && hasLiuNianHuaLu){
			var monthName = defaultLunarMonth[monthIndex - 1];
						
			if(isRunYue){
				monthName = "闰" + monthName;
			}
		
			monthArray.push(monthName);
		}
	}
	
	if(answer.request == "A"){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'append' : '在农历的' + monthArray.join('、'),
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}else{
		return JSON.stringify({
			'request' : 'B',
			'useful' : true,
			'append' : '相对来说正能量会在农历的' + monthArray.join('、'),
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WA3_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	var zuoStars = false;
	var huiStars = false;
	var duiStars = false;
	var liuRiFuQiGong = false;
	
	for(var j = 0; j < sections.length; j ++)
	{
		if(sections[j].getDayGongWei().indexOf("GONGWEI_FUQIGONG") >= 0)
		{
			liuRiFuQiGong = sections[j];
			zuoStars = sections[j].getStars();
			huiStars = sections[(j + 4) % 12].getStars();
			huiStars.concat(sections[(j + 8) % 12].getStars());
			duiStars = sections[(j + 6) % 12].getStars();
		}
	}
	
	for(var i = 0; i < zuoStars.length; i ++)
	{
		if(zuoStars[i].getName() == "NORMALSTAR_HONGLUANXING" || zuoStars[i].getName() == "NORMALSTAR_TIANXIXING" )
		{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	var liuRiFuQiGongIsNotEmpty = !ZiWeiUtils.isEmptyGongWei(liuRiFuQiGong);
	var sanFangStars = zuoStars.concat(huiStars);
	var totalStars = sanFangStars.concat(duiStars);
	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING")
		{
			sanFangHasKongJie = true;
			break;
		}
	}
	
	if(sanFangHasKongJie){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var isAllInXian = true;
	var hasShaInXian = true;
	var zuoShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(zuoStars, "LiuRiMingPan");
	var sfszHasZuoYouChangQu = false;
	
	for(var i = 0; i < zuoStars.length; i ++)
	{
		var starName = zuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0)
		{
			if(WeiSuanQuestionUtil.mainStarsIsStrong(starName))
			{
				isAllInXian = false;
			}
			else
			{
				if(zuoStars[i].getDescriptor() == "MIAOWANG_MIAO" || zuoStars[i].getDescriptor() == "MIAOWANG_WANG")
				{
					isAllInXian = false;
				}
			}
		}
		
		if(starName.indexOf("FIENDSTAR_") >= 0)
		{
			if(zuoStars[i].getDescriptor() == "MIAOWANG_MIAO" || zuoStars[i].getDescriptor() == "MIAOWANG_WANG")
			{
				hasShaInXian = false;
			}
		}
	}
	
	for(var i = 0; i < totalStars.length; i ++)
	{
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING" || starName == "GEMSTAR_ZUOFUXING" || starName == "GEMSTAR_YOUBIXING" )
		{
			sfszHasZuoYouChangQu = true;
			break;
		}
	}
	
	if(liuRiFuQiGongIsNotEmpty && !isAllInXian && !hasShaInXian && zuoShaNum <= 2  && sfszHasZuoYouChangQu)
	{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA4_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
		
	var zuoStars = false;
	var huiStars = false;
	var duiStars = false;
	
	for(var j = 0; j < sections.length; j ++){
		if(sections[j].getDayGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			zuoStars = sections[j].getStars();
			
			huiStars = sections[(j + 4) % 12].getStars();
			
			huiStars.concat(sections[(j + 8) % 12].getStars());
			
			duiStars = sections[(j + 6) % 12].getStars();
		}
	}
	
	var sanFangStars = zuoStars.concat(huiStars);
	
	var totalStars = sanFangStars.concat(duiStars);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	if(sanFangHasKongJie){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasLiuNianHuaLuOrHuaKe = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var star = totalStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU" || star.getSiHuaOfLiuRi() == "SIHUA_KE"){
			hasLiuNianHuaLuOrHuaKe = true;
			
			break;
		}
	}
	
	if(isStrongMainStar && shaNum < 3 && hasLiuNianHuaLuOrHuaKe){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!isStrongMainStar && shaNum <= 1 && hasLiuNianHuaLuOrHuaKe){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA5_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var liuNianMingPan = curUser.getLiuNianMingPan(curLunarDate.year);
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuNianMingPan, "LiuNianMingPan");

	var totalStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui'], fuqiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuNianMingPan");
	
	var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
	
	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	var liuNianMingHasKongJie = false;
	
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++)
	{
		var star = mingSanFangSiZhengStars['zuo'][i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			liuNianMingHasKongJie = true;
			
			break;
		}
	}
	
	if(shaNum < 3 && !sanFangHasKongJie && !liuNianMingHasKongJie){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curLunarDate.year-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var monthArray = new Array();
	
	for(var i = 0; i < monthInfo.length; i ++){
		var monthIndex, isRunYue = false;
		
		if(i < runYueIndex){
			monthIndex = i + 1;
		}else if(i == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(i > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = i;
			}else{
				monthIndex = i + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curLunarDate.year, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
		
		var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuYueMingPan, "LiuYueMingPan");

		var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
		
		var monthTotalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
		
		var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(monthTotalStars, "LiuYueMingPan");

		var sanFangHasKongJie = false;
		
		for(var j = 0; j < fuqiSanFangSiZhengStars['zuo'].length; j ++){
			var star = fuqiSanFangSiZhengStars['zuo'][j];
			
			if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
				sanFangHasKongJie = true;
				
				break;
			}
		}
	
		if(sanFangHasKongJie || shaNum >= 4){
			var monthName = defaultLunarMonth[monthIndex - 1];
						
			if(isRunYue){
				monthName = "闰" + monthName;
			}
		
			monthArray.push(monthName);
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'append' : '相对来说农历的'+monthArray.join(' ')+' 负能量最强。',
		'redirect' :{
			'txt' : '负能量化解神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA6_al_stub = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var liuNianMingPan = curUser.getLiuNianMingPan(curLunarDate.year);
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuNianMingPan, "LiuNianMingPan");

	var totalStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui'], fuqiSanFangSiZhengStars['dui']);
	
	var hasZuoYou = false, 
		hasChangQu = false,
		hasLu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		  
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING"){
			hasChangQu = true;
		}
		
		if(starName == "GEMSTAR_ZUOFUXING" || starName == "GEMSTAR_YOUBIXING"){
			hasZuoYou = true;
		}
		
		if(starName == "GEMSTAR_LUCUNXING"){
			hasLu = true;
		}
		
		if(totalStars[i].getSiXiang() == "SIHUA_LU" || totalStars[i].getSiHuaOfDaYun() == "SIHUA_LU" || totalStars[i].getSiHuaOfLiuNian() == "SIHUA_LU"){
			hasLu = true;
		}
	}
	
	var sections = liuNianMingPan.getItems();
	
	var liuYaos = new Array();
	
	for(var i = 0; i < sections.length; i ++){
		if(sections[i].getLiuNianGongWei().indexOf("GONGWEI_FUQIGONG") >= 0){
			var index = i;
			
			if(sections[index].getLiuNianStars()){
				liuYaos.push(sections[index].getLiuNianStars());
			}
			
			index = (i + 4) % 12;
			
			if(sections[index].getLiuNianStars()){
				liuYaos.push(sections[index].getLiuNianStars());
			}
			
			index = (i + 8) % 12;
			
			if(sections[index].getLiuNianStars()){
				liuYaos.push(sections[index].getLiuNianStars());
			}
			
			index = (i + 6) % 12;
			
			if(sections[index].getLiuNianStars()){
				liuYaos.push(sections[index].getLiuNianStars());
			}
		}
	}
	
	var hasLiuChangQu = false;
	
	for(var i = 0; i < liuYaos.length; i ++){
		var xingyaos = liuYaos[i];
		
		for(var j = 0; j < xingyaos.length; j ++){
			if(xingyaos[j].starName == "LIU_GEMSTAR_WENCHANGXING" || xingyaos[j].starName == "LIU_GEMSTAR_WENQUXING"){
				hasLiuChangQu = true;
				
				break;
			}
		}
	}
	
	if((hasChangQu || hasLiuChangQu) && hasZuoYou && hasLu){
		return 'B';
	}
	
	return 'A';
};

WeiSuanQuestionAlgorithm.iosInvoked_WA6_al = function(){
	var request = WeiSuanQuestionAlgorithm.iosInvoked_WA6_al_stub();
	
	return JSON.stringify({
		'request' : request,
		'useful' : true,
		'redirect' :{
			'txt' : '负能量化解神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA7_al = function()
{
	var request = WeiSuanQuestionAlgorithm.iosInvoked_WA6_al_stub();
	
	return JSON.stringify({
		'request' : request,
		'useful' : true,
		'redirect' :{
			'txt' : '负能量化解神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}	
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA8_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var liuNianMingPan = curUser.getLiuNianMingPan(curLunarDate.year);
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuNianMingPan, "LiuNianMingPan");

	var totalStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui'], fuqiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuNianMingPan");
	
	if(shaNum >= 4){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '负能量化解神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA9_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
	var calendar = new PerpetualCalendar();
		
	var curYear = curLunarDate.year;
	
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var monthArray = new Array();
	
	for(var i = 0; i < monthInfo.length; i ++){
		var monthIndex, isRunYue = false;
		
		if(i < runYueIndex){
			monthIndex = i + 1;
		}else if(i == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(i > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = i;
			}else{
				monthIndex = i + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
		
		var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUQIGONG', liuYueMingPan, "LiuYueMingPan");

		var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
		
		var monthTotalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
		
		var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(monthTotalStars, "LiuYueMingPan");

		var isStrongMainStar = false;
		
		for(var j = 0; j < fuqiSanFangSiZhengStars['zuo'].length; j ++){
			var starName = fuqiSanFangSiZhengStars['zuo'][j].getName();
		
			if(starName.indexOf("MAINSTAR_") >= 0){
				isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			}
		}
		
		var sanFangHasKongJie = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var star = sanFangStars[j];
			
			if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
				sanFangHasKongJie = true;
				
				break;
			}
		}
	
		
		if(!sanFangHasKongJie){
			if(isStrongMainStar){
				var monthName = defaultLunarMonth[monthIndex - 1];
						
				if(isRunYue){
					monthName = "闰" + monthName;
				}
			
				monthArray.push(monthName);
			}else{
				if(shaNum < 1){
					var monthName = defaultLunarMonth[monthIndex - 1];
						
					if(isRunYue){
						monthName = "闰" + monthName;
					}
				
					monthArray.push(monthName);
				}
			}
		}
	}
	
	if(monthArray.length == 0){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '抱歉，没有搜到合适的时间！不扣天币。',
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '农历的'+ monthArray.join('、') +'适合。在这些月份可以发挥自身强大的正能量，好好利用哦！',
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA10_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_FUQIGONG', liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var sanFangHasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getName() == "FIENDSTAR_DIKONGXING" || star.getName() == "FIENDSTAR_DIJIEXING"){
			sanFangHasKongJie = true;
			
			break;
		}
	}
	
	var isStrongMainStar = false;
	
	for(var i = 0; i < fuqiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = fuqiSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}

	var hasLiuRiHuaLuOrHuaKe = false,
		hasLiuRiJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var star = sanFangStars[i];
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_LU" || star.getSiHuaOfLiuRi() == "SIHUA_KE"){
			hasLiuRiHuaLuOrHuaKe = true;
		}
		
		if(star.getSiHuaOfLiuRi() == "SIHUA_JI"){
			hasLiuRiJi = true;
		}
	}
	
	var zuoStars = fuqiSanFangSiZhengStars['zuo'];
	var hasHongLuanTianXi = false;
	
	for(var i = 0; i < zuoStars.length; i ++)
	{
		if(zuoStars[i].getName() == "NORMALSTAR_HONGLUANXING" || zuoStars[i].getName() == "NORMALSTAR_TIANXIXING" )
		{
			hasHongLuanTianXi = true;
			break;
		}
	}
	
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && hasLiuRiHuaLuOrHuaKe && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(hasHongLuanTianXi)
	{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && isStrongMainStar && shaNum <= 3 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	if(!sanFangHasKongJie && !isStrongMainStar && shaNum <= 1 && !hasLiuRiJi){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WA11_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var language = getCurrentUser().languageConfig;
	
	if(!language){
		language = 0;
	}
	
	var xianTianMingPan = curUser.getXianTianMingPan();
	
	if(!xianTianMingPan){
		return false;
	}
	
	var sections = xianTianMingPan.getItems();
	
	var zodiacArray = new Array();
	
	for(var i = 0; i < sections.length; i ++){
		var gongWei = sections[i].getGongWei();
		
		if(gongWei.indexOf("GONGWEI_MINGGONG") >= 0 || gongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 ||
		   gongWei.indexOf("GONGWEI_CAIBOGONG") >= 0 || gongWei.indexOf("GONGWEI_FUQIGONG") >= 0 ||
		   gongWei.indexOf("GONGWEI_FUDEGONG") >= 0 || gongWei.indexOf("GONGWEI_QIANYIGONG") >= 0){
			 
			var stars = sections[i].getStars();
			
			var hasKongJie = false;
			
			for(var j = 0; j < stars.length; j ++){
				if(stars[j].getName() == "FIENDSTAR_DIJIEXING" || stars[j].getName() == "FIENDSTAR_DIKONGXING"){
					hasKongJie = true;
					
					break;
				}
			}
			
			if(!hasKongJie){	
			    zodiacArray.push(Translator.translate(Util.getZodiacByIndex(sections[i].getIndex() - 1), language));
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强：' + zodiacArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS1_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var liuNianGongWei = sections[i].getLiuNianGongWei();
		
		if(liuNianGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_FUDEGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++){
				var starName = stars[j].getName();
				
				if("MAINSTAR_ZIWEIXING" == starName){
					var curYear = liuNianMingPan.getYear();
				
					var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
					var calendar = new PerpetualCalendar();
						
					var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
					
					var runYueIndex = basePerpetualCalenderItem.runYueIndex;
					
					var monthInfo = basePerpetualCalenderItem.monthInfo;

					var resultMonthArray = new Array();
					
					for(var m = 0; m < monthInfo.length; m ++){
						var monthIndex, isRunYue = false;
						
						if(m < runYueIndex){
							monthIndex = m + 1;
						}else if(m == runYueIndex){
							monthIndex = runYueIndex;
							isRunYue = true;
						}else if(m > runYueIndex){
							if(runYueIndex > 0){
								monthIndex = m;
							}else{
								monthIndex = m + 1;
							}
						}
						
						var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

						if(!liuYueMingPan){
							return false;
						}
						
						sections = liuYueMingPan.getItems();
						
						for(var t = 0; t < sections.length; t ++){
							var liuYueGongWei = sections[t].getMonthGongWei();
						
							if(liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_FUDEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
								var stars = sections[t].getStars();
				
								for(var s = 0; s < stars.length; s ++){
									var starName = stars[s].getName();
								
									if("MAINSTAR_ZIWEIXING" == starName){
										if(isRunYue){
											resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
										}else{
											resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
										}
									}
								}
							}
						}
					}
					
					return JSON.stringify({
						'request' : 'A',
						'useful' : true,
						'append' : '农历' + resultMonthArray.join('、') + '能量指数最高。',
						'redirect' :{
							'txt' : '激发正能量神器开运猫恭请',
							'module' : 'KYM',
							'param' : {
								'productId' : 1
							}
						}
					});
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS2_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var liuNianGongWei = sections[i].getLiuNianGongWei();
		
		if(liuNianGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_FUDEGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++){
				var starName = stars[j].getName();
				
				if("MAINSTAR_ZIWEIXING" == starName){
					var curYear = liuNianMingPan.getYear();
				
					var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
					var calendar = new PerpetualCalendar();
						
					var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
					
					var runYueIndex = basePerpetualCalenderItem.runYueIndex;
					
					var monthInfo = basePerpetualCalenderItem.monthInfo;

					var resultMonthArray = new Array();
					
					for(var m = 0; m < monthInfo.length; m ++){
						var monthIndex, isRunYue = false;
						
						if(m < runYueIndex){
							monthIndex = m + 1;
						}else if(m == runYueIndex){
							monthIndex = runYueIndex;
							isRunYue = true;
						}else if(m > runYueIndex){
							if(runYueIndex > 0){
								monthIndex = m;
							}else{
								monthIndex = m + 1;
							}
						}
						
						var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

						if(!liuYueMingPan){
							return false;
						}
						
						sections = liuYueMingPan.getItems();
						
						for(var t = 0; t < sections.length; t ++){
							var liuYueGongWei = sections[t].getMonthGongWei();
						
							if(liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_FUDEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
								var stars = sections[t].getStars();
				
								for(var s = 0; s < stars.length; s ++){
									var starName = stars[s].getName();
								
									if("MAINSTAR_ZIWEIXING" == starName){
										if(isRunYue){
											resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
										}else{
											resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
										}
									}
								}
							}
						}
					}
					
					if(resultMonthArray.length > 0){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true,
							'append' : '尤其在农历' + resultMonthArray.join('、'),
							'redirect' :{
								'txt' : '激发正能量神器开运猫恭请',
								'module' : 'KYM',
								'param' : {
									'productId' : 1
								}
							}
						});
					}
				}
			}
		}
	}
	
	for(var i = 0; i < sections.length; i ++){
		var liuNianGongWei = sections[i].getLiuNianGongWei();
		
		if(liuNianGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0){
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++){
				var starName = stars[j].getName();
				
					if("MAINSTAR_TANLANGXING" == starName || "MAINSTAR_POJUNXING" == starName || "MAINSTAR_QISHAXING" == starName){
					var curYear = liuNianMingPan.getYear();
				
					var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
					var calendar = new PerpetualCalendar();
						
					var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
					
					var runYueIndex = basePerpetualCalenderItem.runYueIndex;
					
					var monthInfo = basePerpetualCalenderItem.monthInfo;

					var resultMonthArray = new Array();
					
					for(var m = 0; m < monthInfo.length; m ++){
						var monthIndex, isRunYue = false;
						
						if(m < runYueIndex){
							monthIndex = m + 1;
						}else if(m == runYueIndex){
							monthIndex = runYueIndex;
							isRunYue = true;
						}else if(m > runYueIndex){
							if(runYueIndex > 0){
								monthIndex = m;
							}else{
								monthIndex = m + 1;
							}
						}
						
						var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

						if(!liuYueMingPan){
							return false;
						}
						
						sections = liuYueMingPan.getItems();
						
						for(var t = 0; t < sections.length; t ++){
							var liuYueGongWei = sections[t].getMonthGongWei();
						
							if(liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0){
								var stars = sections[t].getStars();
				
								for(var s = 0; s < stars.length; s ++){
									var starName = stars[s].getName();
								
									if("MAINSTAR_TANLANGXING" == starName || "MAINSTAR_POJUNXING" == starName || "MAINSTAR_QISHAXING" == starName){
										if(isRunYue){
											resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
										}else{
											resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
										}
									}
								}
							}
						}
					}
					
					return JSON.stringify({
						'request' : 'B',
						'useful' : true,
						'append' : '尤其在农历' + resultMonthArray.join(' '),
						'redirect' :{
							'txt' : '激发正能量神器开运猫恭请',
							'module' : 'KYM',
							'param' : {
								'productId' : 1
							}
						}
					});
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS3_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var shiYeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	
	var zuoStars = shiYeSanFangSiZhengStars['zuo'];
	
	var huiStars = shiYeSanFangSiZhengStars['hui'];
	
	var sanFangStars = zuoStars.concat(huiStars);
	
	var isStrong = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasZuoYou = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
				
		if(starName == "GEMSTAR_ZUOFUXING" || starName == "GEMSTAR_YOUBIXING"){
			hasZuoYou = true;
			
			break;
		}
	}
	
	if(isStrong){
		if(hasZuoYou){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}else{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}
	}else{
		if(hasZuoYou){
			return JSON.stringify({
				'request' : 'C',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WS4_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var shiYeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	
	var zuoStars = shiYeSanFangSiZhengStars['zuo'];
	
	var isStrong = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}

	if(isStrong){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '激发正能量神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS5_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
		
		sections = liuYueMingPan.getItems();
		
		var isStrong = false;
		var isMiaoWang = false;
		
		var stars = WeiSuanQuestionUtil.getSpecifyMonthGongWeiStars(sections, "GONGWEI_SHIYEGONG");
		
		for(var s = 0; s < stars.length; s ++){
			var starName = stars[s].getName();
		
			if(starName.indexOf("MAINSTAR_") >= 0){
				isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
				
				var descriptor = stars[s].getDescriptor();
			
				if(descriptor == "MIAOWANG_MIAO" || descriptor == "MIAOWANG_WANG" ){
					isMiaoWang = true;
				}
			}
		}
		
		if(isStrong && isMiaoWang){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '正能量月份在农历'+resultMonthArray.join('、')+'，可以在以上月份中多积极主动争取。将会有不错的好机会。',
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS6_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var liuNianGongWei = sections[i].getLiuNianGongWei();
		
		if(liuNianGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuNianGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 ){
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++){
				var starName = stars[j].getName();
				
				if("MAINSTAR_ZIWEIXING" == starName){
					var curYear = liuNianMingPan.getYear();
				
					var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
					var calendar = new PerpetualCalendar();
						
					var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
					
					var runYueIndex = basePerpetualCalenderItem.runYueIndex;
					
					var monthInfo = basePerpetualCalenderItem.monthInfo;

					var resultMonthArray = new Array();
					
					for(var m = 0; m < monthInfo.length; m ++){
						var monthIndex, isRunYue = false;
						
						if(m < runYueIndex){
							monthIndex = m + 1;
						}else if(m == runYueIndex){
							monthIndex = runYueIndex;
							isRunYue = true;
						}else if(m > runYueIndex){
							if(runYueIndex > 0){
								monthIndex = m;
							}else{
								monthIndex = m + 1;
							}
						}
						
						var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

						if(!liuYueMingPan){
							return false;
						}
						
						sections = liuYueMingPan.getItems();
						
						for(var t = 0; t < sections.length; t ++){
							var liuYueGongWei = sections[t].getMonthGongWei();
						
							if(liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0){
								var stars = sections[t].getStars();
				
								for(var s = 0; s < stars.length; s ++){
									var starName = stars[s].getName();
								
									if("MAINSTAR_ZIWEIXING" == starName){
										if(isRunYue){
											resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
										}else{
											resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
										}
									}
								}
							}
						}
					}
					
					return JSON.stringify({
						'request' : 'A',
						'useful' : true,
						'append' : '尤其在农历' + resultMonthArray.join('、'),
						'redirect' :{
							'txt' : '激发正能量神器开运猫恭请',
							'module' : 'KYM',
							'param' : {
								'productId' : 1
							}
						}
					});
				}
			}
		}
	}
	
	for(var i = 0; i < sections.length; i ++){
		var liuNianGongWei = sections[i].getLiuNianGongWei();
		
		if(liuNianGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0){
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++){
				var starName = stars[j].getName();
				
				if("MAINSTAR_TANLANGXING" == starName || "MAINSTAR_POJUNXING" == starName || "MAINSTAR_QISHAXING" == starName){
					var curYear = liuNianMingPan.getYear();
				
					var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
					var calendar = new PerpetualCalendar();
						
					var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
					
					var runYueIndex = basePerpetualCalenderItem.runYueIndex;
					
					var monthInfo = basePerpetualCalenderItem.monthInfo;

					var resultMonthArray = new Array();
					
					for(var m = 0; m < monthInfo.length; m ++){
						var monthIndex, isRunYue = false;
						
						if(m < runYueIndex){
							monthIndex = m + 1;
						}else if(m == runYueIndex){
							monthIndex = runYueIndex;
							isRunYue = true;
						}else if(m > runYueIndex){
							if(runYueIndex > 0){
								monthIndex = m;
							}else{
								monthIndex = m + 1;
							}
						}
						
						var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

						if(!liuYueMingPan){
							return false;
						}
						
						sections = liuYueMingPan.getItems();
						
						for(var t = 0; t < sections.length; t ++){
							var liuYueGongWei = sections[t].getMonthGongWei();
						
							if(liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0){
								var stars = sections[t].getStars();
				
								for(var s = 0; s < stars.length; s ++){
									var starName = stars[s].getName();
								
									if("MAINSTAR_TANLANGXING" == starName || "MAINSTAR_POJUNXING" == starName || "MAINSTAR_QISHAXING" == starName){
										if(isRunYue){
											resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
										}else{
											resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
										}
									}
								}
							}
						}
					}
					
					return JSON.stringify({
						'request' : 'B',
						'useful' : true,
						'append' : '尤其在农历' + resultMonthArray.join('、'),
						'redirect' :{
							'txt' : '激发正能量神器开运猫恭请',
							'module' : 'KYM',
							'param' : {
								'productId' : 1
							}
						}
					});
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS7_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");
	
	var totalStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui'], mingSanFangSiZhengStars['dui']);
	
	var hasKuiYue = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
				
		if(starName == "GEMSTAR_TIANKUIXING" || starName == "GEMSTAR_TIANYUEXING"){
			hasKuiYue = true;
			
			break;
		}
	}

	if(hasKuiYue){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS8_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	
	var sanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	var hasKongJie = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
				
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING"){
			hasChangQu = true;
			
			continue;
		}
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
	}
	
	var isStrong = false;
	
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++){
		var starName = mingSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(hasChangQu && !hasKongJie){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}else{
		if(hasChangQu && !hasKongJie){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS9_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasKongJie = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
			
			break;
		}
	}
	
	var fumuSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_FUMUGONG', liuNianMingPan, "LiuNianMingPan");
	
	totalStars = fumuSanFangSiZhengStars['zuo'].concat(fumuSanFangSiZhengStars['hui']);
	
	var hasLiuJi = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		if(totalStars[i].getSiHuaOfLiuNian() == "SIHUA_JI"){
			hasLiuJi = true;
			
			break
		}
	}
	
	if(hasKongJie && hasLiuJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS10_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	var hasKongJie = false;
	var isStrong = false;
	
	for(var i = 0; i < sections.length; i ++){
		if(sections[i].getDayGongWei().indexOf("GONGWEI_SHIYEGONG") >= 0){
			var zuoStars = sections[i].getStars();
			
			for(var j = 0; j < zuoStars.length; j ++){
				var starName = zuoStars[j].getName();
				
				if(starName.indexOf("MAINSTAR_") >= 0){
					isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
					
					break;
				}
			}
			
			var hui1Stars = sections[(i + 4) % 12].getStars();
			
			var hui2Stars = sections[(i + 8) % 12].getStars();
			
			var totalSanFangStars = zuoStars.concat(hui1Stars, hui2Stars);
			
			for(var j = 0; j < totalSanFangStars.length; j ++){
				var starName = totalSanFangStars[j].getName();
				
				if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
					hasKongJie = true;
					
					break;
				}
			}
		}
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasHuaQuanLu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var sihua = totalStars[i].getSiHuaOfLiuRi();
		
		if(sihua == "SIHUA_LU" || sihua == "SIHUA_QUAN"){
			hasHuaQuanLu = true;
			
			break;
		}
	}
	
	if(!hasKongJie && isStrong && hasHuaQuanLu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS11_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui'], mingSanFangSiZhengStars['dui']);
	
	var hasKuiYue = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_TIANKUIXING" || starName == "GEMSTAR_TIANYUEXING"){
			hasKuiYue = true;
			
			break;
		}
	}
	
	if(hasKuiYue){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS12_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING"){
			hasChangQu = true;
			
			break;
		}
	}
	
	if(hasChangQu){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS13_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var qianyiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_QIANYIGONG', liuRiMingPan, "LiuRiMingPan");
	
	var totalStars = qianyiSanFangSiZhengStars['zuo'].concat(qianyiSanFangSiZhengStars['hui']);
	
	var qianyiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuRiMingPan");

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var shiyeShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(shiyeSanFangSiZhengStars['zuo'], "LiuRiMingPan");

	if(qianyiShaNum >= 3){
		if(shiyeShaNum >= 1){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}else{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WS14_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	
	var totalStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui'], shiyeSanFangSiZhengStars['dui']);
	
	var hasLingXing = false;
	
	for(var i = 0; i < totalStars.length; i ++){
		var starName = totalStars[i].getName();
		
		if(starName == "FIENDSTAR_LINGXING"){
			hasLingXing = true;
			
			break;
		}
	}
	
	if(hasLingXing){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WS15_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var shiYeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuNianMingPan, "LiuNianMingPan");
	
	var zuoStars = shiYeSanFangSiZhengStars['zuo'];
	
	var totalStars = zuoStars.concat(shiYeSanFangSiZhengStars['hui']);
	
	var caiboShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(totalStars, "LiuNianMingPan");

	var isStrong = false;
	
	for(var i = 0; i < zuoStars.length; i ++){
		var starName = zuoStars[i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(caiboShaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}else{
		if(caiboShaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WS16_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	for(var i = 0; i < sanFangStars.length; i ++)
	{
		var starName = sanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING" || starName == "FIENDSTAR_QINGYANGXING")
		{
			var result = {
				'request' : 'A',
				'useful' : true
			};
			
			return JSON.stringify(result);
		}
	}
	
	var result = {
		'request' : 'B',
		'useful' : true
	};
	
	return JSON.stringify(result);
}

WeiSuanQuestionAlgorithm.iosInvoked_WS17_al = function()
{
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var shiYeLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_SHIYEGONG", liuYueMingPan, "LiuYueMingPan");
	
	var isAAnswer = false;
	
	if(shiYeLevel > 9)
	{
		isAAnswer = true;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	var isRunYue = curLunarDate.isRunYue;
	var month = curLunarDate.month;
	var curUser = getCurrentUser().user;
	var calendar = new PerpetualCalendar();	
	var basePerpetualCalenderItem = calendar.getCalendar()[curLunarDate.year-1901];    // 获取该年的数据
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	var monthInfo = basePerpetualCalenderItem.monthInfo;
	var _isRunYue = false;
	var monthData = monthInfo[month - 1];
	var matchDays = [];

	if(isRunYue && runYueIndex == month)
	{
		_isRunYue = true;
	}
	
	if((runYueIndex >= 1 && month > runYueIndex) || (isRunYue && runYueIndex == month))
	{
		monthData = monthInfo[month];
	}
	
	for(var i = 1; i <= monthData; i ++)
	{
		var liuRiMingPan = curUser.getLiuRiMingPan(curLunarDate.year, month, i, isRunYue);
		var liuRiShiYeLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_SHIYEGONG", liuRiMingPan, "LiuRiMingPan");
		
		if(liuRiShiYeLevel > 9)
		{
			var gDate = PerpetualCalendar.convertLunarDate2GregorianDate(curLunarDate.year, month, i, 0, isRunYue);
			matchDays.push(gDate.getMonth() + 1 + "." + gDate.getDate());
		}
	}
	
	var result = {
		'request' : isAAnswer ? 'A' : 'B',
		'append' : matchDays.join("、"),
		'useful' : true
	};
	
	return JSON.stringify(result);
}
	
WeiSuanQuestionAlgorithm.iosInvoked_WC1_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuYueMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC2_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC3_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
		
		var liuRiGongWei = section.getDayGongWei();
		
		if(liuRiGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0){
			var liuYueGongWei = section.getMonthGongWei();
			
			if(liuYueGongWei.indexOf("GONGWEI_CAIBOGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_MINGGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_SHIYEGONG") >= 0 || liuYueGongWei.indexOf("GONGWEI_FUDEGONG") >= 0){
				
				var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
				var totalStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui'], caiboSanFangSiZhengStars['dui']);
				
				for(var j = 0; j < totalStars.length; j ++)
				{
					/*
					if(totalStars[j].getSiHuaOfLiuYue() == "SIHUA_LU" || totalStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
					*/
					
					if(totalStars[j].getSiHuaOfLiuRi() == "SIHUA_LU")
					{
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
				
				var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuRiMingPan, "LiuRiMingPan");
				
				var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
				
				for(var j = 0; j < xiongdiSanFangStars.length; j ++){
					if(xiongdiSanFangStars[j].getSiHuaOfLiuRi() == "SIHUA_LU"){
						return JSON.stringify({
							'request' : 'A',
							'useful' : true
						});
					}
				}
			}
		}
	}
	
	var liuRiCaiBoLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_CAIBOGONG", liuRiMingPan, "LiuRiMingPan");
	liuRiCaiBoLevel = WeiSuanQuestionAlgorithm.recalcEnergy4LiuRiMingPan(liuRiCaiBoLevel, liuRiMingPan, "GONGWEI_CAIBOGONG");
	
	if(liuRiCaiBoLevel > 8)
	{
		var caiBoSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
		
		var sanFangStars = caiBoSanFangSiZhengStars['zuo'].concat(caiBoSanFangSiZhengStars['hui']);
		
		for(var i = 0; i < sanFangStars.length; i ++)
		{
			if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_LU")
			{
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC4_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuYueMingPan, "LiuYueMingPan");
	
	var caiboSanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var caiboShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(caiboSanFangStars, "LiuYueMingPan");

	var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuYueMingPan, "LiuYueMingPan");
	
	var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
	
	var xiongdiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(xiongdiSanFangStars, "LiuYueMingPan");
	
	var xiongdiHasLiuYueHasJi = false;
	
	var caiboZuoJi = false;
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = caiboSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == siHua){
			caiboZuoJi = true;
			break;
		}
	}
	
	var caiboSanFangHasKongJie = false;
	for(var i = 0; i < caiboSanFangStars.length; i ++){
		var starName = caiboSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			caiboSanFangHasKongJie = true;
			
			break;
		}
	}
	
	
	var xiongdiSanFangHasKongJie = false;
	for(var i = 0; i < xiongdiSanFangStars.length; i ++){
		if(xiongdiSanFangStars[i].getSiHuaOfLiuYue() == "SIHUA_JI"){
			xiongdiHasLiuYueHasJi = true;
		}
		
		var starName = xiongdiSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			xiongdiSanFangHasKongJie = true;
		}
	}
	
	
	
	if(caiboShaNum <= 2 && !xiongdiHasLiuYueHasJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 4){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboZuoJi && xiongdiSanFangHasKongJie && xiongdiShaNum >= 3){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 3 && xiongdiHasLiuYueHasJi && caiboSanFangHasKongJie){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC5_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");
	
	var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");

	var isStrong = false;
	
	for(var i = 0; i < tianzhaiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = tianzhaiSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	if(isStrong){
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3){
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WC6_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuNianMingPan, "LiuNianMingPan");
	
	var sanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");
	
	var hasLiuNianHuaJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getSiHuaOfLiuNian() == "SIHUA_JI"){
			hasLiuNianHuaJi = true;
			
			break;
		}
	}
	
	if(shaNum < 3 && !hasLiuNianHuaJi){
		return JSON.stringify({
				'request' : 'A',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC7_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuNianMingPan, "LiuNianMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasKongJieJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
			hasKongJieJi = true;
			
			break;
		}
		
		if(sanFangStars[i].getSiHuaOfLiuNian() == "SIHUA_JI"){
			hasKongJieJi = true;
			
			break;
		}
	}
	
	if(isStrong && shaNum < 3 && !hasKongJieJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC8_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	
	var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");

	var isStrong = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasKongJie = false;
	var hasLiuRiHuaLu = false;
	var hasLiuRiHuaJi = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
		
		if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_LU"){
			hasLiuRiHuaLu = true;
		}
		
		if(sanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_JI"){
			hasLiuRiHuaJi = true;
		}
	}
	
	if(isStrong){
		if(shaNum < 3 && !hasKongJie){
			
			// 20150429修改  流日财帛宫主星强三方少于三个煞并且没有空劫并且三方没有流日化忌
			
			if(!hasLiuRiHuaJi)
			{
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}
			else
			{
				return JSON.stringify({
					'request' : 'B',
					'useful' : true
				});
			}
			
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}else{
		if(shaNum < 3 && !hasKongJie){
			if(hasLiuRiHuaLu && !hasLiuRiHuaJi){
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}
			
			if(!hasLiuRiHuaLu || (hasLiuRiHuaJi && hasLiuRiHuaLu))
			{
				return JSON.stringify({
					'request' : 'B',
					'useful' : true
				});
			}
		}else{
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WC9_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");
	
	var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
	
	var totalStars = sanFangStars.concat(tianzhaiSanFangSiZhengStars['dui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");

	var isStrong = false;
	
	for(var i = 0; i < tianzhaiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = tianzhaiSanFangSiZhengStars['zuo'][i].getName();
				
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var hasKongJie = false;
	var hasLiuRiHuaKeLuQuan = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
			hasKongJie = true;
		}
	}
	
	for(var i = 0; i < totalStars.length; i ++){
		if(totalStars[i].getSiHuaOfLiuNian() == "SIHUA_LU" || totalStars[i].getSiHuaOfLiuNian() == "SIHUA_QUAN" || totalStars[i].getSiHuaOfLiuNian() == "SIHUA_KE"){
			hasLiuRiHuaKeLuQuan = true;
			
			break;
		}
	}
	
	if(isStrong){
		if(!hasKongJie){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}else{
		if(hasLiuRiHuaKeLuQuan){
			return JSON.stringify({
				'request' : 'C',
				'useful' : true
			});
		}else{
			return JSON.stringify({
				'request' : 'D',
				'useful' : true
			});
		}
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WC10_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuYueMingPan, "LiuYueMingPan");
	
		for(var i = 0; i < tianzhaiSanFangSiZhengStars['zuo'].length; i ++){
			var starName = tianzhaiSanFangSiZhengStars['zuo'][i].getName();
				
			if(starName.indexOf("MAINSTAR_") >= 0){
				if(WeiSuanQuestionUtil.mainStarsIsStrong(starName)){
					if(isRunYue){
						resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
					}else{
						resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
					}
					
					break;
				}
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份是：农历' + resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC11_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			continue;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuYueMingPan, "LiuYueMingPan");
	
		var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
		
		var hasKongJie = false;
	
		for(var i = 0; i < sanFangStars.length; i ++){
			if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
				
				break;
			}
		}
	
		if(hasKongJie){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份是：农历' + resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC12_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");

	var mingTotalStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui'], mingSanFangSiZhengStars['dui']);
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var mingHasLianZhenWuQu = false;
	var mingHasKongJie = false;
	
	for(var i = 0; i < mingTotalStars.length; i ++){
		var starName = mingTotalStars[i].getName();
		
		if("MAINSTAR_WUQUXING" == starName){   // || "MAINSTAR_LIANZHENXING" == starName
			mingHasLianZhenWuQu = true;
		}
	}
	
	for(var i = 0; i < mingSanFangStars.length; i ++){
		var starName = mingSanFangStars[i].getName();
		
		if("FIENDSTAR_DIKONGXING" == starName || "FIENDSTAR_DIJIEXING" == starName){
			mingHasKongJie = true;
		}
	}
	
	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");

	var tianzhaiSanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui'], tianzhaiSanFangSiZhengStars['dui']);
	
	var tianzhaiHasLuCun = false,
		tianzhaiHasXianTianHuaLu = false,
		tianzhaiHasDaYunHuaLu = false,
		tianzhaiHasLiuNianHuaLu = false;
	
	for(var i = 0; i < tianzhaiSanFangStars.length; i ++){
		var starName = tianzhaiSanFangStars[i].getName();
		var liuNianSiHua = tianzhaiSanFangStars[i].getSiHuaOfLiuNian();
		var daYunSiHua = tianzhaiSanFangStars[i].getSiHuaOfDaYun();
		var xianTianSiHua = tianzhaiSanFangStars[i].getSiXiang();
		
		if(starName == "GEMSTAR_LUCUNXING"){
			tianzhaiHasLuCun = true;
		}
		
		if("SIHUA_LU" == xianTianSiHua){
			tianzhaiHasXianTianHuaLu = true;
		}
		
		if("SIHUA_LU" == liuNianSiHua){
			tianzhaiHasLiuNianHuaLu = true;
		}
		
		if("SIHUA_LU" == daYunSiHua){
			tianzhaiHasDaYunHuaLu = true;
		}
	}
	
	if(mingHasLianZhenWuQu && (tianzhaiHasLuCun || tianzhaiHasLiuNianHuaLu || tianzhaiHasDaYunHuaLu)){
		return JSON.stringify({
			request : 'B',
			useful : true
		});
	}
	
	if(tianzhaiHasLuCun && tianzhaiHasXianTianHuaLu && tianzhaiHasDaYunHuaLu && tianzhaiHasLiuNianHuaLu){
		return JSON.stringify({
			request : 'B',
			useful : true
		});
	}
	
	var tianzhaiCoincideAndHasLu = false;
	
	var sections = liuNianMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++){
		var dayunGongWei = sections[i].getDaYunGongWei();
		var liunianGongWei = sections[i].getLiuNianGongWei();
		var stars = sections[i]
		
		if(dayunGongWei == "GONGWEI_TIANZHAIGONG" && liunianGongWei == "GONGWEI_TIANZHAIGONG"){
			var isStrong = false;
			
			for(var j = 0; j < tianzhaiSanFangSiZhengStars['zuo'].length; j ++){
				var starName = tianzhaiSanFangSiZhengStars['zuo'][j].getName();
				
				if(starName.indexOf("MAINSTAR_") >= 0){
					isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
					
					break;
				}
			}
		
			if(isStrong && (tianzhaiHasLuCun || tianzhaiHasDaYunHuaLu || tianzhaiHasLiuNianHuaLu)){
				tianzhaiCoincideAndHasLu = true;
				
				break;
			}
		}
	}
	
	if(tianzhaiCoincideAndHasLu){
		return JSON.stringify({
			request : 'B',
			useful : true
		});
	}
	
	if(mingHasLianZhenWuQu && mingHasKongJie && (tianzhaiHasLuCun || tianzhaiHasLiuNianHuaLu || tianzhaiHasDaYunHuaLu)){
		return JSON.stringify({
			request : 'A',
			useful : true
		});
	}
	
	if(mingHasKongJie && tianzhaiCoincideAndHasLu){
		return JSON.stringify({
			request : 'A',
			useful : true
		});
	}
	
	var curUser = getCurrentUser().user;
	var mingJu = curUser.getUserInfo().getMingJu().index;
	var daYun = ZiWeiUtils.calcDaYunByXuSui(mingJu, liuNianMingPan.getXuSui());
	var daYunMingPan = curUser.getDaYunMingPan(daYun);
	var dyTZSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', daYunMingPan, "DaYunMingPan");
	var dyTZSanFangStars = dyTZSanFangSiZhengStars['zuo'].concat(dyTZSanFangSiZhengStars['hui']);
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(dyTZSanFangStars, "DaYunMingPan");
	
	if(shaNum == 0)
	{
		 for(var i = 0; i < sections.length; i ++)
		 {
			 var section = sections[i];
			 
			 if(section.getLiuNianGongWei() == "GONGWEI_TIANZHAIGONG")
			 {
				 var dyGongWei = section.getDaYunGongWei();
				 
				 if(dyGongWei == "GONGWEI_XIONGDIGONG" || dyGongWei == "GONGWEI_JIEGONG" || dyGongWei == "GONGWEI_TIANZHAIGONG")
				 {
					 return JSON.stringify({
						request : 'A',
						useful : true
					});
				 }
			 }
		 }
	}
	
	return JSON.stringify({
		request : 'C',
		useful : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC13_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			continue;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuYueMingPan, "LiuYueMingPan");
	
		var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
		
		var isStrong = false;
	
		for(var i = 0; i < sanFangStars.length; i ++){
			var starName = sanFangStars[i].getName();
			
			if(starName.indexOf("MAINSTAR_") >= 0){
				isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
				
				break;
			}
		}
	
		if(isStrong){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份是：农历' + resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC14_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			continue;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuYueMingPan, "LiuYueMingPan");
	
		var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui'], tianzhaiSanFangSiZhengStars['dui']);
		
		var hasKongJie = false;
	
		for(var i = 0; i < sanFangStars.length; i ++){
			if(sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
				
				break;
			}
		}
	
		if(hasKongJie){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份是：农历' + resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC15_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");

	var tianzhaiSanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
	
	var hasKongJieQingYang = false;
	
	for(var i = 0; i < tianzhaiSanFangStars.length; i ++){
		var starName = tianzhaiSanFangStars[i].getName();

		if("FIENDSTAR_QINGYANGXING" == starName || "FIENDSTAR_DIKONGXING" == starName || "FIENDSTAR_DIJIEXING" == starName){
			hasKongJieQingYang = true;
			
			break;
		}
	}
	
	if(hasKongJieQingYang){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC16_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			continue;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuYueMingPan, "LiuYueMingPan");
	
		var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
		
		var hasKongJieQingYang = false;
	
		for(var i = 0; i < sanFangStars.length; i ++){
			if(sanFangStars[i].getName() == "FIENDSTAR_QINGYANGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIKONGXING" || sanFangStars[i].getName() == "FIENDSTAR_DIJIEXING"){
				hasKongJieQingYang = true;
				
				break;
			}
		}
	
		if(hasKongJieQingYang){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '能量最强的月份是：农历' + resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC17_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuNianMingPan, "LiuNianMingPan");

	var caiboHasStrongMainStar = false;
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var starName = caiboSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			caiboHasStrongMainStar = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			
			break;
		}
	}
	
	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");

	var hasKongJieQingYang = false;
	
	for(var i = 0; i < tianzhaiSanFangSiZhengStars['zuo'].length; i ++){
		var starName = tianzhaiSanFangSiZhengStars['zuo'][i].getName();

		if("FIENDSTAR_QINGYANGXING" == starName || "FIENDSTAR_DIKONGXING" == starName || "FIENDSTAR_DIJIEXING" == starName){
			hasKongJieQingYang = true;
			
			break;
		}
	}
	
	if(caiboHasStrongMainStar && hasKongJieQingYang){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WC18_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan");
	var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
	
	var hasKongJieQingYang = false;
	var isStrong = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();

		if("FIENDSTAR_QINGYANGXING" == starName || "FIENDSTAR_DIKONGXING" == starName || "FIENDSTAR_DIJIEXING" == starName){
			hasKongJieQingYang = true;
		}
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
		}
	}
	
	if(isStrong && !hasKongJieQingYang){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(isStrong && hasKongJieQingYang){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
};

// 重新计算流日命盘的能量
WeiSuanQuestionAlgorithm.recalcEnergy4LiuRiMingPan = function(oldEnergy, liuRiMingPan, gongWei)
{	
	if(oldEnergy > 8)
	{
		var sections = liuRiMingPan.getItems();

		for(var i = 0; i < sections.length; i ++)
		{
			if(sections[i].getDayGongWei() == gongWei)
			{
				var stars = sections[i].getStars();
				
				for(var j = 0; j < stars.length; j ++)
				{
					if(stars[j].getName() == "FIENDSTAR_DIJIEXING")
					{
						oldEnergy = 6;
					}
					
					if(stars[j].getName() == "FIENDSTAR_TUOLUOXING" || stars[j].getName() == "FIENDSTAR_QINGYANGXING" ||stars[j].getName() == "FIENDSTAR_HUOXING" ||stars[j].getName() == "FIENDSTAR_LINGXING")
					{
						if(stars[j].getDescriptor() == "MIAOWANG_XIAN")
						{
							oldEnergy = 6;
						}
					}
				}
				
				break;
			}
		}
		
		if(oldEnergy != 6)
		{
			var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars(gongWei, liuRiMingPan, "LiuRiMingPan");
			var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui'], sanFangSiZhengStars['dui']);
			
			for(var i = 0; i < sanFangStars.length; i ++)
			{
				if("SIHUA_JI" == sanFangStars[i].getSiHuaOfLiuRi())
				{
					oldEnergy = 6;
					break;
				}
			}
		}
	}
	
	return oldEnergy;
}

// WC19我今日打牌的赢钱能量指数？
// 流日财帛宫和福德宫同为正能量暴强或强，同时命宫没有进空劫星
WeiSuanQuestionAlgorithm.iosInvoked_WC19_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboEnergyLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_CAIBOGONG", liuRiMingPan, "LiuRiMingPan");
	caiboEnergyLevel = WeiSuanQuestionAlgorithm.recalcEnergy4LiuRiMingPan(caiboEnergyLevel, liuRiMingPan, "GONGWEI_CAIBOGONG");
	
	var request = 'B';
	
	if(caiboEnergyLevel > 10)
	{
		var fudeEnergyLevel = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_FUDEGONG", liuRiMingPan, "LiuRiMingPan");
		fudeEnergyLevel = WeiSuanQuestionAlgorithm.recalcEnergy4LiuRiMingPan(fudeEnergyLevel, liuRiMingPan, "GONGWEI_FUDEGONG");
		
		if(fudeEnergyLevel > 10)
		{
			var mingSanFangSiZheng = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars("GONGWEI_MINGGONG", liuRiMingPan, "LiuRiMingPan");
			
			var stars = mingSanFangSiZheng['zuo'];
			
			for(var i = 0; i < stars.length; i ++)
			{
				var starName = stars[i].getName();
				
				if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING")
				{
					request = 'B';
					break;
				}
				
				request = 'A';
			}
		}
	}
	
	var result = {
		'request' : request,
		'useful' : true
	};
	
	return JSON.stringify(result);
};

// 我今天开销大吗？
WeiSuanQuestionAlgorithm.iosInvoked_WC20_al = function()
{
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuRiMingPan, "LiuRiMingPan");
	var caiboSanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui']);
	var caiboShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(caiboSanFangStars, "LiuRiMingPan");
	var xiongdiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_XIONGDIGONG', liuRiMingPan, "LiuRiMingPan");
	var xiongdiSanFangStars = xiongdiSanFangSiZhengStars['zuo'].concat(xiongdiSanFangSiZhengStars['hui']);
	var xiongdiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(xiongdiSanFangStars, "LiuRiMingPan");
	var xiongdiHasLiuRiHasJi = false;
	var caiboZuoJi = false;
	var caiboSanFangHasKongJie = false;
	var xiongdiSanFangHasKongJie = false;
	
	for(var i = 0; i < caiboSanFangSiZhengStars['zuo'].length; i ++){
		var siHua = caiboSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuRi();
		
		if("SIHUA_JI" == siHua){
			caiboZuoJi = true;
			break;
		}
	}
	
	for(var i = 0; i < caiboSanFangStars.length; i ++){
		var starName = caiboSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			caiboSanFangHasKongJie = true;
			
			break;
		}
	}

	for(var i = 0; i < xiongdiSanFangStars.length; i ++){
		if(xiongdiSanFangStars[i].getSiHuaOfLiuRi() == "SIHUA_JI"){
			xiongdiHasLiuRiHasJi = true;
		}
		
		var starName = xiongdiSanFangStars[i].getName();
		
		if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
			xiongdiSanFangHasKongJie = true;
		}
	}

	if(caiboShaNum <= 2 && !xiongdiHasLiuRiHasJi && !caiboSanFangHasKongJie){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 4){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboZuoJi && xiongdiSanFangHasKongJie && xiongdiShaNum >= 3){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	if(caiboShaNum >= 3 && xiongdiHasLiuRiHasJi && caiboSanFangHasKongJie){
		return JSON.stringify({
			'request' : 'C',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
}

// 我今年一年下来炒股能赚到钱吗？
WeiSuanQuestionAlgorithm.iosInvoked_WC21_al = function()
{
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var caiBoSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_CAIBOGONG', liuNianMingPan, "LiuNianMingPan");
	var sanFangStars = caiBoSanFangSiZhengStars['zuo'].concat(caiBoSanFangSiZhengStars['hui']);
	
	for(var i = 0; i < sanFangStars.length; i ++)
	{
		var starName = sanFangStars[i].getName();

		if("GEMSTAR_ZUOFUXING" == starName || "GEMSTAR_YOUBIXING" == starName)
		{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
}

WeiSuanQuestionAlgorithm.iosInvoked_WX1_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasKongJie = false;
	var isStrong = false;
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();

		if("FIENDSTAR_DIKONGXING" == starName || "FIENDSTAR_DIJIEXING" == starName){
			hasKongJie = true;
		}
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
		}
	}
	
	if(hasChangQu && !hasKongJie){
		if(isStrong){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}else{
			return JSON.stringify({
				'request' : 'B',
				'useful' : true,
				'redirect' :{
					'txt' : '激发正能量神器开运猫恭请',
					'module' : 'KYM',
					'param' : {
						'productId' : 1
					}
				}
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WX2_al_stub = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_SHIYEGONG', liuNianMingPan, "LiuNianMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	if(hasChangQu){
		return 'A';
	}
	
	return 'B';
};

WeiSuanQuestionAlgorithm.iosInvoked_WX2_al = function(){
	var request = WeiSuanQuestionAlgorithm.iosInvoked_WX2_al_stub();
	
	return JSON.stringify({
		'request' : request,
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WX3_al = function(){
	var request = WeiSuanQuestionAlgorithm.iosInvoked_WX2_al_stub();
	
	return JSON.stringify({
		'request' : request,
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WX4_al = function(){
	var request = WeiSuanQuestionAlgorithm.iosInvoked_WX2_al_stub();
	
	return JSON.stringify({
		'request' : request,
		'useful' : true,
		'redirect' :{
			'txt' : '激发正能量神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WX5_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_SHIYEGONG', liuYueMingPan, "LiuYueMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	var hasEnGuangTianGui = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
			break;
		}
	}
	
	for(var i = 0; i < shiyeSanFangSiZhengStars['zuo'].length; i ++)
	{
		var starName = shiyeSanFangSiZhengStars['zuo'][i].getName();
		
		if("NORMALSTAR_ENGUANGXING" == starName || "NORMALSTAR_TIANGUIXING" == starName){
			hasEnGuangTianGui = true;
			break;
		}
	}
	
	if(hasChangQu || hasEnGuangTianGui){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WX6_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}

	var shiyeSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_SHIYEGONG', liuRiMingPan, "LiuRiMingPan");
	var sanFangStars = shiyeSanFangSiZhengStars['zuo'].concat(shiyeSanFangSiZhengStars['hui']);
	
	var hasChangQu = false;
	var hasEnGuangTianGui = false;
	
	for(var i = 0; i < sanFangStars.length; i ++){
		var starName = sanFangStars[i].getName();
		
		if("GEMSTAR_WENCHANGXING" == starName || "GEMSTAR_WENQUXING" == starName){
			hasChangQu = true;
		}
	}
	
	for(var i = 0; i < shiyeSanFangSiZhengStars['zuo'].length; i ++)
	{
		var starName = shiyeSanFangSiZhengStars['zuo'][i].getName();
		
		if("NORMALSTAR_ENGUANGXING" == starName || "NORMALSTAR_TIANGUIXING" == starName){
			hasEnGuangTianGui = true;
			break;
		}
	}
	
	if(hasChangQu || hasEnGuangTianGui){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WT1_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var calendar = new PerpetualCalendar();
	
	var totalMonths = new Array();
	
	var thisMonth = curLunarDate.month;
	
	if(thisMonth == 12){
		var curYear = curLunarDate.year-1901 + 1;
	
		var basePerpetualCalenderItem = calendar.getCalendar()[curYear];    // 获取下一年的数据
		
		var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
		var monthInfo = basePerpetualCalenderItem.monthInfo;
		
		for(var i = 0; i < monthInfo.length; i ++){
			var monthIndex = false, isRunYue = false;
			
			if(i < runYueIndex){
				monthIndex = i + 1;
			}else if(i == runYueIndex){
				monthIndex = runYueIndex;
				isRunYue = true;
			}else if(i > runYueIndex){
				if(runYueIndex > 0){
					monthIndex = i;
				}else{
					monthIndex = i + 1;
				}
			}
			
			if(isRunYue){
				continue;
			}
			
			totalMonths.push({
				'year' : curLunarDate.year + 1,
				'month' : monthIndex
			});
		}
	}else{
		var curYear = curLunarDate.year-1901;
		var curMonth = curLunarDate.month;
		
		var basePerpetualCalenderItem = calendar.getCalendar()[curYear];    // 获取今年的数据
		
		var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
		var monthInfo = basePerpetualCalenderItem.monthInfo;
		
		for(var i = 0; i < monthInfo.length; i ++){
			var monthIndex = false, isRunYue = false;
			
			if(i < runYueIndex){
				monthIndex = i + 1;
			}else if(i == runYueIndex){
				monthIndex = runYueIndex;
				isRunYue = true;
			}else if(i > runYueIndex){
				if(runYueIndex > 0){
					monthIndex = i;
				}else{
					monthIndex = i + 1;
				}
			}
			
			if(isRunYue || monthIndex <= curMonth){
				continue;
			}
			
			totalMonths.push({
				'year' : curLunarDate.year,
				'month' : monthIndex
			});
		}
		
		var leftSize = 12 - totalMonths.length;
		
		basePerpetualCalenderItem = calendar.getCalendar()[curYear + 1];    // 获取下一年的数据
		
		runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
		monthInfo = basePerpetualCalenderItem.monthInfo;
		
		for(var i = 0; i < monthInfo.length; i ++){
			var monthIndex = false, isRunYue = false;
			
			if(i < runYueIndex){
				monthIndex = i + 1;
			}else if(i == runYueIndex){
				monthIndex = runYueIndex;
				isRunYue = true;
			}else if(i > runYueIndex){
				if(runYueIndex > 0){
					monthIndex = i;
				}else{
					monthIndex = i + 1;
				}
			}
			
			if(monthIndex > leftSize){
				break;
			}
			
			if(isRunYue){
				continue;
			}
			
			totalMonths.push({
				'year' : curLunarDate.year + 1,
				'month' : monthIndex
			});
		}
	}
	
	
	var monthResultArray = new Array();
	
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	
	for(var i = 0; i < totalMonths.length; i ++){
		var liuYueMingPan = curUser.getLiuYueMingPan(totalMonths[i].year, totalMonths[i].month, false);

		if(!liuYueMingPan){
			return false;
		}
		
		var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUQIGONG', liuYueMingPan, "LiuYueMingPan", true);
	
		var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
		var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
		
		var hasZuoYou = false;
		var hasKongJie = false;
		var hasLucun = false;
		var hasTianMa = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var starName = sanFangStars[j].getName();
			
			if(starName == "GEMSTAR_ZUOFUXING" || starName == "GEMSTAR_YOUBIXING"){
				hasZuoYou = true;
			}
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
			}
			
			if(starName == "GEMSTAR_LUCUNXING"){
				hasLucun = true;
			}
			
			if(starName == "GEMSTAR_TIANMAXING"){
				hasTianMa = true;
			}
		}
		
		var hasLuKe = false;
		for(var j = 0; j < totalStars.length; j ++){
			var liuNianSiHua = totalStars[j].getSiHuaOfLiuNian();
			var liuYueSiHua = totalStars[j].getSiHuaOfLiuYue();
			
			if(liuNianSiHua == "SIHUA_LU" || liuNianSiHua == "SIHUA_KE"){
				hasLuKe = true;
			}
			
			if(liuYueSiHua == "SIHUA_LU" || liuYueSiHua == "SIHUA_KE"){
				hasLuKe = true;
			}
		}
		
		if(!(hasZuoYou || hasKongJie) && hasLuKe && !(hasTianMa && hasLucun)){
			var monthName = defaultLunarMonth[totalMonths[i].month - 1];
			
			monthResultArray.push(totalMonths[i].year + "年" + monthName);
		}
	}
	
	if(monthResultArray.length == 0){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '没有匹配的月份，抱歉，不扣天币。'
		});
	}else{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'append' : '月份是农历'+monthResultArray.join("、")+',在以上月份中在根据中国黄历喜嫁娶日做筛选就吉上加吉。择日的目的是让最强的正能量从此刻开始！好的开始就已经成功了一半。'
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WT2_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curGregorianDate = WeiSuanQuestionUtil.getCurrentGregorianDate();
	
	if(!curGregorianDate){
		return false;
	}
	
	var resultArray = new Array();
	
	for(var i = 0; i < 183; i ++){
		var newDate = PerpetualCalendar.add(curGregorianDate, i);
		
		var newLunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(newDate.getFullYear(), newDate.getMonth() + 1, newDate.getDate(), 0);
		
		if(newLunarDate.isRunYue){
			continue;           // 不考虑闰月
		}
		
		var newLiuRiMingPan = curUser.getLiuRiMingPan(newLunarDate.year, newLunarDate.month, newLunarDate.day, newLunarDate.isRunYue);
		
		if(!newLiuRiMingPan){
			return false;
		}
		
		var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUQIGONG', newLiuRiMingPan, "LiuRiMingPan", true);
		
		var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui']);
		var totalStars = sanFangStars.concat(fuqiSanFangSiZhengStars['dui']);
		
		var hasKongJie = false;
		var hasZuoYou = false;
		var hasLuCun = false;
		var hasTianMa = false;
		var hasLuKe = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var starName = sanFangStars[j].getName();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
			}
			
			if(starName == "GEMSTAR_ZUOFUXING" || starName == "GEMSTAR_YOUBIXING"){
				hasZuoYou = true;
			}
			
			if(starName == "GEMSTAR_LUCUNXING"){
				hasLuCun = true;
			}
			
			if(starName == "GEMSTAR_TIANMAXING"){
				hasTianMa = true;
			}
		}
		
		for(var j = 0; j < totalStars.length; j ++){
			var liuRiSiHua = totalStars[j].getSiHuaOfLiuRi();
			
			if(liuRiSiHua == "SIHUA_LU" || liuRiSiHua == "SIHUA_KE"){
				hasLuKe = true;
				break;
			}
		}
		
		if(!(hasKongJie || hasZuoYou) && hasLuKe && !(hasLuCun && hasTianMa)){
			resultArray.push(newDate);
		}
	}
	
	if(resultArray.length == 0){
		return JSON.stringify({
			'request' : 'false',
			'useful' : 'false',
			'append' : '没有匹配的日子，抱歉，不扣天币。'
		});
	}else{ 
		var completeDateStrArray = new Array();
	
		for(var m = 0; m < resultArray.length; m ++){
			completeDateStrArray.push(PerpetualCalendar.formatDateString(resultArray[m]));
		}
	
		return JSON.stringify({
			'request' : 'A',
			'useful' : 'true',
			'append' : completeDateStrArray.join("、")
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WT3_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curGregorianDate = WeiSuanQuestionUtil.getCurrentGregorianDate();
	
	if(!curGregorianDate){
		return false;
	}
	
	var resultArray = new Array();
	
	for(var i = 0; i < 92; i ++){
		var newDate = PerpetualCalendar.add(curGregorianDate, i);
		
		var newLunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(newDate.getFullYear(), newDate.getMonth() + 1, newDate.getDate(), 0);
		
		if(newLunarDate.isRunYue){
			continue;           // 不考虑闰月
		}
		
		var newLiuRiMingPan = curUser.getLiuRiMingPan(newLunarDate.year, newLunarDate.month, newLunarDate.day, newLunarDate.isRunYue);
		
		if(!newLiuRiMingPan){
			return false;
		}
		
		var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_TIANZHAIGONG', newLiuRiMingPan, "LiuRiMingPan", true);
		
		var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui'], tianzhaiSanFangSiZhengStars['dui']);
		
		var hasKongJie = false;
		var hasLuKe = false;
		
		var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var starName = sanFangStars[j].getName();
			var siHua = sanFangStars[j].getSiHuaOfLiuRi();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
			}
			
			if(siHua == "SIHUA_LU" || siHua == "SIHUA_KE"){
				hasLuKe = true;
			}
		}
		
		if(!(hasKongJie) && hasLuKe && shaNum < 3){
			resultArray.push(newDate);
		}
	}
	
	if(resultArray.length == 0){
		return JSON.stringify({
			'request' : 'false',
			'useful' : 'false',
			'append' : '没有匹配的日子，抱歉，不扣天币。'
		});
	}else{ 
		var completeDateStrArray = new Array();
	
		for(var m = 0; m < resultArray.length; m ++){
			completeDateStrArray.push(PerpetualCalendar.formatDateString(resultArray[m]));
		}
	
		return JSON.stringify({
			'request' : 'A',
			'useful' : 'true',
			'append' : completeDateStrArray.join("、")
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WT4_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curGregorianDate = WeiSuanQuestionUtil.getCurrentGregorianDate();
	
	if(!curGregorianDate){
		return false;
	}
	
	var resultArray = new Array();
	
	for(var i = 0; i < 92; i ++){
		var newDate = PerpetualCalendar.add(curGregorianDate, i);
		
		var newLunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(newDate.getFullYear(), newDate.getMonth() + 1, newDate.getDate(), 0);
		
		if(newLunarDate.isRunYue){
			continue;           // 不考虑闰月
		}
		
		var newLiuRiMingPan = curUser.getLiuRiMingPan(newLunarDate.year, newLunarDate.month, newLunarDate.day, newLunarDate.isRunYue);
		
		if(!newLiuRiMingPan){
			return false;
		}
		
		var caiboSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_CAIBOGONG', newLiuRiMingPan, "LiuRiMingPan", true);
		
		var sanFangStars = caiboSanFangSiZhengStars['zuo'].concat(caiboSanFangSiZhengStars['hui'], caiboSanFangSiZhengStars['dui']);
		
		var hasKongJie = false;
		var hasLuKe = false;
		var isStrong = false;
		
		var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan");
		
		for(var m = 0; m < caiboSanFangSiZhengStars['zuo'].length; m ++){
			var starName = caiboSanFangSiZhengStars['zuo'][m].getName();
			
			if(starName.indexOf("MAINSTAR_") >= 0){
				isStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
				
				break;
			}
		}
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var starName = sanFangStars[j].getName();
			var siHua = sanFangStars[j].getSiHuaOfLiuRi();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
			}
			
			if(siHua == "SIHUA_LU" || siHua == "SIHUA_KE"){
				hasLuKe = true;
			}
		}
		
		if(isStrong && !hasKongJie && hasLuKe && shaNum < 3){
			resultArray.push(newDate);
		}
	}
	
	if(resultArray.length == 0){
		return JSON.stringify({
			'request' : 'false',
			'useful' : 'false',
			'append' : '没有匹配的日子，抱歉，不扣天币。'
		});
	}else{ 
		var completeDateStrArray = new Array();
	
		for(var m = 0; m < resultArray.length; m ++){
			completeDateStrArray.push(PerpetualCalendar.formatDateString(resultArray[m]));
		}
	
		return JSON.stringify({
			'request' : 'A',
			'useful' : 'true',
			'append' : completeDateStrArray.join("、")
		});
	}
};

// 最近1年正能量最佳的整容好日子？
// 算法：选择流月为贪狼化禄或者太阴化禄的，在这两个月份里选择流日命宫三方会贪狼化禄或太阴化禄的日子。
WeiSuanQuestionAlgorithm.iosInvoked_WT5_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	var suitableMonth = new Array();
	
	var thisYearSuitableMonth = WeiSuanQuestionAlgorithm.getSuitableLiuYue(curLunarDate.year, curLunarDate.month, 12);
	suitableMonth = suitableMonth.concat(thisYearSuitableMonth);
	
	
	if(curLunarDate.month != 1)
	{
		var nextYearSuitableMonth =  WeiSuanQuestionAlgorithm.getSuitableLiuYue(curLunarDate.year + 1, 1, curLunarDate.month - 1); 
		suitableMonth = suitableMonth.concat(nextYearSuitableMonth);
	}
	
	var days = new Array();
	
	for(var i = 0; i < suitableMonth.length; i ++)
	{
		days = days.concat(WeiSuanQuestionAlgorithm.getSuitableDays4WT5(suitableMonth[i].year, suitableMonth[i].month, 1, suitableMonth[i].monthLength, suitableMonth[i].isRunYue));
	}
	
	var result = {
		'request' : false,
		'useful' : false,
		'append' : '没有匹配的日子，抱歉，不扣天币。'
	}
	
	if(days.length != 0)
	{
		var str = "";
		
		for(var i = 0; i < days.length; i ++)
		{
			var gDate = PerpetualCalendar.convertLunarDate2GregorianDate(days[i].year, days[i].month, days[i].day, 0, days[i].isRunYue)
			
			str += (gDate.getFullYear() + "年") + ((gDate.getMonth() + 1)+ "月") +  (gDate.getDate() + "日");
			
			if(i < days.length - 1)
			{
				str += "、";
			}
			else
			{
				str += "。";
			}
		}
		
		result = {
			'request' : 'A',
			'useful' : true,
			'append' : str
		}
	}

	return JSON.stringify(result);
};

WeiSuanQuestionAlgorithm.getSuitableLiuYue = function(year, fromMonth, toMonth)
{
	var thisYearCalendar = new PerpetualCalendar().getCalendar()[year - 1901];
	
	var runYueIndex = thisYearCalendar.runYueIndex;
	
	var suitableMonth = new Array();
	
	for(var i = fromMonth; i <= toMonth; i ++)
	{
		var liuYueMingPan = getCurrentUser().user.getLiuYueMingPan(year, i, false);
		
		var isSuitable = WeiSuanQuestionAlgorithm.isSuitableLiuYue(liuYueMingPan);
		
		if(isSuitable)
		{
			suitableMonth.push({
				year : year,
				month : i,
				monthLength : thisYearCalendar.monthInfo[(runYueIndex > 0 && i > runYueIndex) ?  i : (i-1)],
				isRunYue : false
			});
		}
	}
	
	if(runYueIndex > 0)
	{
		if(runYueIndex >= fromMonth && runYueIndex <= toMonth)
		{
			var liuYueMingPan = getCurrentUser().user.getLiuYueMingPan(year, runYueIndex, true);
		
			var isSuitable = WeiSuanQuestionAlgorithm.isSuitableLiuYue(liuYueMingPan);
			
			if(isSuitable)
			{
				suitableMonth.push({
					year : year,
					month : runYueIndex,
					monthLength : thisYearCalendar.monthInfo[runYueIndex],
					isRunYue : true
				});
			}
		}
	}
	
	return suitableMonth;
};

// 获取流月中适合的日期
WeiSuanQuestionAlgorithm.getSuitableDays4WT5 = function(year, month, startDay, monthLength, isRunYue)
{
	var suitableDays = new Array();
	
	for(var i = startDay; i <= monthLength; i ++ )
	{
		var liuRiMingPan = getCurrentUser().user.getLiuRiMingPan(year, month, i, isRunYue);
		
		var isSuitable = WeiSuanQuestionAlgorithm.isSuitableDay(liuRiMingPan);
		
		if(isSuitable)
		{
			suitableDays.push({
				year : year,
				month : month,
				day : i,
				isRunYue : isRunYue
			});
		}
	}
	
	return suitableDays;
};

// 判断是否适合的日期
WeiSuanQuestionAlgorithm.isSuitableDay = function(liuRiMingPan)
{
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		var stars = sections[i].getStars();
		
		for(var j = 0; j < stars.length; j ++)
		{
				var starName = stars[j].getName();
				if(starName.indexOf("MAINSTAR_") >= 0)
				{
					if(starName == "MAINSTAR_TANLANGXING" || starName == "MAINSTAR_TAIYINXING")
					{
						var siHua = stars[j].getSiHuaOfLiuRi();
						
						if(siHua == "SIHUA_LU")
						{
							return true;
						}
				   }
			  }
		}
	}
   
   return false;
};

// 流月是否为贪狼化禄或者太阴化禄
WeiSuanQuestionAlgorithm.isSuitableLiuYue = function(liuYueMingPan)
{
	var sections = liuYueMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		var stars = sections[i].getStars();
		
		for(var j = 0; j < stars.length; j ++)
		{
				var starName = stars[j].getName();
				if(starName.indexOf("MAINSTAR_") >= 0)
				{
					if(starName == "MAINSTAR_TANLANGXING" || starName == "MAINSTAR_TAIYINXING")
					{
						var siHua = stars[j].getSiHuaOfLiuYue();
						
						if(siHua == "SIHUA_LU")
						{
							return true;
						}
				   }
			  }
		}
	}
   
   return false;
};

WeiSuanQuestionAlgorithm.iosInvoked_WD1_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var sections = liuRiMingPan.getItems();
	
	for(var i = 0; i < sections.length; i ++)
	{
		var liuRiGongWei = sections[i].getDayGongWei();
		
		if(liuRiGongWei == "GONGWEI_MINGGONG" || liuRiGongWei == "GONGWEI_FUQIGONG" || liuRiGongWei == "GONGWEI_ZINVGONG" || liuRiGongWei == "GONGWEI_JIEGONG")
		 {
			var liuNianJiangQian = sections[i].getLiuNianJiangQian();
			 
			if(liuNianJiangQian == "LIUNIANJIANGQIAN_XIANCHI")
			{
				return JSON.stringify({
					'request' : 'A',
					'useful' : true
				});
			}
			 
			var stars = sections[i].getStars();
			
			for(var j = 0; j < stars.length; j ++)
			{
				if("MAINSTAR_TANLANGXING" == stars[j].getName()){
					return JSON.stringify({
						'request' : 'A',
						'useful' : true
					});
				}
			}
		 }
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WD2_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}

	var defaultAnswer = {
		'MAINSTAR_ZIWEIXING' : '品牌酒店',
		'MAINSTAR_TIANFUXING' : '高档大酒店',
		'MAINSTAR_TIANXIANGXING' : '豪华酒店',
		'MAINSTAR_LIANZHENXING' : '情侣酒店',
		'MAINSTAR_WUQUXING' : '经济酒店',
		'MAINSTAR_QISHAXING' : '酒店',
		'MAINSTAR_POJUNXING' : '旅游景区',
		'MAINSTAR_TANLANGXING' : '夜店 会所 情调酒店',
		'MAINSTAR_TAIYANGXING' : '郊外',
		'MAINSTAR_TAIYINXING' : '海景房 湖景别墅',
		'MAINSTAR_TIANLIANGXING' : '古镇',
		'MAINSTAR_TIANTONGXING' : '露营',
		'MAINSTAR_JUMENXING' : '便捷酒店 厨房',
		'MAINSTAR_TIANJIXING' : '客厅 车里'
	};
	
	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_ZINVGONG', liuRiMingPan, "LiuRiMingPan");
	
	var resultArray = new Array();
	
	for(var i = 0; i < zinvSanFangSiZhengStars['zuo'].length; i ++){
		var starName = zinvSanFangSiZhengStars['zuo'][i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0){
			resultArray.push(defaultAnswer[starName]);
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : resultArray.join(" ")
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WD3_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var sections = liuNianMingPan.getItems();
	
	for(var m = 0; m < sections.length; m ++)
	{
		var liuNianGongWei = sections[m].getLiuNianGongWei();
		
		if(liuNianGongWei == "GONGWEI_MINGGONG" || liuNianGongWei == "GONGWEI_FUQIGONG" || liuNianGongWei == "GONGWEI_ZINVGONG" || liuNianGongWei == "GONGWEI_JIEGONG")
		 {
			var liuNianJiangQian = sections[m].getLiuNianJiangQian();
			 
			if(liuNianJiangQian == "LIUNIANJIANGQIAN_XIANCHI")
			{				
				var curYear = liuNianMingPan.getYear();
				var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
				var calendar = new PerpetualCalendar();
				var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
				var runYueIndex = basePerpetualCalenderItem.runYueIndex;
				var monthInfo = basePerpetualCalenderItem.monthInfo;
				var monthArray = new Array();
				
				for(var i = 0; i < monthInfo.length; i ++)
				{
					var monthIndex, isRunYue = false;
					
					if(i < runYueIndex){
						monthIndex = i + 1;
					}else if(i == runYueIndex){
						monthIndex = runYueIndex;
						isRunYue = true;
					}else if(i > runYueIndex){
						if(runYueIndex > 0){
							monthIndex = i;
						}else{
							monthIndex = i + 1;
						}
					}
					
					var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

					if(!liuYueMingPan){
						return false;
					}
					
					var liuYueSections = liuYueMingPan.getItems();
	
					for(var j = 0; j < liuYueSections.length; j ++)
					{
						var liuYueGongWei = liuYueSections[j].getMonthGongWei();
		
						if(liuYueGongWei == "GONGWEI_ZINVGONG" || liuYueGongWei == "GONGWEI_JIEGONG")
						{
							var liuNianJiangQian = liuYueSections[j].getLiuNianJiangQian();
			 
							if(liuNianJiangQian == "LIUNIANJIANGQIAN_XIANCHI")
							{
								var monthName = defaultLunarMonth[monthIndex-1];
								monthName = isRunYue ? "闰" : "" + monthName;
								monthArray.push(monthName);
							}
						}
					}
				}
				
				if(monthArray.length > 0)
				{
					return JSON.stringify({
						'request' : 'A',
						'useful' : true,
						'append' : '尤其在农历的' + monthArray.join('、') + '的能量最强。'
					});
				}
				else
				{
					return JSON.stringify({
						'request' : 'A',
						'useful' : true
					});
				}
			}
		 }
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WY1_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	if(curUser.getUserInfo().getGender() == "GENDER_NAN"){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '此问题仅对女士有效。'
		});
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}

	var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_ZINVGONG', liuNianMingPan, "LiuNianMingPan");
	var ziNvSanFangStars = zinvSanFangSiZhengStars['zuo'].concat(zinvSanFangSiZhengStars['hui']);
	var ziNvLiuNianHuaQuan = false;
	var ziNvDaYunHuaQuan = false;
	var ziNvHasHongLuanTianXi = false;
	
	for(var i = 0; i < ziNvSanFangStars.length; i ++)
	{
		var liuNianSiHua = ziNvSanFangStars[i].getSiHuaOfLiuNian();
		
		if(liuNianSiHua == "SIHUA_QUAN")
		{
			ziNvLiuNianHuaQuan = true;
		}
		
		var daYunSiHua = ziNvSanFangStars[i].getSiHuaOfDaYun();
		
		if(daYunSiHua == "SIHUA_QUAN")
		{
			ziNvDaYunHuaQuan = true;
		}
		
		var starName = ziNvSanFangStars[i].getName();
		
		if(starName == "NORMALSTAR_TIANXIXING" || starName == "NORMALSTAR_HONGLUANXING")
		{
			ziNvHasHongLuanTianXi = true;
		}
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	var mingHasHongLuanTianXi = false;
	var mingLiuNianHuaQuan = false;
	
	for(var i = 0; i < mingSanFangStars.length; i ++)
	{
		var starName = mingSanFangStars[i].getName();
		
		if(starName == "NORMALSTAR_TIANXIXING" || starName == "NORMALSTAR_HONGLUANXING")
		{
			mingHasHongLuanTianXi = true;
		}
	}
	
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++)
	{
		var liuNianSiHua = mingSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuNian();
		
		if(liuNianSiHua == "SIHUA_QUAN")
		{
			mingLiuNianHuaQuan = true;
		}
	}
	
	if((ziNvLiuNianHuaQuan && ziNvHasHongLuanTianXi) || (ziNvLiuNianHuaQuan && mingHasHongLuanTianXi) 
		|| (ziNvDaYunHuaQuan && ziNvHasHongLuanTianXi) || (ziNvDaYunHuaQuan && mingHasHongLuanTianXi) || (mingLiuNianHuaQuan && ziNvHasHongLuanTianXi))
	{
		var items = liuNianMingPan.getItems();
		var liuNianZiNvIndex = -1;

		for(var i = 0; i < items.length; i ++)
		{
			if(items[i].getLiuNianGongWei() == "GONGWEI_ZINVGONG")
			{
				liuNianZiNvIndex = i;
				break;
			}
		}
		
		var monthIndexs = [items[liuNianZiNvIndex]._month.index, items[(liuNianZiNvIndex + 4) % 12]._month.index, items[(liuNianZiNvIndex + 8) % 12]._month.index];
		monthIndexs = monthIndexs.sort(function(a,b){return a -b;});

		var months = [];
		
		for(var i = 0; i < monthIndexs.length; i ++)
		{
			months.push(Translator.translate(Util.getLunarMonthByIndex(monthIndexs[i] - 1).name));
		}


		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'append' : '尤其在农历' + months.join("、") + " 概率最高。"
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WY2_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var gender = curUser.getUserInfo().getGender();
	
	if(gender == "GENDER_NAN"){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '此问题仅对女士有效。'
		});
	}
	
	var curGregorianDate = WeiSuanQuestionUtil.getCurrentGregorianDate();
	
	if(!curGregorianDate){
		return false;
	}
	
	var resultArray = new Array();
	
	for(var i = 0; i < 30; i ++){
		var newDate = PerpetualCalendar.add(curGregorianDate, i);
		
		var newLunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(newDate.getFullYear(), newDate.getMonth() + 1, newDate.getDate(), 0);
		
		var newLiuRiMingPan = curUser.getLiuRiMingPan(newLunarDate.year, newLunarDate.month, newLunarDate.day, newLunarDate.isRunYue);
		
		if(!newLiuRiMingPan){
			return false;
		}
		
		var sections = newLiuRiMingPan.getItems();
		
		for(var j = 0; j < sections.length; j ++){
			var liuRiGongWei = sections[j].getDayGongWei();
			
			if(liuRiGongWei.indexOf('GONGWEI_ZINVGONG') >= 0){
				var stars = sections[j].getStars();
				
				var isStrong = false;
				var hasKongJie = false;
				
				for(var s = 0; s < stars.length; s ++){
					var starName = stars[s].getName();
					
					if(starName.indexOf("MAINSTAR_") >= 0){
						WeiSuanQuestionUtil.mainStarsIsStrong(starName);
					}
					
					if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
						hasKongJie = true;
					}
				}
				
				var zinvSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_ZINVGONG', newLiuRiMingPan, "LiuRiMingPan", true);
		
				var sanFangStars = zinvSanFangSiZhengStars['zuo'].concat(zinvSanFangSiZhengStars['hui'],zinvSanFangSiZhengStars['dui']);
				
				var hasLu = false;
				
				for(var t = 0; t < sanFangStars.length; t ++){
				//	var liuNianHuaLu = sanFangStars[t].getSiHuaOfLiuNian();
				//	var liuYueHuaLu = sanFangStars[t].getSiHuaOfLiuYue();
					var liuRiHuaLu = sanFangStars[t].getSiHuaOfLiuRi();
				//	var daYunHuaLu = sanFangStars[t].getSiHuaOfDaYun();
				//	var xiantianHuaLu = sanFangStars[t].getSiXiang();
				// liuNianHuaLu == "SIHUA_LU" || liuYueHuaLu == "SIHUA_LU" ||  || daYunHuaLu == "SIHUA_LU" || xiantianHuaLu == "SIHUA_LU"
					if(liuRiHuaLu == "SIHUA_LU"){
						hasLu = true;
						
						break;
					}
				}
				
				if(!hasKongJie){
					if(isStrong){
						resultArray.push(newDate);
					}else if(hasLu){
						resultArray.push(newDate);
					}
				}
			}
		}
	}
	
	if(resultArray.length == 0){
		return JSON.stringify({
			'request' : 'false',
			'useful' : 'false',
			'append' : '抱歉最近一个月内没有找到。'
		});
	}else{ 
		var completeDateStrArray = new Array();
	
		for(var m = 0; m < resultArray.length; m ++){
			completeDateStrArray.push(PerpetualCalendar.formatDateString(resultArray[m]));
		}
	
		return JSON.stringify({
			'request' : 'A',
			'useful' : 'true',
			'append' : '最近一月内的能量高的日子是' + completeDateStrArray.join("、")
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WY3_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var gender = curUser.getUserInfo().getGender();
	
	if(gender == "GENDER_NV"){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '此问题仅对男士有效。'
		});
	}
	
	var lunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!lunarDate){
		return false;
	}
	
	var thisLunarYear = lunarDate.year;
	
	var resultArray = new Array();
	
	for(var i = 0; i < 4; i ++){
		var liuNianMingPan = curUser.getLiuNianMingPan(thisLunarYear + i);
		
		
		var fuqiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUQIGONG', liuNianMingPan, "LiuNianMingPan", true);
		
		var sanFangStars = fuqiSanFangSiZhengStars['zuo'].concat(fuqiSanFangSiZhengStars['hui'],fuqiSanFangSiZhengStars['dui']);
		
		var hasKongJie = false;
		var hasLiuNianHuaJiQuan = false;
		
		for(var j = 0; j < sanFangStars.length; j ++){
			var starName = sanFangStars[j].getName();
			var liuNianSiHua = sanFangStars[j].getSiHuaOfLiuNian();
			
			if(starName == "FIENDSTAR_DIKONGXING" || starName == "FIENDSTAR_DIJIEXING"){
				hasKongJie = true;
			}
			
			if(liuNianSiHua == "SIHUA_QUAN" || liuNianSiHua == "SIHUA_JI"){
				hasLiuNianHuaJiQuan = true;
			}
		}
		
		if(hasLiuNianHuaJiQuan || hasKongJie){
			resultArray.push(thisLunarYear + i);
		}
	}
	
	if(resultArray.length == 0){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}else{
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'append' : resultArray.join("、") + " 这些年相对正能量最高。"
		});
	}
};

WeiSuanQuestionAlgorithm.iosInvoked_WF1_al = function()
{
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan)
	{
		return false;
	}
	
	var fumuSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUMUGONG', liuNianMingPan, "LiuNianMingPan", true);
	var zuoStars = fumuSanFangSiZhengStars['zuo'];
	
	for(var i = 0; i < zuoStars.length; i ++)
	{
		var starName = zuoStars[i].getName();
		
		if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_LIANZHENXING")
		{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WF2_al = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan)
	{
		return false;
	}
	
	var fumuSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUMUGONG', liuYueMingPan, "LiuYueMingPan", true);
	var zuoStars = fumuSanFangSiZhengStars['zuo'];

	for(var i = 0; i < zuoStars.length; i ++)
	{
		var starName = zuoStars[i].getName();
		
		if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_LIANZHENXING")
		{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WF3_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var fumuSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUMUGONG', liuNianMingPan, "LiuNianMingPan", true);
		
	var sanFangStars = fumuSanFangSiZhengStars['zuo'].concat(fumuSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");
	
	var totalStars = sanFangStars.concat(fumuSanFangSiZhengStars['dui']);
	
	var huiJi = false;
	for(var i = 0; i < totalStars.length; i ++){
		var siHua = totalStars[i].getSiHuaOfLiuNian();
		
		if(siHua == "SIHUA_JI"){
			huiJi = true;
			
			break;
		}
	}
	
	if(huiJi || shaNum >= 3){
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WF4_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var fumuSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_FUMUGONG', liuNianMingPan, "LiuNianMingPan", true);
		
	var sanFangStars = fumuSanFangSiZhengStars['zuo'].concat(fumuSanFangSiZhengStars['hui']);
	
	var fumuShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(fumuSanFangSiZhengStars['zuo'], "LiuNianMingPan");
	
	var sanFangShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");
	
	var totalStars = sanFangStars.concat(fumuSanFangSiZhengStars['dui']);
	
	var huiJi = false;
	for(var i = 0; i < totalStars.length; i ++){
		var siHua = totalStars[i].getSiHuaOfLiuNian();
		
		if(siHua == "SIHUA_JI"){
			huiJi = true;
			
			break;
		}
	}
	
	if(fumuShaNum == 0 && !huiJi && sanFangShaNum < 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WF5_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var gender = curUser.getUserInfo().getGender();
	
	if(gender == "GENDER_NAN"){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '此问题仅对女士有效。'
		});
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var tianzhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_TIANZHAIGONG', liuNianMingPan, "LiuNianMingPan", true);
		
	var sanFangStars = tianzhaiSanFangSiZhengStars['zuo'].concat(tianzhaiSanFangSiZhengStars['hui']);
	
	var shaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuNianMingPan");
	
	var huiJi = false;
	for(var i = 0; i < sanFangStars.length; i ++){
		var siHua = sanFangStars[i].getSiHuaOfLiuNian();
		
		if(siHua == "SIHUA_JI"){
			huiJi = true;
			
			break;
		}
	}
	
	if(!huiJi && shaNum < 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ1_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var curYear = liuNianMingPan.getYear();
				
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];

	var calendar = new PerpetualCalendar();
		
	var basePerpetualCalenderItem = calendar.getCalendar()[curYear-1901];    // 获取该年的数据
	
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	
	var monthInfo = basePerpetualCalenderItem.monthInfo;

	var resultMonthArray = new Array();
	
	for(var m = 0; m < monthInfo.length; m ++){
		var monthIndex, isRunYue = false;
		
		if(m < runYueIndex){
			monthIndex = m + 1;
		}else if(m == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(m > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = m;
			}else{
				monthIndex = m + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(curYear, monthIndex, isRunYue);

		if(!liuYueMingPan){
			return false;
		}
		
		var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuYueMingPan, "LiuYueMingPan", true);
		
		var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
		
		var hasTianFu = false;
		for(var t = 0; t < sanFangStars.length; t ++){
			var starName = sanFangStars[t].getName();
			
			if(starName == "MAINSTAR_TIANFUXING"){
				hasTianFu = true;
				
				break;
			}
		}
		
		if(hasTianFu){
			if(isRunYue){
				resultMonthArray.push("闰" + defaultLunarMonth[monthIndex - 1]);
			}else{
				resultMonthArray.push(defaultLunarMonth[monthIndex - 1]);
			}
		}
	}
	
	return JSON.stringify({
		'request' : 'A',
		'useful' : true,
		'append' : '最容易的月份为农历'+resultMonthArray.join('、')
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ2_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var hasTianFu = false;
	for(var t = 0; t < sanFangStars.length; t ++){
		var starName = sanFangStars[t].getName();
		
		if(starName == "MAINSTAR_TIANFUXING"){
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ3_al_stub = function(){
	var liuYueMingPan = WeiSuanQuestionUtil.getLiuYueMingPan();
	
	if(!liuYueMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuYueMingPan, "LiuYueMingPan", true);
		
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var mingHasHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	var jieHasLiuNianHuaLu = false;
	for(var i = 0; i < mingSanFangStars.length; i ++){
		var liuYueSiHua = mingSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = mingSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua || "SIHUA_JI" == liuNianSiHua){
			mingHasHuaJi = true;
			
			break;
		}
	}
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieTotalStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
		
		if("SIHUA_LU" == liuNianSiHua){
			jieHasLiuNianHuaLu = true;
		}
	}
	
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuNianHuaJi = false;
	
	for(var i = 0; i < jieSanFangSiZhengStars['zuo'].length; i ++){
		var liuYueSiHua = jieSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
	}
	
	var jieSanFangHasLiuYueHuaJi = false;
	var jieSanFangHasLiuYueHuaLu = false;
	for(var i = 0; i < jieSanFangStars.length; i ++){
		var liuYueSiHua = jieSanFangStars[i].getSiHuaOfLiuYue();
		var liuNianSiHua = jieSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuYueSiHua){
			jieSanFangHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_JI" == liuNianSiHua){
			jieHasLiuNianHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieSanFangHasLiuYueHuaLu = true;
		}
	}
	
	var mingShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuYueMingPan");
	var jieShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieTotalStars, "LiuYueMingPan");
	var jieZuoShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangSiZhengStars['zuo'], "LiuYueMingPan"); 
	var jieSanFangShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuYueMingPan"); 
	
	if(mingHasHuaJi && jieZuoShaNum >= 1 && (jieHasLiuYueHuaLu || jieHasLiuNianHuaLu)){
		return 'B';
	}
	
	if(jieShaNum >= 3 && jieHasLiuYueHuaLu){
		return 'B';
	}
	
	if(jieHasLiuYueHuaJi){
		return 'B';
	}
	
	if(mingShaNum >= 4 && (jieSanFangHasLiuYueHuaJi || jieSanFangHasLiuYueHuaLu)){
		return 'B';
	}
	
	if(jieHasLiuNianHuaJi){
		jieSanFangShaNum ++;
	}
	
	if(jieSanFangShaNum >= 4){
		return 'B';
	}
	
	return 'A';
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ3_al = function(){
	var answer = WeiSuanQuestionAlgorithm.iosInvoked_WJ3_al_stub();
	
	return JSON.stringify({
		'request' : answer,
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ4_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan, "GONGWEI_FUDEGONG");
	
	if(level > 8)
	{
		return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
	}
	
	if(level < 5)
	{
		return JSON.stringify({
			'request' : 'B',
			'useful' : true
		});
	}

	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
	
	/*
	var mingLevel = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan);
	level = ZiWeiUtils.getLiuRiEnergy(liuRiMingPan, "GONGWEI_FUDEGONG");
	
	if(mingLevel > 8)
	{
		if(level > 8)
		{
			return JSON.stringify({
				'request' : 'A',
				'useful' : true
			});
		}
	}
	else
	{
		if(level < 7)
		{
			return JSON.stringify({
				'request' : 'B',
				'useful' : true
			});
		}
	}
	
	return JSON.stringify({
		'request' : 'C',
		'useful' : true
	});
	*/
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ5_al = function(){
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan){
		return false;
	}
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_MINGGONG', liuNianMingPan, "LiuNianMingPan");
	
	var mingHasLiuNianHuaJi = false;
	for(var i = 0; i < mingSanFangSiZhengStars['zuo'].length; i ++){
		var liuNianSiHua = mingSanFangSiZhengStars['zuo'][i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == liuNianSiHua){
			mingHasLiuNianHuaJi = true;
			
			break;
		}
	}
	
	if(mingHasLiuNianHuaJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStars('GONGWEI_JIEGONG', liuNianMingPan, "LiuNianMingPan");
		
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var jieHasHuaJiNum = 0;
	var jieHasHuaLuNum = 0;
	var jieHasLiuNianHuaJi = false;
	for(var i = 0; i < jieSanFangStars.length; i ++){
		var xianTianSiHua = jieSanFangStars[i].getSiXiang();
		var daYunSiHua = jieSanFangStars[i].getSiHuaOfDaYun();
		var liuNianSiHua = jieSanFangStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_JI" == xianTianSiHua || "SIHUA_JI" == daYunSiHua){
			jieHasHuaJiNum ++;
		}
		
		if("SIHUA_JI" == liuNianSiHua){
			jieHasLiuNianHuaJi = true;
			jieHasHuaJiNum ++;
		}
	}
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var xianTianSiHua = jieTotalStars[i].getSiXiang();
		var daYunSiHua = jieTotalStars[i].getSiHuaOfDaYun();
		var liuNianSiHua = jieTotalStars[i].getSiHuaOfLiuNian();
		
		if("SIHUA_LU" == xianTianSiHua || "SIHUA_LU" == daYunSiHua || "SIHUA_LU" == liuNianSiHua){
			jieHasHuaLuNum ++;
		}
	}
	
	if(jieHasHuaJiNum >= 2){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var level = EnergyCalculator.getSpecifyGongWeiEnergyLevel("GONGWEI_MINGGONG", liuNianMingPan, "LiuNianMingPan");
	
	if(level <= 4 && jieHasHuaLuNum >= 2){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	if(level <= 4 && jieHasLiuNianHuaJi){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieTotalStars, "LiuNianMingPan"); 
	
	if(shaNum >= 5){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'redirect' :{
				'txt' : '负能量化解神器开运猫恭请',
				'module' : 'KYM',
				'param' : {
					'productId' : 1
				}
			}
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true,
		'redirect' :{
			'txt' : '负能量化解神器开运猫恭请',
			'module' : 'KYM',
			'param' : {
				'productId' : 1
			}
		}
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ6_al = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
		
	var sanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
		
	var shaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(sanFangStars, "LiuRiMingPan"); 
	
	if(shaNum >= 3){
		return JSON.stringify({
			'request' : 'A',
			'useful' : true
		});
	}
	
	return JSON.stringify({
		'request' : 'B',
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ7_al_stub = function(){
	var liuRiMingPan = WeiSuanQuestionUtil.getLiuRiMingPan();
	
	if(!liuRiMingPan){
		return false;
	}
	
	var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
	
	var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
	
	var jieHasLiuRiHuaJi = false;
	var jieHasLiuRiHuaLu = false;
	var jieHasLiuYueHuaJi = false;
	var jieHasLiuYueHuaLu = false;
	
	for(var i = 0; i < jieTotalStars.length; i ++){
		var liuRiSiHua = jieTotalStars[i].getSiHuaOfLiuRi();
		var liuYueSiHua = jieTotalStars[i].getSiHuaOfLiuYue();
		
		if("SIHUA_JI" == liuRiSiHua){
			jieHasLiuRiHuaJi = true;
		}
		
		if("SIHUA_LU" == liuRiSiHua){
			jieHasLiuRiHuaLu = true;
		}
		
		if("SIHUA_JI" == liuYueSiHua){
			jieHasLiuYueHuaJi = true;
		}
		
		if("SIHUA_LU" == liuYueSiHua){
			jieHasLiuYueHuaLu = true;
		}
	}
	
	var jieShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(jieSanFangStars, "LiuRiMingPan"); 
	
	if(jieShaNum >= 1 && jieHasLiuRiHuaJi){
		return 'B';
	}
	
	
	var mingSanFangSiZhengStars = EnergyCalculator.getSpecifyGongWeiSanFangSiZhengStarsWithTianMa('GONGWEI_MINGGONG', liuRiMingPan, "LiuRiMingPan", true);
	
	var mingSanFangStars = mingSanFangSiZhengStars['zuo'].concat(mingSanFangSiZhengStars['hui']);
	
	var mingShaNum =  MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(mingSanFangStars, "LiuRiMingPan"); 
	
	if(mingShaNum >= 4 && (jieHasLiuRiHuaJi || jieHasLiuRiHuaLu || jieHasLiuYueHuaJi || jieHasLiuYueHuaLu)){
		return 'B';
	}
	
	return 'A';
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ7_al_calcAnswer = function()
{
	//A Wj3为A Wj7为A
	//B Wj3为B Wj7为B
	//C Wj3为A Wj7为B
	//D Wj3为B Wj7为A
	var wj3Answer = WeiSuanQuestionAlgorithm.iosInvoked_WJ3_al_stub();
	var wj7Answer = WeiSuanQuestionAlgorithm.iosInvoked_WJ7_al_stub();
    
	var answer = 'A';
	
	if(wj3Answer == 'A')
	{
		if(wj7Answer == 'A')
		{
			answer = 'A';
		}
		else
		{
			answer = 'C';
		}
	}
	else
	{
		if(wj7Answer == 'A')
		{
			answer = 'D';
		}
		else
		{
			answer = 'B';
		}
	}
   
	return answer;
}

WeiSuanQuestionAlgorithm.iosInvoked_WJ7_al = function(){
	return JSON.stringify({
		'request' : WeiSuanQuestionAlgorithm.iosInvoked_WJ7_al_calcAnswer(),
		'useful' : true
	});
};

WeiSuanQuestionAlgorithm.iosInvoked_WJ8_al = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}

	if(curUser.getUserInfo().getGender() == "GENDER_NAN"){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '此问题仅对女士有效。'
		});
	}
	
	var curGregorianDate = WeiSuanQuestionUtil.getCurrentGregorianDate();
	
	if(!curGregorianDate){
		return false;
	}
	
	/*
	var weekDay = curGregorianDate.getDay();
	
	if(weekDay == 0){
		weekDay = 7;
	}
	*/
	
	var dateArray = new Array();
	
	for(var i = 0; i < 7; i ++){
	//	var offset = i - weekDay;
		
		var offset = i;
		
		var weekDate = PerpetualCalendar.add(curGregorianDate, offset);
		
		var weekLunarDate = PerpetualCalendar.convertGregorianDate2LunarDate(weekDate.getFullYear(), (weekDate.getMonth() + 1), weekDate.getDate(), 0);
		
		var liuRiMingPan = curUser.getLiuRiMingPan(weekLunarDate.year, weekLunarDate.month, weekLunarDate.day, weekLunarDate.isRunYue);
		
		var jieSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars('GONGWEI_JIEGONG', liuRiMingPan, "LiuRiMingPan");
	
		var jieSanFangStars = jieSanFangSiZhengStars['zuo'].concat(jieSanFangSiZhengStars['hui']);
		
		var jieTotalStars = jieSanFangStars.concat(jieSanFangSiZhengStars['dui']);
		
		var hasHongLuan = false;
		var hasLiuRiSiHua = false;
		
		for(var j = 0; j < jieTotalStars.length; j ++){
			var starName = jieTotalStars[j].getName();
			var liuRiSiHua = jieTotalStars[j].getSiHuaOfLiuRi();
			
			if("NORMALSTAR_HONGLUANXING" == starName || "NORMALSTAR_TIANXIXING" == starName){
				hasHongLuan = true;
			}
			
			if(liuRiSiHua){
				hasLiuRiSiHua = true;
			}
		}
		
		var hasLiuNianHongLuanTianXi = false;
		
		var sections = liuRiMingPan.getItems();
		
		for(var j = 0; j < sections.length; j ++){
			var liuRiGongWei = sections[j].getDayGongWei();
			
			if(liuRiGongWei.indexOf("GONGWEI_MINGGONG") >= 0){
				var zuoLiuNianStars = sections[j].getLiuNianStars();
					
				var liuNianStarNameArray = new Array();
				
				for(var m = 0; m < zuoLiuNianStars.length; m ++){
					if(zuoLiuNianStars[m] && zuoLiuNianStars[m].starName){
						liuNianStarNameArray.push(zuoLiuNianStars[m].starName);
					}
				}
				
				var hui1LiuNianStars = sections[(j + 4) % 12].getLiuNianStars();
				
				for(var m = 0; m < hui1LiuNianStars.length; m ++){
					if(hui1LiuNianStars[m] && hui1LiuNianStars[m].starName){
						liuNianStarNameArray.push(hui1LiuNianStars[m].starName);
					}
				}
				
				var duiLiuNianStars = sections[(j + 6) % 12].getLiuNianStars();
				
				for(var m = 0; m < duiLiuNianStars.length; m ++){
					if(duiLiuNianStars[m] && duiLiuNianStars[m].starName){
						liuNianStarNameArray.push(duiLiuNianStars[m].starName);
					}
				}
				
				var hui2LiuNianStars = sections[(j + 8) % 12].getLiuNianStars();
				
				for(var m = 0; m < hui2LiuNianStars.length; m ++){
					if(hui2LiuNianStars[m] && hui2LiuNianStars[m].starName){
						liuNianStarNameArray.push(hui2LiuNianStars[m].starName);
					}
				}
				
				for(var m = 0; m < liuNianStarNameArray.length; m ++){
					if("LIU_NORMALSTAR_HONGLUANXING" == liuNianStarNameArray[m] || "LIU_NORMALSTAR_TIANXIXING"  == liuNianStarNameArray[m]){
						hasLiuNianHongLuanTianXi = true;
						
						break;
					}
				}
			}
		}
		
		if((hasHongLuan || hasLiuNianHongLuanTianXi) && hasLiuRiSiHua){
			dateArray.push(weekDate);
		}
	}
	
	if(dateArray.length == 0){
		return JSON.stringify({
			'request' : false,
			'useful' : false,
			'append' : '没有找到答案，不扣天币。亲，下周再试吧'
		});
	}else{
		var dateStringArray = new Array();
		
		for(var i = 0; i < dateArray.length; i ++){
			dateStringArray.push(PerpetualCalendar.formatDateString(dateArray[i]));
		}
	
		return JSON.stringify({
			'request' : 'A',
			'useful' : true,
			'append' : '一周内' + dateStringArray.join("、")+ " 这些天正能量最强。"
		});
	}
};

// WZ11  我今年拍车牌中签的几率高吗？相对哪几个月最容易中签？  50  （答案每年正月初一更新）
WeiSuanQuestionAlgorithm.iosInvoked_WZ11_al = function()
{
	var liuNianMingPan = WeiSuanQuestionUtil.getLiuNianMingPan();
	
	if(!liuNianMingPan)
	{
		return false;
	}
	
	var liuNianTianZhaiSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars("GONGWEI_TIANZHAIGONG", liuNianMingPan, "LiuNianMingPan");
	var liuNianTianZhaiZuoStars = liuNianTianZhaiSanFangSiZhengStars['zuo'];
	
	var liuNianTianZhaiZuoIsStrong = false;
	var liuNianTianZhaiShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(liuNianTianZhaiZuoStars, "LiuNianMingPan");
	
	for(var i = 0; i < liuNianTianZhaiZuoStars.length; i ++)
	{
		var starName = liuNianTianZhaiZuoStars[i].getName();
		
		if(starName.indexOf("MAINSTAR_") >= 0)
		{
			liuNianTianZhaiZuoIsStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
			break;
		}
	}
	
	var liuNianFuMuSanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars("GONGWEI_FUMUGONG", liuNianMingPan, "LiuNianMingPan");
	var liuNianFuMuZuoStars = liuNianFuMuSanFangSiZhengStars['zuo'];
	var liuNianFuMuShaNum = MingShuQuestionsAlgorithm.commonUtil_getSanFangSiZhengShaNum(liuNianFuMuZuoStars, "LiuNianMingPan");
	var liuNianFuMuHuiChangQu = false;
	var liuNianFuMuSanFangStars = liuNianFuMuZuoStars.concat(liuNianFuMuSanFangSiZhengStars['hui']);
	
	for(var i = 0; i < liuNianFuMuSanFangStars.length; i ++)
	{
		var starName = liuNianFuMuSanFangStars[i].getName();
		
		if(starName == "GEMSTAR_WENCHANGXING" || starName == "GEMSTAR_WENQUXING")
		{
			liuNianFuMuHuiChangQu = true;
			break;
		}
	}
	
	// 流月田宅宫强主星三方会昌曲。
	var thisYear = liuNianMingPan.getYear();
	var calendar = new PerpetualCalendar();
	var basePerpetualCalenderItem = calendar.getCalendar()[thisYear-1901];    // 获取该年的数据
	var runYueIndex = basePerpetualCalenderItem.runYueIndex;
	var monthInfo = basePerpetualCalenderItem.monthInfo;
	var monthResultArray = new Array();
	var defaultLunarMonth = ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"];
	var curUser = getCurrentUser().user;
	
	for(var i = 0; i < monthInfo.length; i ++)
	{
		var monthIndex = false, isRunYue = false;
		
		if(i < runYueIndex){
			monthIndex = i + 1;
		}else if(i == runYueIndex){
			monthIndex = runYueIndex;
			isRunYue = true;
		}else if(i > runYueIndex){
			if(runYueIndex > 0){
				monthIndex = i;
			}else{
				monthIndex = i + 1;
			}
		}
		
		var liuYueMingPan = curUser.getLiuYueMingPan(thisYear, monthIndex, isRunYue);
		
		if(!liuYueMingPan){
			return false;
		}
		
		var sanFangSiZhengStars = EnergyCalculator.getSpecifyMingPanSanFangSiZhengStarsWithAllStars("GONGWEI_TIANZHAIGONG", liuYueMingPan, "LiuYueMingPan");
		var monthIsStrong = false;
	
		for(var j = 0; j < sanFangSiZhengStars['zuo'].length; j ++)
		{
			var starName = sanFangSiZhengStars['zuo'][j].getName();
			
			if(starName.indexOf("MAINSTAR_") >= 0)
			{
				monthIsStrong = WeiSuanQuestionUtil.mainStarsIsStrong(starName);
				break;
			}
		}
		
		var monthHasChangQu = false;
		var sanFangStars = sanFangSiZhengStars['zuo'].concat(sanFangSiZhengStars['hui']);
		
		for(var j = 0; j < sanFangStars.length; j ++)
		{
			var starName = sanFangStars[j].getName();
			if(starName == 'GEMSTAR_WENCHANGXING' || starName == 'GEMSTAR_WENQUXING')
			{
				monthHasChangQu = true;
				break;
			}
		}
		
		if(monthIsStrong && monthHasChangQu){
			var monthName = defaultLunarMonth[monthIndex - 1];
						
			if(isRunYue){
				monthName = "闰" + monthName;
			}
			
			monthResultArray.push(monthName);
		
			continue;
		}
	}

	return JSON.stringify({
		'request' : (liuNianTianZhaiZuoIsStrong && (liuNianTianZhaiShaNum == 0) &&  (liuNianFuMuShaNum == 0) && liuNianFuMuHuiChangQu)? 'A' : 'B',
		'useful' : true,
		'append' : monthResultArray.length > 0 ? "能量最强的月份是：农历" + monthResultArray.join("、") : ""
	});
};

function WeiSuanQuestionUtil(){

};

WeiSuanQuestionUtil.mainStarsIsStrong = function(starName){
	if(!starName){
		return false;
	}
	
	if(starName == "MAINSTAR_ZIWEIXING" || starName == "MAINSTAR_WUQUXING" || starName == "MAINSTAR_TIANFUXING" ||
				   starName == "MAINSTAR_TIANXIANGXING" || starName == "MAINSTAR_LIANZHENXING" || starName == "MAINSTAR_QISHAXING" ||
				   starName == "MAINSTAR_POJUNXING" || starName == "MAINSTAR_TANLANGXING"){
		return true;
	}
		
	return false;
};

WeiSuanQuestionUtil.getSpecifyDayGongWeiStars = function(sections, gongwei){
	if(!(sections && gongwei)){
		return false;
	}
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
	
		var dayGongWei = section.getDayGongWei();
		
		if(dayGongWei.indexOf(gongwei) >= 0){
			var stars = section.getStars();
			
			var isEmpty = true;
			
			for(var j = 0; j < stars.length; j ++){
				if(stars[j].getName().indexOf("MAINSTAR_") >= 0){
					isEmpty = false;
				}
			}
			
			if(isEmpty){
				section = sections[(i + 6) % 12];
				
				return stars.concat(section.getStars());
			}else{
				return stars;
			}
		}
	}
	
	return false;
};

WeiSuanQuestionUtil.getSpecifyMonthGongWeiStars = function(sections, gongwei){
	if(!(sections && gongwei)){
		return false;
	}
	
	for(var i = 0; i < sections.length; i ++){
		var section = sections[i];
	
		var monthGongWei = section.getMonthGongWei();
		
		if(monthGongWei.indexOf(gongwei) >= 0){
			var stars = section.getStars();
			
			var isEmpty = true;
			
			for(var j = 0; j < stars.length; j ++){
				if(stars[j].getName().indexOf("MAINSTAR_") >= 0){
					isEmpty = false;
				}
			}
			
			if(isEmpty){
				section = sections[(i + 6) % 12];
				
				return stars.concat(section.getStars());
			}else{
				return stars;
			}
		}
	}
	
	return false;
};

WeiSuanQuestionUtil.validateCurrentUser = function(){
	
};

WeiSuanQuestionUtil.getCurrentLunarDate = function(){
	var session = Session.getSession();
	
	return session.getLunarDate();
};

WeiSuanQuestionUtil.getCurrentGregorianDate = function(){
	var session = Session.getSession();
	
	return session.getGregorianDate();
};

WeiSuanQuestionUtil.getLiuRiMingPan = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	return curUser.getLiuRiMingPan(curLunarDate.year, curLunarDate.month, curLunarDate.day, curLunarDate.isRunYue);
};

WeiSuanQuestionUtil.getLiuYueMingPan = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	return curUser.getLiuYueMingPan(curLunarDate.year, curLunarDate.month, curLunarDate.isRunYue);
};

WeiSuanQuestionUtil.getLiuNianMingPan = function(){
	var curUser = getCurrentUser() ? getCurrentUser().user : false;
	
	if(!curUser){
		return false;
	}
	
	var curLunarDate = WeiSuanQuestionUtil.getCurrentLunarDate();
	
	if(!curLunarDate){
		return false;
	}
	
	return curUser.getLiuNianMingPan(curLunarDate.year); 
};